// Copyright 2015 by Paulo Augusto Peccin. See license.txt distributed with this file.

// Main Emulator parameters.
// You may change any of these after loading the project and before starting the Emulator

Javatari = {

    VERSION:                        "version 0.91",             // Don't change this one!

    ROM_AUTO_LOAD_URL:              "",                         // Full or relative URL of ROM
    AUTO_START:                     true,                       // Set false to start emulator manually with Javatari.start()
    SCREEN_ELEMENT_ID:              "javatari-screen",
    CONSOLE_PANEL_ELEMENT_ID:       "javatari-console-panel",
    CARTRIDGE_CHANGE_DISABLED:      false,
    SCREEN_RESIZE_DISABLED:         false,
    SCREEN_FULLSCREEN_DISABLED:     false,
    CARTRIDGE_LABEL_COLORS:         "",                         // Space-separated colors for Label, Background, Border. e.g. "#f00 #000 transparent". Leave "" for defaults
    PADDLES_MODE:                   -1,                         // -1 = auto, 0 = off, 1 = 0n
    SCREEN_CRT_MODE:                -1,                         // -1 = auto, 0 .. 4 = mode
    SCREEN_OPENING_SIZE:            2,                          // 1 .. 4
    SCREEN_CONTROL_BAR:             0,                          // 0 = Always, 1 = Hover, 2 = Original Javatari
    SCREEN_NATURAL_FPS:             60,                         // 60, 50 fps
    AUDIO_BUFFER_SIZE:              512,                        // 256, 512, 1024, 2048, 4096, 8192. More buffer = more delay
    IMAGES_PATH:                    window.Javatari_IMAGES_PATH || "javatari/",
    SHOW_ERRORS:		                true,
    DEBUG_SCANLINE_OVERFLOW:        false,

};

jt = window.jt || {};

for(var n in jt.Util=new function(){this.log=function(n){console.log(">> Javatari: "+n)},this.message=function(n){alert(n)},this.arraysEqual=function(n,e){var t=n.length;if(t!==e.length)return!1;for(;t--;)if(n[t]!==e[t])return!1;return!0},this.arrayFill=function(n,e){for(var t=n.length;t--;)n[t]=e;return n},this.arrayFillWithArrayClone=function(n,e){for(var t=n.length;t--;)n[t]=e.slice(0);return n},this.arrayFillSegment=function(n,e,t,r){for(var a=t;a-- >e;)n[a]=r;return n},this.arrayCopy=function(n,e,t,r,a){for(var i=e+a;e<i;)t[r++]=n[e++]},this.uInt32ArrayCopyToUInt8Array=function(n,e,t,r,a){var i=e+a;for(r*=4;e<i;){var o=n[e++];t[r++]=255&o,t[r++]=o>>8&255,t[r++]=o>>16&255,t[r++]=o>>>24}},this.arrayCopyCircularSourceWithStep=function(n,e,t,r,a,i,o){for(var A=e,C=i,D=i+o;C<D;)a[C]=n[0|A],C++,t<=(A+=r)&&(A-=t)},this.arrayRemove=function(n,e){var t=n.indexOf(e);t<0||n.splice(t,1)},this.booleanArrayToByteString=function(n){for(var e="",t=0,r=n.length;t<r;t++)e+=n[t]?"1":"0";return e},this.byteStringToBooleanArray=function(n){for(var e=[],t=0,r=n.length;t<r;t++)e.push("1"===n.charAt(t));return e},this.uInt8ArrayToByteString=function(n){for(var e="",t=0,r=n.length;t<r;t++)e+=String.fromCharCode(255&n[t]);return e},this.byteStringToUInt8Array=function(n){for(var e=[],t=0,r=n.length;t<r;t++)e.push(255&n.charCodeAt(t));return e},this.uInt32ArrayToByteString=function(n){for(var e="",t=0,r=n.length;t<r;t++){var a=n[t];e+=String.fromCharCode((4278190080&a)>>>24),e+=String.fromCharCode((16711680&a)>>>16),e+=String.fromCharCode((65280&a)>>>8),e+=String.fromCharCode(255&a)}return e},this.byteStringToUInt32Array=function(n){for(var e=[],t=0,r=n.length;t<r;)e.push(n.charCodeAt(t++)*(1<<24)+(n.charCodeAt(t++)<<16)+(n.charCodeAt(t++)<<8)+n.charCodeAt(t++));return e},this.uInt8BiArrayToByteString=function(n){for(var e="",t=0,r=n.length;t<r;t++)for(var a=0,i=n[t].length;a<i;a++)e+=String.fromCharCode(255&n[t][a]);return e},this.byteStringToUInt8BiArray=function(n,e){for(var t=[],r=0,a=n.length;r<a;){for(var i=new Array(e),o=0;o<e;o++)i[o]=255&n.charCodeAt(r++);t.push(i)}return t}},jt.M6502=function(){function n(){return[Jn,function(){Be("KIL/HLT/JAM")},function(){Q--}]}function e(n){return n(function(){Be("NOP/DOP")})}function t(n){return n(function(){var n,e,t,r;W?(9<(e=(15&H)+(15&(n=q))+Z)&&(e+=6),t=(H>>4)+(n>>4)+(15<e)<<4,ae(H+n+Z&255),ie(t),oe((H^t)&~(H^n)&128),159<t&&(t+=96),Ae(255<t),H=255&(t|15&e)):(Ae(255<(r=H+q+Z)),oe((H^r)&(q^r)&128),ae(H=255&r),ie(H))})}function r(n){return n(function(){ae(H&=q),ie(H)})}function a(n){return n(function(){var n=q;ae(H&n),oe(64&n),ie(n)})}function i(n){return n(function(){var n=H-q&255;Ae(q<=H),ae(n),ie(n)})}function o(n){return n(function(){var n=G-q&255;Ae(q<=G),ae(n),ie(n)})}function A(n){return n(function(){var n=J-q&255;Ae(q<=J),ae(n),ie(n)})}function C(n){return n(function(){ae(H^=q),ie(H)})}function D(n){return n(function(){ae(H=q),ie(H)})}function E(n){return n(function(){ae(G=q),ie(G)})}function s(n){return n(function(){ae(J=q),ie(J)})}function F(n){return n(function(){ae(H|=q),ie(H)})}function B(n){return n(function(){var n,e,t,r;W?(t=(H>>4)-((n=q)>>4)-((e=(15&H)-(15&n)-(1-Z))<0),e<0&&(e-=6),t<0&&(t-=6),Ae(256&~(r=H-n-(1-Z))),oe((H^n)&(H^r)&128),ae(255&r),ie(r),H=255&(t<<4|15&e)):(Ae(255<(r=H+(n=255&~q)+Z)),oe((H^r)&(n^r)&128),ae(H=255&r),ie(H))})}function c(n){return n(function(){Be("ANC"),ae(H&=q),N=Z=128&H?1:0})}function l(n){return n(function(){Be("LAX");var n=q;ae(G=H=n),ie(n)})}function u(n){return n(function(){q=H})}function d(n){return n(function(){q=G})}function f(n){return n(function(){q=J})}function h(n){return n(function(){Be("SAX"),q=H&G})}function p(n){return n(function(){Be("SHA"),q=H&G&1+(en>>>8)&255})}function P(n){return n(function(){Ae(127<q);var n=q<<1&255;ae(q=n),ie(n)})}function m(n){return n(function(){var n=q-1&255;ae(q=n),ie(n)})}function g(n){return n(function(){var n=q+1&255;ae(q=n),ie(n)})}function S(n){return n(function(){Z=1&q,ae(q>>>=1),N=0})}function v(n){return n(function(){var n=127<q,e=255&(q<<1|Z);q=e,Ae(n),ae(e),ie(e)})}function y(n){return n(function(){var n=1&q,e=q>>>1|Z<<7;q=e,Ae(n),ae(e),ie(e)})}function k(n){return n(function(){Be("DCP");var n=q-1&255;Ae(0<=(n=H-(q=n))),ae(n),ie(n)})}function L(n){return n(function(){var n,e,t,r;Be("ISB"),q=q+1&255,W?(t=(H>>4)-((n=q)>>4)-((e=(15&H)-(15&n)-(1-Z))<0),e<0&&(e-=6),t<0&&(t-=6),Ae(256&~(r=H-n-(1-Z))),oe((H^n)&(H^r)&128),ae(255&r),ie(r),H=255&(t<<4|15&e)):(Ae(255<(r=H+(n=255&~q)+Z)),oe((H^r)&(n^r)&128),ae(H=255&r),ie(H))})}function b(n){return n(function(){Be("RLA");var n=q,e=Z;Ae(128&n),H&=q=n=255&(n<<1|e),ae(n),ie(n)})}function T(n){return n(function(){Be("RRA");var n,e,t,r,a=q,i=Z?128:0;Ae(1&a),q=a>>>1|i,W?(9<(e=(15&H)+(15&(n=q))+Z)&&(e+=6),t=(H>>4)+(n>>4)+(15<e)<<4,ae(H+n+Z&255),ie(t),oe((H^t)&~(H^n)&128),159<t&&(t+=96),Ae(255<t),H=255&(t|15&e)):(Ae(255<(r=H+q+Z)),oe((H^r)&(q^r)&128),ae(H=255&r),ie(H))})}function _(n){return n(function(){Be("SLO");var n=q;Ae(128&n),q=n=n<<1&255,ae(H=n|=H),ie(n)})}function w(n){return n(function(){Be("SRE");var n=q;Ae(1&n),ae(H=n=255&(H^(q=n>>>=1))),ie(n)})}function R(){return[Jn,ee,function(){O.debug&&O.breakpoint("BRK "+q),Ee(V>>>8&255)},function(){Ee(255&V)},function(){Ee(se())},function(){nn=K.read(Dn)},function(){nn|=K.read(Dn+1)<<8},function(){V=nn,Nn()}]}function I(){return[Jn,ee,function(){O.debug&&O.breakpoint("NMI "+q),Ee(V>>>8&255)},function(){Ee(255&V)},function(){Ee(se())},function(){nn=K.read(An)},function(){nn|=K.read(An+1)<<8},function(){V=nn,Nn()}]}function M(n,e){var t=n===sn?function(){return X===e}:n===En?function(){return N===e}:n===Fn?function(){return Z===e}:function(){return z===e};return[Jn,Wn,function(){t()?(zn(),te()):Nn()},function(){on?(zn(),re()):Nn()},Nn]}var K,O=this;this.powerOn=function(){this.reset()},this.powerOff=function(){},this.clockPulse=function(){x&&U[++Q]()},this.connectBus=function(n){K=n},this.setRDY=function(n){x=n},this.isRDY=function(){return x};var U,x=!(this.reset=function(){Q=-(Y=1),U=[Jn],V=K.read(Cn)|K.read(Cn+1)<<8,this.setRDY(!0)}),V=0,j=0,H=0,G=0,J=0,N=0,z=0,W=0,Y=0,X=0,Z=0,Q=-1,$=-1,q=0,nn=0,en=0,tn=!1,rn=0,an=0,on=0,An=65530,Cn=65532,Dn=65534,En=7,sn=1,Fn=0;this.debug=!1,this.trace=!1;function Bn(){nn=K.read(en)}function cn(){nn|=K.read(en)<<8}function ln(){en=K.read(V),V++}function un(){en|=K.read(V)<<8,V++}function dn(){var n=(255&en)+G;tn=255<n,en=65280&en|255&n}function fn(){var n=(255&en)+J;tn=255<n,en=65280&en|255&n}function hn(){var n=1+(255&en);tn=255<n,en=65280&en|255&n}function pn(){tn&&(en=en+256&65535)}function Pn(){q=K.read(nn)}function mn(){q=K.read(en)}function gn(){K.write(nn,q)}function Sn(){K.write(en,q)}function vn(n){return[Jn,ee,function(){n(),Nn()}]}function yn(n){return[Jn,Yn,Pn,function(){n(),Nn()}]}function kn(n){return[Jn,Yn,Xn,Pn,function(){n(),Nn()}]}function Ln(n){return[Jn,ln,mn,function(){dn(),Bn()},function(){hn(),cn()},Pn,function(){n(),Nn()}]}function bn(n){var e=0===n?dn:fn;return function(n){return[Jn,ln,un,function(){e(),mn(),pn()},function(){tn?mn():(n(),Nn())},function(){n(),Nn()}]}}function Tn(n){var e=0===n?dn:fn;return function(n){return[Jn,ln,mn,function(){e(),mn()},function(){n(),Nn()}]}}function _n(n){return[Jn,$n,Zn,function(){ne(),Qn()},function(){fn(),mn(),pn()},function(){tn?mn():(n(),Nn())},function(){n(),Nn()}]}function wn(n){return[Jn,Yn,function(){n(),gn()},Nn]}function Rn(n){return[Jn,Yn,Xn,function(){n(),gn()},Nn]}function In(n){return[Jn,ln,mn,function(){dn(),Bn()},function(){hn(),cn()},function(){n(),gn()},Nn]}function Mn(n){var e=0===n?dn:fn;return function(n){return[Jn,ln,un,function(){e(),mn(),pn()},function(){n(),Sn()},Nn]}}function Kn(n){var e=0===n?dn:fn;return function(n){return[Jn,ln,mn,function(){e(),n(),Sn()},Nn]}}function On(n){return[Jn,$n,Zn,function(){ne(),Qn()},function(){fn(),mn(),pn()},function(){n(),Sn()},Nn]}function Un(n){return[Jn,Yn,Pn,gn,function(){n(),gn()},Nn]}function xn(n){return[Jn,Yn,Xn,Pn,gn,function(){n(),gn()},Nn]}function Vn(n){var e=0===n?dn:fn;return function(n){return[Jn,ln,mn,function(){e(),mn()},Sn,function(){n(),Sn()},Nn]}}function jn(n){var e=0===n?dn:fn;return function(n){return[Jn,ln,un,function(){e(),mn(),pn()},mn,Sn,function(){n(),Sn()},Nn]}}function Hn(n){return[Jn,ln,mn,function(){dn(),Bn()},function(){hn(),cn()},Pn,gn,function(){n(),gn()},Nn]}function Gn(n){return[Jn,$n,Zn,function(){ne(),Qn()},function(){fn(),mn(),pn()},mn,Sn,function(){n(),Sn()},Nn]}var Jn=function(){$=K.read(V),U=ue[$],Q=0,V++},Nn=Jn,zn=function(){K.read(V)},Wn=function(){an=K.read(V),V++},Yn=function(){nn=K.read(V),V++},Xn=function(){nn|=K.read(V)<<8,V++},Zn=function(){en=K.read(rn)},Qn=function(){en|=K.read(rn)<<8},$n=function(){rn=K.read(V),V++},qn=function(){rn|=K.read(V)<<8,V++},ne=function(){rn=65280&rn|255&1+(255&rn)},ee=function(){q=K.read(V),V++},te=function(){var n=255&V,e=n+an&255;on=127<an?n<e?-256:0:e<n?256:0,V=65280&V|e},re=function(){V=V+on&65535},ae=function(n){X=0===n?1:0},ie=function(n){N=128&n?1:0},oe=function(n){z=n?1:0},Ae=function(n){Z=n?1:0},Ce=function(){return j=j+1&255,K.read(256+j)},De=function(){return K.read(256+j)},Ee=function(n){K.write(256+j,n),j=j-1&255},se=function(){return N<<7|z<<6|48|W<<3|Y<<2|X<<1|Z},Fe=function(n){N=n>>>7,z=n>>>6&1,W=n>>>3&1,Y=n>>>2&1,X=n>>>1&1,Z=1&n},Be=function(n){O.debug&&O.breakpoint("Illegal Opcode: "+n)},ce=function(n){return[Jn,zn,function(){n(),Nn()}]},le=new Array(256),ue=new Array(256);le[0]="BRK",ue[0]=R(),le[1]="ORA",ue[1]=F(Ln),le[2]="uKIL",ue[2]=n(),le[3]="uSLO",ue[3]=_(Hn),le[4]="uNOP",ue[4]=e(yn),le[5]="ORA",ue[5]=F(yn),le[6]="ASL",ue[6]=P(Un),le[7]="uSLO",ue[7]=_(Un),le[8]="PHP",ue[8]=[Jn,zn,function(){Ee(se())},Nn],le[9]="ORA",ue[9]=F(vn),le[10]="ASL",ue[10]=ce(function(){Ae(127<H),ae(H=H<<1&255),ie(H)}),le[11]="uANC",ue[11]=c(vn),le[12]="uNOP",ue[12]=e(kn),le[13]="ORA",ue[13]=F(kn),le[14]="ASL",ue[14]=P(xn),le[15]="uSLO",ue[15]=_(xn),le[16]="BPL",ue[16]=M(En,0),le[17]="ORA",ue[17]=F(_n),le[18]="uKIL",ue[18]=n(),le[19]="uSLO",ue[19]=_(Gn),le[20]="uNOP",ue[20]=e(Tn(0)),le[21]="ORA",ue[21]=F(Tn(0)),le[22]="ASL",ue[22]=P(Vn(0)),le[23]="uSLO",ue[23]=_(Vn(0)),le[24]="CLC",ue[24]=ce(function(){Z=0}),le[25]="ORA",ue[25]=F(bn(1)),le[26]="uNOP",ue[26]=e(ce),le[27]="uSLO",ue[27]=_(jn(1)),le[28]="uNOP",ue[28]=e(bn(0)),le[29]="ORA",ue[29]=F(bn(0)),le[30]="ASL",ue[30]=P(jn(0)),le[31]="uSLO",ue[31]=_(jn(0)),le[32]="JSR",ue[32]=[Jn,Yn,De,function(){Ee(V>>>8&255)},function(){Ee(255&V)},Xn,function(){V=nn,Nn()}],le[33]="AND",ue[33]=r(Ln),le[34]="uKIL",ue[34]=n(),le[35]="uRLA",ue[35]=b(Hn),le[36]="BIT",ue[36]=a(yn),le[37]="AND",ue[37]=r(yn),le[38]="ROL",ue[38]=v(Un),le[39]="uRLA",ue[39]=b(Un),le[40]="PLP",ue[40]=[Jn,zn,De,function(){Fe(Ce())},Nn],le[41]="AND",ue[41]=r(vn),le[42]="ROL",ue[42]=ce(function(){var n=127<H;H=255&(H<<1|Z),Ae(n),ae(H),ie(H)}),le[43]="uANC",ue[43]=c(vn),le[44]="BIT",ue[44]=a(kn),le[45]="AND",ue[45]=r(kn),le[46]="ROL",ue[46]=v(xn),le[47]="uRLA",ue[47]=b(xn),le[48]="BMI",ue[48]=M(En,1),le[49]="AND",ue[49]=r(_n),le[50]="uKIL",ue[50]=n(),le[51]="uRLA",ue[51]=b(Gn),le[52]="uNOP",ue[52]=e(Tn(0)),le[53]="AND",ue[53]=r(Tn(0)),le[54]="ROL",ue[54]=v(Vn(0)),le[55]="uRLA",ue[55]=b(Vn(0)),le[56]="SEC",ue[56]=ce(function(){Z=1}),le[57]="AND",ue[57]=r(bn(1)),le[58]="uNOP",ue[58]=e(ce),le[59]="uRLA",ue[59]=b(jn(1)),le[60]="uNOP",ue[60]=e(bn(0)),le[61]="AND",ue[61]=r(bn(0)),le[62]="ROL",ue[62]=v(jn(0)),le[63]="uRLA",ue[63]=b(jn(0)),le[64]="RTI",ue[64]=[Jn,zn,De,function(){Fe(Ce())},function(){nn=Ce()},function(){nn|=Ce()<<8},function(){V=nn,Nn()}],le[65]="EOR",ue[65]=C(Ln),le[66]="uKIL",ue[66]=n(),le[67]="uSRE",ue[67]=w(Hn),le[68]="uNOP",ue[68]=e(yn),le[69]="EOR",ue[69]=C(yn),le[70]="LSR",ue[70]=S(Un),le[71]="uSRE",ue[71]=w(Un),le[72]="PHA",ue[72]=[Jn,zn,function(){Ee(H)},Nn],le[73]="EOR",ue[73]=C(vn),le[74]="LSR",ue[74]=ce(function(){Z=1&H,ae(H>>>=1),N=0}),le[75]="uASR",ue[75]=vn(function(){Be("ASR");var n=H&q;Z=1&n,ae(H=n>>>=1),N=0}),le[76]="JMP",ue[76]=[Jn,Yn,Xn,function(){V=nn,Nn()}],le[77]="EOR",ue[77]=C(kn),le[78]="LSR",ue[78]=S(xn),le[79]="uSRE",ue[79]=w(xn),le[80]="BVC",ue[80]=M(6,0),le[81]="EOR",ue[81]=C(_n),le[82]="uKIL",ue[82]=n(),le[83]="uSRE",ue[83]=w(Gn),le[84]="uNOP",ue[84]=e(Tn(0)),le[85]="EOR",ue[85]=C(Tn(0)),le[86]="LSR",ue[86]=S(Vn(0)),le[87]="uSRE",ue[87]=w(Vn(0)),le[88]="CLI",ue[88]=ce(function(){Y=0}),le[89]="EOR",ue[89]=C(bn(1)),le[90]="uNOP",ue[90]=e(ce),le[91]="uSRE",ue[91]=w(jn(1)),le[92]="uNOP",ue[92]=e(bn(0)),le[93]="EOR",ue[93]=C(bn(0)),le[94]="LSR",ue[94]=S(jn(0)),le[95]="uSRE",ue[95]=w(jn(0)),le[96]="RTS",ue[96]=[Jn,zn,De,function(){nn=Ce()},function(){nn|=Ce()<<8},function(){V=nn,ee()},Nn],le[97]="ADC",ue[97]=t(Ln),le[98]="uKIL",ue[98]=n(),le[99]="uRRA",ue[99]=T(Hn),le[100]="uNOP",ue[100]=e(yn),le[101]="ADC",ue[101]=t(yn),le[102]="ROR",ue[102]=y(Un),le[103]="uRRA",ue[103]=T(Un),le[104]="PLA",ue[104]=[Jn,zn,De,function(){H=Ce(),ae(H),ie(H)},Nn],le[105]="ADC",ue[105]=t(vn),le[106]="ROR",ue[106]=ce(function(){var n=1&H;H=H>>>1|Z<<7,Ae(n),ae(H),ie(H)}),le[107]="uARR",ue[107]=vn(function(){Be("ARR");var n=H&q;ae(H=n=n>>>1|(Z?128:0)),ie(n);var e=96&H;96==e?(Z=1,z=0):0==e?z=Z=0:32==e?(Z=0,z=1):64==e&&(z=Z=1)}),le[108]="JMP",ue[108]=[Jn,$n,qn,Zn,function(){ne(),Qn()},function(){V=en,Nn()}],le[109]="ADC",ue[109]=t(kn),le[110]="ROR",ue[110]=y(xn),le[111]="uRRA",ue[111]=T(xn),le[112]="BVS",ue[112]=M(6,1),le[113]="ADC",ue[113]=t(_n),le[114]="uKIL",ue[114]=n(),le[115]="uRRA",ue[115]=T(Gn),le[116]="uNOP",ue[116]=e(Tn(0)),le[117]="ADC",ue[117]=t(Tn(0)),le[118]="ROR",ue[118]=y(Vn(0)),le[119]="uRRA",ue[119]=T(Vn(0)),le[120]="SEI",ue[120]=ce(function(){Y=1}),le[121]="ADC",ue[121]=t(bn(1)),le[122]="uNOP",ue[122]=e(ce),le[123]="uRRA",ue[123]=T(jn(1)),le[124]="uNOP",ue[124]=e(bn(0)),le[125]="ADC",ue[125]=t(bn(0)),le[126]="ROR",ue[126]=y(jn(0)),le[127]="uRRA",ue[127]=T(jn(0)),le[128]="uNOP",ue[128]=e(vn),le[129]="STA",ue[129]=u(In),le[130]="uNOP",ue[130]=e(vn),le[131]="uSAX",ue[131]=h(In),le[132]="STY",ue[132]=f(wn),le[133]="STA",ue[133]=u(wn),le[134]="STX",ue[134]=d(wn),le[135]="uSAX",ue[135]=h(wn),le[136]="DEY",ue[136]=ce(function(){ae(J=J-1&255),ie(J)}),le[137]="uNOP",ue[137]=e(vn),le[138]="TXA",ue[138]=ce(function(){ae(H=G),ie(H)}),le[139]="uANE",ue[139]=vn(function(){Be("ANE")}),le[140]="STY",ue[140]=f(Rn),le[141]="STA",ue[141]=u(Rn),le[142]="STX",ue[142]=d(Rn),le[143]="uSAX",ue[143]=h(Rn),le[144]="BCC",ue[144]=M(Fn,0),le[145]="STA",ue[145]=u(On),le[146]="uKIL",ue[146]=n(),le[147]="uSHA",ue[147]=p(On),le[148]="STY",ue[148]=f(Kn(0)),le[149]="STA",ue[149]=u(Kn(0)),le[150]="STX",ue[150]=d(Kn(1)),le[151]="uSAX",ue[151]=h(Kn(1)),le[152]="TYA",ue[152]=ce(function(){ae(H=J),ie(H)}),le[153]="STA",ue[153]=u(Mn(1)),le[154]="TXS",ue[154]=ce(function(){j=G}),le[155]="uSHS",ue[155]=Mn(1)(function(){Be("SHS");var n=H&G;q=(j=n)&1+(en>>>8)&255}),le[156]="uSHY",ue[156]=Mn(0)(function(){Be("SHY"),q=J&1+(en>>>8)&255}),le[157]="STA",ue[157]=u(Mn(0)),le[158]="uSHX",ue[158]=Mn(1)(function(){Be("SHX"),q=G&1+(en>>>8)&255}),le[159]="uSHA",ue[159]=p(Mn(1)),le[160]="LDY",ue[160]=s(vn),le[161]="LDA",ue[161]=D(Ln),le[162]="LDX",ue[162]=E(vn),le[163]="uLAX",ue[163]=l(Ln),le[164]="LDY",ue[164]=s(yn),le[165]="LDA",ue[165]=D(yn),le[166]="LDX",ue[166]=E(yn),le[167]="uLAX",ue[167]=l(yn),le[168]="TAY",ue[168]=ce(function(){ae(J=H),ie(J)}),le[169]="LDA",ue[169]=D(vn),le[170]="TAX",ue[170]=ce(function(){ae(G=H),ie(G)}),le[171]="uLXA",ue[171]=vn(function(){Be("LXA");var n=H&q;ae(G=H=n),ie(n)}),le[172]="LDY",ue[172]=s(kn),le[173]="LDA",ue[173]=D(kn),le[174]="LDX",ue[174]=E(kn),le[175]="uLAX",ue[175]=l(kn),le[176]="BCS",ue[176]=M(Fn,1),le[177]="LDA",ue[177]=D(_n),le[178]="uKIL",ue[178]=n(),le[179]="uLAX",ue[179]=l(_n),le[180]="LDY",ue[180]=s(Tn(0)),le[181]="LDA",ue[181]=D(Tn(0)),le[182]="LDX",ue[182]=E(Tn(1)),le[183]="uLAX",ue[183]=l(Tn(1)),le[184]="CLV",ue[184]=ce(function(){z=0}),le[185]="LDA",ue[185]=D(bn(1)),le[186]="TSX",ue[186]=ce(function(){ae(G=j),ie(G)}),le[187]="uLAS",ue[187]=bn(1)(function(){Be("LAS");var n=j&q;ae(j=G=H=n),ie(n)}),le[188]="LDY",ue[188]=s(bn(0)),le[189]="LDA",ue[189]=D(bn(0)),le[190]="LDX",ue[190]=E(bn(1)),le[191]="uLAX",ue[191]=l(bn(1)),le[192]="CPY",ue[192]=A(vn),le[193]="CMP",ue[193]=i(Ln),le[194]="uNOP",ue[194]=e(vn),le[195]="uDCP",ue[195]=k(Hn),le[196]="CPY",ue[196]=A(yn),le[197]="CMP",ue[197]=i(yn),le[198]="DEC",ue[198]=m(Un),le[199]="uDCP",ue[199]=k(Un),le[200]="INY",ue[200]=ce(function(){ae(J=J+1&255),ie(J)}),le[201]="CMP",ue[201]=i(vn),le[202]="DEX",ue[202]=ce(function(){ae(G=G-1&255),ie(G)}),le[203]="uSBX",ue[203]=vn(function(){Be("SBX");var n=H&G,e=n-q&255;G=e,Ae(q<=n),ae(e),ie(e)}),le[204]="CPY",ue[204]=A(kn),le[205]="CMP",ue[205]=i(kn),le[206]="DEC",ue[206]=m(xn),le[207]="uDCP",ue[207]=k(xn),le[208]="BNE",ue[208]=M(sn,0),le[209]="CMP",ue[209]=i(_n),le[210]="uKIL",ue[210]=n(),le[211]="uDCP",ue[211]=k(Gn),le[212]="uNOP",ue[212]=e(Tn(0)),le[213]="CMP",ue[213]=i(Tn(0)),le[214]="DEC",ue[214]=m(Vn(0)),le[215]="uDCP",ue[215]=k(Vn(0)),le[216]="CLD",ue[216]=ce(function(){W=0}),le[217]="CMP",ue[217]=i(bn(1)),le[218]="uNOP",ue[218]=e(ce),le[219]="uDCP",ue[219]=k(jn(1)),le[220]="uNOP",ue[220]=e(bn(0)),le[221]="CMP",ue[221]=i(bn(0)),le[222]="DEC",ue[222]=m(jn(0)),le[223]="uDCP",ue[223]=k(jn(0)),le[224]="CPX",ue[224]=o(vn),le[225]="SBC",ue[225]=B(Ln),le[226]="uNOP",ue[226]=e(vn),le[227]="uISB",ue[227]=L(Hn),le[228]="CPX",ue[228]=o(yn),le[229]="SBC",ue[229]=B(yn),le[230]="INC",ue[230]=g(Un),le[231]="uISB",ue[231]=L(Un),le[232]="INX",ue[232]=ce(function(){ae(G=G+1&255),ie(G)}),le[233]="SBC",ue[233]=B(vn),le[234]="NOP",ue[234]=ce(function(){}),le[235]="SBC",ue[235]=B(vn),le[236]="CPX",ue[236]=o(kn),le[237]="SBC",ue[237]=B(kn),le[238]="INC",ue[238]=g(xn),le[239]="uISB",ue[239]=L(xn),le[240]="BEQ",ue[240]=M(sn,1),le[241]="SBC",ue[241]=B(_n),le[242]="uKIL",ue[242]=n(),le[243]="uISB",ue[243]=L(Gn),le[244]="uNOP",ue[244]=e(Tn(0)),le[245]="SBC",ue[245]=B(Tn(0)),le[246]="INC",ue[246]=g(Vn(0)),le[247]="uISB",ue[247]=L(Vn(0)),le[248]="SED",ue[248]=ce(function(){W=1}),le[249]="SBC",ue[249]=B(bn(1)),le[250]="uNOP",ue[250]=e(ce),le[251]="uISB",ue[251]=L(jn(1)),le[252]="uNOP",ue[252]=e(bn(0)),le[253]="SBC",ue[253]=B(bn(0)),le[254]="INC",ue[254]=g(jn(0)),le[255]="uISB",ue[255]=L(jn(0)),this.saveState=function(){return{PC:V,A:H,X:G,Y:J,SP:j,N:N,V:z,D:W,I:Y,Z:X,C:Z,T:Q,o:$,R:0|x,d:q,AD:nn,BA:en,BC:0|tn,IA:rn,bo:an,boa:on}},this.loadState=function(n){V=n.PC,H=n.A,G=n.X,J=n.Y,j=n.SP,N=n.N,z=n.V,W=n.D,Y=n.I,X=n.Z,Z=n.C,Q=n.T,$=n.o,x=!!n.R,q=n.d,nn=n.AD,en=n.BA,tn=!!n.BC,rn=n.IA,an=n.bo,on=n.boa,U=ue[$]},this.toString=function(){return"CPU  PC: "+V.toString(16)+"  op: "+$.toString()+"  T: "+Q+"  data: "+q+"\n A: "+H.toString(16)+"  X: "+G.toString(16)+"  Y: "+J.toString(16)+"  SP: "+j.toString(16)+"     N"+N+"  V"+z+"  D"+W+"  I"+Y+"  Z"+X+"  C"+Z+"  "},this.breakpoint=function(n){var e;jt.Util.log(n),this.trace&&(e="CPU Breakpoint!  "+(n?"("+n+")":"")+"\n\n"+this.toString(),jt.Util.message(e))};var de=[7,6,0,8,3,3,5,5,3,2,2,2,4,4,6,6,2,5,0,8,4,4,6,6,2,4,0,7,4,4,7,7,6,6,0,8,3,3,5,5,4,2,2,2,4,4,6,6,2,5,0,8,4,4,6,6,2,4,0,7,4,4,7,7,6,6,0,8,3,3,5,5,3,2,2,2,3,4,6,6,2,5,0,8,4,4,6,6,2,4,0,7,4,4,7,7,6,6,0,8,3,3,5,5,4,2,2,2,5,4,6,6,2,5,0,8,4,4,6,6,2,4,0,7,4,4,7,7,0,6,0,6,3,3,3,3,2,0,2,0,4,4,4,4,2,6,0,0,4,4,4,4,2,5,2,0,0,5,0,0,2,6,2,6,3,3,3,3,2,2,2,0,4,4,4,4,2,5,0,5,4,4,4,4,2,4,2,0,4,4,4,4,2,6,0,8,3,3,5,5,2,2,2,2,4,4,3,6,2,5,0,8,4,4,6,6,2,4,0,7,4,4,7,7,2,6,0,8,3,3,5,5,2,2,2,0,4,4,6,6,2,5,0,8,4,4,6,6,2,4,0,7,4,4,7,7],fe=[0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,1,0,0,0,1,0,1,0,1,1,1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,1,0,0,0,1,0,1,0,1,1,1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,1,0,0,0,1,0,1,0,1,1,1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,1,0,0,0,1,0,1,0,1,1,1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,1,0,0,0,1,0,1,0,0,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,1,0,0,0,1,0,1,0,1,1,1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,1,0,1,0,0,0,1,0,1,0,1,1,1,0,1],he=[1,2,0,2,2,2,2,2,1,2,1,2,3,3,3,3,2,2,0,2,2,2,2,2,1,3,0,3,3,3,3,3,3,2,0,2,2,2,2,2,1,2,1,2,3,3,3,3,2,2,0,2,2,2,2,2,1,3,0,3,3,3,3,3,1,2,0,2,2,2,2,2,1,2,1,2,3,3,3,3,2,2,0,2,2,2,2,2,1,3,0,3,3,3,3,3,1,2,0,2,2,2,2,2,1,2,1,2,3,3,3,3,2,2,0,2,2,2,2,2,1,3,0,3,3,3,3,3,0,2,0,2,2,2,2,2,1,0,1,0,3,3,3,3,2,2,0,0,2,2,2,3,1,3,1,0,0,3,0,0,2,2,2,2,2,2,2,2,1,2,1,0,3,3,3,3,2,2,0,2,2,2,2,2,1,3,1,0,3,3,3,3,2,2,0,2,2,2,2,2,1,2,1,2,3,3,3,3,2,2,0,2,2,2,2,2,1,3,0,3,3,3,3,3,2,2,0,2,2,2,2,2,1,2,1,0,3,3,3,3,2,2,0,2,2,2,2,2,1,3,0,3,3,3,3,3];Javatari.getOpcodeMetadata=function(n,e){ue[n];return{opcode:n,mnenomic:le[n],minCycles:de[n],maxCycles:de[n]+fe[n],insnlength:he[n]}},this.runCycles=function(n){for(var e=performance.now(),t=0;t<n;t++)this.clockPulse();var r=performance.now();jt.Util.message("Done running "+n+" cycles in "+(r-e)+" ms.")};function pe(n){for(var e=0;0!=Q&&e<20;)O.clockPulse(),e++;for(U=n(),Q=1,V--;0!=Q&&e<20;)O.clockPulse(),e++;return e}this.setNMIAndWait=function(){return pe(I)},this.setIRQAndWait=function(){return pe(R)},this.executeInstruction=function(){for(var n=0;O.clockPulse(),n++,0!=Q&&n<20;);return n},this.getSP=function(){return j},this.getPC=function(){return V-1&65535},this.getT=function(){return Q},this.isPCStable=function(){return 0==Q}},jt.Ram=function(){this.powerOn=function(){},this.powerOff=function(){},this.read=function(n){return a[n&t]},this.write=function(n,e){a[n&t]=e},this.powerFry=function(){for(var n=1-A+2*Math.random()*A,e=n*i,t=0;t<e;t++)a[128*Math.random()|0]&=256*Math.random()|0;for(var r=n*o,t=0;t<r;t++)a[128*Math.random()|0]|=1<<(8*Math.random()|0)},this.saveState=function(){return{b:btoa(jt.Util.uInt8ArrayToByteString(a))}},this.loadState=function(n){a=jt.Util.byteStringToUInt8Array(atob(n.b))};var a=new Array(128),t=127,i=120,o=25,A=.3;!function(){for(var n=a.length-1;0<=n;n--)a[n]=256*Math.random()|0}()},jt.Pia=function(){this.powerOn=function(){},this.powerOff=function(){},this.clockPulse=function(){--D<=0&&r()},this.connectBus=function(n){t=n},this.read=function(n){var e=n&m;return 4==e||6==e?(i(),u):0==e?F:2==e?c:1==e?B:3==e?l:5==e||7==e?d:0},this.write=function(n,e){var t=n&m;if(4!=t)if(5!=t)if(6!=t)if(7!=t)if(2!=t)if(3!=t)if(0!=t){if(1!=t)return 0;A(">>>> Unsupported Write to PIA SWACNT "+e)}else A(">>>> Unsupported Write to PIA SWCHA: "+e);else A(">>>> Ineffective Write to PIA SWBCNT: "+(l=e));else o(e);else a(P=e,1024);else a(p=e,64);else a(h=e,8);else a(f=e,1)};var t,r=function(){D=--u<0?(d|=192,u=255,E=1):E},a=function(n,e){u=n,d&=63,D=E=s=e,r()},i=function(){d&=191,1===E&&(D=E=s)},o=function(n){c=203&c|34&n},A=function(n){self.debug&&jt.Util.log(n)},C=jt.ConsoleControls;this.controlStateChanged=function(n,e){switch(n){case C.JOY0_UP:return void(e?F&=239:F|=16);case C.JOY0_DOWN:return void(e?F&=223:F|=32);case C.PADDLE1_BUTTON:case C.JOY0_LEFT:return void(e?F&=191:F|=64);case C.PADDLE0_BUTTON:case C.JOY0_RIGHT:return void(e?F&=127:F|=128);case C.JOY1_UP:return void(e?F&=254:F|=1);case C.JOY1_DOWN:return void(e?F&=253:F|=2);case C.JOY1_LEFT:return void(e?F&=251:F|=4);case C.JOY1_RIGHT:return void(e?F&=247:F|=8);case C.RESET:return void(e?c&=254:c|=1);case C.SELECT:return void(e?c&=253:c|=2)}if(e)switch(n){case C.BLACK_WHITE:return 0==(8&c)?c|=8:c&=247,void t.getTia().getVideoOutput().showOSD(0!=(8&c)?"COLOR":"B/W",!0);case C.DIFFICULTY0:return 0==(64&c)?c|=64:c&=191,void t.getTia().getVideoOutput().showOSD(0!=(64&c)?"P1 Expert":"P1 Novice",!0);case C.DIFFICULTY1:return 0==(128&c)?c|=128:c&=127,void t.getTia().getVideoOutput().showOSD(0!=(128&c)?"P2 Expert":"P2 Novice",!0)}},this.controlValueChanged=function(n,e){},this.controlsStateReport=function(n){n[C.BLACK_WHITE]=0==(8&c),n[C.DIFFICULTY0]=0!=(64&c),n[C.DIFFICULTY1]=0!=(128&c),n[C.SELECT]=0==(2&c),n[C.RESET]=0==(1&c)},this.saveState=function(){return{t:D,c:E,l:s,SA:F,SAC:B,SB:c,SBC:l,IT:u,IS:d,T1:f,T8:h,T6:p,T2:P}},this.loadState=function(n){D=n.t,E=n.c,s=n.l,F=n.SA,B=n.SAC,c=n.SB,l=n.SBC,u=n.IT,d=n.IS,f=n.T1,h=n.T8,p=n.T6,P=n.T2},this.saveControlsState=function(){return{SA:F,SB:c}},this.loadControlsState=function(n){F=n.SA,c=n.SB},this.debug=!1;var D=1024,E=1024,s=1024,F=255,B=0,c=11,l=0,u=256*Math.random()|0,d=0,f=0,h=0,p=0,P=0,m=7},function(){for(var n=[0,4210752,7105644,9474192,11579568,13158600,14474460,16053492,17476,1074276,2393220,3448992,4241592,5296336,6088936,6880508,10352,1328260,2645144,3963052,5016764,6070476,6862044,7915756,6276,1586328,3166380,4745408,6062288,7378144,8431852,9747708,136,2105500,3947696,5789888,7368912,8947936,10526956,11842812,6029432,7610508,8928416,10246320,11563200,12616912,13671644,14725356,7864392,9445472,10763384,12081292,13398176,14451892,15506628,16560340,8650772,9969712,11287628,12605544,13660284,14715028,15507624,16561340,8912896,10231836,11550776,12606544,13661288,14716028,15508624,16562340,8132608,9451548,11031608,12349520,13404264,14457980,15512720,16566436,6040576,7883804,9463864,11306064,12622952,13939836,15256720,16572580,2898944,4742172,6585400,8428624,9745512,11325564,12641424,13958308,15360,2120736,4226112,6069340,7648372,9228428,10806436,12123320,14356,1858612,3701840,5281900,6861956,8178844,9495732,10812616,12332,1855564,3436648,5016708,6596764,7913652,8967372,10284256,10308,1591396,3172484,4490400,5807288,7124176,8178920,9232636],e=[0,2631720,5263440,7631988,9737364,11842740,13684944,15856113,0,2631720,5263440,7631988,9737364,11842740,13684944,15856113,22656,2125972,3966120,5807292,7384268,8700124,10277100,11591932,23620,2127964,3969140,5811340,7389344,8705200,10283204,11599060,13424,2117768,3958944,5801140,7379144,8695004,10273004,11588860,1336320,3440672,5281852,7123032,8701040,10279044,11856028,13171888,1310832,3416200,5258400,7100596,8679624,10257628,11836652,13152508,6052864,7631904,9210940,10789976,12105840,13158532,14474396,15527088,6029424,7610500,8928404,10246312,11563188,12616900,13671632,14725344,7355392,8935452,10515512,11832400,13149288,14465148,15518864,16572580,7340120,8921196,10501248,11819156,13136036,14451892,15506628,16560340,7348224,8928284,10508344,11826256,13142120,14459004,15512720,16566436,8388668,9707604,11025516,12343424,13398164,14451880,15506616,16560328,8912896,10231840,11549756,12605528,13660272,14713988,15506588,16560304,0,2631720,5263440,7631988,9737364,11842740,13684944,15856113,0,2631720,5263440,7631988,9737364,11842740,13684944,15856113],t=new Array(256),r=new Array(256),a=0,i=n.length;a<i;a++)t[2*a]=t[2*a+1]=n[a]+4278190080,r[2*a]=r[2*a+1]=e[a]+4278190080;n=e=void 0,jt.VideoStandard={NTSC:{name:"NTSC",width:228,height:262,fps:60,palette:t},PAL:{name:"PAL",width:228,height:312,fps:50.38461538461539,palette:r}}}(),jt.TiaVideoSignal=function(){this.connectMonitor=function(n){this.monitor=n},this.nextLine=function(n,e){return!!this.monitor&&this.monitor.nextLine(n,e)},this.finishFrame=function(){this.monitor.synchOutput()},this.signalOff=function(){this.monitor&&this.monitor.nextLine(null,!1)},this.showOSD=function(n,e){this.monitor&&this.monitor.showOSD(n,e)},this.standard=null,this.monitor=null},jt.TiaAudioSignal=function(){this.connectMonitor=function(n){0},this.cartridgeInserted=function(n){a=n&&n.needsAudioClock()?n:null},this.getChannel0=function(){return A},this.getChannel1=function(){return C},this.audioClockPulse=function(){s<e&&i(1)},this.signalOn=function(){o=!0},this.signalOff=function(){o=!1,A.setVolume(0),C.setVolume(0)},this.setFps=function(n){e=Math.round(jt.TiaAudioSignal.SAMPLE_RATE/n),B<e&&(e=B)},this.finishFrame=function(){var n=e-s;0<n&&i(n),s=0},this.retrieveSamples=function(n){D-E>2*Javatari.AUDIO_BUFFER_SIZE&&D--;var e=E<=D?n-(D-E):n-(B-E+D);0<e&&i(e,!0);var t=E+n;B<=t&&(t-=B);var r=u;return r.start=E,E=t,r};var a,i=function(n,e){for(var t,r=n;0<r;r--)a&&a.audioClockPulse(),o?(t=A.nextSample()-C.nextSample())!==F&&(F=t=(9*t+F)/10):t=0,l[D]=t*c,B<=++D&&(D=0);e||(s+=n)},o=!1,A=new jt.TiaAudioChannel,C=new jt.TiaAudioChannel,D=0,E=0,e=jt.TiaAudioSignal.SAMPLE_RATE/jt.VideoStandard.NTSC.fps,s=0,F=0,B=10*Javatari.AUDIO_BUFFER_SIZE,c=.5,l=jt.Util.arrayFill(new Array(B),0),u={buffer:l,bufferSize:B,start:0}},jt.TiaAudioSignal.SAMPLE_RATE=31440,jt.TiaAudioChannel=function(){this.nextSample=function(){return--d<=0&&(d+=u,f=B()),1===f?c:0},this.setVolume=function(n){c=n/b},this.setDivider=function(n){u!==n&&(d=d/u*n,u=n)},this.setControl=function(n){l!==n&&(B=0===(l=n)||11===n?t:1===n?r:2===n?D:3===n?E:4===n||5===n?o:6===n||10===n?C:7===n||9===n?a:8===n?i:12===n||13===n?A:14===n?s:15===n?F:t)};function n(){return S[g]}function e(){return L[k]}var t=function(){return 1},r=function(){return 15==++g&&(g=0),S[g]},a=function(){return 31==++v&&(v=0),y[v]},i=function(){var n=1&m,e=1&(m>>4^n);return m>>>=1,0==e?m&=255:m|=256,n},o=function(){return 1===u?1:h=h?0:1},A=function(){return 0==--P&&(P=3,p=p?0:1),p},C=function(){return 31==++k&&(k=0),L[k]},D=function(){return(e()!==C()?r:n)()},E=function(){return(a()?r:n)()},s=function(){return e()!=C()?A():p},F=function(){return a()?A():p},B=t,c=0,l=0,u=1,d=1,f=0,h=1,p=1,P=3,m=511,g=14,S=[1,1,1,1,0,0,0,1,0,0,1,1,0,1,0],v=30,y=[1,1,1,1,1,0,0,0,1,1,0,1,1,1,0,1,0,1,0,0,0,0,1,0,0,1,0,1,1,0,0],k=30,L=[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0],b=15},jt.Tia=function(n,e){var t=this;this.powerOn=function(){jt.Util.arrayFill(wn,Dn),jt.Util.arrayFill(We,0),Ft.getChannel0().setVolume(0),Ft.getChannel1().setVolume(0),R(),_(),tt=!0,Ft.signalOn(),0},this.powerOff=function(){st.signalOff(),Ft.signalOff()},this.disableDebug=function(){Ze=null},this.setDebugCondition=function(n){Ze=n},this.frame=function(){if(!(Ye&&Xe--<=0)){var n=Ze,e=-1,t=Javatari.DEBUG_SCANLINE_OVERFLOW;do{for(j=0,n&&e<0&&n()&&(e=j),V.clockPulse(),t&&Tn.isRDY()&&console.log("Scan overflow @ "+Tn.saveState().PC.toString(16)),Tn.setRDY(!0),j=3;j<an;j+=3)nt||w(),n&&e<0&&n()&&(e=j),V.clockPulse();Ft.audioClockPulse();var r=2;for(j=68;j<on;j++)nt||w(),Mn&&T(),0==--r&&(n&&e<0&&n()&&(e=j),V.clockPulse(),r=3),h(),nt||!(76<=j)&&Ve||a();Ft.audioClockPulse(),i()}while(!st.nextLine(wn,Rn));Ft.finishFrame(),st.finishFrame()}},this.connectBus=function(n){V=n},this.getVideoOutput=function(){return st},this.getAudioOutput=function(){return Ft},this.setVideoStandard=function(n){st.standard=n,G=n===jt.VideoStandard.NTSC?jt.VideoStandard.NTSC.palette:jt.VideoStandard.PAL.palette},this.debug=function(n){Je=0!==(Ne=4<n?0:n),st.showOSD(Je?"Debug Level "+Ne:"Debug OFF",!0),Tn.debug=Je,((_n.debug=Je)?K:O)()},this.read=function(n){var e=n&Ln;return 0==e?Bt:1==e?ct:2==e?lt:3==e?ut:4==e?dt:5==e?ft:6==e?ht:7==e?pt:8==e?Pt:9==e?mt:10==e?gt:11==e?St:12==e?vt:13==e?yt:0},this.write=function(n,e){var t=n&bn;if(27!=t)if(28!=t){if(2==t)return Tn.setRDY(!1),void(Je&&I(yn));if(42!=t)if(13!=t)if(14!=t)if(15!=t){if(6==t)return _(),void(Je||(Xn=fe=G[e]));if(7==t)return _(),void(Je||(Ae=ve=G[e]));if(8==t)return _(),void(Je||(xn=Re=G[e]));if(9==t)return _(),void(Je||(Vn=G[e]));if(29==t)return _(),void(de=0!=(2&e));if(30==t)return _(),void(Se=0!=(2&e));if(20!=t)if(16!=t)if(17!=t)if(18!=t)if(19!=t)if(32!=t)if(33!=t)if(34!=t)if(35!=t)if(36!=t)if(43!=t)if(31!=t)if(4!=t)if(5!=t)if(10!=t){if(11==t)return _(),void(ae=0!=(8&e));if(12==t)return _(),void(ue=0!=(8&e));if(37==t)return _(),void(ne=0!=(1&e));if(38==t)return _(),void(Fe=0!=(1&e));if(39==t)return _(),void(Oe=0!=(1&e));if(21==t)return W=e,void Ft.getChannel0().setControl(15&e);if(22==t)return Y=e,void Ft.getChannel1().setControl(15&e);if(23==t)return X=e,void Ft.getChannel0().setDivider(1+(31&e));if(24==t)return Z=e,void Ft.getChannel1().setDivider(1+(31&e));if(25==t)return Q=e,void Ft.getChannel0().setVolume(15&e);if(26==t)return $=e,void Ft.getChannel1().setVolume(15&e);if(40!=t)if(41!=t){if(1!=t)return 0==t?(_(),Rn=0!=(2&e),void(Je&&I(En))):44==t?(_(),void(Bt=ct=lt=ut=dt=ft=ht=pt=0)):0;b(e)}else L(e);else k(e)}else s(e);else E(e);else D(e);else A(e);else q=nn=en=tn=rn=0;else rn=127<e?(e>>>4)-16:e>>>4;else tn=127<e?(e>>>4)-16:e>>>4;else en=127<e?(e>>>4)-16:e>>>4;else nn=127<e?(e>>>4)-16:e>>>4;else q=127<e?(e>>>4)-16:e>>>4;else l();else c();else B();else F();else u()}else z==e&&2!==Nn||r(2,e);else N==e&&1!==Nn||r(1,e);else J==e&&0!==Nn||r(0,e);else d()}else v(1,e);else v(0,e)};var a=function(){var n,e,t,r,a,i,o,A;Rn?wn[j]=Qe:In?wn[j]=$e:(i=a=r=t=e=n=!1,0!=(3&j)&&j!==et||C(),Gn&&(0<=Me&&Me<=7&&(y(),_e&&(i=!0,o=Re)),Un&&(a=!0,o=o||xn)),0<=$n&&$n<=31&&(y(),0!=(A=ne?Wn:Yn)&&0!=(A>>(ae?7-($n>>>2):$n>>>2)&1)&&(n=!0,o=o||Xn)),0<=Pe&&de&&Pe<=7&&!ge&&(t=!0,0<!o&&(o=fe)),0<=Ee&&Ee<=31&&(y(),0!==(A=Fe?ie:oe)&&0!=(A>>(ue?7-(Ee>>>2):Ee>>>2)&1)&&(e=!0,o=o||Ae)),0<=Le&&Se&&Le<=7&&!Te&&(r=!0,o=o||ve),Gn||(0<=Me&&Me<=7&&(y(),_e&&(i=!0,o=o||Re)),Un&&(a=!0,o=o||(Hn?j<148?Xn:Ae:xn))),o=o||Vn,wn[j]=o,ze||(n&&a&&(lt|=128),e&&(a&&(ut|=128),n&&(pt|=128)),i&&(a&&(ht|=128),n&&(lt|=64),e&&(ut|=64)),t&&(e&&(Bt|=128),n&&(Bt|=64),a&&(dt|=128),i&&(dt|=64)),r&&(n&&(ct|=128),e&&(ct|=64),a&&(ft|=128),i&&(ft|=64),t&&(pt|=64))))},i=function(){0<=At&&!ot&&(Pt<128&&++Ct>=At&&(Pt|=128),mt<128&&++Et>=Dt&&(mt|=128)),Ve&&(wn[an]=wn[an+1]=wn[an+2]=wn[an+3]=wn[an+4]=wn[an+5]=wn[an+6]=wn[an+7]=qe,Ve=!1),He&&(He=!1,Ve=Ge,f()),tt=tt&&!(et=227),2<=Ne&&M()},C=function(){if(o(!1),On){if(On=!1,0===J&&0===N&&0===z)return jt.Util.arrayFill(Kn,!1),void(Un=!1);var n,e=jn?(n=40,-1):(n=19,1);Kn[0]=Kn[n+=e]=0!=(16&J),Kn[1]=Kn[n+=e]=0!=(32&J),Kn[2]=Kn[n+=e]=0!=(64&J),Kn[3]=Kn[n+=e]=0!=(128&J),Kn[4]=Kn[n+=e]=0!=(128&N),Kn[5]=Kn[n+=e]=0!=(64&N),Kn[6]=Kn[n+=e]=0!=(32&N),Kn[7]=Kn[n+=e]=0!=(16&N),Kn[8]=Kn[n+=e]=0!=(8&N),Kn[9]=Kn[n+=e]=0!=(4&N),Kn[10]=Kn[n+=e]=0!=(2&N),Kn[11]=Kn[n+=e]=0!=(1&N),Kn[12]=Kn[n+=e]=0!=(1&z),Kn[13]=Kn[n+=e]=0!=(2&z),Kn[14]=Kn[n+=e]=0!=(4&z),Kn[15]=Kn[n+=e]=0!=(8&z),Kn[16]=Kn[n+=e]=0!=(16&z),Kn[17]=Kn[n+=e]=0!=(32&z),Kn[18]=Kn[n+=e]=0!=(64&z),Kn[19]=Kn[n+=e]=0!=(128&z)}Un=Kn[j-an>>>2]},r=function(n,e){_(),Je&&I(pn),o(!0),Jn=j,Nn=n,zn=e},o=function(n){if(-1!==Nn){if(!n){var e=j-Jn;if(0==e||1==e)return}_(),0===Nn?J=zn:1===Nn?N=zn:2===Nn&&(z=zn),On=!0,Nn=-1}},A=function(n){_(),we=0!=(2&n),Oe||(_e=we)},D=function(n){_();var e=48&n;0===e?e=8:16===e?e=4:32===e?e=2:48===e&&(e=1),me!==e&&(7<Pe?Pe=7+(Pe-7)/me*e:0<=Pe&&(Pe=-1),me=e),5==(7&n)?ee=te=re=!(e=2):7==(7&n)?ee=te=re=!(e=1):(ee=0!=(1&n),te=0!=(2&n),re=0!=((e=4)&n)),qn!==e&&(31<$n?$n=31+($n-31)/qn*e:0<=$n&&($n=-1),qn=e)},E=function(n){_();var e=48&n;0===e?e=8:16===e?e=4:32===e?e=2:48===e&&(e=1),be!==e&&(7<Le?Le=7+(Le-7)/be*e:0<=Le&&(Le=-1),be=e),5==(7&n)?Be=ce=le=!(e=2):7==(7&n)?Be=ce=le=!(e=1):(Be=0!=(1&n),ce=0!=(2&n),le=0!=((e=4)&n)),se!==e&&(31<Ee?Ee=31+(Ee-31)/se*e:0<=Ee&&(Ee=-1),se=e)},s=function(n){_();var e=0!=(1&n);jn!=e&&(jn=e,On=!0),Hn=0!=(2&n),Gn=0!=(4&n);var t=48&n;0===t?t=8:16===t?t=4:32===t?t=2:48===t&&(t=1),Ke!==t&&(7<Me?Me=7+(Me-7)/Ke*t:0<=Me&&(Me=-1),Ke=t)},F=function(){if(_(),tt=!0,Je&&I(Fn),an+(Ve?7:0)<=j)return 155!==Qn&&(Zn=!0),void(Qn=155);var n=0;Ve&&(an<=j?n=an-j+8:8<(n=j-je-4>>2)&&(n=8)),Zn=(Qn=157-n)<=155},B=function(){if(_(),tt=!0,Je&&I(ln),an+(Ve?7:0)<=j)return 155!==De&&(Ce=!0),void(De=155);var n=0;Ve&&(an<=j?n=an-j+8:8<(n=j-je-4>>2)&&(n=8)),Ce=(De=157-n)<=155},c=function(){if(_(),tt=!0,Je&&I(dn),an+(Ve?7:0)<=j)return 155!==pe&&(he=!0),void(pe=155);var n=0;Ve&&(an<=j?n=an-j+8:8<(n=j-je-4>>2)&&(n=8)),he=(pe=157-n)<=155},l=function(){if(_(),tt=!0,Je&&I(fn),an+(Ve?7:0)<=j)return 155!==ke&&(ye=!0),void(ke=155);var n=0;Ve&&(an<=j?n=an-j+8:8<(n=j-je-4>>2)&&(n=8)),ye=(ke=157-n)<=155},u=function(){var n;_(),Je&&I(mn),Ie=an+(Ve?7:0)<=j?155:(n=0,Ve&&(an<=j?n=an-j+8:8<(n=j-je-4>>2)&&(n=8)),157-n)},d=function(){if(Je&&I(kn),j<an)return je=j,Ve=!0,void f();j<219?U("Unsupported HMOVE hit"):(je=160-j,He=!0,Ge=225<=j)},f=function(){var n=!1,e=Ve?q:q+8;if(0!==e)if(n=!0,0<e)for(var t=e;0<t;t--)p();else(Qn+=e)<0&&(Qn+=160),0<=$n&&($n-=qn*e);if(0!==(e=Ve?nn:nn+8))if(n=!0,0<e)for(t=e;0<t;t--)P();else(De+=e)<0&&(De+=160),0<=Ee&&(Ee-=se*e);if(0!==(e=Ve?en:en+8))if(n=!0,0<e)for(t=e;0<t;t--)m();else(pe+=e)<0&&(pe+=160),0<=Pe&&(Pe-=me*e);if(0!=(e=Ve?tn:tn+8))if(n=!0,0<e)for(t=e;0<t;t--)g();else(ke+=e)<0&&(ke+=160),0<=Le&&(Le-=be*e);if(0!=(e=Ve?rn:rn+8))if(n=!0,0<e)for(t=e;0<t;t--)S();else(Ie+=e)<0&&(Ie+=160),0<=Me&&(Me-=Ke*e);n&&_()},h=function(){p(),P(),m(),g(),S()},p=function(){160==++Qn&&(Qn=0),0<=$n&&(ge&&Qn<12&&28<=$n&&$n<=31&&(pe=156),$n-=qn),156===Qn?Zn?Zn=!1:$n=31+qn*(4===qn?5:6):12===Qn?ee&&($n=31+5*qn):28===Qn?te&&($n=31+5*qn):60===Qn&&re&&($n=31+5*qn)},P=function(){160==++De&&(De=0),0<=Ee&&(Te&&De<12&&28<=Ee&&Ee<=31&&(ke=156),Ee-=se),156===De?Ce?Ce=!1:Ee=31+se*(4===se?5:6):12===De?Be&&(Ee=31+5*se):28===De?ce&&(Ee=31+5*se):60===De&&le&&(Ee=31+5*se)},m=function(){160==++pe&&(pe=0),0<=Pe&&(Pe-=me),156===pe?he?he=!1:Pe=7+4*me:12===pe?ee&&(Pe=7+4*me):28===pe?te&&(Pe=7+4*me):60===pe&&re&&(Pe=7+4*me)},g=function(){160==++ke&&(ke=0),0<=Le&&(Le-=be),156===ke?ye?ye=!1:Le=7+4*be:12===ke?Be&&(Le=7+4*be):28===ke?ce&&(Le=7+4*be):60===ke&&le&&(Le=7+4*be)},S=function(){160==++Ie&&(Ie=0),0<=Me&&(Me-=Ke),156===Ie&&(Me=7+4*Ke)},v=function(n,e){_(),Je&&I(0===n?Bn:un),An<=xe?U(">>> Max player delayed changes reached: "+An):(Ue[xe][0]=j,Ue[xe][1]=n,Ue[xe][2]=e,xe++)},y=function(){if(0!==xe&&Ue[0][0]!==j){for(var n=0;n<xe;n++){var e=Ue[n];0===e[1]?(Yn=e[2],ie=oe):(oe=e[2],Wn=Yn,_e=we)}xe=0}},k=function(n){_(),(ge=0!=(2&n))&&(de=!1)},L=function(n){_(),(Te=0!=(2&n))&&(Se=!1)},b=function(n){0!=(2&n)!==In&&(Mn=!0,H=!In),0!=(64&n)?rt=!0:(rt=!1,at?vt&=127:vt|=128,it?yt&=127:yt|=128),0!=(128&n)?(ot=!0,Ct=Et=0,Pt&=127,mt&=127,gt&=127,St&=127):ot=!1},T=function(){Mn=!1,In=H,Je&&I(vn),_()},_=function(){et=j,nt=nt&&!1},w=function(){j===et&&(nt=!0,et=-1)},R=function(){Bt=ct=lt=ut=dt=ft=ht=pt=0,Pt=mt=gt=St=0,vt=yt=128},I=function(n){We[j]=n},M=function(){if(jt.Util.arrayFillSegment(wn,0,an,qe),4<=Ne&&st.monitor.currentLine()%10==0)for(var n=0;n<on;n++)0===We[n]&&(n<an?n%6!=0&&66!=n&&63!=n||(We[n]=gn):(n-an-1)%6==0&&(We[n]=gn));if(3<=Ne)for(n=0;n<on;n++)0!=We[n]&&(wn[n]=We[n],We[n]=0);_()},K=function(){Xn=sn,Ae=cn,fe=dn,ve=fn,Re=mn,xn=hn,Vn=Pn,qe=1<=Ne?Sn:Dn,$e=2<=Ne?vn:Cn},O=function(){qe=Dn,$e=Cn,Vn=G[0],jt.Util.arrayFill(wn,qe),_()},U=function(n){Je&&jt.Util.log("Line: "+st.monitor.currentLine()+", Pixel: "+j+". "+n)},x=jt.ConsoleControls;this.controlStateChanged=function(n,e){switch(n){case x.JOY0_BUTTON:return void(e?(at=!0,vt&=127):(at=!1,rt||(vt|=128)));case x.JOY1_BUTTON:return void(e?(it=!0,yt&=127):(it=!1,rt||(yt|=128)))}if(e)switch(n){case x.DEBUG:return void t.debug(Ne+1);case x.NO_COLLISIONS:return ze=!ze,void st.showOSD(ze?"Collisions OFF":"Collisions ON",!0);case x.PAUSE:return Ye=!Ye,Xe=1,void st.showOSD(Ye?"PAUSE":"RESUME",!0);case x.FRAME:return void(Ye&&(Xe=1));case x.TRACE:return void(Tn.trace=!Tn.trace)}},this.controlValueChanged=function(n,e){switch(n){case x.PADDLE0_POSITION:return void(At=e);case x.PADDLE1_POSITION:return void(Dt=e)}},this.controlsStateReport=function(n){},this.saveState=function(){return{lp:btoa(jt.Util.uInt32ArrayToByteString(wn)),lo:et,oc:0|tt,rl:0|nt,vs:0|Rn,vb:0|In,vbd:0|Mn,vbn:0|H,f:jt.Util.booleanArrayToByteString(Kn),fi:0|On,fp:0|Un,fc:xn,fb:Vn,fr:0|jn,fs:0|Hn,ft:0|Gn,p0:Wn,p0d:Yn,p0c:Xn,p0rr:0|Zn,p0co:Qn,p0sc:$n,p0ss:qn,p0v:0|ne,p0cc:0|ee,p0mc:0|te,p0wc:0|re,p0r:0|ae,p1:ie,p1d:oe,p1c:Ae,p1rr:0|Ce,p1co:De,p1sc:Ee,p1ss:se,p1v:0|Fe,p1cc:0|Be,p1mc:0|ce,p1wc:0|le,p1r:0|ue,m0:0|de,m0c:fe,m0rr:0|he,m0co:pe,m0sc:Pe,m0ss:me,m0r:0|ge,m1:0|Se,m1c:ve,m1rr:0|ye,m1co:ke,m1sc:Le,m1ss:be,m1r:0|Te,b:0|_e,bd:0|we,bc:Re,bco:Ie,bsc:Me,bss:Ke,bv:0|Oe,fd:Jn,fdc:Nn,fdp:zn,pds:btoa(jt.Util.uInt8BiArrayToByteString(Ue)),pdc:xe,hb:0|Ve,hc:je,PF0:J,PF1:N,PF2:z,AC0:W,AC1:Y,AF0:X,AF1:Z,AV0:Q,AV1:$,HP0:q,HP1:nn,HM0:en,HM1:tn,HB:rn,XM0P:Bt,XM1P:ct,XP0F:lt,XP1F:ut,XM0F:dt,XM1F:ft,XBP:ht,XPM:pt}},this.loadState=function(n){wn=jt.Util.byteStringToUInt32Array(atob(n.lp)),et=n.lo,tt=!!n.oc,nt=!!n.rl,Rn=!!n.vs,In=!!n.vb,Mn=!!n.vbd,H=!!n.vbn,Kn=jt.Util.byteStringToBooleanArray(n.f),On=!!n.fi,Un=!!n.fp,xn=n.fc,Vn=n.fb,jn=!!n.fr,Hn=!!n.fs,Gn=!!n.ft,Wn=n.p0,Yn=n.p0d,Xn=n.p0c,Zn=!!n.p0rr,Qn=n.p0co,$n=n.p0sc,qn=n.p0ss,ne=!!n.p0v,ee=!!n.p0cc,te=!!n.p0mc,re=!!n.p0wc,ae=!!n.p0r,ie=n.p1,oe=n.p1d,Ae=n.p1c,Ce=!!n.p1rr,De=n.p1co,Ee=n.p1sc,se=n.p1ss,Fe=!!n.p1v,Be=!!n.p1cc,ce=!!n.p1mc,le=!!n.p1wc,ue=!!n.p1r,de=!!n.m0,fe=n.m0c,he=!!n.m0rr,pe=n.m0co,Pe=n.m0sc,me=n.m0ss,ge=!!n.m0r,Se=!!n.m1,ve=n.m1c,ye=!!n.m1rr,ke=n.m1co,Le=n.m1sc,be=n.m1ss,Te=!!n.m1r,_e=!!n.b,we=!!n.bd,Re=n.bc,Ie=n.bco,Me=n.bsc,Ke=n.bss,Oe=!!n.bv,Jn=n.fd,Nn=n.fdc,zn=n.fdp,Ue=jt.Util.byteStringToUInt8BiArray(atob(n.pds),3),xe=n.pdc,Ve=!!n.hb,je=n.hc,J=n.PF0,N=n.PF1,z=n.PF2,W=n.AC0,Ft.getChannel0().setControl(15&W),Y=n.AC1,Ft.getChannel1().setControl(15&Y),X=n.AF0,Ft.getChannel0().setDivider(1+(31&X)),Z=n.AF1,Ft.getChannel1().setDivider(1+(31&Z)),Q=n.AV0,Ft.getChannel0().setVolume(15&Q),$=n.AV1,Ft.getChannel1().setVolume(15&$),q=n.HP0,nn=n.HP1,en=n.HM0,tn=n.HM1,rn=n.HB,Bt=n.XM0P,ct=n.XM1P,lt=n.XP0F,ut=n.XP1F,dt=n.XM0F,ft=n.XM1F,ht=n.XBP,pt=n.XPM,Je&&K()},this.saveControlsState=function(){return{P0btn:at,P1btn:it,Pground:ot,P0pos:At,P0chg:Ct,P1pos:Dt,P1chg:Et}},this.loadControlsState=function(n){at=n.P0btn,it=n.P1btn,ot=n.Pground,At=n.P0pos,Ct=n.P0chg,Dt=n.P1pos,Et=n.P1chg};var V,j,H,G,J,N,z,W,Y,X,Z,Q,$,q,nn,en,tn,rn,an=68,on=228,An=50,Cn=4278190080,Dn=4278190080,En=4292730333,sn=4278190335,Fn=4280427195,Bn=4279308663,cn=4294901760,ln=4290454050,un=4285993233,dn=4284901119,fn=4294927974,hn=4282681412,pn=4281589043,Pn=4281549875,mn=4278255615,gn=4280295456,Sn=4282664004,vn=4280953386,yn=4287103112,kn=4294967295,Ln=15,bn=63,Tn=n,_n=e,wn=jt.Util.arrayFill(new Array(on),0),Rn=!1,In=!1,Mn=!1,Kn=jt.Util.arrayFill(new Array(40),!1),On=!0,Un=!1,xn=4278190080,Vn=4278190080,jn=!1,Hn=!1,Gn=!1,Jn=-1,Nn=-1,zn=-1,Wn=0,Yn=0,Xn=4278190080,Zn=!1,Qn=0,$n=-1,qn=4,ne=!1,ee=!1,te=!1,re=!1,ae=!1,ie=0,oe=0,Ae=4278190080,Ce=!1,De=0,Ee=-1,se=4,Fe=!1,Be=!1,ce=!1,le=!1,ue=!1,de=!1,fe=4278190080,he=!1,pe=0,Pe=-1,me=8,ge=!1,Se=!1,ve=4278190080,ye=!1,ke=0,Le=-1,be=8,Te=!1,_e=!1,we=!1,Re=4278190080,Ie=0,Me=-1,Ke=8,Oe=!1,Ue=jt.Util.arrayFillWithArrayClone(new Array(An),[0,0,0]),xe=0,Ve=!1,je=-1,He=!1,Ge=!1,Je=!1,Ne=0,ze=!1,We=jt.Util.arrayFill(new Array(on),0),Ye=!1,Xe=0,Ze=null,Qe=En,$e=Cn,qe=Cn,nt=!1,et=-1,tt=!1,rt=!1,at=!1,it=!1,ot=!1,At=-1,Ct=0,Dt=-1,Et=0,st=new jt.TiaVideoSignal,Ft=new jt.TiaAudioSignal,Bt=0,ct=0,lt=0,ut=0,dt=0,ft=0,ht=0,pt=0,Pt=0,mt=0,gt=0,St=0,vt=0,yt=0},jt.Bus=function(n,e,t,r){var a,i,o,A,C;this.powerOn=function(){s=0,C||(i.getVideoOutput().showOSD("NO CARTRIDGE INSERTED!",!0),s=256*Math.random()|0),null!=C&&C.powerOn(),A.powerOn(),o.powerOn(),a.powerOn(),i.powerOn()},this.powerOff=function(){i.powerOff(),a.powerOff(),o.powerOff(),A.powerOff()},this.setCartridge=function(n){(C=n)&&(s=0,C.connectBus(this)),E=C&&C.needsBusMonitoring()},this.getCartridge=function(){return C},this.getTia=function(){return i},this.clockPulse=function(){o.clockPulse(),a.clockPulse()},this.read=function(n){return E&&C.monitorBusBeforeRead(n,s),(n&F)===B?C&&(s=C.read(n)):s=(n&c)===l?A.read(n):(n&f)===h?o.read(n):63&s|i.read(n),s};var D,E=!(this.write=function(n,e){E&&C.monitorBusBeforeWrite(n,e),s=e,(n&u)===d?i.write(n,e):(n&c)===l?A.write(n,e):(n&f)===h?o.write(n,e):C&&C.write(n,e)}),s=0,F=4096,B=4096,c=4736,l=128,u=4224,d=0,f=4736,h=640;D=this,i=e,o=t,A=r,(a=n).connectBus(D),i.connectBus(D),o.connectBus(D)},jt.Clock=function(n,e){this.go=function(){o||(o=!0,A||r())},this.pauseOnNextPulse=function(){o=!1},this.setFrequency=function(n){A?(i(),t(n),a()):t(n)};var t=function(n){C=1e3/n,D=window.requestAnimationFrame&&n===F},r=function(){if(!o)return i(),void(A=!1);A=!0,n.clockPulse(),a()},a=function(){D?E=window.requestAnimationFrame(r):s=s||window.setInterval(r,C)},i=function(){E&&(window.cancelAnimationFrame(E),E=null),s&&(window.clearTimeout(s),s=null)},o=!(this.isRunning=function(){return o}),A=!1,C=null,D=null,E=null,s=null,F=Javatari.SCREEN_NATURAL_FPS;t(e||F)},jt.ConsoleControls={JOY0_UP:11,JOY0_DOWN:12,JOY0_LEFT:13,JOY0_RIGHT:14,JOY0_BUTTON:15,JOY1_UP:21,JOY1_DOWN:22,JOY1_LEFT:23,JOY1_RIGHT:24,JOY1_BUTTON:25,PADDLE0_POSITION:31,PADDLE1_POSITION:41,PADDLE0_BUTTON:35,PADDLE1_BUTTON:45,POWER:51,BLACK_WHITE:52,SELECT:53,RESET:54,DIFFICULTY0:55,DIFFICULTY1:56,POWER_OFF:61,DEBUG:101,NO_COLLISIONS:102,TRACE:103,PAUSE:104,FRAME:105,FAST_SPEED:106,CARTRIDGE_FORMAT:107,CARTRIDGE_CLOCK_DEC:108,CARTRIDGE_CLOCK_INC:109,CARTRIDGE_REMOVE:110,VIDEO_STANDARD:111,POWER_FRY:112,SAVE_STATE_0:{to:0},SAVE_STATE_1:{to:1},SAVE_STATE_2:{to:2},SAVE_STATE_3:{to:3},SAVE_STATE_4:{to:4},SAVE_STATE_5:{to:5},SAVE_STATE_6:{to:6},SAVE_STATE_7:{to:7},SAVE_STATE_8:{to:8},SAVE_STATE_9:{to:9},SAVE_STATE_10:{to:10},SAVE_STATE_11:{to:11},SAVE_STATE_12:{to:12},LOAD_STATE_0:{from:0},LOAD_STATE_1:{from:1},LOAD_STATE_2:{from:2},LOAD_STATE_3:{from:3},LOAD_STATE_4:{from:4},LOAD_STATE_5:{from:5},LOAD_STATE_6:{from:6},LOAD_STATE_7:{from:7},LOAD_STATE_8:{from:8},LOAD_STATE_9:{from:9},LOAD_STATE_10:{from:10},LOAD_STATE_11:{from:11},LOAD_STATE_12:{from:12},SAVE_STATE_FILE:201,playerDigitalControls:[11,12,13,14,15,21,22,23,24,25,35,45]},jt.AtariConsole=function(){function n(){this.insert=function(n,e){e&&a.powerIsOn&&a.powerOff(),i(n),e&&!a.powerIsOn&&a.powerOn()},this.inserted=function(){return p()},this.cartridgeInserted=function(n,e){for(var t=0;t<r.length;t++)r[t].cartridgeInserted(n,e)},this.addInsertionListener=function(n){r.indexOf(n)<0&&(r.push(n),n.cartridgeInserted(this.inserted()))},this.removeInsertionListener=function(n){jt.Util.arrayRemove(r,n)};var r=[]}function e(){var e;this.connectControls=function(n){e=n},this.cartridgeInserted=function(n,e){e&&l.removeForwardedInput(e),n&&l.addForwardedInput(n)},this.clockPulse=function(){e.clockPulse()},this.controlStateChanged=function(n,e){for(var t=0;t<a;t++)r[t].controlStateChanged(n,e)},this.controlValueChanged=function(n,e){for(var t=0;t<a;t++)r[t].controlValueChanged(n,e)},this.controlsStateReport=function(n){for(var e=0;e<a;e++)r[e].controlsStateReport(n)},this.addForwardedInput=function(n){r.push(n),a=r.length},this.removeForwardedInput=function(n){jt.Util.arrayRemove(r,n),a=r.length},this.addRedefinitionListener=function(n){t.indexOf(n)<0&&(t.push(n),n.controlsStatesRedefined())},this.controlsStatesRedefined=function(){for(var n=0;n<t.length;n++)t[n].controlsStatesRedefined()};var r=[],a=0,t=[]}function t(){var t;this.connectMedia=function(n){t=n},this.getMedia=function(){return t},this.cartridgeInserted=function(n){n&&n.connectSaveStateSocket(this)},this.externalStateChange=function(){},this.saveState=function(n){var e;a.powerIsOn&&t&&((e=S()).v=r,t.saveState(n,e)?a.showOSD("State "+n+" saved",!0):a.showOSD("State "+n+" save failed",!0))},this.loadState=function(n){var e;t&&((e=t.loadState(n))?e.v===r?(A(e),a.showOSD("State "+n+" loaded",!0)):a.showOSD("State "+n+" load failed, wrong version",!0):a.showOSD("State "+n+" not found",!0))},this.saveStateFile=function(){var n,e;a.powerIsOn&&t&&(n=u.inserted()&&u.inserted().rom.info.l,(e=S()).v=r,t.saveStateFile(n,e)?a.showOSD("State Cartridge saved",!0):a.showOSD("State Cartridge save failed",!0))},this.loadStateFile=function(n){if(t){var e=t.loadStateFile(n);if(e)return e.v!==r?a.showOSD("State Cartridge load failed, wrong version",!0):(A(e),a.showOSD("State Cartridge loaded",!0)),!0}};var r=1}var a=this;this.powerOn=function(n){this.powerIsOn&&this.powerOff(),F.powerOn(),this.powerIsOn=!0,l.controlsStatesRedefined(),m(),n||f()},this.powerOff=function(){h(),F.powerOff(),this.powerIsOn=!1,l.controlsStatesRedefined()},this.clockPulse=function(){b&&g(),0<K&&(M-=K,K=0,I=S()),O=K,l.clockPulse(),E.frame(),this.framesGenerated++},this.getCartridgeSocket=function(){return u},this.getControlsSocket=function(){return l},this.getVideoOutput=function(){return E.getVideoOutput()},this.getAudioOutput=function(){return E.getAudioOutput()},this.getSavestateSocket=function(){return d},this.showOSD=function(n,e){this.getVideoOutput().showOSD(n,e)};function i(n){Javatari.cartridge=n;var e=p();F.setCartridge(n),u.cartridgeInserted(n,e)}function r(n){c!==n&&(c=n,E.setVideoStandard(c),v()),a.showOSD((L?"AUTO: ":"")+c.name,!1)}function o(n){L=!1,r(n)}function A(n){a.powerIsOn||a.powerOn(),E.loadState(n.t),D.loadState(n.p),s.loadState(n.r),C.loadState(n.c),i(n.ca&&jt.CartridgeDatabase.createCartridgeFromSaveState(n.ca)),r(jt.VideoStandard[n.vs]),l.controlsStatesRedefined()}var C,D,E,s,F,B,c,l,u,d,f=function(){B.go()},h=function(){B.pauseOnNextPulse()},p=function(){return F.getCartridge()},P=function(){L=!0,a.powerIsOn?m():r(jt.VideoStandard.NTSC)},m=function(){L&&!b&&(F.getCartridge()?E.getVideoOutput().monitor&&(b=!0,T=0,E.getVideoOutput().monitor.videoStandardDetectionStart()):r(jt.VideoStandard.NTSC))},g=function(){T++;var n=E.getVideoOutput().monitor.getVideoStandardDetected();!n&&T<_||(n?r(n):a.showOSD("AUTO: FAILED",!1),b=!1)},S=function(){return{t:E.saveState(),p:D.saveState(),r:s.saveState(),c:C.saveState(),ca:p()&&p().saveState(),vs:c.name}},v=function(){var n=c.fps;B.setFrequency(n),E.getAudioOutput().setFps(n)},y=function(){a.cpu=C=new jt.M6502,a.pia=D=new jt.Pia,a.tia=E=new jt.Tia(C,D),a.ram=s=new jt.Ram,a.bus=F=new jt.Bus(C,E,D,s),a.mainClock=B=new jt.Clock(a,jt.VideoStandard.NTSC.fps)},k=function(){(l=new e).addForwardedInput(a),l.addForwardedInput(E),l.addForwardedInput(D),(u=new n).addInsertionListener(E.getAudioOutput()),u.addInsertionListener(l),d=new t,u.addInsertionListener(d)};this.powerIsOn=!1,this.framesGenerated=0;var L=!1,b=!1,T=0,_=90,w=jt.ConsoleControls;this.controlStateChanged=function(n,e){if(n!=w.FAST_SPEED){if(e)switch(n){case w.POWER:a.powerIsOn?a.powerOff():a.powerOn();break;case w.POWER_OFF:a.powerIsOn&&a.powerOff();break;case w.POWER_FRY:s.powerFry();break;case w.SAVE_STATE_0:case w.SAVE_STATE_1:case w.SAVE_STATE_2:case w.SAVE_STATE_3:case w.SAVE_STATE_4:case w.SAVE_STATE_5:case w.SAVE_STATE_6:case w.SAVE_STATE_7:case w.SAVE_STATE_8:case w.SAVE_STATE_9:case w.SAVE_STATE_10:case w.SAVE_STATE_11:case w.SAVE_STATE_12:d.saveState(n.to);break;case w.SAVE_STATE_FILE:d.saveStateFile();break;case w.LOAD_STATE_0:case w.LOAD_STATE_1:case w.LOAD_STATE_2:case w.LOAD_STATE_3:case w.LOAD_STATE_4:case w.LOAD_STATE_5:case w.LOAD_STATE_6:case w.LOAD_STATE_7:case w.LOAD_STATE_8:case w.LOAD_STATE_9:case w.LOAD_STATE_10:case w.LOAD_STATE_11:case w.LOAD_STATE_12:d.loadState(n.from);break;case w.VIDEO_STANDARD:a.showOSD(null,!0),L?o(jt.VideoStandard.NTSC):c==jt.VideoStandard.NTSC?o(jt.VideoStandard.PAL):P();break;case w.CARTRIDGE_FORMAT:break;case w.CARTRIDGE_REMOVE:Javatari.CARTRIDGE_CHANGE_DISABLED?a.showOSD("Cartridge change is disabled",!0):u.insert(null,!1)}}else e?(a.showOSD("FAST FORWARD",!0),B.setFrequency(600),E.getAudioOutput().setFps(600)):(a.showOSD(null,!0),v())},this.controlValueChanged=function(n,e){},this.controlsStateReport=function(n){n[w.POWER]=a.powerIsOn},this.startProfiling=function(){var n=this.framesGenerated;setInterval(function(){jt.Util.log(a.framesGenerated-n),n=a.framesGenerated},1e3)},this.runFramesAtTopSpeed=function(n){h();for(var e=performance.now(),t=0;t<n;t++)a.clockPulse();var r=performance.now()-e;jt.Util.log("Done running "+n+" in "+r+" ms"),jt.Util.log(n/(r/1e3)+"frames/sec"),f()},this.pause=h,this.go=f,this.isRunning=function(){return B.isRunning()};var R,I=null,M=0,K=0,O=0;this.onBreakpointHit=null,this.getClocksFromFrameStart=function(){return K-O},this.resetDebug=function(){I=null,O=K=M=0},this.disableDebug=function(){this.resetDebug(),E.disableDebug()},this.setDebugCondition=function(n){I?A(I):I=S(),K=0,E.setDebugCondition(n),this.isRunning()||f()},this.breakpointHit=function(){console.log("Breakpoint at clk",K),R=S(),h(),this.onBreakpointHit&&this.onBreakpointHit(R)},this.debugSingleStepCPUClock=function(){var e=this,t=-1;e.setDebugCondition(function(){if(K++>M){var n=C.saveState();if(t<0)t=n.PC;else if(n.PC!=t&&0==n.T)return M=K-1,e.breakpointHit(),!0}return!1})},this.debugStepBackInstruction=function(){var n,e,t=this;this.setDebugCondition(function(){return K++>=M&&n?(A(n),M=e-1,t.breakpointHit(),!0):(M-86<K&&K<M&&0==C.saveState().T&&(n=S(),e=K),!1)})},this.debugEval=function(e){var t=this;t.setDebugCondition(function(){if(K++>M){var n=C.saveState();return n.PC=n.PC-1&65535,!!e(n)&&(t.breakpointHit(),M=K,!0)}})},this.saveState=S,this.loadState=A,this.getCPUState=function(){return C.saveState()},this.saveControlsState=function(){return{pia:D.saveControlsState(),tia:E.saveControlsState()}},this.loadControlsState=function(n){D.loadControlsState(n.pia),E.loadControlsState(n.tia)},this.readAddress=function(n){return F.read(n)},this.writeAddress=function(n,e){F.write(n,e)},y(),k(),P()},jt.ROM=function(n,e,t){this.source=n,this.content=e,this.info=t||jt.CartridgeDatabase.produceInfo(this),this.saveState=function(){return{s:this.source,i:this.info}}},jt.ROM.loadState=function(n){return new jt.ROM(n.s,null,n.i)},jt.CartridgeInfoLibrary={version:20130406,"0685BD0BCB975CEEF7041749A5454A48":{n:"11 Sprite Demo (Piero Cavina) (PD)"},"1862FCA4F98E66F363308B859B5863AF":{n:"128-in-1 Junior Console (Chip 1 of 4) (1991) (Atari) (PAL)"},"715DD9E0240638D441A3ADD49316C018":{n:"128-in-1 Junior Console (Chip 2 of 4) (1991) (Atari) (PAL)"},"0D6B974FE58A1BDD453600401C407856":{n:"128-in-1 Junior Console (Chip 3 or 4) (1991) (Atari) (PAL)"},"7F525B07BC98080CC8950F7284E52EDE":{n:"128-in-1 Junior Console (Chip 4 of 4) (1991) (Atari) (PAL)"},"7F430C33044E0354815392B53A9A772D":{n:"2 Pak Special - Cavern Blaster, City War (1992) (HES) (PAL)"},"7732E4E4CC2644F163D6650DDCC9D9DF":{n:"2 Pak Special - Challenge, Spitfallrfing (1990) (HES) (PAL)"},FD7464EDAA8CC264B97BA0D13E7F0678:{n:"2 Pak Special - Challenge, Surfing (1990) (HES) (PAL) [a]"},"8C8A26ED57870DABA8E13162D497BAD1":{n:"2 Pak Special - Dolphin, Oink (1990) (HES) (PAL)"},ED1306436CE237AFC5A7ED3F77134202:{n:"2 Pak Special - Dolphin, Pigs 'n' Wolf (1990) (HES) (PAL)"},F8C1C4A41303BD40B0D6C81BFAF8573B:{n:"2 Pak Special - Dungeon Master, Creature Strike (1992) (HES) (PAL)"},AB434F4C942D6472E75D5490CC4DD128:{n:"2 Pak Special - Hoppy, Alien Force (1992) (HES) (PAL)"},"5B9C2E0012FBFD29EFD3306359BBFC4A":{n:"2 Pak Special - Hoppy, Alien Force (1992) (HES) (PAL) [a]"},"2E842C2EE22E9DAD9DF16EED091315C4":{n:"2 Pak Special - Motocross, Boom Bang (1990) (HES) (PAL)"},A94B8CA630F467B574B614808D813919:{n:"2 Pak Special - Space Voyage, Fire Alert (1992) (HES) (PAL)"},"02A5FC90A0D183F870E8EEBAC1F16591":{n:"2 Pak Special - Star Warrior, Frogger (1990) (HES) (PAL)"},"4D2CEF8F19CAFEEC72D142E34A1BBC03":{n:"2 Pak Special - Star Warrior, Frogger (1990) (HES) (PAL) [a]"},"72FD08DEED1D6195942E0C6F392E9848":{n:"2 Pak Special - Wall Defender, Planet Patrol (1990) (HES) (PAL)"},"9C40BF810F761FFC9C1B69C4647A8B84":{n:"2 in 1 - Frostbite, River Raid (Unknown)"},"94E3FBC19107A169909E274187247A9D":{n:"2-in-1 Freeway and Tennis (Unknown)"},FA529EC88ECA679F6D5FD0CCB2120E46:{n:"20 Sprites at Once Demo 1 (PD)"},"7A93D0C029EAA72236523EEDC3F19645":{n:"20 Sprites at Once Demo 2 (PD)"},"6C449DB9BBBD90972AD1932D6AF87330":{n:"20 Sprites at Once Demo 3 (PD)"},BFA58198C6B9CD8062EE76A2B38E9B33:{n:"20 Sprites at Once Demo 4 (PD)"},D2D8C4F1EA7F347C8BCC7D24F45AA338:{n:"20 Sprites at Once Demo 5 (PD)"},AD2E6BFB3B9B9B36BA8BF493CE764C49:{n:"2600 Collison Demo 1 (Piero Cavina) (PD)"},"777AECE98D7373998FFB8BC0B5EFF1A2":{n:"2600 Collison Demo 2 (Piero Cavina) (PD)"},EADA0DD61CE13F8317DE774DC1E68604:{n:"2600 Digital Clock (Demo 1) (PD)"},"3E5CA1AFAA27C5DA3C54C9942FEC528B":{n:"2600 Digital Clock (Demo 2) (PD)"},F6EFA00AE99AAF33E427B674BCFD834D:{n:"2600 Digital Clock (Demo 3) (PD)"},"75E8D8B9E9C5C67C2226DBFD77DCFA7D":{n:"2600 Digital Clock (V b1) (PD)"},"5E99AA93D0ACC741DCDA8752C4E813CE":{n:"2600 Digital Clock (V b2) (PD)"},"62FFD175CAC3F781EF6E4870136A2520":{n:"2600 Digital Clock (V x.xx) (PD)"},"4FAEB04B1B7FB0FA25DB05753182A898":{n:"2600 Digital Clock (V x.xx) (PD) [a1]"},"655C84E5B951258C9D20F0BF2B9D496D":{n:"2600_2003 Demo (PD)"},B95A6274CA0E0C773BFDC06B4C3DAA42:{n:"3-D Corridor (29-03-2003) (Paul Slocum)"},"6B8FB021BB2E1F1E9BD7EE57F2A8E709":{n:"3-D Corridor (29-03-2003) (Paul Slocum) (PD) [a]"},"8D00A38F4C8F8800F1C237215AC243FC":{n:"3-D Corridor (Green) (30-03-2003) (AD)"},"7B6F3348DBF71ADA88DB0FDAF7FEEFE0":{n:"3-D Corridor (Pink Spiral) (31-03-2003) (AD)"},B6960BE26BEE87D53BA4E2E71CFE772F:{n:"3-D Corridor (Spiral Words) (31-03-2003) (AD)"},"493DAAF9FB1BA450EBA6B8ED53FFB37D":{n:"3-D Corridor Demo (27-03-2003) (MP)"},"4947C9DE2E28B2F5F3B0C40CE7E56D93":{n:"3-D Corridor Demo 2 (29-03-2003) (MP)"},"0DB4F4150FECF77E4CE72CA4D04C052F":{n:"3-D Tic-Tac-Toe (1980) (Atari)"},F3213A8A702B0646D2EAF9EE0722B51C:{n:"3-D Tic-Tac-Toe (1980) (Atari) (4K)"},E3600BE9EB98146ADAFDC12D91323D0F:{n:"3-D Tic-Tac-Toe (1980) (Atari) (PAL)"},"854B68B93E7123A3BE42B5A2A41F75D7":{n:"3-D Tic-Tac-Toe (1980) (Atari) (PAL) (4K)"},"7B5207E68EE85B16998BEA861987C690":{n:"3-D Tic-Tac-Toe (32 in 1) (1988) (Atari) (PAL)"},"402B1CA3C230A60FB279D4A2A10FA677":{n:"3-D Tic-Tac-Toe (Unknown) (PAL) (4K)"},"291DD47588B9158BEEBE4ACCC3A093A6":{n:"32 in 1 Console ROM (02-10-1989) (Atari) (Prototype) (PAL)"},"291BCDB05F2B37CDF9452D2BF08E0321":{n:"32 in 1 Game Cartridge (1988) (Atari) (Prototype) (PAL)"},"792B1D93EB1D8045260C840B0688EC8F":{n:"3E Bankswitch Test (TIA @ $00)"},"9B150A42FC788960FBB4CBE250259EE2":{n:"3E Bankswitch Test (TIA @ $40)"},"703F0F7AF350B0FA29DFE5FBF45D0D75":{n:"4 Game in One Dark Green (1983) (BitCorp) (PAL)"},"31BB9B8CEED46CB3E506777A9E65F3CE":{n:"4 Game in One Light Green (1983) (BitCorp) (PAL)"},FE6ABC0F63E31E2646C9C600926B5B7F:{n:"4 in 1 (02-19-1987) (Atari) (Prototype)"},"6D218DAFBF5A691045CDC1F67CEB6A8F":{n:"6 Digit Score Display (1998) (Robin Harbron) (PD)"},"7465B06B6E25A4A6C6D77D02242AF6D6":{n:"8 in 1 (01-16-92) (Atari) (Prototype)"},"2CEFA695DF2ED020899A7DF7BB1E3A95":{n:"A-Team (2002) (Manuel Polik) (Hack)"},DAFC3945677CCC322CE323D1E9930BEB:{n:"A-Team (Atari) (Prototype) (PAL)"},C02E1AFA0671E438FD526055C556D231:{n:"A-Team (Atari) (Prototype) (PAL60)"},C00734A2233EF683D9B6E622AC97A5C8:{n:"A-Team, The (03-30-1984) (Atari) (Prototype)"},CD5AF682685CFECBC25A983E16B9D833:{n:"A-Team, The (05-08-1984) (Atari) (Prototype)"},"537ED1E0D80E6C9F752B33EA7ACBE079":{n:"A-VCS-tec Challenge (beta 5) (PD)"},"8786C1E56EF221D946C64F6B65B697E9":{n:"AKA Space Adventure"},"00F7985C20B8BDF3C557FAC4D3F26775":{n:"AStar (NTSC)"},"3FD1F9D66A418C9F787FC5799174DDB7":{n:"AStar (PAL)"},A3FEE8CE15525EA00D45A06F04C215D1:{n:"AStar (PAL60)"},"17EE23E5DA931BE82F733917ADCB6386":{n:"Acid Drop (1992) (Salu) (PAL)"},"09274C3FC1C43BF1E362FDA436651FD8":{n:"Acid Drop (TJ)"},B9F6FA399B8CD386C235983EC45E4355:{n:"Action Force (1983) (Parker Bros) (PAL)",p:1},D573089534CA596E64EFEF474BE7B6BC:{n:"Action Force (1983) (Parker Bros) (PAL) [a]",p:1},"543B4B8FF1D616FA250C648BE428A75C":{n:"Adventure (1978) (Warren Robinett) (Hack)"},"157BDDB7192754A45372BE196797F284":{n:"Adventure (1980) (Atari)"},"4B27F5397C442D25F0C418CCDACF1926":{n:"Adventure (1980) (Atari) (PAL)"},"9BE58A14E055B0E7581FC4D6C2F6B31D":{n:"Adventure (Color Scrolling) (Hack)"},A5B7F420CA6CC1384DA0FED523920D8E:{n:"Adventure (New Graphics) (Hack)"},"171CD6B55267573E6A9C2921FB720794":{n:"Adventure 34 (Kurt Howe) (Hack)"},E923001015BEDD7901569F035D9C592C:{n:"Adventure II (Hack)"},E2846AF3E4D172B251AB77CBDD01761E:{n:"Adventure Plus (2003) (Steve Engelhardt) (Hack)"},CA4F8C5B4D6FB9D608BB96BC7EBD26C7:{n:"Adventures of TRON (1982) (M Network)"},"06CFD57F0559F38B9293ADAE9128FF88":{n:"Adventures on GX-12 (1989) (Telegames) (PAL)"},"35BE55426C1FEC32DFB503B4F0651572":{n:"Air Raid (Men-A-Vision) (PAL)",c:1},A9CB638CD2CB2E8E0643D7A67DB4281C:{n:"Air Raiders (1982) (M Network)"},F066BEA7AB0A37B83C83C924A87C5B67:{n:"Air Raiders (1982) (Unknown)"},DA0FB2A484D0D2D8F79D6E063C94063D:{n:"Air Raiders (1982) (Unknown) [a]"},CF3A9ADA2692BB42F81192897752B912:{n:"Air Raiders (Unknown) (PAL)"},"16CB43492987D2F32B423817CDAAF7C4":{n:"Air-Sea Battle (1977) (Atari)"},"1D1D2603EC139867C1D1F5DDF83093F1":{n:"Air-Sea Battle (1977) (Atari) (4K)"},"0C7926D660F903A2D6910C254660C32C":{n:"Air-Sea Battle (1977) (Atari) (PAL)"},"8AAD33DA907BED78B76B87FCEAA838C1":{n:"Air-Sea Battle (32 in 1) (1988) (Atari) (PAL)"},"605DCB73D22F4EFDB90EF9DA2F290F7C":{n:"Air-Sea Battle (32 in 1) (1988) (Atari) (PAL) (4K)"},"98E5E4D5C4DD9A986D30FD62BD2F75AE":{n:"Air-Sea Battle (Unknown) (Hack) (4K)"},E5FCC62E1D73706BE7B895E887E90F84:{n:"Air-Sea Battle (Unknown) (PAL) (4K)"},"4D77F291DCA1518D7D8E47838695F54B":{n:"Airlock (1982) (Data Age)"},"8C7E5E2329F4F4E06CBCC994A30FD352":{n:"Airlock (1982) (Data Age) (Prototype)"},F1A0A23E6464D954E3A9579C4CCD01C8:{n:"Alien (1982) (20th Century Fox)",c:1},"956496F81775DE0B69A116A0D1AD41CC":{n:"Alien (CCE)",c:1},"1287535256BF5DFF404839AC9E25C3E7":{n:"Alien Pac-Man (PacManPlus) (Hack)",c:1},E1A51690792838C5C687DA80CD764D78:{n:"Alligator People (1983) (20th Century Fox) (Prototype)"},DF95E4AF466C809619299F49ECE92365:{n:"Alpha Beam with Ernie (06-03-1983) (Atari) (Prototype) (PAL)"},"8F5AC5139419C5D49BACC296E342A247":{n:"Alpha Beam with Ernie (12-22-1983) (Atari) (Prototype)"},"9E01F7F95CB8596765E03B9A36E8E33C":{n:"Alpha Beam with Ernie (1983) (Atari)"},F2D40C70CF3E1D03BC112796315888D9:{n:"Alpha Beam with Ernie (1983) (Atari) (PAL)"},B0BA51723B9330797985808DB598FC31:{n:"Alpha Beam with Ernie (1983) (Atari) (PAL) [a]"},"2A10053FD08664C7CFBBB104386ED77F":{n:"Alpha Demo - The Beta Demo (2000) (MP)"},FDF6680B2B1E8054293A39700A765692:{n:"Alpha Demo - The Beta Demo 2 (2000) (MP)"},"26BC2BDF447A17376AEA7EF187FF6E44":{n:"Amanda Invaders (PD)"},"51F15B39D9F502C2361B6BA6A73464D4":{n:"Amanda Invaders (PD) [a]"},ACB7750B4D0C4BD34969802A7DEB2990:{n:"Amidar (1982) (Parker Bros)"},"056F5D886A4E7E6FDD83650554997D0D":{n:"Amidar (1982) (Parker Bros) (PAL)"},"6354F9C7588A27109C66905B0405825B":{n:"Amidar DS (2003) (TJ) (Hack)"},"93B9229FC0EA4FB959D604F83F8F603C":{n:"Amidar DS (Fast Enemies) (2003) (TJ) (Hack)"},"5BD79139A0C03B63F6F2CF00A7D385D2":{n:"An Exercise In Minimalism (V1) (1999) (Marc de Smet) (PD)"},"6F74ED915FFE73B524EF0F63819E2A1D":{n:"An Exercise In Minimalism (V2) (1999) (Eckhard Stolberg)"},E39A13B13DC82C5FDBFBBFD55BA1230E:{n:"Analog Clock (Additional Frame Info) (V0.0) (20-01-2003) (AD)"},"0AE3497E731CA0BF6A77B23441D9D9F9":{n:"Analog Clock (V0.0) (20-01-2003) (AD)"},"335793736CBF6FC99C9359ED2A32A49D":{n:"Analog Clock (V0.0) (20-01-2003) (AD) [a]"},"63C5FEF3208BB1424D26CF1AB984B40C":{n:"Analog Clock (V0.1) (20-01-2003) (AD)"},FC9C1652FE3A2CADE6188F4D3692481F:{n:"Andrew Davies early notBoulderDash demo (NTSC)",c:1},"4C606235F4EC5D2A4B89139093A69437":{n:"Andrew Davies early notBoulderDash demo (PAL)",c:1},"0866E22F6F56F92EA1A14C8D8D01D29C":{n:"AndroMan on the Moon (1984) (Western Tech) (Prototype)"},"6672DE8F82C4F7B8F7F1EF8B6B4F614D":{n:"Angeln I (Ariola) (PAL)"},ADF1AFAC3BDD7B36D2EDA5949F1A0FA3:{n:"Angriff der Luftflotten (1983) (Quelle) (PAL)"},AFE4EEFC7D885C277FC0649507FBCD84:{n:"Ant Party (32 in 1) (1988) (Atari) (PAL)",c:1},"6B01A519B413F8CFA2F399F4D2841B42":{n:"Aphex Invaders (Hack)"},E73838C43040BCBC83E4204A3E72EEF4:{n:"Apples and Dolls (CCE)",c:1},"038E1E79C3D4410DEFDE4BFE0B99CC32":{n:"Aquaventure (08-12-1983) (Atari) (Prototype)"},F69D4FCF76942FCD9BDF3FD8FDE790FB:{n:"Aquaventure (CCE)"},A7B584937911D60C120677FE0D47F36F:{n:"Armor Ambush (1982) (M Network)"},D0AF33865512E9B6900714C26DB5FA23:{n:"Armor Ambush (1989) (Telegames) (PAL)"},C77C35A6FC3C0F12BF9E8BAE48CBA54B:{n:"Artillery Duel (1983) (Xonox)"},"589C73BBCD77DB798CB92A992B4C06C3":{n:"Artillery Duel (1983) (Xonox) (PAL)"},D341D39774277CEE6A1D378A013F92AC:{n:"Artillery Duel (1983) (Xonox) (PAL) [a]"},"3F039981255691D3859D04EF813A1264":{n:"Artillery Duel (1983) (Xonox) [a]"},"3750F2375252B6A20E4628692E94E8B1":{n:"Ases do Ar (Dismac)"},DE78B3A064D374390AC0710F95EDDE92:{n:"Assault (1983) (Bomb)"},"327468D6C19697E65AB702F06502C7ED":{n:"Aster-Hawk (2002) (Charles Morgan) (Hack)",c:1},"89A68746EFF7F266BBF08DE2483ABE55":{n:"Asterix (1983) (Atari)"},FAEBCB2EF1F3831B2FC1DBD39D36517C:{n:"Asterix (1983) (Atari) (PAL)"},C5C7CC66FEBF2D4E743B4459DE7ED868:{n:"Asterix (1983) (Atari) (PAL) [a]"},"47B82D47E491AC7FDB5053A88FCCC832":{n:"Asteroid 2 (Atari Freak 1) (Hack)",c:1},"18F299EDB5BA709A64C80C8C9CEC24F2":{n:"Asteroid Fire (1983) (Home Vision) (PAL)"},DD7884B4F93CAB423AC471AA1935E3DF:{n:"Asteroids (1981) (Atari)",c:1},"8CF0D333BBE85B9549B1E6B1E2390B8D":{n:"Asteroids (1981) (Atari) (PAL)",c:1},A957DBE7D85EA89133346AD56FBDA03F:{n:"Asteroids (1981) (Atari) (PAL) [a1]",c:1},"19ABAF2144B6A7B281C4112CFF154904":{n:"Asteroids (1981) (Atari) (PAL) [a2]",c:1},BB5049E4558DAADE0F87FED69A244C59:{n:"Asteroids (1981) (Atari) (PAL) [no copyright]",c:1},B227175699E372B8FE10CE243AD6DDA5:{n:"Asteroids (1981) (Atari) [a1]",c:1},D563BA38151B8204C9F5C9F58E781455:{n:"Asteroids (1981) (Atari) [a2]",c:1},CCBD36746ED4525821A8083B0D6D2C2C:{n:"Asteroids (1981) (Atari) [no copyright]",c:1},"3E4B1137433CC1E617B5508619E13063":{n:"Asteroids (Genesis)",c:1},DF40AF244A8D68B492BFBA9E97DEA4D6:{n:"Asteroids 2 (Franlin Cruz) (Hack)",c:1},"2DBDCA3058035D2B40C734DCF06A86D9":{n:"Asteroids DC+ (Thomas Jentzsch) (Hack)",c:1},"8DF4BE9DDC54AC363B13DC57CEAF161A":{n:"Asteroids SS (Scott Stilphen) (Hack)",c:1},"75169C08B56E4E6C36681E599C4D8CC5":{n:"Astroblast (1982) (M Network)",p:1},"170E7589A48739CFB9CC782CBB0FE25A":{n:"Astroblast (1982) (M Network) [fixed]",p:1},"46E9428848C9EA71A4D8F91FF81AC9CC":{n:"Astroblast (1989) (Telegames) (PAL)",p:1},"8F53A3B925F0FD961D9B8C4D46EE6755":{n:"Astrowar (Unknown)"},E643AAEC9A9E1C8AB7FE1EAE90BC77D7:{n:"Asymmetric Playfield (Roger Williams)"},"4B753A97AEE91E4B3E4E02F5E9758C72":{n:"Asymmetric Reflected Playfield (Glenn Saunders)"},A4AA7630E4C0AD7EBB9837D2D81DE801:{n:"Atari 2600 Invaders (Hack)"},D0A379946ED77B1B126230CA68461333:{n:"Atari Invaders (Ataripoll) (Hack)"},D61629BBBE035F45552E31CEF7D591B2:{n:"Atari Logo Demo (PD) (PAL)"},E932F44FAD2A66B6D5FAEC9ADDEC208E:{n:"Atari Logo Demo 1 (PD)"},"13D8326BF5648DB4DAFCE45D25E62DDD":{n:"Atari Logo Demo 2 (PD)"},"3E49DA621193D2611A4EA152D5D5CA3A":{n:"Atari Logo Demo 3 (PD)"},"42E0EC5AB8F5DEBA53E4169FF2A5EFBE":{n:"Atari Logo Demo 5 (PD)"},"9526E3DB3BDFBC27989A9CBFD0EE34BF":{n:"Atari Logo Demo 6 (PD)"},"5DF32450B9FBCAF43F9D83BD66BD5A81":{n:"Atari Logo Playfield Demo (2001) (Eric Ball) (PD)"},"4EDB251F5F287C22EFC64B3A2D095504":{n:"Atari VCS Point-of-Purchase ROM (1982) (Atari)"},"3F540A30FDEE0B20AED7288E4A5EA528":{n:"Atari Video Cube (1982) (Atari)"},"2CA6445204FFB7686DDEE3E33BA64D5B":{n:"AtariVox Test ROM"},"9AD36E699EF6F45D9EB6C4CF90475C9F":{n:"Atlantis (1982) (Imagic)"},ACB962473185D7A652F90ED6591AE13B:{n:"Atlantis (1982) (Imagic) (16K)"},"5324CF5B6DC17AF4C64BF8696C39C2C1":{n:"Atlantis (1982) (Imagic) (8K)"},"3D2367B2B09C28F1659C082BB46A7334":{n:"Atlantis (1982) (Imagic) (PAL)"},"41818738AB1745E879024A17784D71F5":{n:"Atlantis (1983) (CCE)"},"0B33252B680B65001E91A411E56E72E9":{n:"Atlantis (1983) (CCE) [a]"},"71B193F46C88FB234329855452DFAC5B":{n:"Atlantis (1983) (Digitel)"},"3AAD0EF62885736A5B8C6CCAC0DBE00C":{n:"Atlantis (1983) (Dynacom)"},"6CEA35DED079863A846159C3A1101CC7":{n:"Atlantis (208 in 1) (Unknown) (PAL) (Hack)"},A1403FEF01641DCD3980CAC9F24D63F9:{n:"Atlantis (Dactari - Milmar)"},"72BDA70C75DFA2365B3F8894BACE9E6A":{n:"Atlantis (TJ) (Hack)"},C4BBBB0C8FE203CBD3BE2E318E55BCC0:{n:"Atlantis (Unknown) (PAL) (Hack)"},AC0DDBCFF34D064009591607746E33B8:{n:"Atlantis FH (2003) (TJ) (Hack)"},"826481F6FC53EA47C9F272F7050EEDF7":{n:"Atlantis II (1982) (Imagic)"},A7CF2B9AFDBB3A161BF418DBCF0321DC:{n:"Attack Of The Mutant Space Urchins (2002) (Barry Laws Jr.) (Hack)",c:1},B5110F55ED99D5279F18266D001A8CD5:{n:"Auto-mobile Demo (2001) (Eckhard Stolberg)"},B4F87CE75F7329C18301A2505FE59CD3:{n:"Autorennen (Ariola) (PAL)"},"7C757BB151269B2A626C907A22F5DAE7":{n:"BMX Air Master (1989) (TNT Games) (PAL)"},"968EFC79D500DCE52A906870A97358AB":{n:"BMX Air Master (1990) (Atari)"},"4F89B897444E7C3B36AED469B8836839":{n:"BMX Air Master (1990) (Atari) (PAL)"},"4E2C884D04B57B43F23A5A2F4E9D9750":{n:"Baby Center Animation (PD)",c:1},"5B124850DE9EEA66781A50B2E9837000":{n:"Bachelor Party (1982) (PlayAround)",p:1,c:1},"274D17CCD825EF9C728D68394B4569D2":{n:"Bachelorette Party (1982) (Playaround)",p:1,c:1},"8556B42AA05F94BC29FF39C39B11BFF4":{n:"Backgammon (1979) (Atari)",p:1},"85B1BCA93E69F13905107CC802A02470":{n:"Backgammon (1979) (Atari) (PAL)",p:1},"4E4895C3381AA4220F8C2795D6338237":{n:"Backwards Cannonball v1 (Hack)"},"2A33E21447BF9E13DCFED85077FF6B40":{n:"Backwards Cannonball v2 (Hack)"},FCEA12625C071DDC49F4E409F4038C60:{n:"Balls! (16-09-2002) (Fabrizio Zavagli)",c:1},"805F9A32EF97AC25F999A25014DC5C23":{n:"Balthazar (SnailSoft)",c:1},"00CE0BDD43AED84A983BEF38FE7F5EE3":{n:"Bank Heist (1983) (20th Century Fox)"},"83B8C01C72306D60DD9B753332EBD276":{n:"Bank Heist (208 in 1) (Unknown) (PAL)"},E9C71F8CDBA6037521C9A3C70819D171:{n:"Bank Heist (PAL)"},C2A37F1C7603C5FD97DF47D6C562ABFA:{n:"Bar-Score Demo (2001) (Roger Williams)"},"73A710E621D44E97039D640071908AEF":{n:"Barber Pole Demo (PD)"},F8240E62D8C0A64A61E19388414E3104:{n:"Barnstorming (1982) (Activision)"},A29FC854838E08C247553A7D883DD65B:{n:"Barnstorming (1982) (Activision) (16K)"},"9AEB5206C5BF974892A9CC59F1478DB3":{n:"Barnstorming (1982) (Activision) (8K)"},E7DD8C2E6C100044002C1086D02B366E:{n:"Barnstorming (1982) (Activision) (PAL)"},"5AE73916FA1DA8D38CEFF674FA25A78A":{n:"Barnstorming (CCE)"},"9AD362179C2EEA4EA115C7640B4B003E":{n:"Barnstorming (Unknown) (PAL)"},DCEC46A98F45B193F07239611EB878C2:{n:"Bars and Text Demo (PD)"},D7891B0FAA4C7F764482762D0ED427A5:{n:"Bars and Text Demo 2 (PD)"},"600D48EEF5C0EC27DB554B7328B3251C":{n:"Bars and Text Demo 3 (PD)"},C469151655E333793472777052013F4F:{n:"Base Attack (Unknown) (Hack)"},"034C1434280B0F2C9F229777D790D1E1":{n:"Baseball (1989) (Telegames) (PAL)"},"9848B5EF7A0C02FE808B920A2AC566D2":{n:"Baseball (2002) (Skyworks)"},A41450333F8DD0E96E5E9F0AF3770AE9:{n:"Basic Math (208 in 1) (Unknown) (PAL)"},"7EAB0284A0CD1043461D446A08D08CEC":{n:"Basic Math (Jone Yuan) (4K)"},"9F48EEB47836CF145A15771775F0767A":{n:"Basic Programming (1979) (Atari)",c:1},B061E98A4C854A672AADEFA233236E51:{n:"Basic Programming (1979) (Atari) (PAL)",c:1},AB4AC994865FB16EBB85738316309457:{n:"Basketball (1978) (Atari)"},E13C7627B2E136B9C449D9E8925B4547:{n:"Basketball (1978) (Atari) (4K)"},"218C0FE53DFAAA37F3C823F66EAFD3FC":{n:"Basketball (1978) (Atari) (PAL)"},F4AB6BD5F80D8988141EDDE4C84B23B5:{n:"Basketball (1978) (Atari) (PAL) (4K)"},"77BE57D872E3F5B7ECF8D19D97F73281":{n:"Basketball (208 in 1) (Unknown) (PAL)"},"5D132D121AABC5235DD039DFC46AA024":{n:"Basketball (208 in 1) (Unknown) (PAL) (Hack)"},"1228C01CD3C4B9C477540C5ADB306D2A":{n:"Basketball (32 in 1) (1988) (Atari) (PAL)"},"32D1260EA682E1BB10850FA94C04EC5F":{n:"Basketball (32 in 1) (1988) (Atari) (PAL) (4K)"},"5C0227AD63300670A647FCEBF595EA37":{n:"Battle for Naboo (Josh) (Hack)"},E434C0E161DD3C3FB435EB6BAD2E182C:{n:"Battlezone (05-02-1983) (Atari) (Prototype)"},"5B85E987E2B1618769D97BA9182333D0":{n:"Battlezone (05-12-1983) (Atari) (Prototype)"},"41F252A66C6301F1E8AB3612C19BC5D4":{n:"Battlezone (1983) (Atari)"},FBE554AA8F759226D251BA6B64A9CCE4:{n:"Battlezone (1983) (Atari) (PAL)"},E38DC1F81A02E325562CD285123F579B:{n:"Battlezone (1983) (Atari) (PAL) [a1]"},"2319922DF4D0C820B3E5F15FAA870CC3":{n:"Battlezone (1983) (Atari) (PAL) [a]"},"6015A9CEF783E97E98A2AA2CF070AE06":{n:"Battlezone TC (Thomas Jentzsch) (Hack)"},"38C362DCD5CAD5A62E73AE52631BD9D8":{n:"Baubles (14-11-2001) (Jake Patterson) (PD)"},"3EB1E34A4F0EEC36F12E7336BADCECF2":{n:"Baubles (V0.001) (2001) (Jake Patterson) (PD)"},"599CBF919D47A05AF975AD447DF29497":{n:"Baubles (V0.002) (2001) (Jake Patterson) (PD)"},FBFEBEE9C14694719E3EDA4854DC42EE:{n:"Baubles 3 (Jake Patterson) (PD)"},"79AB4123A83DC11D468FB2108EA09E2E":{n:"Beamrider (1984) (Activision)"},FEC0C2E2AB0588ED20C750B58CF3BAA3:{n:"Beamrider (1984) (Activision) (PAL)"},F4204FC92D17ED4CB567C40361AD58F1:{n:"Beanie Baby Bash (Inky) (Hack)"},D0B9DF57BFEA66378C0418EC68CFE37F:{n:"Beany Bopper (1982) (20th Century Fox)"},"6A9E0C72FAB92DF70084ECCD9061FDBD":{n:"Beany Bopper (1983) (CCE)"},"235436AB0832370E73677C9C6F0C8B06":{n:"Beast Invaders (Double Shot) (Hack)"},"4D0A28443F7DF5F883CF669894164CFA":{n:"Beast Invaders (Hack)"},B4F31EA8A6CC9F1FD4D5585A87C3B487:{n:"Beat 'Em & Eat 'Em (1982) (Mystique) (PAL)",p:1},"59E96DE9628E8373D1C685F5E57DCF10":{n:"Beat 'Em & Eat 'Em (1982) (PlayAround)",p:1},"6C25F58FD184632CA76020F589BB3767":{n:"Beat 'Em & Eat 'Em (1983) (Dynacom)",p:1},EE6665683EBDB539E89BA620981CB0F6:{n:"Berenstain Bears (1983) (Coleco)"},"073D7AFF37B7601431E4F742C36C0DC1":{n:"Bermuda (Unknown) (PAL)"},B8ED78AFDB1E6CFE44EF6E3428789D5F:{n:"Bermuda Triangle (1982) (Data Age)"},"36C993DC328933E4DD6374A8FFE224F4":{n:"Bermuda Triangle (1983) (Gameworld) (PAL)"},BCEF7880828A391CF6B50D5A6DCEF719:{n:"Bermuda, The (Rainbow Vision) (PAL)"},CF3C2725F736D4BCB84AD6F42DE62A41:{n:"Bermuda, The (Rainbow Vision) (PAL) [a]"},"136F75C4DD02C29283752B7E5799F978":{n:"Berzerk (1982) (Atari)"},"0805366F1B165A64B6D4DF20D2C39D25":{n:"Berzerk (1982) (Atari) (PAL)"},FAC28963307B6E85082CCD77C88325E7:{n:"Berzerk (CCE)"},"4B205EF73A5779ACC5759BDE3F6D33ED":{n:"Berzerk (Unknown) (PAL)"},"490E3CC59D82F85FAE817CDF767EA7A0":{n:"Berzerk (Unknown) (PAL) [a]"},BE41463CD918DAEF107D249F8CDE3409:{n:"Berzerk (Voice Enhanced) (Hack)"},"5C618A50DFA23DAAC97BA459B9FF5206":{n:"Berzerk Renegade (2002) (Steve Engelhardt) (Hack)",c:1},"4C4CE802CBFD160F7B3EC0F13F2A29DF":{n:"Beta Demo (V1.1) (26-09-2002) (MP)"},"63A7445B1D3046D3CDCDBD488DCA38D9":{n:"Better Space Invaders (1999) (Rob Kudla) (Hack)"},"012020625A3227815E47B37FD025E480":{n:"Better Space Invaders (1999) (Rob Kudla) (Hack) [a]"},"4D5F6DB55F7F44FD0253258E810BDE21":{n:"Betterblast (Fabrizio Zavagli) (Hack)"},"7CD900E9ECCBB240FE9C37FA28F917B5":{n:"Bi! Bi! (Jone Yuan) (PAL)"},F714A223954C28ECCF459295517DCAE6:{n:"Big - Move This Demo (PD)"},"16CC6D1B4DDCE51C767A1BA8E5FF196C":{n:"Big - Move This Demo 2 (PD)",c:1},"151FA3218D8D7600114EB5BCD79C85CB":{n:"Big Bird's Egg Catch (05-02-1983) (Atari) (Prototype)"},"0B17ED42984000DA8B727CA46143F87A":{n:"Big Bird's Egg Catch (05-17-1983) (Atari) (Prototype)"},AFD2CF258D51AE4965EE21ABBA3627AB:{n:"Big Bird's Egg Catch (12-08-1982) (Atari) (Prototype)"},"1802CC46B879B229272501998C5DE04F":{n:"Big Bird's Egg Catch (1983) (Atari)"},F283CC294ECE520C2BADF9DA20CFC025:{n:"Big Bird's Egg Catch (1983) (Atari) (PAL)"},"2CB42CF62B2F25F59F909B5447821B14":{n:"Big Bird's Egg Catch (1983) (Atari) (PAL) [a]"},F8FF34B53D86F55BD52D7A520AF6D1DC:{n:"Big Dig (04-04-2003) (CT)"},"7CCF350354EE15CD9B85564A2014B08C":{n:"Big Dig (13-04-2003) (CT)"},"23E4CA038ABA11982E1694559F3BE10F":{n:"Big Dig (V3) (20-10-2002) (CT)"},"93C9F9239A4E5C956663DD7AFFA70DA2":{n:"Billard (1983) (Quelle) (PAL)",c:1},BD1BD6F6B928DF17A702DEF0302F46F4:{n:"Binary To Decimal Routine (2001) (AD)"},"84535AFB9A69712EC0AF4947329E08B8":{n:"Bingo (1983) (CCE) (PAL)"},"10F0ECAF962AEF1FC28ABED870B01B65":{n:"Bionic Breakthrough (06-22-1984) (Atari) (Prototype)"},F0541D2F7CDA5EC7BAB6D62B6128B823:{n:"Bionic Breakthrough (1984) (Atari) (Prototype)"},AA8E4B2CB8A78FFE6B20580033F4DEC9:{n:"Bitmap Demo (13-01-2003) (AD)"},"282A77841CB3D33AF5B56151ACBA770E":{n:"Black Hole (1983) (Quelle) (PAL)"},CBEAFD37F15E0DDDB0540DBE15C545A4:{n:"Black and White Fast Scolling Demo (PD)"},"0A981C03204AC2B278BA392674682560":{n:"Blackjack (1977) (Atari)",p:1},B2761EFB8A11FC59B00A3B9D78022AD6:{n:"Blackjack (1977) (Atari) (4K)",p:1},FF3BD0C684F7144AEAA18758D8281A78:{n:"Blackjack (1977) (Atari) (PAL)",p:1},FF7627207E8AA03730C35C735A82C26C:{n:"Blackjack (32 in 1) (1988) (Atari) (PAL)",p:1},D726621C676552AFA503B7942AF5AFA2:{n:"Blackjack (32 in 1) (1988) (Atari) (PAL) (4K)",p:1},"575C0FB61E66A31D982C95C9DEA6865C":{n:"Blackjack (Unknown) (PAL)",p:1},"19A9D3F9FA1B1358FB53009444247AAF":{n:"Blackjack (Unknown) (PAL) (4K)",p:1},"93420CC4CB1AF1F2175C63E52EC18332":{n:"Blair Witch Project (Tim Snider) (Hack)"},"07C76F2D88552D20AD2C0ED7AEF406C6":{n:"Blob (Cody Pittman) (Hack)"},"1086FF69F82B68D6776634F336FB4857":{n:"Bloody Human Freeway (Activision) (Prototype)"},FCF8E306F6615F74FEBA5CB25550038C:{n:"Blue Dot Demo (PD)"},"2942680C47BEB9BF713A910706FFABFE":{n:"Blue Line Demo (PD)"},B7F184013991823FC02A6557341D2A7A:{n:"Blue Rod Demo (PD)"},DAD2AB5F66F98674F12C92ABCFBF3A20:{n:"Blue and White Sprite Demo (PD)"},"33D68C3CD74E5BC4CF0DF3716C5848BC":{n:"Blueprint (1983) (CBS Electronics)",c:1},"2432F33FD278DEA5FE6AE94073627FCC":{n:"Blueprint (1983) (CBS Electronics) (PAL)",c:1},"345488D3B014B684A181108F0EF823CB":{n:"Blueprint (1983) (CBS Electronics) (Prototype)"},"6FBD05B0AD65B2A261FA154B34328A7F":{n:"Boardgame Demo (20-12-2002) (CT)"},EBCB084A91D41865B2C1915779001CA7:{n:"Bob Is Going Home (JVP)"},"521F4DD1EB84A09B2B19959A41839AAD":{n:"Bobby Is Going Home (1983) (BitCorp)"},"2823364702595FEEA24A3FBEE138A243":{n:"Bobby Is Going Home (1983) (BitCorp) (PAL)"},CCB56107FF0492232065B85493DAA635:{n:"Bobby Is Going Home (1983) (BitCorp) (PAL) [demo cart]"},"075069AD80CDE15ECA69E3C98BD66714":{n:"Bobby Is Going Home (1983) (CCE)"},"3CBDF71BB9FD261FBC433717F547D738":{n:"Bobby Is Going Home (1983) (CCE) (PAL)"},F2F59629D7341C97644405DAEAC08845:{n:"Bobby Is Going Home (Jone Yuan)"},"2F2F9061398A74C80420B99DDECF6448":{n:"Bobby Is Going Home (Rentacom)"},"48E5C4AE4F2D3B62B35A87BCA18DC9F5":{n:"Bobby geht nach Hause (1983) (Quelle) (PAL)"},AFE776DB50E3378CD6F29C7CDD79104A:{n:"Bobby is Going Home (TJ)"},C59633DBEBD926C150FB6D30B0576405:{n:"Bogey Blaster (1989) (Telegames)"},B438A6AA9D4B9B8F0B2DDB51323B21E4:{n:"Bogey Blaster (1989) (Telegames) (PAL)"},A5855D73D304D83EF07DDE03E379619F:{n:"Boggle (08-07-1978) (Atari) (Prototype)",c:1},"14C2548712099C220964D7F044C59FD9":{n:"Boing! (1983) (First Star Software)",c:1},C471B97446A85304BBAC021C57C2CB49:{n:"Boing! (1983) (First Star Software) (PAL)",c:1},"0E08CD2C5BCF11C6A7E5A009A7715B6A":{n:"Boing! (PD) [a1]"},"5D8FB14860C2F198472B233874F6B0C9":{n:"Boing! (PD) [a2]"},"956B99511C0F47B3A11D18E8B7AC8D47":{n:"Bones (Arcade Golf Hack)"},E5359CBBBFF9C6D7FE8AEFF5FB471B46:{n:"Boom Bang (1983) (CCE)"},"7F54FA6AA824001AF415503C313262F2":{n:"Boom Bang (HES) (PAL)"},A2AAE759E4E76F85C8AFEC3B86529317:{n:"Boom Bang (Unknown)"},"2825F4D068FEBA6973E61C84649489FE":{n:"Boom Bang (Unknown) (PAL)"},"02E3F4BA156FB578BEF7D7A0BF3400C1":{n:"Booster (Junkosoft) (PD)"},"5BC9998B7E9A970E31D2CB60E8696CC4":{n:"Borgwars Asteroids (2003) (Jack Kortkamp) (Hack)",c:1},"05F11FB2E45C4E47424D3CB25414D278":{n:"Boring (NTSC) (AD)"},"9B246683F44C963A50E41D6B485BEE77":{n:"Boring (PAL) (AD)"},F0CACAE1D1B79EE92F0DC035F42E0560:{n:"Boring Donkey Kong (Hack)"},CE17325834BF8B0A0D0D8DE08478D436:{n:"Boring Freeway (Hack)"},"1733772165D7B886A94E2B4ED0F74CCD":{n:"Boring Journey Escape (Hack)"},"613ABF596C304EF6DBD8F3351920C37A":{n:"Boring Pac-Man (Hack)"},"96670D0BF3610DA2AFCABD8E21D8EABF":{n:"Boring Pitfall (Hack)"},E8E7B9BDF4BF04930C2BCAA0278EE637:{n:"Boring Taz (Hack)"},"8A49CF1785E3DEA2012D331A3AD476E1":{n:"Boulderdash (10 Blocks Wide) (02-04-2003) (AD)"},E0DE3773F5B867795DB557BE7B8A703E:{n:"Boulderdash (13 Blocks Wide) (02-04-2003) (AD)"},"29DFA26B7988AF9984D617708E4FC6E2":{n:"Boulderdash Demo (05-04-2003) (AD)"},"68CD2ADC6B1FC9A1F263AB4561112F30":{n:"Boulderdash Demo (09-12-2002) (TJ)",c:1},D90205E29BB73A4CDF28EA7662BA0C3C:{n:"Boulderdash Demo (Brighter Version) (09-12-2002) (TJ)",c:1},B2D1E63F7F22864096B7B6C154151D55:{n:"Bounce! (17-03-2003) (Fabrizio Zavagli)",c:1},"7EAF009A892F03D90682DC1E67E85F07":{n:"Bounce! (18-03-2003) (Fabrizio Zavagli)",c:1},C9B7AFAD3BFD922E006A6BFC1D4F3FE7:{n:"Bowling (1979) (Atari)"},A28D872FC50FA6B64EB35981D0F4BB8D:{n:"Bowling (1979) (Atari) (4K)"},"2AA5E56D36C2E58B6F2856109F2099A9":{n:"Bowling (1979) (Atari) (4K) [a]"},"969B968383D9F0E9D8FFD1056BCAEF49":{n:"Bowling (1979) (Atari) (PAL)"},"82C25D1C35E6AC6F893D1D7C2FC2F9C8":{n:"Bowling (1979) (Atari) (PAL) (4K)"},"11E7E0D9437EC98FA085284CF16D0EB4":{n:"Bowling (208 in 1) (Unknown) (PAL)"},F69BB58B815A6BDCA548FA4D5E0D5A75:{n:"Bowling (32 in 1) (1988) (Atari) (PAL)"},"4B71197153D651480830638CB6A03249":{n:"Bowling (32 in 1) (1988) (Atari) (PAL) (4K)"},"32ECB5A652EB73D287E883EEA751D99C":{n:"Bowling (Dactar - Milmar)"},"58746219D8094EDFF869F0F5C2AEAAD5":{n:"Bowling (Jone Yuan) (4K)"},"7F07CD2E89DDA5A3A90D3AB064BFD1F6":{n:"Boxen (Ariola) (PAL)"},C3EF5C4653212088EDA54DC91D787870:{n:"Boxing (1980) (Activision)"},"88F74EC75EF696E7294B7B6AC5CA465F":{n:"Boxing (1980) (Activision) (16K)"},"277CCA62014FCEEBB46C549BAC25A2E3":{n:"Boxing (1980) (Activision) (4K)"},"5A80B857EB8B908AB477EC4EF902EDC8":{n:"Boxing (1980) (Activision) (8K)"},"25F2E760CD7F56B88AAC88D63757D41B":{n:"Boxing (1980) (Activision) (PAL)"},C2BCD8F2378C3779067F3A551F662BB7:{n:"Boxing (1980) (Activision) (PAL) (4K)"},A8B3EA6836B99BEA77C8F603CF1EA187:{n:"Boxing (1983) (CCE)"},"2C45C3EB819A797237820A1816C532EB":{n:"Boxing (32 in 1) (1988) (Atari) (PAL)"},B77468D586957D1B7FB4CCCDA2684F47:{n:"Boxing (32 in 1) (1988) (Atari) (PAL) (4K)"},CFB3260C603B0341D49DDFC94051EC10:{n:"Boxing (Dactari - Milmar)"},"34FD4FCB40FF5BABCE67F8B806D5969C":{n:"Boxing (Dactari) (4K)"},AFC194534C1B346609EF05EFF6D3CEF6:{n:"Boxing (Jone Yuan)"},FD6E507B5DF68BEEEDDEAF696B6828FA:{n:"Boxing (Unknown) (PAL)"},"1CCA2197D95C5A41F2ADD49A13738055":{n:"Brain Games (1978) (Atari)"},CB9626517B440F099C0B6B27CA65142C:{n:"Brain Games (1978) (Atari) (4K)"},F280976D69D6E27A48506BD6BAD11DCD:{n:"Brain Games (1978) (Atari) (PAL)"},"2162266B906C939B35C84FF9A0F50AD1":{n:"Brain Games (1978) (Atari) (PAL) (4K)"},"4DBF47C7F5AC767A3B07843A530D29A5":{n:"Breaking News (2002) (Ric Pryor) (Hack)"},F34F08E5EB96E500E851A80BE3277A56:{n:"Breakout (1978) (Atari)",p:1},C738FC3F5AAE1E8F86F7249F6C82AC81:{n:"Breakout (1978) (Atari) (16K)",p:1},"9A25B3CFE2BBB847B66A97282200CCA2":{n:"Breakout (1978) (Atari) (4K)",p:1},"6C76FE09AA8B39EE52035E0DA6D0808B":{n:"Breakout (1978) (Atari) (PAL)",p:1},C5FE45F2734AFD47E27CA3B04A90213C:{n:"Breakout (1978) (Atari) (PAL) (4K)",p:1},"4DF6124093CCB4F0B6C26A719F4B7706":{n:"Breakout (1978) (Atari) [a]",p:1},CFD6A8B23D12B0462BAF6A05EF347CD8:{n:"Bridge (1980) (Activision)"},"413C925C5FDCEA62842A63A4C671A5F2":{n:"Bridge (1980) (Activision) [fixed]"},"18A970BEA7AC4D29707C8D5CD559D03A":{n:"Bridge (208 in 1) (Unknown) (PAL)"},"428B2D36F5D716765460701F7016AC91":{n:"Brooni (2001) (Andrew Wallace) (PD)"},A537879D8E82E1061D3AD800479D3B84:{n:"Brooni (2001) (Andrew Wallace) (PD) (PAL)"},"1CF59FC7B11CDBCEFE931E41641772F6":{n:"Buck Rogers - Planet of Zoom (1983) (Sega)",c:1},CD88EF1736497288C4533BCCA339F881:{n:"Buck Rogers - Planet of Zoom (1983) (Sega) (PAL)",c:1},"68597264C8E57ADA93BE3A5BE4565096":{n:"Bugs (1982) (Data Age)",p:1},E61210293B14C9C4ECC91705072C6A7E:{n:"Bugs (1983) (Gameworld) (PAL)",p:1},A3486C0B8110D9D4B1DB5D8A280723C6:{n:"Bugs Bunny (08-04-1983) (Atari) (Prototype)"},FA4404FABC094E3A31FCD7B559CDD029:{n:"Bugs Bunny (1983) (Atari) (Prototype)"},"9E792A59F8795664CBAAFF1BA152D731":{n:"Bullet Demo (20-12-2002) (CT)"},"76F53ABBBF39A0063F24036D6EE0968A":{n:"Bump 'n' Jump (1983) (M Network)"},"9295570A141CDEC18074C55DC7229D08":{n:"Bump 'n' Jump (1989) (Telegames) (PAL)"},AA1C41F86EC44C0A44EB64C332CE08AF:{n:"Bumper Bash (1983) (Spectravideo)"},"1BF503C724001B09BE79C515ECFCBD03":{n:"Bumper Bash (1983) (Spectravideo) (PAL)"},"0443CFA9872CDB49069186413275FA21":{n:"BurgerTime (1983) (M Network)"},B42DF8D92E3118DC594CECD575F515D7:{n:"Burning Desire (1982) (Mystique) (PAL)",c:1},"19D6956FF17A959C48FCD8F4706A848D":{n:"Burning Desire (1982) (PlayAround)",c:1},"572D0A4633D6A9407D3BA83083536E0F":{n:"Busy Police (Funvision)"},"8905D54F48B8024FC718ED643E9033F7":{n:"Cabbage Patch Kids (05-24-1984) (Coleco) (Prototype)"},E1486C7822C07117B4F94A32E5ED68C1:{n:"Cabbage Patch Kids (06-14-1984) (Coleco) (Prototype)"},"80E5400470AC788143E6DB9BC8DD88CF":{n:"Cabbage Patch Kids (06-XX-1984) (Coleco) (Prototype)"},"4605A00F5B44A9CBD5803A7A55DE150E":{n:"Cabbage Patch Kids (07-03-1984) (Coleco) (Prototype)"},"7D726FA494F706784BAFEB1B50D87F23":{n:"Cabbage Patch Kids (07-27-1984) (Coleco) (Prototype)"},F4DABD5BCC603E8464A478208037D423:{n:"Cabbage Patch Kids (08-21-1984) (Coleco) (Prototype)"},"1FA7A42C2C7D6B7A0C6A05D38C7508F4":{n:"Cabbage Patch Kids (09-04-1984) (Coleco) (Prototype)"},"5D0E8A25CBD23E76F843C75A86B7E15B":{n:"Cabbage Patch Kids (09-07-1984) (Coleco) (Prototype)"},"66FCF7643D554F5E15D4D06BAB59FE70":{n:"Cabbage Patch Kids (09-13-1984) (Coleco) (Prototype)"},F6B5EBB65CBB2981AF4D546C470629D7:{n:"Cabbage Patch Kids (09-13-1984) (Coleco) (Prototype) [a]"},"7F6533386644C7D6358F871666C86E79":{n:"Cakewalk (1983) (CommaVid)"},"0060A89B4C956B9C703A59B181CB3018":{n:"Cakewalk (1983) (CommaVid) (PAL)"},"0EEBFB60D437796D536039701EC43845":{n:"Cakewalk (Fabrizio Zavagli)"},"9AB72D3FD2CC1A0C9ADB504502579037":{n:"California Games (1988) (Epyx)"},"8068E07B484DFD661158B3771D6621CA":{n:"California Games (1988) (Epyx) (PAL)"},"85478BB289DFA5C63726B9153992A920":{n:"Candi (Hack)"},"0E0808227EF41F6825C06F25082C2E56":{n:"Candi (Hack) [a]"},FEEDCC20BC3CA34851CD5D9E38AA2CA6:{n:"Canyon Bomber (1979) (Atari)",p:1},"3051B6071CB26377CD428AF155E1BFC4":{n:"Canyon Bomber (1979) (Atari) (4K)",p:1},"457F4AD2CDA5F4803F122508BFBDE3F5":{n:"Canyon Bomber (208 in 1) (Unknown) (PAL)"},"151C33A71B99E6BCFFB34B43C6F0EC23":{n:"Care Bears (1983) (Parker Bros) (Prototype)"},DE29E46DBEA003C3C09C892D668B9413:{n:"Carnival (1982) (CBS Electronics) (PAL)"},"028024FB8E5E5F18EA586652F9799C96":{n:"Carnival (1982) (Coleco)"},"8ED5A746C59571FEB255EAA7D6D0CF98":{n:"Carnival (208 in 1) (Unknown) (PAL) (Hack)"},"5409D20C1AEA0B89C56993AEC5DC5740":{n:"Carnival Shooter (PD)"},B816296311019AB69A21CB9E9E235D12:{n:"Casino (1979) (Atari)",p:1},"2BC26619E31710A9884C110D8430C1DA":{n:"Casino (1979) (Atari) (PAL)",p:1},"681206A6BDE73E71C19743607E96C4BB":{n:"Casino (Unknown) (PAL)",p:1},"76F66CE3B83D7A104A899B4B3354A2F2":{n:"Cat Trax (1983) (UA Limited) (Prototype)",c:1},D071D2EC86B9D52B585CC0382480B351:{n:"Cat Trax (1983) (UA Limited) (Prototype) [a]",c:1},B7903268E235310DC346A164AF4C7022:{n:"Cat Trax (Thomas Jentzsch) (PAL60)",c:1},A2DE0FC85548871279ED2A3C1325C13E:{n:"Cat and Mouse (George Veeder) (Hack)"},E2904748DA63DFEFC8816652B924B642:{n:"Catch Time (Jone Yuan)"},"9E192601829F5F5C2D3B51F8AE25DBE5":{n:"Cathouse Blues (1982) (PlayAround)",c:1},"8726C17EE7B559CB7BF2330D20972AD0":{n:"Cave Demo (21-04-2003) (CT)"},"91C2098E88A6B13F977AF8C003E0BCA5":{n:"Centipede (1982) (Atari)"},"17D000A2882F9FDAA8B4A391AD367F00":{n:"Centipede (1982) (Atari) (PAL)"},"2F11BA54609777E2C6A5DA9B302C98E8":{n:"Centipede (1982) (Atari) (Prototype) (PAL)"},"10958CD0A1A81D599005F1797AB0E51D":{n:"Centipede 2k (2000) (PD) (Hack)"},"713FDE2AF865B6EC464DFD72E2EBB83E":{n:"Challenge (208 in 1) (Unknown) (PAL)",c:1},"9905F9F4706223DADEE84F6867EDE8E3":{n:"Challenge (HES) (PAL)"},"4311A4115FB7BC68477C96CF44CEBACF":{n:"Challenge (Unknown)"},"73158EA51D77BF521E1369311D26C27B":{n:"Challenge (Zellers)"},"5D799BFA9E1E7B6224877162ACCADA0D":{n:"Challenge of.... Nexar, The (1982) (Spectravision)"},"1DA2DA7974D2CA73A823523F82F517B3":{n:"Challenge of.... Nexar, The (1982) (Spectravision) (PAL)"},"45C4413DD703B9CFEA49A13709D560EB":{n:"Challenge of.... Nexar, The (Jone Yuan) (Hack)"},"3D9C2FCCF8B11630762FF00811C19277":{n:"Challenge of.... Nexar, The (Unknown) (PAL)"},"3E33AC10DCF2DFF014BC1DECF8A9AEA4":{n:"Chase the Chuckwagon (1983) (Spectravideo)",c:1},"3F5A43602F960EDE330CD2F43A25139E":{n:"Checkers (1980) (Activision)"},"7EDC8FCB319B3FB61CAC87614AFD4FFA":{n:"Checkers (1980) (Activision) (4K)"},"191AC4EEC767358EE3EC3756C120423A":{n:"Checkers (208 in 1) (Unknown) (PAL)"},BCE93984B920E9B56CF24064F740FE78:{n:"Checkers (32 in 1) (1988) (Atari) (PAL)"},"499B612F6544AE71D4915AA63E403E10":{n:"Checkers (32 in 1) (1988) (Atari) (PAL) (4K)"},"3D7749FB9C2F91A276DFE494495234C5":{n:"Checkers (Jone Yuan)"},"04E737C9D53CD84BFD5EE679954E4706":{n:"Checkers (Jone Yuan) (4K)"},E5ECD78EDD24326A968809DECBC7B916:{n:"Cheese (Dragonfire Beta) (05-21-1982) (Imagic) (Prototype)"},"749FEC9918160921576F850B2375B516":{n:"China Syndrome (1982) (Spectravision)",c:1},E150F0D14F013A104B032305C0CE23EF:{n:"China Syndrome (1982) (Spectravision) (PAL)",c:1},"36F9A953EBDD9A8BE97CCF27A2041903":{n:"Chinese Character Demo (PD)"},C1CB228470A87BEB5F36E90AC745DA26:{n:"Chopper Command (1982) (Activision)"},"25D4BE3309B89583C6B39D9F93BF654F":{n:"Chopper Command (1982) (Activision) (16K)"},"51F211C8FC879391FEE26EDFA7D3F11C":{n:"Chopper Command (1982) (Activision) (8K)"},"114C599454D32F74C728A6E1F71012BA":{n:"Chopper Command (1982) (Activision) (PAL)"},"85A4133F6DCF4180E36E70AD0FCA0921":{n:"Chopper Command (1983) (CCE)"},FFDC0EB3543404EB4C353FBDDDFA33B6:{n:"Chopper Command (1983) (CCE) [a]"},DA66D75E4B47FAB99733529743F86F4F:{n:"Chopper Command (1983) (Digitel)"},C2C7A11717E255593E54D0ACAF653EE5:{n:"Chopper Command (208 in 1) (Unknown) (PAL) (Hack)"},"1CAD3B56CC0E6E858554E46D08952861":{n:"Chopper Command (Jone Yuan)"},F8811D45A9935CCA90C62F924712F8E6:{n:"Chopper Command (Jone Yuan) (Hack)"},B9F9C0FED0DB08C34346317F3957A945:{n:"Chopper Command (SuperVision) (PAL)"},ACB6787B938079F4E74313A905EC3CEB:{n:"Chronocolor Donkey Kong (PD)"},EE456542B93FA8D7E6A8C689B5A0413C:{n:"Chronocolor Donkey Kong Clean (PD)"},"1D5EAC85E67B8CFF1377C8DBA1136929":{n:"Chronocolor Donkey Kong Sideways (PD)"},D605ED12F4EAAAEC3DCD5AA909A4BAD7:{n:"Chronocolor Frame Demo (10-01-2003) (AD)"},DB339AEA2B65B84C7CFE0EEAB11E110A:{n:"Chronocolor Frame Demo 2 (10-01-2003) (AD)"},A30ECE6DC4787E474FBC4090512838DC:{n:"Circus (Zellers)"},A7B96A8150600B3E800A4689C3EC60A2:{n:"Circus Atari (1980) (Atari)",p:1},A29DF35557F31DFEA2E2AE4609C6EBB7:{n:"Circus Atari (1980) (Atari) (Joystick)"},"30E0AB8BE713208AE9A978B34E9E8E8C":{n:"Circus Atari (1980) (Atari) (PAL)",p:1},EFFFAFC17B7CB01B9CA35324AA767364:{n:"Circus Atari (Unknown)"},"324CB4A749BCAC4F3DB9DA842B85D2F7":{n:"Climber 5 (01-05-2003) (Dennis Debro)"},"9D4BC7C6FE9A7C8C4AA24A237C340ADB":{n:"Climber 5 (16-04-2003) (Dennis Debro)"},"87B460DF21B7BBCFC57B1C082C6794B0":{n:"Climber 5 (20-03-2003) (Dennis Debro)"},D82C8A58098A6B46C5B81C16180354D1:{n:"Climber 5 (30-10-2002) (Dennis Debro) (Prototype)"},"1E587CA91518A47753A28217CD4FD586":{n:"Coco Nuts (1982) (Telesys)"},"5846B1D34C296BF7AFC2FA05BBC16E98":{n:"Codebreaker (1978) (Atari)"},"83F50FA0FBAE545E4B88BB53B788C341":{n:"Codebreaker (1978) (Atari) (4K)"},A47E26096DE6F6487BF5DD2D1CCED294:{n:"Codebreaker (1978) (Atari) (PAL)"},"71D005B60CF6E608D04EFB99A37362C3":{n:"Codebreaker (1978) (Atari) (PAL) (4K) [a]"},"551A64A945D7D6ECE81E9C1047ACEDBC":{n:"Coffee Cup Soccer (Matthias Jaap) (Hack)"},"76A9BF05A6DE8418A3EBC7FC254B71B4":{n:"Color Bar Generator (1984) (VideoSoft)"},E5A6E0BB7D56E2F08B237E15076E5699:{n:"Color Table Display Helper (PD)"},C221607529CABC93450EF25DBAC6E8D2:{n:"Color Test (26-09-2002) (Eckhard Stolberg)"},"58C396323EA3E85671E34C98EB54E2A4":{n:"Color Tweaker (B. Watson)"},F6DAEBC0424FA0F8D9AAF26C86DF50F4:{n:"Color Tweaker (V1.0) (2001) (B. Watson)"},"35AE903DFF7389755AD4A07F2FB7400C":{n:"Colored Wall Demo (PD)"},"97A9BB5C3679D67F5C2CD17F30B85D95":{n:"Colors (1980) (Atari) (Prototype) (PAL)"},"3F9431CC8C5E2F220B2AC14BBC8231F4":{n:"Colors Demo (PD)"},CC74DDB45D7BC4D04C2E6F1907416699:{n:"Colour Display Programme (1997) (Chris Cracknell)"},"9989F974C3CF9C641DB6C8A70A2A2267":{n:"Colours Selector (Eckhard Stolberg)"},"3C72DDAF41158FDD66E4F1CB90D4FD29":{n:"Comando Suicida (Dismac)"},"4C8832ED387BBAFC055320C05205BC08":{n:"Combat (1977) (Atari)"},AC05C0E53A5E7009DDD75ED4B99949FC:{n:"Combat (1977) (Atari) (4K)"},BE35D8B37BBC03848A5F020662A99909:{n:"Combat (1977) (Atari) (4K) [a]"},E8AA36E3D49E9BFA654C25DCC19C74E6:{n:"Combat (1977) (Atari) (PAL)"},"0EF64CDBECCCB7049752A3DE0B7ADE14":{n:"Combat (32 in 1) (1988) (Atari) (PAL)"},E2ECCBBE963F80F291CB1F18803BF557:{n:"Combat (32 in 1) (1988) (Atari) (PAL) (4K)"},E94632B0D863DD76459D689A9865BB33:{n:"Combat (Jone Yuan) (4K)"},"331938989F0F33CA39C10AF4C09FF640":{n:"Combat - Tank AI (19-04-2003) (Zach Matley)"},"176D3FBA7D687F2B23158098E103C34A":{n:"Combat AI (16-02-2003) (Zach Matley)"},"5385CF2A04DE1D36AB55C73174B84DB0":{n:"Combat Rock (PD) (Hack)"},E63EFDFDA9A4003DCD77A854A781A06A:{n:"Combat Rock (PD) (Hack) [a]"},"461029AB23800833E9645BE3E472D470":{n:"Combat TC (v0.1)"},B0C9CF89A6D4E612524F4FD48B5BB562:{n:"Combat Two (1982) (Atari) (Prototype)"},E25E173740F7ECC0E23025445C4591F3:{n:"Comitoid (Greg Zumwalt)"},"99F7C6C26046BBE95F1C604B25DA8360":{n:"Comitoid beta 2 (SnailSoft)"},"755FED16B48E81DE05130708A905D00D":{n:"Comitoid beta 3 (SnailSoft)"},E4E9125A8741977583776729359614E1:{n:"Comitoid beta 4 (SnailSoft)"},"5D2CC33CA798783DEE435EB29DEBF6D6":{n:"Commando (1988) (Activision)"},DE1E9FB700BAF8D2E5AE242BFFE2DBDA:{n:"Commando (1988) (Activision) (PAL)"},"61631C2F96221527E7DA9802B4704F93":{n:"Commando (1988) (Activision) [different logo]"},F457674CEF449CFD85F21DB2B4F631A7:{n:"Commando Raid (1982) (U.S. Games)"},"5864CAB0BC21A60BE3853B6BCD50C59F":{n:"Commando Raid (208 in 1) (Unknown) (PAL)"},"5F316973FFD107F7AB9117E93F50E4BD":{n:"Commando Raid (Unknown) (PAL)"},"2C8835AED7F52A0DA9ADE5226EE5AA75":{n:"Communist Mutants from Space (1982) (Arcadia)"},E2C89F270F72CD256ED667507FA038A2:{n:"Communist Mutants from Space (1982) (Arcadia) (PAL)"},C4B73C35BC2F54B66CD786F55B668A82:{n:"Communist Mutants from Space (1982) (Arcadia) [a]"},D541B20EAE221A8EE321375E5971E766:{n:"Communist Mutants from Space (Preview) (1982) (Arcadia)"},"7BA07D4EA18BF3B3245C374D8720AD30":{n:"Communist Mutants from Space (Preview) (1982) (Arcadia) (PAL)"},B98CC2C6F7A0F05176F74F0F62C45488:{n:"CompuMate (1983) (Spectravideo)",c:1},E7F005DDB6902C648DE098511F6AE2E5:{n:"CompuMate (1983) (Spectravideo) (PAL)",c:1},"6A2C68F7A77736BA02C0F21A6BA0985B":{n:"Computer Chess (07-07-1978) (Atari) (Prototype)"},B49331B237C8F11D5F36FE2054A7B92B:{n:"Condor Attack (Unknown) (PAL)"},F965CC981CBB0822F955641F8D84E774:{n:"Confrontation (1983) (Answer) (Prototype)",c:1},"00B7B4CBEC81570642283E7FC1EF17AF":{n:"Congo Bongo (1983) (Sega)"},"335A7C5CFA6FEE0F35F5824D1FA09AED":{n:"Congo Bongo (1983) (Sega) (PAL)"},D078D25873C5B99F78FA267245A2AF02:{n:"Congo Bongo (1983) (Sega) [a]"},C2FBEF02B6EEA37D8DF3E91107F89950:{n:"Conquest Of Mars (NTSC)"},"85BBEFB90E16BF386B304C1E9A1F6084":{n:"Conquest Of Mars (PAL60)"},A81B29177F258494B499FBAC69789CEF:{n:"Console Wars (Greg Thompson) (Hack)"},"57C5B351D4DE021785CF8ED8191A195C":{n:"Cookie Monster Munch (1983) (Atari)"},A0297C4788F9E91D43E522F4C561B4AD:{n:"Cookie Monster Munch (1983) (Atari) (PAL)"},"798B8921276EEC9E332DFCB47A2DBB17":{n:"Cookie Monster Munch (1983) (Atari) (PAL) [a]"},"01E5C81258860DD82F77339D58BC5F5C":{n:"Corrida da Matematica (CCE)"},"6A3B0C33CF74B1E213A629E3C142B73C":{n:"Cory The Interviewer (Cody Pittman) (Hack)"},EEB92F3F46DF841487D1504F2896D61A:{n:"Corys Adventure (Cody Pittman) (Hack)"},AB5BF1EF5E463AD1CBB11B6A33797228:{n:"Cosmic Ark (1982) (Imagic)"},C5124E7D7A8C768E5A18BDE8B54AEB1D:{n:"Cosmic Ark (1982) (Imagic) (PAL)"},"0FD72A13B3B6103FC825A692C71963B4":{n:"Cosmic Ark (1982) (Imagic) (PAL) [selectable starfield]"},"98EF1593624B409B9FB83A1C272A0AA7":{n:"Cosmic Ark (1983) (CCE)"},"69DF0411D4D176E558017F961F5C5849":{n:"Cosmic Ark (1983) (CCE) [a]"},"7D903411807704E725CF3FAFBEB97255":{n:"Cosmic Ark (Reaction) (1982) (Imagic) [selectable starfield]"},"72D0ACB5DE0DB662DE0360A6FC59334D":{n:"Cosmic Ark (Unknown) (PAL)"},"05D61B925D3D2474BAB83F0A79BB5DF1":{n:"Cosmic Ark Stars (1997) (Eckhard Stolberg)"},"00CE76AD69CDC2FA36ADA01AE092D5A6":{n:"Cosmic Avenger (4 Game in One) (1983) (BitCorp) (PAL)"},"133B56DE011D562CBAB665968BDE352B":{n:"Cosmic Commuter (1984) (Activision)"},BA657D940A11E807FF314BBA2C8B389B:{n:"Cosmic Commuter (1984) (Activision) (16K)"},"59734E1CC41822373845A09C51E6BA21":{n:"Cosmic Commuter (1984) (Activision) (8K)"},"5F1B7D5FA73AA071BA0A3C2819511505":{n:"Cosmic Commuter (CCE)"},"8E879AA58DB41EDB67CBF318B77766C4":{n:"Cosmic Commuter (Thomas Jentzsch) (PAL60)"},F367E58667A30E7482175809E3CEC4D4:{n:"Cosmic Corridor (1983) (ZiMAG)"},"3C853D864A1D5534ED0D4B325347F131":{n:"Cosmic Creeps (1982) (Telesys)",c:1},E2CA84A2BB63D1A210EBB659929747A9:{n:"Cosmic Creeps (1982) (Telesys) (PAL)",c:1},"5835A78A88F97ACEA38C964980B7DBC6":{n:"Cosmic Creeps (Unknown) (PAL)",c:1},E5F17B3E62A21D0DF1CA9AEE1AA8C7C5:{n:"Cosmic Swarm (1982) (CommaVid)",c:1},"9DEC0BE14D899E1AAC4337ACEF5AB94A":{n:"Cosmic Swarm (1982) (CommaVid) (4K)",c:1},"2A2F46B3F4000495239CBDAD70F17C59":{n:"Cosmic Swarm (1982) (CommaVid) (PAL)",c:1},"3E22C7EAF6459B67388602E4BEBBB3A8":{n:"Cosmic Swarm (1982) (CommaVid) (PAL) (4K)"},"8AF58A9B90B25907DA0251EC0FACF3B8":{n:"Cosmic Swarm (Jone Yuan)"},"1B0F3D7AF668EEEA38DDD6182D8F48FB":{n:"Cosmic Swarm (Jone Yuan) (4K)",c:1},"36547BC6FAA5132B87504E18D088E1D7":{n:"Cosmic Swarm (Unknown) (PAL) (4K)",c:1},"6C91AC51421CB9FC72C9833C4F440D65":{n:"Cosmic Town (1983) (ITT Family Games) (PAL)"},"4981CEFE5493EA512284E7F9F27D1E54":{n:"Cosmic War (1983) (Home Vision) (PAL)"},BE561B286B6432CAC71BCCBAE68002F7:{n:"Counter Demo (PD)"},FE67087F9C22655CE519616FC6C6EF4D:{n:"Crack'ed (11-28-1988) (Atari) (Prototype)"},A184846D8904396830951217B47D13D9:{n:"Crackpots (1983) (Activision)"},"88ED87C011F699DD27321DBE404DB6C8":{n:"Crackpots (1983) (Activision) (16K)"},"5A17E30E6E911E74CCD7B716D02B16C6":{n:"Crackpots (1983) (Activision) (8K)"},"3F3AD2765C874CA13C015CA6A44A40A1":{n:"Crackpots (1983) (CCE)"},"3091AF0EF1A61E801F4867783C21D45C":{n:"Crackpots (1983) (CCE) [a]"},"13448EB5BA575E8D7B8D5B280EA6788F":{n:"Crackpots (Digivision)"},"606C2C1753051E03C1F1AC096C9D2832":{n:"Crackpots (Jone Yuan)"},F3C431930E035A457FE370ED4D230659:{n:"Crackpots (Unknown) (PAL)"},FB88C400D602FE759AE74EF1716EE84E:{n:"Crash Dive (1983) (20th Century Fox)"},"0CEBB0BB45A856B23F56D21CE7D1BC34":{n:"Crash Dive (1983) (20th Century Fox) (PAL)"},"9072C142728A3A3D994956D03BFACBA2":{n:"Crash Dive (Fabrizio Zavagli) (PAL60)"},"55EF7B65066428367844342ED59F956C":{n:"Crazy Climber (1982) (Atari)"},"4A7EEE19C2DFB6AEB4D9D0A01D37E127":{n:"Crazy Valet (Hozer Video Games)"},C17BDC7D14A36E10837D039F43EE5FA3:{n:"Cross Force (1982) (Spectravision)"},"8F88309AFAD108936CA70F8B2B084718":{n:"Cross Force (1982) (Spectravision) (PAL)"},"8372EEC01A08C60DBED063C5524CDFB1":{n:"Cross Force (Unknown) (PAL)"},"8CD26DCF249456FE4AEB8DB42D49DF74":{n:"Crossbow (1987) (Atari)"},"7E4783A59972AE2CD8384F231757EA0B":{n:"Crossbow (1987) (Atari) (PAL)"},"384F5FBF57B5E92ED708935EBF8A8610":{n:"Crypts of Chaos (1982) (20th Century Fox)"},F12AFBFFA080DD3B2801DD14D4837CF6:{n:"Crystal Castles (01-04-1984) (Atari) (Prototype)",c:1},"1C6EB740D3C485766CADE566ABAB8208":{n:"Crystal Castles (1984) (Atari)"},CA7ABC774A2FA95014688BC0849EEE47:{n:"Crystal Castles (1984) (Atari) (PAL)"},C68A6BAFB667BAD2F6D020F879BE1D11:{n:"Crystal Castles (1984) (Atari) (Prototype)"},A6127F470306EED359D85EB4A9CF3C96:{n:"Crystal Castles (1984) (Atari) [a]"},"0ABF64CA504A116ADCA80F77F85E00FB":{n:"Cube Conquest (Billy Eno) (PD)"},"58E313E2B5613B2439B5F12BB41E3EEF":{n:"Cube Conquest (Demo Interlace) (Billy Eno) (PD)",c:1},F1929BB9B5DB22D98DD992AA3FE72920:{n:"Cube Conquest (Improved Interlace) (Billy Eno) (PD)",c:1},"36A701C60A9F9768D057BC2A83526A80":{n:"Cube Conquest (Interlaced) (Billy Eno) (PD)",c:1},"292F2446A0325B7B423E88A2EBFEB5A0":{n:"Cube Conquest (Non Interlaced) (Billy Eno) (PD)",c:1},"6FA0AC6943E33637D8E77DF14962FBFC":{n:"Cubicolor (1982) (Imagic) (Prototype)"},F74AD642552385C3DAA203A2A6FC2291:{n:"Cubis (1997) (Eckhard Stolberg)"},D2C957DD7746521B51BB09FDE25C5774:{n:"Cubis (6K) (1997) (Eckhard Stolberg)"},"281FF9BD0470643853DE5CBD6D9E17F5":{n:"Cubis (EM) (1997) (Eckhard Stolberg)"},"64CA518905311D2D9AEB56273F6CAA04":{n:"Cubo Magico (CCE)"},"58513BAE774360B96866A07CA0E8FD8E":{n:"Custer's Revenge (1982) (Mystique)"},"50200F697AEEF38A3CE31C4F49739551":{n:"Custer's Revenge (1982) (Mystique) (PAL60)"},D57EB282D7540051BC9B5427CF966F03:{n:"Custer's Viagra (Atari Troll) (Hack)"},"93EB1795C8B1065B1B3D62BB9EC0CCDC":{n:"Custer's Viagra (JSK) (Hack)"},"211F76DFF0B7DAD3F6FCAC9D938EE61A":{n:"Custer's Viagra (JSK) (Hack) [a]"},"5355F80CACF0E63A49CBF4ADE4E27034":{n:"Cute Dead Things House (Christian Samuel) (Hack)"},"60358EDF0C2CC76B1E549E031E50E130":{n:"Cyber Goth Galaxian (Manuel Polik) (Hack)"},"52615AE358A68DE6E76467E95EB404C7":{n:"DJdsl-wopd (PD)",c:1},"2B42DA79A682ED6E2D735FACBF70107E":{n:"DKjr Improved (Hack)"},B719ADA17771A8D206C7976553825139:{n:"DUP Space Invaders (Ron Corcoran) (Hack)"},"929E8A84ED50601D9AF8C49B0425C7EA":{n:"Dancing Plate (1982) (BitCorp) (PAL)",c:1},ECE463ABDE92E8B89BCD867EC71751B8:{n:"Dancing Plate (1982) (Puzzy) (PAL)",c:1},F48735115EC302BA8BB2D2F3A442E814:{n:"Dancing Plate (Unknown) (PAL)",c:1},"2D1CF85FBC732856BF76470CD4060F4A":{n:"Daredevil (V1) (Stunt_Cycle_Rules!) (PD)"},CD8FA2E9F6255EF3D3B9B5A4F24A54F7:{n:"Daredevil (V2) (Stunt_Cycle_Rules!) (PD)"},"585F73010E205AE5B04EE5C1A67E632D":{n:"Daredevil (V3) (Stunt_Cycle_Rules!) (PD)"},A422194290C64EF9D444DA9D6A207807:{n:"Dark Cavern (1982) (M Network)"},"106855474C69D08C8FFA308D47337269":{n:"Dark Chambers (1988) (Atari)",c:1},"0D5AF65AD3F19558E6F8E29BF2A9D0F8":{n:"Dark Chambers (1988) (Atari) (PAL)",c:1},"951E8CEC7A1A1D6C01FD649E7FF7743A":{n:"Dark Chambers (1988) (Atari) (Prototype) (PAL)"},DBA270850AE997969A18EE0001675821:{n:"Dark Mage (Greg Troutman) (PD) (4K)",c:1},"6333EF5B5CBB77ACD47F558C8B7A95D3":{n:"Dark Mage (Greg Troutman) (PD) (8K)",c:1},"6CD506509E8FD5627F55603780E862A8":{n:"Dark Mage (SuperCharger) (Greg Troutman) (PD)",c:1},"2B71A59A53BE5883399917BF582B7772":{n:"Dark Mage (final beta) (Greg Troutman) (PD)",c:1},"1345E972DBE08EA3E70850902E20E1A5":{n:"Dark Mage (rough beta) (Greg Troutman) (PD)",c:1},C1F209D80F0624DADA5866CE05DD3399:{n:"Deadly Discs (1989) (Telegames) (PAL)"},E4C00BEB17FDC5881757855F2838C816:{n:"Deadly Duck (1982) (20th Century Fox)"},"80CD42881E670E4B74A9CCD10D0D7B2E":{n:"Deadly Duck (1982) (20th Century Fox) [a]"},"4E15DDFD48BCA4F0BF999240C47B49F5":{n:"Death Trap (1983) (Avalon Hill)",c:1},AC7C2260378975614192CA2BC3D20E0B:{n:"Decathlon (1983) (Activision)"},"883258DCD68CEFC6CD4D40B1185116DC":{n:"Decathlon (1983) (Activision) (PAL)"},"525F2DFC8B21B0186CFF2568E0509BFC":{n:"Decathlon (1983) (Activision) [fixed]"},BF52327C2197D9D2C4544BE053CADED1:{n:"Decathlon (HES) (PAL) (16K)"},E1029676EDB3D35B76CA943DA7434DA8:{n:"Defender (10-30-1981) (Atari) (Prototype)"},"0F643C34E40E3F1DAAFD9C524D3FFE64":{n:"Defender (1982) (Atari)"},E4BFF1D5DF70163C0428A1EAD309C22D:{n:"Defender (1982) (Atari) (PAL)"},"808C3B1E60EE0E7C65205FA4BD772221":{n:"Defender (CCE)"},"6596B3737AE4B976E4AADB68D836C5C7":{n:"Defender (Digivision)"},"35B10A248A7E67493EC43AEB9743538C":{n:"Defender (Dor-x) (Hack)"},"3C4223316C835CEAAD619651E25DF0F9":{n:"Defender (Genesis)"},"047AC3B9FAEA64522B7A23C4465A7AA8":{n:"Defender (Unknown) (PAL)"},CE82A675C773FF21E0FFC0A4D1C90A71:{n:"Defender 2 (Genesis)"},"6F3E3306DA2AA6E74A5E046FF43BF028":{n:"Defender Arcade (Genesis)"},"3A771876E4B61D42E3A3892AD885D889":{n:"Defender II (1988) (Atari)"},"5F786B67E05FB9985B77D4BEB35E06EE":{n:"Defender II (1988) (Atari) (PAL)"},"278531CC31915747018D22145823D2C9":{n:"Defender MegaDrive (PAL) (Genesis)"},"039CF18B459D33B8A8FCA31D06C4C244":{n:"Demo Image Series #0 (12-02-2003) (AD)"},A4AB331E8768EAFDC20CE8B0411FF77A:{n:"Demo Image Series #1 - Sam (19-02-2003) (AD)"},EA86176B27AB0DA8CCE8F0179884BFAA:{n:"Demo Image Series #10 - It's Art (28-02-2003) (AD)"},"678C1D71A1616D9D022F03D8545B64BB":{n:"Demo Image Series #11 - Donald And Mario (28-02-2003) (AD)"},CB8399DC0D409FF1F531EF86B3B34953:{n:"Demo Image Series #12 - Luigi And Mario (01-03-2003) (AD)"},"83F05ECECAE8BE59BA1E51135F4BDCBF":{n:"Demo Image Series #13 - Mario (4K Interleaved Chronocolour) (05-03-2003) (AD)"},"3025BDC30B5AEC9FB40668787F67D24C":{n:"Demo Image Series #14 - Two Marios (4K Interleaved Chronocolour Vertical Movement) (05-03-2003) (AD)"},"25710BDE8FA181B0C5CF0846B983BEC1":{n:"Demo Image Series #15 - Three Marios (NTSC) (06-03-2003) (AD)"},FB0C32EF7AF5B45486DB663510094BE8:{n:"Demo Image Series #15 - Three Marios (NTSC) (Non-Interleave) (06-03-2003) (AD)"},"8D8B7D7B983F75DEBBDAAC651E814768":{n:"Demo Image Series #15 - Three Marios (PAL) (06-03-2003) (AD)"},"14DBB3686DD31964332DC2EF0C55CAD0":{n:"Demo Image Series #15 - Three Marios (PAL) (Non-Interleave) (06-03-2003) (AD)"},EDE7E8BF865B0AFB4744F86D13624F9A:{n:"Demo Image Series #2 - Clown (19-02-2003) (AD)"},"02066B17F29082412C6754C1A2D6302E":{n:"Demo Image Series #3 - Baboon (19-02-2003) (AD)"},C1B1049B88BCD98437D8872D1D62BA31:{n:"Demo Image Series #4 - Donald (19-02-2003) (AD)"},BB6A5A2F7B67BEE5D1F237F62F1E643F:{n:"Demo Image Series #5 - Animegirl (19-02-2003) (AD)"},A47878A760F5FA3AA99F95C3FDC70A0B:{n:"Demo Image Series #5 - Baboon (19-02-2003) (AD)"},"373B8A081ACD98A895DB0CB02DF35673":{n:"Demo Image Series #5 - Boofly (19-02-2003) (AD)"},"7CD379DA92C93679F3B6D2548617746A":{n:"Demo Image Series #5 - Clown (19-02-2003) (AD)"},CD38AD19F51B1048D8E5E99C86A2A655:{n:"Demo Image Series #5 - Flag (19-02-2003) (AD)"},A0D502DC8B90B1D7DAA5F6EFFB10D349:{n:"Demo Image Series #5 - Sam (19-02-2003) (AD)"},A310494AD5BA2B5B221A30D7180A0336:{n:"Demo Image Series #6 - Mario (19-02-2003) (AD)"},B451307B8B5E29F1C5F2CF064F6C7227:{n:"Demo Image Series #6 - Mario (Fixed) (26-02-2003) (AD)"},D1B4075925E8D3031A7616D2F02FDD1F:{n:"Demo Image Series #7 - Two Marios (27-02-2003) (AD)"},"5C1B1AA78B7609D43C5144C3B3B60ADF":{n:"Demo Image Series #8 - Two Marios (Different Interlacing) (27-02-2003) (AD)"},C8C7DA12F087E8D16D3E6A21B371A5D3:{n:"Demo Image Series #9 - Genius (28-02-2003) (AD)"},D09935802D6760AE58253685FF649268:{n:"Demolition Herby (1983) (Telesys)",c:1},"7DFD100BDA9ABB0F3744361BC7112681":{n:"Demolition Herby (1983) (Telesys) (PAL)",c:1},"4A6BE79310F86F0BEBC7DFCBA4D74161":{n:"Demolition Herby (Unknown) (PAL)",c:1},F0E0ADDC07971561AB80D9ABE1B8D333:{n:"Demon Attack (1982) (Imagic)"},"4901C05068512828367FDE3FB22199FE":{n:"Demon Attack (1982) (Imagic) (PAL)"},B12A7F63787A6BB08E683837A8ED3F18:{n:"Demon Attack (1982) (Imagic) [fixed]"},B24F6A5820A4B7763A3D547E3E07441D:{n:"Demon Attack (1983) (CCE)"},"9718B85AC5A55CBC7348963C63FFA35A":{n:"Demon Attack (Robby)"},BAC28D06DFC03D3D2F4A7C13383E84EE:{n:"Demon Attack (Supergame)"},"110AC8ECAF1B69F41BC94C59DFCB8B2D":{n:"Demon Attack (Unknown)"},"442602713CB45B9321EE93C6EA28A5D0":{n:"Demon Attack (Unknown) (PAL)"},F91FB8DA3223B79F1C9A07B77EBFA0B2:{n:"Demons to Diamonds (1982) (Atari)",p:1},D62283AED0F4199ADB2333DE4C263E9C:{n:"Demons to Diamonds (1982) (Atari) (PAL)",p:1},BF84F528DE44225DD733C0E6A8E400A0:{n:"Demons to Diamonds (CCE)",p:1},"698F569EAB5A9906EEC3BC7C6B3E0980":{n:"Demons! (2003) (SpkLeader) (Hack)"},"2D16A8B59A225EA551667BE45F554652":{n:"Der Geheimkurier (1983) (Quelle) (PAL)"},A1CA372388B6465A693E4626CC98B865:{n:"Der Vielfrass (1983) (Quelle) (PAL)"},"25A21C47AFE925A3CA0806876A2B4F3F":{n:"Der kleine Baer (1983) (Quelle) (PAL)"},A1F9159121142D42E63E6FB807D337AA:{n:"Der moderne Ritter (1983) (Quelle) (PAL)"},E9E6AD30549A6E2CD89FE93B7691D447:{n:"Desert Falcon (05-27-1987) (Atari) (Prototype) (PAL)"},FD4F5536FD80F35C64D365DF85873418:{n:"Desert Falcon (1987) (Atari)"},D4806775693FCAAA24CF00FC00EDCDF3:{n:"Desert Falcon (1987) (Atari) (PAL)"},"626D67918F4B5E3F961E4B2AF2F41F1D":{n:"Diagnostic Test Cartridge 2.0 (1980) (Atari) (Prototype)"},"38BD172DA8B2A3A176E517C213FCD5A6":{n:"Diagnostic Test Cartridge 2.6 (1982) (Atari)"},"02AB2C47BC21E7FEAFA015F90D7DF776":{n:"Diagnostic Test Cartridge 2.6 (1982) (Atari) (Prototype)"},"09F89BBFA2AB00F1964D200E12D7CED0":{n:"Diagnostic Test Cartridge 2.6 (1982) (Atari) (Prototype) (4K)"},"740F39E71104E90416C29A73560B9C6B":{n:"Diagnostic Test Cartridge 2.6P (1982) (Atari) (PAL) (4K)"},"9222B25A0875022B412E8DA37E7F6887":{n:"Dice Puzzle (1983) (Panda)",c:1},E02156294393818FF872D4314FC2F38E:{n:"Dice Puzzle (1983) (Sancho) (PAL)",c:1},"72876FD7C7435F41D571F1101FC456EA":{n:"Die Ente und der Wolf (1983) (Quelle) (PAL)"},"31DF1C50C4351E144C9A378ADB8C10BA":{n:"Die Ratte und die Karotten (1983) (Quelle) (PAL)"},"834A2273E97AEC3181EE127917B4B269":{n:"Die hungrigen Froesche (1983) (Quelle) (PAL)"},"6DDA84FB8E442ECF34241AC0D1D91D69":{n:"Dig Dug (1983) (Atari)"},"977294AE6526C31C7F9A166EE00964AD":{n:"Dig Dug (1983) (Atari) (PAL)"},"21D2C435BCCCDE7792D82844B3CF60F4":{n:"Dig Dug (1983) (Atari) (PAL) [a]"},BAE1A23F9B6ACDADF465CFB330BA0ACB:{n:"Dig Dug (1983) (Atari) [a]"},EF66AF190840871409FE1702D2483554:{n:"DiscoTech (12-02-2003) (Andrew Davie)"},"939CE554F5C0E74CC6E4E62810EC2111":{n:"Dishaster (1983) (ZiMAG)",c:1},"740B47DF422372FBEF700B42CEA4E0BF":{n:"Dizzy Wiz (2001) (B. Watson)"},A5E9ED3033FB2836E80AA7A420376788:{n:"Dodge 'Em (1980) (Atari) (PAL)"},"10F62443F1AE087DC588A77F9E8F43E9":{n:"Dodge 'Em (1980) (Atari) (PAL) [fixed]"},C3472FA98C3B452FA2FD37D1C219FB6F:{n:"Dodge 'Em (1980) (Atari) [a]"},"83BDC819980DB99BF89A7F2ED6A2DE59":{n:"Dodge 'Em (1980) (Atari) [fixed]"},D28AFE0517A046265C418181FA9DD9A1:{n:"Dodge 'Em (Unknown) (PAL)"},BC526185AD324241782DC68BA5D0540B:{n:"Dodge Demo 1 (PD)"},"5ACF9865A72C0CE944979F76FF9610F0":{n:"Dodge Demo 2 (PD)"},"0C0392DB94A20E4D006D885ABBE60D8E":{n:"Dodge Demo 3 (PD)"},E2B682F6E6D76B35C180C7D847E93B4F:{n:"Dodge Demo 4 (PD)"},CA09FA7406B7D2AEA10D969B6FC90195:{n:"Dolphin (1983) (Activision)"},D09A7504EE8C8717AC3E24D263E7814D:{n:"Dolphin (1983) (Activision) (16K)"},E237EE91514D5ED535C95A14FC608C11:{n:"Dolphin (1983) (Activision) (8K)"},"3889351C6C2100B9F3AEF817A7E17A7A":{n:"Dolphin (CCE)"},"7FFC2D80FD49A124808315306D19868E":{n:"Domino (Ishido) (PD)"},"937736D899337036DE818391A87271E0":{n:"Donald Duck's Speedboat (04-12-1983) (Atari) (Prototype)"},FA7CE62E7FD77E02B3E2198D70742F80:{n:"Donald Duck's Speedboat (04-18-1983) (Atari) (Prototype) (PAL)"},F473F99E47D4026A7A571184922EBF04:{n:"Donkey Claus (Philip R. Frey) (Hack)"},"8B5B1E3A434EBBDC2C2A49DC68F46360":{n:"Donkey Kong (1982) (CBS Electronics) (PAL)"},"3A526E6A1F9FE918AF0F2CE997DFEA73":{n:"Donkey Kong (1982) (CBS Electronics) (PAL) [a1]"},"0894AA7BE77521F9DF562BE8D9555FE6":{n:"Donkey Kong (1982) (CBS Electronics) (PAL) [a2]"},B59417D083B0BE2D49A7D93769880A4B:{n:"Donkey Kong (1983) (Pet Boat) (PAL)"},"36B20C427975760CB9CF4A47E41369E4":{n:"Donkey Kong (1987) (Atari)"},"7511C34518A9A124EA773F5B0B5C9A48":{n:"Donkey Kong (208 in 1) (Unknown) (PAL)"},DE5AAB22E5ABA5EDCB29A3E7491FF319:{n:"Donkey Kong (Star Game)"},E7864CAAF9EC49ED67B1904CE8602690:{n:"Donkey Kong 2K3 Pic (PD)"},"5B98E0536C3F60547DD708AE22ADB04B":{n:"Donkey Kong Gingerbread Man (Ben Hudman) (Prototype)"},"5A6FEBB9554483D8C71C86A84A0AA74E":{n:"Donkey Kong Jr (1983) (CCE)"},"2880C6B59BD54B153174676E465167C7":{n:"Donkey Kong Jr. (Tron)"},"2091AF29B4E7B86914D79D9AAA4CBD20":{n:"Donkey Kong Junior (1983) (CBS Electronics) (PAL)"},C8FA5D69D9E555EB16068EF87B1C9C45:{n:"Donkey Kong Junior (1987) (Atari)"},"278155FC9956E9B6EF2359EB238F7C7F":{n:"Donkey Kong Junior (Unknown) (Hack)"},"200A9D2A7CB4441CE4F002DF6AA47E38":{n:"Doomzerk (PD) (Hack)"},"7E2FE40A788E56765FE56A3576019968":{n:"Double Dragon (1989) (Activision)"},"3624E5568368929FABB55D7F9DF1022E":{n:"Double Dragon (1989) (Activision) (PAL)"},"47464694E9CCE07FDBFD096605BF39D4":{n:"Double Dragon (1989) (Activision) (PAL) [a]"},"4999B45BE0AB5A85BAC1B7C0E551542B":{n:"Double Dragon (CCE) (PAL)"},"740A7FA80F52CC7287BA37677AFB6B21":{n:"Double Dragon (PAL) (Genesis)"},"368D88A6C071CABA60B4F778615AAE94":{n:"Double Dunk (1989) (Atari)"},CFC226D04D7490B69E155ABD7741E98C:{n:"Double Dunk (1989) (Atari) (PAL)"},"3B966BF3C2CA34AC6CA1DE4CF6383582":{n:"Double-Height 6-Digit Score Display (2001) (AD)"},"707ECD80030E85751EF311CED66220BC":{n:"Double-Height 6-Digit Score Display (Background Color Change) (2001) (AD)"},"88DCE4037471424BB38AB6841AAA8CAB":{n:"Double-Height 6-Digit Score Display (Two Background Color Change) (2001) (AD)"},"6A882FB1413912D2CE5CF5FA62CF3875":{n:"Dragon Defender (Ariola) (PAL)",c:1},"24D9A55D8F0633E886A1B33EE1E0E797":{n:"Dragon Defender (Thomas Jentzsch)",c:1},"41810DD94BD0DE1110BEDC5092BEF5B0":{n:"Dragon Treasure (Funvision)"},"6FC394DBF21CF541A60E3B3631B817F1":{n:"Dragonfire (1982) (Imagic) (PAL)"},"1267E3C6CA951FF1DF6F222C8F813D97":{n:"Dragonfire (Unknown) (PAL)"},"78B84CFB1C57B0488D674D2374E656E6":{n:"Dragonstomper (1 of 3) (1982) (Arcadia)"},"2D9E65959808A6098C16C82A59C9D9DC":{n:"Dragonstomper (1 of 3) (1982) (Arcadia) (PAL)"},"90CCF4F30A5AD8C801090B388DDD5613":{n:"Dragonstomper (1982) (Arcadia)"},"8B04E9D132B8E30D447ACAA6BD049C32":{n:"Dragonstomper (1982) (Arcadia) (PAL)"},"5B7EA6AA6B35DC947C65CE665FDE624B":{n:"Dragonstomper (2 of 3) (1982) (Arcadia)"},"66C4E0298D4120DF333BC2F3E163657E":{n:"Dragonstomper (2 of 3) (1982) (Arcadia) (PAL)"},DD8A2124D4EDA200DF715C698A6EA887:{n:"Dragonstomper (3 of 3) (1982) (Arcadia)"},AFF8CBA0F2D2EB239953DD7116894A08:{n:"Dragonstomper (3 of 3) (1982) (Arcadia) (PAL)"},A302B922A8DBEC47743F28B7F91D4CD8:{n:"Dragonstomper (Preview) (1982) (Arcadia)"},FBAC6476E7B2B20D246202AF81662C88:{n:"Dragonstomper (Preview) (1982) (Arcadia) (PAL)"},A867B76098786C4091DBA2FCEE5084C3:{n:"Dragrace (Hack)"},"77057D9D14B99E465EA9E29783AF0AE3":{n:"Dragster (1980) (Activision)"},D763E3A9CDCDD56C715EC826106FAB6A:{n:"Dragster (1980) (Activision) (16K)"},"63A6EDA1DA30446569AC76211D0F861C":{n:"Dragster (1980) (Activision) (4K)"},"9D1556AE5890398BE7E3D57449774B40":{n:"Dragster (1980) (Activision) (8K)"},"0C54811CF3B1F1573C9164D5F19ECA65":{n:"Dragster (1980) (Activision) (PAL)"},BB18189021D58362D9E4D317CD2E28B7:{n:"Dragster (1980) (Activision) (PAL) (4K)"},C216B91F5DB21A093DED6A5AAEC85709:{n:"Dragster (Jone Yuan)"},"3BB9793C60C92911895CF44530846136":{n:"Dragster (Jone Yuan) (4K)"},B1339C56A9EA63122232FE4328373AC5:{n:"Dream Flight (1983) (Goliath) (PAL)"},"2BC6C53B19E0097A242F22375A6A60FF":{n:"Droid Demo 2 (David Conrad Schweinsberg) (PD)"},"37F42AB50018497114F6B0F4F01AA9A1":{n:"Droid Demo 2-M (David Conrad Schweinsberg) (PD)"},BFF8F8F53A8AEB1EE804004CCBB08313:{n:"Droid Demo 22 (David Conrad Schweinsberg) (PD)"},C1B7AEABC3EC41556D924C8372A9BA5B:{n:"Dukes of Hazard (1980) (Atari) (Prototype)"},"34CA2FCBC8BA4A0B544ACD94991CFB50":{n:"Dukes of Hazzard (1980) (Atari) (Prototype) (4K)"},"51DE328E79D919D7234CF19C1CD77FBC":{n:"Dukes of Hazzard (1983) (Atari)"},"2BA02F509A4991AA176BA8D9E540DF3D":{n:"Dukes of Hazzard (1983) (Atari) [a]"},"3897744DD3C756EA4B1542E5E181E02A":{n:"Dumbo's Flying Circus (05-05-1983) (Atari) (Prototype)"},"1F773A94D919B2A3C647172BBB97F6B4":{n:"Dumbo's Flying Circus (07-11-1983) (Atari) (Prototype) (PAL)"},"31FCBCE1CFA6EC9F5B6DE318E1F57647":{n:"Dumbo's Flying Circus (1983) (Atari) (Prototype) (PAL)"},"469473FF6FED8CC8D65F3C334F963AAB":{n:"Dune (07-10-1984) (Atari) (Prototype)",c:1},AFB3BC45C6A82739CC82582127CD96E6:{n:"Dungeon (11-22-1985) (Atari) (Prototype)"},"615A3BF251A38EB6638CDC7FFBDE5480":{n:"E.T. - The Extra-Terrestrial (1982) (Atari)"},"8FEBDD9142960D084AB6EEB1D3E88969":{n:"E.T. - The Extra-Terrestrial (1982) (Atari) (PAL)"},A511F7EE13E4B35512F9217A677B4028:{n:"E.T. - The Extra-Terrestrial (1982) (Atari) (PAL) [a]"},C82EC00335CBB4B74494AECF31608FA1:{n:"E.T. - The Extra-Terrestrial (CCE)"},F71694BD8E89D5A28DAA73BF856635DF:{n:"E.T. Book Cart (NTSC)",c:1},"91191666186117F5BF78B40623D79039":{n:"E.T. Book Cart (PAL)",c:1},"84DF0704E6C777E1F9A16EC92AD80DF0":{n:"E.T. Book Cart (PAL60)",c:1},EFA1098C7D091B940C2543ABE372F036:{n:"E.T. The Extra-Terrestrial (Scott Stilphen) (Hack)"},"13ABC32F803165C458BB086FA57195FB":{n:"E.T. The Extra-Testical (Christian Samuel) (Hack)"},"6982854657A2CC87D712F718E402BF85":{n:"Earth Attack (Zellers)"},"033E21521E0BF4E54E8816873943406D":{n:"Earth Dies Screaming, The (1983) (20th Century Fox)"},"2C0DC885D5EDE94AA664BF3081ADD34E":{n:"Earth Dies Screaming, The (Unknown) (PAL)"},"2BF34B6AD7D2317A2D0808B3FB93571B":{n:"Easy Playfield Graphics (1997) (Chris Cracknell)"},"9CBB07F1993A027BC2F87D5205457EC9":{n:"Eckhard Stolberg's Scrolling Text Demo 1 (PD)"},F8BFD99163D2C4EC688357786E6FBA28:{n:"Eckhard Stolberg's Scrolling Text Demo 2 (PD)"},"32E65D1E4DFCBCD9B57FEE72CAFE074C":{n:"Eckhard Stolberg's Scrolling Text Demo 3 (PD)"},"3B5751A8D20F7DE41EB069F76FECD5D7":{n:"Eckhard Stolberg's Scrolling Text Demo 4 (PD)"},"3E6DAB92009D6034618CB6B7844C5216":{n:"Ed Invaders (Hack)"},"07973BE3ECFD55235BF59AA56BDEF28C":{n:"Eddy Langfinger, der Museumsdieb (1983) (Quelle) (PAL)",c:1},C6D48C6AE6461E0E82753540A985AC9E:{n:"Edtris (1994) (Ed Federmeyer)"},"683DC64EF7316C13BA04EE4398E2B93A":{n:"Edtris (1995) (Ed Federmeyer)"},A00EE0AED5C8979ADD4C170F5322C706:{n:"Egghead (Barry Laws Jr.) (Hack)"},"42B2C3B4545F1499A083CFBC4A3B7640":{n:"Eggomania (1982) (U.S. Games)",p:1},"2B1589C7E1F394AE6A1C046944F06688":{n:"Eggomania (1983) (Carrere Video) (PAL)",p:1},A3F2A0FCF74BBC5FA763B0EE979B05B1:{n:"Eishockey-Fieber (1983) (Quelle) (PAL)"},"71F8BACFBDCA019113F3F0801849057E":{n:"Elevator Action (1983) (Atari) (Prototype)"},B6812EAF87127F043E78F91F2028F9F4:{n:"Eli's Ladder (1982) (Simage)"},"7EAFC9827E8D5B1336905939E097AAE7":{n:"Elk Attack (1987) (Atari) (Prototype)"},DBC8829EF6F12DB8F463E30F60AF209F:{n:"Encounter at L-5 (1982) (Data Age)",p:1},"5188FEE071D3C5EF0D66FB45C123E4A5":{n:"Encounter at L-5 (1983) (Gameworld) (PAL)",p:1},"94B92A882F6DBAA6993A46E2DCC58402":{n:"Enduro (1983) (Activision)",l:"ENDURO"},CFE62ED7125FF9FAE99B4C8A367C0399:{n:"Enduro (1983) (Activision) (16K)",l:"ENDURO"},"265C74A956500BD31EFD24ADC6D5CCF6":{n:"Enduro (1983) (Activision) (8K)",l:"ENDURO"},"6A82B8ECC663F371B19076D99F46C598":{n:"Enduro (1983) (Activision) (PAL)",l:"ENDURO"},DE62F8A30298E2325249FE112ECB5C10:{n:"Enduro (1983) (CCE)",l:"ENDURO"},"360C0DCB11506E73BD0B77207C81BC62":{n:"Enduro (1983) (Digitel)",l:"ENDURO"},E1EFE2EF7664BB6758B1A22FF8EA16A1:{n:"Enduro (1983) (Dynacom)",l:"ENDURO"},"07F84DB31E97EF8D08DC9FA8A5250755":{n:"Enduro (1984) (Supergame)",l:"ENDURO"},"5DF559A36347D8572F9A6E8075A31322":{n:"Enduro (Digivision)",l:"ENDURO"},D2F713C78A9EBBA9DA6D10AEEFC6F20F:{n:"Enduro (Digivision) [a]",l:"ENDURO"},A8E49D7E24CE293629CA29614862821B:{n:"Enduro (Genesis)"},"2BB0A1F1DEE5226DE648EB5F1C97F067":{n:"Enduro (Robby)",l:"ENDURO"},E9E646F730B8400CD5DA08C849EF3E3B:{n:"Enduro (Tron)",l:"ENDURO"},"4279485E922B34F127A88904B31CE9FA":{n:"Enduro (Unknown)",l:"ENDURO"},"61719A8BDAFBD8DAB3CA9CE7B171B9E2":{n:"Enduro (Unknown) (PAL)",l:"ENDURO"},"9F5096A6F1A5049DF87798EB59707583":{n:"Entity, The (1983) (20th Century Fox) (Prototype)"},"6B683BE69F92958ABE0E2A9945157AD5":{n:"Entombed (1982) (U.S. Games)",c:1},D7F5BF138CFC7FEAB7B8EF1534C8B477:{n:"Eric Bergstrom's KC-135 (Radar Map) (Aaron Bergstrom)"},"8538C5E3EE83267774480649F83FA8D6":{n:"Escape Demo (PD)"},D1A1841B7F2007A24439AC248374630A:{n:"Escape from the Mindmaster (1 of 4) (1982) (Arcadia)"},"3576037C9281656655FA114A835BE553":{n:"Escape from the Mindmaster (1 of 4) (1982) (Arcadia) (PAL)"},"81F4F0285F651399A12FF2E2F35BAB77":{n:"Escape from the Mindmaster (1982) (Arcadia)"},C9E721EB29C940C2E743485B044C0A3F:{n:"Escape from the Mindmaster (1982) (Arcadia) (PAL)"},"64198BB6470C78AC24FCF13FE76AB28C":{n:"Escape from the Mindmaster (1982) (Arcadia) [a]"},FDF0DE38517E0CF7F0885F98CCC95836:{n:"Escape from the Mindmaster (2 of 4) (1982) (Arcadia)"},A075AD332942740C386F4C3814925ECE:{n:"Escape from the Mindmaster (2 of 4) (1982) (Arcadia) (PAL)"},"7A63D7EA3F2851BCF04F0BB4BA1A3929":{n:"Escape from the Mindmaster (3 of 4) (1982) (Arcadia)"},CC1939E4769D0C157ACE326EFCFDCF80:{n:"Escape from the Mindmaster (3 of 4) (1982) (Arcadia) (PAL)"},F0536303F49006806BAC3AEC15738336:{n:"Escape from the Mindmaster (4 of 4) (1982) (Arcadia)"},"1EE2CFC7D0333B96BD11F7F3EC8CE8BC":{n:"Escape from the Mindmaster (4 of 4) (1982) (Arcadia) (PAL)"},F1127ADE54037236E75A133B1DFC389D:{n:"Escape from the Mindmaster (Preview) (1982) (Arcadia)"},"271BFD5DC2673D382019F1FB6CAB9332":{n:"Escape from the Mindmaster (Preview) (1982) (Arcadia) (PAL)"},F344AC1279152157D63E64AA39479599:{n:"Espial (1984) (Tigervision)"},F7A138EED69665B5CD1BFA796A550B01:{n:"Espial (1984) (Tigervision) (PAL)"},"66362890EB78D6EA65301592CCE65F5B":{n:"Euchre (13-07-2001) (Eric Eid) (PD)"},"72097E9DC366900BA2DA73A47E3E80F5":{n:"Euchre (15-06-2001) (Eric Eid) (PD)"},"524693B337F7ECC9E8B9126E04A232AF":{n:"Euchre (19-08-2001) (Eric Eid) (PD)"},"8EE3F64DC0F349ADC893FE93DF5245D8":{n:"Euchre (20-07-2001) (Eric Eid) (PD)"},EB71743C6C7CCCE5B108FAD70A326AD9:{n:"Euchre (25-11-2001) (Erik Eid) (PD)"},"65562F686B267B21B81C4DDDC129D724":{n:"Euchre (28-07-2001) (Eric Eid) (PD)"},"29949F893EF6CB9E8ECB368B9E99EEE4":{n:"Euchre (Alpha) (NTSC) (31-08-2002) (Erik Eid)"},"407A0C6CC0FF777F67B669440D68A242":{n:"Euchre (Alpha) (PAL) (31-08-2002) (Erik Eid)"},FFB1CD548563158CE33F9D10268187E7:{n:"Euchre (Beta) (NTSC) (12-09-2002) (Erik Eid)"},"877A5397F3F205BF6750398C98F33DE1":{n:"Euchre (Beta) (PAL) (12-09-2002) (Erik Eid)"},"873FB75A7788BA0F4AE715229A05545E":{n:"Euchre (Improved Colors) (PAL) (26-09-2002) (Erik Eid)"},"15BF2EF7583BFCBBBA630847A1DC5539":{n:"Euchre (Jul 15) (2002) (Eric Eid) (PD)"},"80E52315919BD8A8B82A407CCD9BB13F":{n:"Euchre (Jul 28) (2002) (Eric Eid) (PD)"},"40AA851E8D0F1C555176A5E209A5FABB":{n:"Euchre (More for less) (NTSC) (22-08-2002) (Erik Eid)"},C9D02D3CFEEF8B48FB71CB4520A4AA84:{n:"Euchre (More for less) (PAL) (22-08-2002) (Erik Eid)"},B1B20536AEF4EED9C79DC5804F077862:{n:"Euchre (NTSC) (09-11-2001) (Erik Eid)"},D4AA89E96D2902692F5C45F36903D336:{n:"Euchre (NTSC) (Erik Eid) (PD)"},E5D5085123A98C1E61818CAA2971E999:{n:"Euchre (PAL) (Erik Eid) (PD)"},"6205855CC848D1F6C4551391B9BFA279":{n:"Euchre (Release Candidate 2) (NTSC) (01-10-2002) (Erik Eid)"},"199985CAE1C0123AB1AEF921DAACE8BE":{n:"Euchre (Release Candidate 2) (PAL) (01-10-2002) (Erik Eid)"},"4690FDB70C86604BB35DA26696818667":{n:"Euchre (Release Candidate) (NTSC) (28-09-2002) (Erik Eid)"},BFFE34516AAA3CBF5D307EAB382A7E95:{n:"Euchre (Release Candidate) (PAL) (28-09-2002) (Erik Eid)"},"77CD9A9DD810CE8042BDB9D40E256DFE":{n:"Evil Dead (2003) (Kyle Pittman) (Hack)"},B5657D4C1C732FBB6AF150668464247F:{n:"Excalibur (Dragonstomper Beta) (1982) (Arcadia) (Prototype)"},"1B4B06C2A14ED3EE73B7D0FD61B6AAF5":{n:"Excalibur (Dragonstomper Beta) (1982) (Arcadia) (Prototype) [a]"},"3AD58B53A1E972396890BD86C735E78D":{n:"Excalibur Version 36 (Dragonstomper Beta) (1982) (Arcadia) (Prototype)"},"2EAF8FA9E9FDF1FCFC896926A4BDBF85":{n:"Excalibur Version 39 (Dragonstomper Beta) (1982) (Arcadia) (Prototype)"},"6362396C8344EEC3E86731A700B13ABF":{n:"Exocet (1983) (Panda)"},"295F3679BDF91CA5E37DA3F787B29997":{n:"Exorcise (Hack)"},EBD2488DCACE40474C1A78FA53EBFADF:{n:"Extra Terrestrials (1983) (SSG)"},"7926083AD423ED685DE3B3A04A914315":{n:"Face Invaders 2 (Barry Laws Jr.) (Hack)"},"0AF51CEB4AECC7A8FC89781AC44A1973":{n:"Face Invaders Deluxe (Barry Laws Jr.) (Hack)"},B80D50ECEE73919A507498D0A4D922AE:{n:"Fantastic Voyage (1982) (20th Century Fox)"},"0F24CA5668B4AB5DFAF217933C505926":{n:"Fantastic Voyage (208 in 1) (Unknown) (PAL)"},F7E07080ED8396B68F2E5788A5C245E2:{n:"Farmyard Fun (Ariola)"},"9DE0D45731F90A0A922AB09228510393":{n:"Fast Eddie (1982) (20th Century Fox)"},A97733B0852EE3096300102CB0689175:{n:"Fast Eddie (1983) (CCE)"},"665B8F8EAD0EEF220ED53886FBD61EC9":{n:"Fast Food (1982) (Telesys)"},"48411C9EF7E2CEF1D6B2BEE0E6055C27":{n:"Fast Food (1982) (Telesys) (PAL)"},"313243FC41E49EF6BD3AA9EBC0D372DD":{n:"Fast Food (Unknown) (PAL)"},"6B7E1C11448C4D3F28160D2DE884EBC8":{n:"Fast Food (Zirok)"},"63E783994DF824CAF289B69A084CBF3E":{n:"Fat Albert (David Marli) (Hack)"},"8A159EE58B2F0A54805162984B0F07E5":{n:"Fatal Run (1989) (Atari) (PAL) [a]"},"85470DCB7989E5E856F36B962D815537":{n:"Fatal Run (1989) (Atari) (Prototype)"},EF263D40A23483AB339CAC44D9515A56:{n:"Fatal Run (TJ)"},"074EC425EC20579E64A7DED592155D48":{n:"Fatal Run (Ultimate Driving) (1989) (Atari) (PAL)"},"0B55399CF640A2A00BA72DD155A0C140":{n:"Fathom (1983) (Imagic)",c:1},"47CD61F83457A0890DE381E478F5CF5F":{n:"Fathom (1983) (Imagic) (PAL)",c:1},"962FFD3EAF865230A7A312B80E6C5CFD":{n:"Fathom (1983) (Imagic) (PAL) [a]",c:1},"540075F657D4B244A1F74DA1B9E4BF92":{n:"Festival (4 Game in One Dark Green) (1983) (BitCorp) (PAL)"},"8E737A88A566CC94BD50174C2D019593":{n:"Feuerwehr im Einsatz (1983) (Quelle) (PAL)"},"2AC3A08CFBF1942BA169C3E9E6C47E09":{n:"Fighter Pilot (1988) (Activision) (PAL)"},"211FBBDBBCA1102DC5B43DC8157C09B3":{n:"Final Approach (1982) (Apollo)"},"51E390424F20E468D2B480030CE95D7B":{n:"Fire Bird (Video Game Program) (PAL)"},"01E60A109A6A67C70D3C0528381D0187":{n:"Fire Birds (1983) (ITT Family Games) (PAL)"},D09F1830FB316515B90694C45728D702:{n:"Fire Fighter (1982) (Imagic)"},"90D77E966793754AB4312C47B42900B1":{n:"Fire Fighter (1982) (Imagic) (PAL)"},"20DCA534B997BF607D658E77FBB3C0EE":{n:"Fire Fly (1983) (Mythicon)"},"386FF28AC5E254BA1B1BAC6916BCC93A":{n:"Fireball (1982) (Arcadia)",p:1},CDB81BF33D830EE4EE0606EE99E84DBA:{n:"Fireball (1982) (Arcadia) (PAL)",p:1},"5438E84B90E50A5362F01CC843B358D4":{n:"Fireball (1982) (Arcadia) (Prototype)",p:1},"683BB0D0F0C5DF58557FBA9DFFC32C40":{n:"Fireball (1982) (Arcadia) [a]",p:1},"66BC1BEF269EA59033928BAC2D1D81E6":{n:"Fireball (Preview) (1982) (Arcadia)",p:1},A3D7C299FBCD7B637898EE0FDCFC47FC:{n:"Fireball (Preview) (1982) (Arcadia) (PAL)",p:1},"6C85098518D3F94F7622C42FD1D819AC":{n:"Firebug (Suntek) (PAL)"},D2901C34BB6496BB96C7BC78A9E6142A:{n:"Fish Revenge (2003) (Greg Zumwalt) (Hack)"},"3FE43915E5655CF69485364E9F464097":{n:"Fisher Price (1983) (CCE)"},"2517827950FEE41A3B9DE60275C8AA6A":{n:"Fishing (32 in 1) (1988) (Atari) (PAL)"},F9967369943209B4788D4E92CEFC0795:{n:"Fishing (32 in 1) (1988) (Atari) (PAL) (4K)"},B8865F05676E64F3BEC72B9DEFDACFA7:{n:"Fishing Derby (1980) (Activision)"},"3C82E808FE0E6A006DC0C4E714D36209":{n:"Fishing Derby (1980) (Activision) (16K)"},"85227160F37AAA29F5E3A6C7A3219F54":{n:"Fishing Derby (1980) (Activision) (4K)"},"5131AB3797FE8C127E3E135B18B4D2C8":{n:"Fishing Derby (1980) (Activision) (8K)"},"571C6D9BC71CB97617422851F787F8FE":{n:"Fishing Derby (1980) (Activision) (PAL)"},ECFA04523DDE82FE42CDC7315A8F61B6:{n:"Fishing Derby (1980) (Activision) (PAL) (4K)"},"7628D3CADEEE0FD2E41E68B3B8FBE229":{n:"Fishing Derby (32 in 1) (1988) (Atari) (PAL)"},D782543818B6320E4F60D77DA2B596DE:{n:"Fishing Derby (32 in 1) (1988) (Atari) (PAL) (4K)"},DEA0ADE296F7093E71185E802B500DB8:{n:"Fishing Derby (CCE)"},"804ED85EADF1CE3E93721547CBEA7592":{n:"Fishing Derby (CCE) (4K)"},"0651216C4A4A9C9AC5ADA3013A317C72":{n:"Fishing Derby (Jone Yuan) (4K) (Hack)"},"74023E0F2E739FC5A9BA7CAAEEEE8B6B":{n:"Fishing Derby (Jone Yuan) (Hack)"},"1D2A28EB8C95DA0D6D6B18294211839F":{n:"Fishing Derby (Unknown) (PAL) (4K)"},"6B72B691EA86F61438ED0D84C4D711DE":{n:"Fishing Derby (Unknown) (PAL) (4K) (Hack)"},"458883F1D952CD772CF0057ABCA57497":{n:"Fishing Derby (Unknown) (PAL) (Hack)"},"30512E0E83903FC05541D2F6A6A62654":{n:"Flag Capture (1978) (Atari)"},"4B143D7DCF6C96796C37090CBA045F4F":{n:"Flag Capture (1978) (Atari) (4K)"},DA7A17DCDAA62D6971393C0A6FAF202A:{n:"Flag Capture (208 in 1) (Unknown) (PAL)"},F5445B52999E229E3789C39E7EE99947:{n:"Flag Capture (32 in 1) (1988) (Atari) (PAL)"},B897F9E3F939B9F21566D56DB812A84E:{n:"Flag Capture (32 in 1) (1988) (Atari) (PAL) (4K)"},"19162393786098D50587827588198A86":{n:"Flag Capture (Jone Yuan) (4K)"},"4AE8C76CD6F24A2E181AE874D4D2AA3D":{n:"Flash Gordon (Unknown) (PAL)"},"7A2AF383014F5D810AD26D322823549D":{n:"FlickerSort Demo (20-04-2002) (MP)"},"02811151906E477D47C135DB5B1699C6":{n:"FlickerSort Demo (Updated) (20-04-2002) (MP)"},"5A2F2DCD775207536D9299E768BCD2DF":{n:"Flippern (Double-Game Package) (1983) (Quelle) (PAL)"},E549F1178E038FA88DC6D657DC441146:{n:"Football (1979) (Atari)"},D86DEB100C6ABED1588AA84B2F7B3A98:{n:"Football (1979) (Atari) (4K)"},"5F9B62350B31BE8BD270D9A241CBD50E":{n:"Football (1989) (Telegames) (PAL)"},CFE2185F84CE8501933BEB5C5E1FD053:{n:"Football (208 in 1) (Unknown) (PAL)"},E6D5948F451A24994DFAACA51DFDB4E1:{n:"Football (Jone Yuan) (4K)"},"213E5E82ECB42AF237CFED8612C128AC":{n:"Forest (1983) (Sancho) (PAL)",c:1},"7AB210F448DE518FA61A5924120BA872":{n:"Fortress (20-04-2003) (CT)"},"2008C76DEBA5953201EF75A09B2FF7DC":{n:"Fortress (21-04-2003) (CT)"},"19D9B5F8428947EAE6F8E97C7F33BF44":{n:"Fortress (Dual Version) (20-04-2003) (CT)"},"6D74EBABA914A5CFC868DE9DD1A5C434":{n:"Fortress (Smooth Version) (20-04-2003) (CT)"},"76EE917D817EF9A654BC4783E0273AC4":{n:"Fox & Goat (Double-Game Package) (1983) (Quelle) (PAL)"},"0856F202B18CD46E44FD1DC3B42E9BFB":{n:"Frame Counter 1 (2001) (Jake Patterson) (PD)"},DB1753CC702C18D3917EC7F3B0E8659F:{n:"Frame Counter 2 (2001) (Jake Patterson) (PD)"},"8290DAEA8391F96D7C8E1482E184D19C":{n:"Frame Timed Sound Effects (Eckhard Stolberg)"},"442B7863683E5F084716FDA050474FEB":{n:"Frame Timed Sound Effects-EM (Eckhard Stolberg)"},"15DD21C2608E0D7D9F54C0D3F08CCA1F":{n:"Frankenstein's Monster (1983) (Data Age)"},"7D0B49EA4FE3A5F1E119A6D14843DB17":{n:"Frankenstein's Monster (1983) (Gameworld) (PAL)"},"8E0AB801B1705A740B476B7F588C6D16":{n:"Freeway (1981) (Activision)"},"69974DD5D6420B90898CDE50AEC5EF39":{n:"Freeway (1981) (Activision) (16K)"},"851CC1F3C64EAEDD10361EA26345ACEA":{n:"Freeway (1981) (Activision) (4K)"},"0F95264089C99FC2A839A19872552004":{n:"Freeway (1981) (Activision) (8K)"},"2EC6B045CFD7BC52D9CDFD1B1447D1E5":{n:"Freeway (1981) (Activision) (PAL)"},E4AFE157C09962CF39CDB25845D83D47:{n:"Freeway (1981) (Activision) (PAL) (4K)"},EDDEF10FDC0029301064115AE0CD41D4:{n:"Freeway (CCE)"},"28148A52B1955CE12C7A74D3A3E620A4":{n:"Freeway (CCE) (4K)"},"7D5C3B7B908752B98E30690E2A3322C2":{n:"Freeway (Dactari - Milmar)"},B822FBA8B7C8A97EA4E92AEB2C455EF9:{n:"Freeway (Dactari) (4K)"},"7B7B4AC05232490C28F9B680C72998F9":{n:"Freeway (Zellers)"},"914A8FEAF6D0A1BBED9EB61D33817679":{n:"Freeway Chicken (32 in 1) (1988) (Atari) (PAL)"},B7B1D3CE07E75976C43A2DCA3866237E:{n:"Freeway Chicken (32 in 1) (1988) (Atari) (PAL) (4K)"},"481D20EC22E7A63E818D5EF9679D548B":{n:"Freeway Rabbit (32 in 1) (1988) (Atari) (PAL)"},"060C865C782DEBB047E6FD101C8923FC":{n:"Freeway Rabbit (32 in 1) (1988) (Atari) (PAL) (4K)"},E80A4026D29777C3C7993FBFAEE8920F:{n:"Frisco (Unknown)"},"056FF67DD9715FAFA91FB8B0DDCC4A46":{n:"Frisco (Unknown) (PAL) (Hack)"},"45A4F55BB9A5083D470AD479AFD8BCA2":{n:"Frog Demo (1983) (CommaVid)"},F67181B3A01B9C9159840B15449B87B0:{n:"Frog Pond (08-27-1982) (Atari) (Prototype)"},"5F73E7175474C1C22FB8030C3158E9B3":{n:"Frog Pond (1982) (Atari) (Prototype)"},"081E2C114C9C20B61ACF25FC95C71BF4":{n:"Frogger (1982) (Parker Bros)"},"02CED7EA2B7CB509748DB6BFA227EBEC":{n:"Frogger (1982) (Parker Bros) (PAL)"},"27C6A2CA16AD7D814626CEEA62FA8FB4":{n:"Frogger II (1984) (Parker Bros)",c:1},FB91DFC36CDDAA54B09924AE8FD96199:{n:"Frogger II (1984) (Parker Bros) (PAL)",c:1},DCC2956C7A39FDBF1E861FC5C595DA0D:{n:"Frogs and Flies (1982) (M Network)"},"1B8C3C0BFB815B2A1010BBA95998B66E":{n:"Frogs and Flies (1989) (Telegames) (PAL)"},"4A196713A21EF07A3F74CF51784C6B12":{n:"Frogs and Flies (Jone Yuan) (Hack)"},E556E07CC06C803F2955986F53EF63ED:{n:"Front Line (1984) (Coleco)"},"4CA73EB959299471788F0B685C3BA0B5":{n:"Frostbite (1983) (Activision)"},"5A93265095146458DF2BAF2162014889":{n:"Frostbite (1983) (Activision) (PAL)"},"70CE036E59BE92821C4C7FD735EC6F68":{n:"Frostbite (1983) (Activision) (PAL) (16K)"},"9831EFC7F4CB8FFB4DF0082BAB2F07A3":{n:"Frostbite (1983) (Activision) (PAL) (8K)"},F4469178CD8998CB437FA110A228EACA:{n:"Frostbite (1983) (Digitel)"},C225379E7C4FB6F886EF9C8C522275B4:{n:"Frostbite (1983) (Video Mania)"},C6AE21CACEAAD734987CB24243793BD5:{n:"Frostbite (CCE)"},ADB79F9AC1A633CDD44954E2EAC14774:{n:"Frostbite (Digivision)"},"6B71F20C857574B732E7A8E840BD3CB2":{n:"Frostbite (Unknown) (PAL)"},"6A9B30CA46B0DBA9E719F4CBD340E01C":{n:"Frostbite (Unknown) (PAL) (Hack)"},"415C11FCAC66BBD2ACE2096687774B5A":{n:"Fu Kung! (V0.00) (07-01-2003) (AD)"},EB3D680699F8762F71F38E28E321234D:{n:"Fu Kung! (V0.01) (08-01-2003) (AD)"},"9F2D58DCE1B81C6BA201ED103507C025":{n:"Fu Kung! (V0.02) (2003) (AD)"},DFF33523CCD2FDC8912E84CAB8E0D982:{n:"Fu Kung! (V0.03) (10-01-2003) (AD)"},AB2EA35DCC1098C87455BB8210B018CF:{n:"Fu Kung! (V0.04 Single Line Resolution) (10-01-2003) (AD)"},"81341F00B61AB37D19D1529F483D496D":{n:"Fu Kung! (V0.04) (10-01-2003) (AD)"},"7ED7130A6E4020161836414332B11983":{n:"Fu Kung! (V0.05 Cuttle Card Compatible) (13-01-2003) (AD)"},"61621A556AD3228F0234F5FEB3AB135C":{n:"Fu Kung! (V0.05 Cuttle Card Compattle Revision) (14-01-2003) (AD)"},D026716B3C5BE2C951CC4C064317C524:{n:"Fu Kung! (V0.06) (14-01-2003) (AD)"},CBAD928E10AEEE848786CC55394FB692:{n:"Fu Kung! (V0.06a Cuttle Cart Compatible) (15-01-2003) (AD)"},"78C2DE58E42CD1FAAC2EA7DF783EAEB3":{n:"Fu Kung! (V0.07) (25-01-2003) (AD)"},"9ECA521DB1959156A115DEE85A405194":{n:"Fu Kung! (V0.08) (2003) (AD)"},"58D331C23297ED98663D11B869636F16":{n:"Fu Kung! (V0.09) (26-01-2003) (AD)"},"2228C67D25E507603D4873D3934F0757":{n:"Fu Kung! (V0.10) (28-01-2003) (AD)"},"52E9DB3FE8B5D336843ACAC234AAEA79":{n:"Fu Kung! (V0.11) (28-01-2003) (AD)"},D632B74FEA533D593AF82CF16E7C5E4A:{n:"Fu Kung! (V0.13) (01-02-2003) (AD)"},"6076B187A5D8EA7A2A05111C19B5D5CD":{n:"Fu Kung! (V0.14) (01-02-2003) (AD)"},F80CF77164079D774B9B0FAE33DFFCA9:{n:"Fu Kung! (V0.15) (Negative Version) (05-02-2003) (AD)"},F1BECA5A198CF08190487E5C27B8E540:{n:"Fu Kung! (V0.16) (2003) (AD)"},"2240655247D6DE1C585564004A853AB7":{n:"Fu Kung! (V0.17) (07-02-2003) (AD)"},"0DE53160A8B54C3AA5AED8D68C970B62":{n:"Fuchs & Schweinchen Schlau (1983) (Quelle) (PAL)"},"456453A54CA65191781AEF316343AE00":{n:"Full Screen Bitmap (3-D Green) (PD)"},C3F53993ADE534B0982CA3A286C85BB5:{n:"Full Screen Bitmap Drawing System (12-02-2003) (AD)"},"819AEEB9A2E11DEB54E6DE334F843894":{n:"Fun with Numbers (1980) (Atari)"},DFC03EF371CF5163F54C50D8EE73C8CF:{n:"Fun with Numbers (1980) (Atari) (4K)"},"5F46D1FF6D7CDEB4B09C39D04DFD50A1":{n:"Fun with Numbers (1980) (Atari) (PAL)"},D0CB28E1B7BD6C7F683A0917B59F707E:{n:"Fun with Numbers (1980) (Atari) (PAL) (4K)"},D816FEA559B47F9A672604DF06F9D2E3:{n:"Fun with Numbers (32 in 1) (1988) (Atari) (PAL)"},"08989FA4FF537F5DBD611AFF4019521A":{n:"Fun with Numbers (32 in 1) (1988) (Atari) (PAL) (4K)"},D3BB42228A6CD452C111C1932503CC03:{n:"Funky Fish (1983) (UA Limited) (Prototype)",c:1},CD568D6ACB2F14477EBF7E59FB382292:{n:"Fussball (Ariola) (PAL)"},C1FDD44EFDA916414BE3527A47752C75:{n:"G.I. Joe - Cobra Strike (1983) (Parker Bros)",p:1},"840A5A2EAEA24D95D289F514FD12F9BB":{n:"GBImprov (Hack)"},A3B9D2BE822EAB07E7F4B10593FB5EAA:{n:"GREGXM Demo (PD)"},"13A991BC9C2FF03753AEB322D3E3E2E5":{n:"Galactic (Funvision) (PAL)"},C745487828A1A6A743488ECEBC55AD44:{n:"Galactic (Rainbow Vision) (PAL)"},EA7E25ADE3FE68F5B786EE0AA82B1FE5:{n:"Galatic (208 in 1) (Unknown) (PAL)"},"590AC71FA5F71D3EB29C41023B09ADE9":{n:"Galaxian (01-05-1983) (Atari) (Prototype)"},"803393ED29A9E9346569DD1BF209907B":{n:"Galaxian (02-04-1983) (Atari) (Prototype)"},"211774F4C5739042618BE8FF67351177":{n:"Galaxian (1983) (Atari)"},"13A37CF8170A3A34CE311B89BDE82032":{n:"Galaxian (1983) (Atari) (PAL)"},"18DC28BC22402F21E1C9B81344B3B8C5":{n:"Galaxian (1983) (Atari) (PAL) [a1]"},"218B76F5A4142DC2EA9051A768583D70":{n:"Galaxian (1983) (Atari) (PAL) [a2]"},D65028524761EF52FBBDEBAB46F79D0F:{n:"Galaxian (CCE)"},"93C8D9D24F9C5F1F570694848D087DF7":{n:"Galaxian (Digivision)"},"579BAA6A4AA44F035D245908EA7A044D":{n:"Galaxian Enhanced Graphics (Jess Ragan) (Hack)"},D6B8BEEB05E5B730084D4B8F381BBF8D:{n:"Game Select (208 in 1) (Unknown) (PAL)"},"31F4692EE2CA07A7CE1F7A6A1DAB4AC9":{n:"Game of Concentration (1980) (Atari) (4K)"},F539E32BF6CE39C8CA47CB0CDD2C5CB8:{n:"GameLine Master Module ROM (1983) (Control Video)"},DB971B6AFC9D243F614EBF380AF0AC60:{n:"Gamma-Attack (1983) (Gammation)"},A7523DB9A33E9417637BE0E71FA4377C:{n:"Gangster (Ariola) (PAL)"},"20EDCC3AA6C189259FA7E2F044A99C49":{n:"Gangster Alley (1982) (Spectravision)"},BAE66907C3200BC63592EFE5A9A69DBB:{n:"Gangster Alley (1982) (Spectravision) (PAL)"},DC13DF8420EC69841A7C51E41B9FBBA5:{n:"Garfield (06-21-1984) (Atari) (Prototype)"},E0EFF071F578ECF19EDC2AB276644E46:{n:"Gas Gauge Demo (2001) (Joe Grand) (PD)"},"61EF8C2FC43BE9A04FE13FDB79FF2BD9":{n:"Gas Gauge Demo - Revisited (2001) (Joe Grand) (PD)"},"728152F5AE6FDD0D3A9B88709BEE6C7A":{n:"Gas Hog (1983) (Spectravideo)"},"5CBD7C31443FB9C308E9F0B54D94A395":{n:"Gas Hog (1983) (Spectravideo) [fixed]"},E64A8008812327853877A37BEFEB6465:{n:"Gauntlet (1983) (Answer Software)"},E784A9D26707CFCD170A4C1C60422A72:{n:"Gefecht im All (1983) (Quelle) (PAL)"},"7E464186BA384069582D9F0C141F7491":{n:"General Re-Treat (1982) (PlayAround) (PAL)"},"2BEE7F226D506C217163BAD4AB1768C0":{n:"Ghost Manor (1983) (Xonox)"},"0EECB5F58F55DE9DB4EEDB3A0F6B74A8":{n:"Ghost Manor (1983) (Xonox) (4K)"},"40D8ED6A5106245AA79F05642A961485":{n:"Ghost Manor (1983) (Xonox) (PAL)"},"3B10106836565E5DB28C7823C0898FBB":{n:"Ghost Manor (1983) (Xonox) (PAL) [a]"},"7B33407B2B198AF74906B936CE1EECBB":{n:"Ghostbuster 2 (King Atari)",c:1},D36308387241E98F813646F346E7F9F7:{n:"Ghostbuster 2 (King Atari) (PAL)",c:1},E314B42761CD13C03DEF744B4AFC7B1B:{n:"Ghostbusters (1985) (Activision)"},F7D6592DCB773C81C278140ED4D01669:{n:"Ghostbusters (1985) (Activision) (PAL)"},"721A5567F76856F6B50A6707AA8F8316":{n:"Ghostbusters (1985) (Activision) (PAL) [a]"},C2B5C50CCB59816867036D7CF730BF75:{n:"Ghostbusters II (1992) (Salu) (PAL)",c:1},"643E6451EB6B8AB793EB60BA9C02E000":{n:"Ghostbusters II (1992) (Salu) (PAL) [different tune]",c:1},"718EE85EA7EC27D5BEA60D11F6D40030":{n:"Ghostbusters II (1992) (Thomas Jentzsch)",c:1},"1C8C42D1AEE5010B30E7F1992D69216E":{n:"Gigolo (1982) (PlayAround)",c:1},F303630A2D7316787AECD67FFF6B2E33:{n:"Gingerbread Man (Fred Quimby)"},"37E828675D556775AE8285C0CAF7D11C":{n:"Gingerbread Man (Fred Quimby) (Genesis)"},"5E0C37F534AB5CCC4661768E2DDF0162":{n:"Glacier Patrol (1989) (Telegames)"},"2D9E5D8D083B6367EDA880E80DFDFAEB":{n:"Glib (1983) (Selchow & Righter)"},A591B5E8587AAE0D984A0F6FE2CC7D1C:{n:"Globe Trotter Demo (24-03-2003) (Weston)"},"0F6676B05621F80C670966E2995B227A":{n:"Globe Trotter Demo 1 (24-03-2003) (Weston)"},"103F1756D9DC0DD2B16B53AD0F0F1859":{n:"Go Go Home Monster (1983) (Quelle) (PAL)"},"4093382187F8387E6D011883E8EA519B":{n:"Go Go Home Monster (Unknown)"},CFB83A3B0513ACAF8BE4CAE1512281DC:{n:"Going-Up (1983) (Starpath) (Prototype)"},"2E663EAA0D6B723B645E643750B942FD":{n:"Golf (1980) (Atari)"},F542B5D0193A3959B54F3C4C803BA242:{n:"Golf (1980) (Atari) (4K)"},"9D522A3759AA855668E75962C84546F7":{n:"Golf (1980) (Atari) (PAL)"},BB756AA98B847DDDC8FC170BC79F92B2:{n:"Golf (208 in 1) (Unknown) (PAL)"},"95351B46FA9C45471D852D28B9B4E00B":{n:"Golf (32 in 1) (1988) (Atari) (PAL)"},DB5073BD75EB05F7D62A7268396D1E77:{n:"Golf (32 in 1) (1988) (Atari) (PAL) (4K)"},C16C79AAD6272BAFFB8AAE9A7FFF0864:{n:"Gopher (1982) (U.S. Games)"},A56B642A3D3AB9BBEEE63CD44EB73216:{n:"Gopher (1983) (Carrere Video) (PAL)"},"8F90590DBA143D783DF5A6CFF2000E4D":{n:"Gopher (208 in 1) (Unknown) (PAL)"},"06DB908011065E5EBB37F4E253C2A0B0":{n:"Gopher (Unknown) (PAL)"},"81B3BF17CF01039D311B4CD738AE608E":{n:"Gorf (1982) (CBS Electronics)",c:1},"3E03086DA53ECC29D855D8EDF10962CB":{n:"Gorf (1982) (CBS Electronics) (PAL)",c:1},"98BA601A60172CB46C5BF9A962FD5B1F":{n:"Gorilla Kong (Hack)"},"2903896D88A341511586D69FCFC20F7D":{n:"Grand Prix (1982) (Activision)"},DE4436EAA41E5D7B7609512632B90078:{n:"Grand Prix (1982) (Activision) (16K)"},"5E1B7A6078AF428EF056FE85A37A95CA":{n:"Grand Prix (1982) (Activision) (8K)"},"757F529026696E13838364DEA382A4ED":{n:"Grand Prix (1982) (Activision) (PAL)"},"41C4E3D45A06DF9D21B7AAE6AE7E9912":{n:"Grand Prix (1983) (CCE)"},E5F84930AA468DB33C0D0F7B26DD8293:{n:"Grand Prix (1983) (CCE) [a]"},D5D2D44FB73785996CCC24AE3A0F5CEF:{n:"Grand Prix (Robby)"},"0F738DC44437557624EB277ED7AD91C9":{n:"Grand Prix (Unknown) (PAL)"},"9E437229136F1C5E6EF4C5F36178ED18":{n:"Grand Prize (Funvision)"},"5A9685C4D51A6C1D6A9544946D9E8DC3":{n:"Grandma's Revenge (AtariAge)"},"4767356FA0ED3EBE21437B4473D4EE28":{n:"Gravitar (04-12-1983) (Atari) (Prototype)"},"8AC18076D01A6B63ACF6E2CAB4968940":{n:"Gravitar (1983) (Atari)"},A81697B0C8BBC338AE4D0046EDE0646B:{n:"Gravitar (CCE)"},"9245A84E9851565D565CB6C9FAC5802B":{n:"Great Escape (1983) (Bomb)"},ED014BEEEB77DBB2BBCF9B5F6850B2F4:{n:"Green Bar Text Demo (PD)"},ABC64037CA5D5B04AE8A7EEDBCA3ED74:{n:"Green and Yellow Number 1 Demo (PD)",c:1},B41FDD4A522E1D5A2721840028684AC2:{n:"Green and Yellow Number 1 Demo 2 (PD)",c:1},"42B5E3A35B032F033809AFB0EA28802D":{n:"Gremlins (03-12-1984) (Atari) (Prototype)"},"01CB3E8DFAB7203A9C62BA3B94B4E59F":{n:"Gremlins (1984) (Atari)"},"9962034EA7B3D4A905D0991804670087":{n:"Grid Demo (PD)"},"95A69CF8C08EF1522B050529464F0BCA":{n:"Grid Pattern Demo 1 (20-12-2002) (CT)"},"8D9A06101EBB0F147936356E645309B8":{n:"Grid Pattern Demo 2 (20-12-2002) (CT)"},D65900FEFA7DC18AC3AD99C213E2FA4E:{n:"Grid and Purple Dot Demo (PD)"},EB46E99EC15858F8CD8C91CEF384CE09:{n:"Ground Zero (1983) (Goliath) (PAL)"},"66B89BA44E7AE0B51F9EF000EBBA1EB7":{n:"Grover's Music Maker (01-18-1983) (Atari) (Prototype)"},"4AC9F40DDFCF194BD8732A75B3F2F214":{n:"Grover's Music Maker (12-29-1982) (Atari) (Prototype)"},"7AB2F190D4E59E8742E76A6E870B567E":{n:"Guardian (1982) (Apollo)",p:1},"6A07836C382195DD5305CE61D992AAA6":{n:"Guardian (1982) (Apollo) (Prototype)",p:1},F750B5D613796963ACECAB1690F554AE:{n:"Gunfight 2600 (MP)"},"18B28B386ABDADB3A700AC8FB68E639A":{n:"Gunfight 2600 (MP) (PAL)"},"6CBE945E16D9F827D0D295546AC11B22":{n:"Gunfight 2600 - AI (MP)"},"2ABC3D46B3F2140160759E2E10BC86D9":{n:"Gunfight 2600 - Beta Release! (2001) (MP)"},"9853089672116117258097DBBDB939B7":{n:"Gunfight 2600 - Cowboy Hair (2001) (MP)"},A025A8F83A42A4D6D46C4887E799BFAC:{n:"Gunfight 2600 - Descissions had to be made (2001) (MP)"},"25472DFDEEF6A42581A231D631D6B04D":{n:"Gunfight 2600 - Design thoughts (MP)"},"14A56B493A8D9D10E94A3E100362E3A2":{n:"Gunfight 2600 - Early Play-kernel (2001) (MP)"},"0FBA7D8C3520BDB681F75494E498EC36":{n:"Gunfight 2600 - Final Run (MP)"},"91A3749FF7B7E72B7FA09E05396A0E7B":{n:"Gunfight 2600 - Final Run Part 2 (2002) (MP)"},"29396DB58406084E416032C372734A3E":{n:"Gunfight 2600 - Fixed Beta Release! (2001) (MP)"},"862CF669CBCED78F9ED31A5D375B2EBE":{n:"Gunfight 2600 - Flicker acceptance (2001) (MP)"},"910DD9BF98CC5BC080943E5128B15BF5":{n:"Gunfight 2600 - Improved AI (MP)"},C21450C21EFB7715746E9FA87AD6F145:{n:"Gunfight 2600 - It could've been soooo cool, but... (2001) (MP)"},D17A671029B1532B197DEFCA5F3649A7:{n:"Gunfight 2600 - Limit broken again! (2001) (MP)"},E6F49A1053C79211F82BE4D90DC9FE3D:{n:"Gunfight 2600 - Little progress... (2001) (MP)"},C67FF409F28F44883BD5251CEA79727D:{n:"Gunfight 2600 - Music & Bugfixes 1 (2001) (MP)"},"7D93071B3E3616093A6B5A98B0315751":{n:"Gunfight 2600 - Music & Bugfixes 2 (2001) (MP)"},BC703EA6AFB20BC089F04D8C9D79A2BD:{n:"Gunfight 2600 - Not mergeable with Colbert wizardry... (2001) (MP)"},"111029770226B319524134193886A10E":{n:"Gunfight 2600 - One Limit Reached! (2001) (MP)"},"68C80E7E1D30DF98A0CF67ECBF39CC67":{n:"Gunfight 2600 - One Step Forward & Two Steps Back (2001) (MP)"},E4A0B28BEFAAA2915DF1FA01238B1E29:{n:"Gunfight 2600 - Red River (MP)"},CFDB4D0427A1EA8085C6BC6EB90259D8:{n:"Gunfight 2600 - Release Candidate (2001) (MP)"},"83D15FB9843D9F84AA3710538403F434":{n:"Gunfight 2600 - Release Candidate (2001) (MP) (PAL)"},DFCDD6F593BB7B05DBC2E8E1FC6EE0DE:{n:"Gunfight 2600 - Scenarios complete (MP)"},D245E2F27C84016041E9496B66B722FE:{n:"Gunfight 2600 - The Final Kernel (MP)"},"991D57BBCD529AD62925098E0AEC1241":{n:"Gunfight 2600 - The Final Kernel (MP) [a1]"},A4F1CEA2C8479284E2A2292F8D51B5FA:{n:"Gunfight 2600 - The Final Kernel Part 2 (MP)"},D81BB6965E6C99B3BE99FFD8978740E4:{n:"Gunfight 2600 - The Final Kernel Part 3 (MP)"},A15B5831A1FAB52E4C416068C85EC011:{n:"Gunfight 2600 - The Good, The Bad, The Ugly (2001) (MP)"},"24AD538291EB5F5CAC4B9998F3B851C3":{n:"Gunfight 2600 - This time it's your decission! (2001) (MP)"},"801BA40F3290FC413E8C816C467C765C":{n:"Gunfight 2600 - Westward Ho! (2001) (MP)"},"24759BE31E8FE55D2829FD86BDF3181F":{n:"Gunfight 2600 - Worst Nightmare... (2001) (MP)"},B311AB95E85BC0162308390728A7361D:{n:"Gyruss (1984) (Parker Bros)",c:1},E600F5E98A20FAFA47676198EFE6834D:{n:"Gyruss (1984) (Parker Bros) (PAL)",c:1},FCA4A5BE1251927027F2C24774A02160:{n:"H.E.R.O. (1984) (Activision)"},D9B49F0678776E04916FA5478685A819:{n:"H.E.R.O. (1984) (Activision) (PAL)"},"48BCF2C5A8C80F18B24C55DB96845472":{n:"H.E.R.O. (1984) (Activision) (PAL) (16K)"},"467340A18158649AA5E02A4372DCFCCD":{n:"H.E.R.O. (1984) (Activision) (PAL) [a1]"},"66B92EDE655B73B402ECD1F4D8CD9C50":{n:"H.E.R.O. (1984) (Activision) (PAL) [a2]"},"1D284D6A3F850BAFB25635A12B316F3D":{n:"H.E.R.O. (CCE)"},"769DDC995DBB9EDB8167EFCEA9F34A7C":{n:"H.E.R.O. (Genesis)"},BDF1996E2DD64BAF8EFF5511811CA6CA:{n:"H.E.R.O. (Tron)"},"98E7CAAAB8EC237558378D2776C66616":{n:"HMOVE Test (Bradford W. Mott) (1998) (PD)"},"30516CFBAA1BC3B5335EE53AD811F17A":{n:"Halloween (1983) (Wizard Video Games)"},C450A285DAA7A3B65188C2C3CF04FB3E:{n:"Halloween (1983) (Wizard Video Games) [a]"},"54DA3B0B3F43F5B37911C135B9432B49":{n:"Halloween III Revision (Hack)",p:1},"4AFA7F377EAE1CAFB4265C68F73F2718":{n:"Halo 2600 (2010) (Ed Fries)"},F16C709DF0A6C52F47FF52B9D95B7D8D:{n:"Hangman (1978) (Atari)"},"378C118B3BDA502C73E76190CA089EEF":{n:"Hangman (1978) (Atari) (PAL)"},C3E4AA718F46291311F1CCE53E6CCD79:{n:"Hangman Ghost 4letter (Hack)"},"99A24D7BB31D49B720B422550B32C35F":{n:"Hangman Ghost Biglist1 (Hack)"},"6AA66E9C3EEA76A0C40EF05513497C40":{n:"Hangman Ghost Biglist2 (Hack)"},A62E3E19280FF958407E05CA0A2D5EC7:{n:"Hangman Ghost Biglist3 (Hack)"},"4E37992A37EA36489283F7EB90913BBC":{n:"Hangman Ghost Halloween (Kris) (Hack)"},"8E822B39A71C84AC875F0107FB61D6F0":{n:"Hangman Ghost Original Words (Hack)"},"9671B658286E276CC4A3D02AA25931D2":{n:"Hangman Ghost Wordlist (Hack)"},"502044B1AC111B394E6FBB0D821FCA41":{n:"Hangman Invader 4letter (Hack)"},"2C9FADD510509CC7F28F1CCBA931855F":{n:"Hangman Invader Biglist1 (Hack)"},"6C658B52D03E01828B9D2D4718A998AC":{n:"Hangman Invader Biglist2 (Hack)"},"8A9D953AC3DB52A313A90D6A9B139C76":{n:"Hangman Invader Biglist3 (Hack)"},E8F7679359C4F532F5D5E93AF7D8A985:{n:"Hangman Invader Original Words (Hack)"},"8A42E2C7266439D8997A55D0124C912C":{n:"Hangman Invader Wordlist (Hack)"},"898748D5EAAC3164B0391A64AE1E0E32":{n:"Hangman Man 4letter (Hack)"},"135708B9A7DD20576C1B66AB2A41860D":{n:"Hangman Man Biglist1 (Hack)"},"1F562B89D081E36D58E6FC943512EC05":{n:"Hangman Man Biglist2 (Hack)"},"5CE98F22ADE915108860424D8DDE0D35":{n:"Hangman Man Biglist3 (Hack)"},"227532D82505C3C185A878273C285D5F":{n:"Hangman Man Original Words (Hack)"},"4CA90BA45ECED6F5AD560EA8938641B2":{n:"Hangman Man Wordlist (Hack)"},"67CF913D1DF0BF2D7AE668060D0B6694":{n:"Hangman Monkey 4letter (Hack)"},"1738B2E3F25AB3EEF3CECB95E1D0D957":{n:"Hangman Monkey Biglist1 (Hack)"},"205070B6A0D454961DD9196A8E81D877":{n:"Hangman Monkey Biglist2 (Hack)"},DAC38B4DD3DA73BB7B2E9D70C61D2B7C:{n:"Hangman Monkey Biglist3 (Hack)"},"30C92C685224DC7A72B9BBE5EB62D004":{n:"Hangman Monkey Original Words (Hack)"},"7860716FA5DBC0FFFAB93FB9A4CB4132":{n:"Hangman Monkey Wordlist (Hack)"},CD032AB6764B55438A7B0BFB5E78595A:{n:"Hangman Pac-Man 4letter (Hack)"},"0A1B98937911D621B004B1617446D124":{n:"Hangman Pac-Man Biglist1 (Hack)"},DCA941DAB5C6F859B71883B13ADE9744:{n:"Hangman Pac-Man Biglist2 (Hack)"},"662ECA7E3D89175BA0802E8E3425DEDB":{n:"Hangman Pac-Man Biglist3 (Hack)"},"9BD4E0D5F28BA6DA417C26649171F8E4":{n:"Hangman Pac-Man Original Words (Hack)"},"79D4AF56036EC28F298CAD964A2E2494":{n:"Hangman Pac-Man Wordlist (Hack)"},BE1922BD8E09D74DA471287E1E968653:{n:"Hangman Pacman Demo (Cropsy) (Hack)"},A8435EC570141DE5D833C4ABEC499E55:{n:"Happy Birthday Demo (2001) (Dennis Debro) (PD)"},B9232C1DE494875EFE1858FC8390616D:{n:"Harbor Escape (1983) (Panda)"},A34560841E0878C7B14CC65F79F6967D:{n:"Harem (1982) (Multivision)"},F0A6E99F5875891246C3DBECBF2D2CEA:{n:"Haunted House (1982) (Atari)"},"09E1ECF9BD2A3030D5670DBA7A65E78D":{n:"Haunted House (1982) (Atari) (PAL)"},"06742CF522F23797157F215A1DC8A1A9":{n:"Healthbars (PD)"},"260C787E8925BF3649C8AEAE5B97DCC0":{n:"Hell Driver (Thomas Jentzsch)"},E77F332B71F13884C84771E7A121182D:{n:"Hey! Stop! (Jone Yuan)"},FE9AE625D924B54C9F8A14AC9A0F6C6D:{n:"High Bid! (BG Dodson) (Hack)"},"8FE00172E7FFF4C1878DABCF11BB8DCE":{n:"Hili Ball (1983) (Quelle) (PAL)",c:1},CD34B3B3EF9E485201E841BA71BEB253:{n:"Hit HMOVE At Various Cycles After WSYNC Test (Bradford W. Mott) (1998) (PD)"},"3D48B8B586A09BDBF49F1A016BF4D29A":{n:"Hole Hunter (Video Game Cartridge)"},C52D9BBDC5530E1EF8E8BA7BE692B01E:{n:"Holey Moley (02-29-1984) (Atari) (Prototype)"},"0BFABF1E98BDB180643F35F2165995D0":{n:"Home Run (1978) (Atari)"},"9F901509F0474BF9760E6EBD80E629CD":{n:"Home Run (1978) (Atari) (4K)"},"328949872E454181223A80389D03C122":{n:"Home Run (Unknown) (PAL)"},"24B5F4BBDB853ECA38EA0CAE2DFE73A1":{n:"Home Run (Unknown) (PAL) (4K)"},CA7AAEBD861A9EF47967D31C5A6C4555:{n:"Homerun (32 in 1) (1988) (Atari) (PAL)"},"63811ED69BDBC35C69D8AA7806C3D6E9":{n:"Homerun (32 in 1) (1988) (Atari) (PAL) (4K)"},F7A651972D78F9BA485B14690452D4BE:{n:"Homestar Runner Demo #2 (2004-03-29)",c:1},"6B7A56B6AC2CA4BF9254474BF6ED7D80":{n:"Horizonal Color Bars Demo (PD)"},"68449E4AABA677ABCD7CDE4264E02168":{n:"Horizonal Color Bars Demo 2 (PD)"},"70A8480CFAF08776E5420365732159D2":{n:"Horizontally Scrolling Playfield Thing (Rob Kudla) (PD)"},"78821EF76EBC3934850D1BC1B9E4F4B0":{n:"Hot Action Pak - Ghostbusters, Tennis, Plaque Attack (1990) (HES) (PAL)"},CCD6CE508EEE4B3FCA67212833EDCD85:{n:"Hot Wave (Double-Game Package) (1983) (Quelle) (PAL)"},"2DBC92688F9BA92A7E086D62BE9DF79D":{n:"How to Draw a Playfield (1997) (Jim Crawford) (PD)"},D6D5DD8FD322D3CF874E651E7B6C1657:{n:"How to Draw a Playfield (1997) (Nick Bensema) (PD)"},"9E904E2EAA471C050C491289B8B80F60":{n:"How to Draw a Playfield II (1997) (Erik Mooney) (PD)"},"4A45C6D75B1BA131F94A9C13194D8E46":{n:"How to Draw a Playfield II (Joystick Hack) (1997) (Eric Bacher) (PD)"},"7DC03A1F56D0E6A8AAE3E3E50D654A08":{n:"Hozer Video Demo (PD)"},"11330EAA5DD2629052FAC37CFE1A0B7D":{n:"Human Cannonball (128-in-1 Junior Console) (PAL)"},C6C63DA3BC2E47291F63280E057061D0:{n:"Human Cannonball (128-in-1 Junior Console) (PAL) (4K)"},"7972E5101FA548B952D852DB24AD6060":{n:"Human Cannonball (1979) (Atari)"},FFE51989BA6DA2C6AE5A12D277862E16:{n:"Human Cannonball (1979) (Atari) (4K)"},"10A3CD14E5DCFDDE6FF216A14CE7B7DD":{n:"Human Cannonball (1979) (Atari) (PAL)"},AD42E3CA3144E2159E26BE123471BFFC:{n:"Human Cannonball (32 in 1) (1988) (Atari) (PAL)"},"4BDAE9246D6EE258C26665512C1C8DE3":{n:"Human Cannonball (32 in 1) (1988) (Atari) (PAL) (4K)"},"42DCC02777B0BCFACD85AEB61D33558A":{n:"Human Cannonball (Unknown) (PAL) (4K)"},"5BE03A1FE7B2C114725150BE04B38704":{n:"Hunt & Score (1978) (Atari) (PAL)"},B26506FBF411009E5E3F7365F442960E:{n:"Hunt & Score (1978) (Atari) (PAL) (4K)"},"102672BBD7E25CD79F4384DD7214C32B":{n:"Hunt & Score - Memory Match (1978) (Atari)"},F4C2E50B01DFF99BDDBE037B3489511C:{n:"Hypnotic (V0.04) (2001) (Inkling) (PD)"},"7C9B3B8B25ACF2FE3B8DA834F69629C6":{n:"I Robot (1984) (Atari) (Prototype) [!]"},F6A282374441012B01714E19699FC62A:{n:"I Want My Mommy (1983) (ZiMAG)",c:1},DC33479D66615A3B09670775DE4C2A38:{n:"I.Q. Memory Teaser (Suntek) (PAL)"},"2016726DB38AD6A68B4C48BA6FE51557":{n:"INV 2 (Piero Cavina, Erik Mooney)"},"9EA8ED9DEC03082973244A080941E58A":{n:"INV+"},AB301D3D7F2F4FE3FDD8A3540B7A74F5:{n:"IQ 180 (Jone Yuan)"},"4B9581C3100A1EF05EAC1535D25385AA":{n:"IQ 180 (Unknown)"},A4C08C4994EB9D24FB78BE1793E82E26:{n:"Ice Hockey (1981) (Activision)"},"5BCC83677D68F7EF74C1B4A0697BA2A8":{n:"Ice Hockey (1981) (Activision) (16K)"},"3EB21313EA5D5764C5ED9160A5A55A83":{n:"Ice Hockey (1981) (Activision) (8K)"},AC9ADBD6DE786A242E19D4BEC527982B:{n:"Ice Hockey (1981) (Activision) (PAL)"},C7D5819B26B480A49EB26AEB63CC831E:{n:"Ice Hockey (4 Game in One Light Green) (1983) (BitCorp) (PAL)"},"47711C44723DA5D67047990157DCB5DD":{n:"Ice Hockey (CCE)"},C3AEB796FDAF9429E8CD6AF6346F337E:{n:"If It's Not One Thing It's Another (1997) (Chris Cracknell)"},"9A21FBA9EE9794E0FADD7C7EB6BE4E12":{n:"Ikari Warriors (1989) (Atari)"},"321C3451129357AF42A375D12AFD4450":{n:"Ikari Warriors (1989) (Atari) (PAL)"},"9813B9E4B8A6FD919C86A40C6BDA8C93":{n:"Ikari Warriors (1989) (Atari) (PAL) [a]"},"3F251C50AA7237E61A38AB42315EBED4":{n:"Ikari Warriors (1990) (Thomas Jentzsch)"},"95E542A7467C94B1E4AB24A3EBE907F1":{n:"Im Schutz der Drachen (1983) (Quelle) (PAL)",c:1},C4BC8C2E130D76346EBF8EB544991B46:{n:"Imagic Selector ROM (1982) (Imagic)"},"9B21D8FC78CC4308990D99A4D906EC52":{n:"Immies & Aggies (1983) (CCE)"},"75A303FD46AD12457ED8E853016815A0":{n:"Immies & Aggies (1983) (ZiMAG) (Prototype)"},"47ABFB993FF14F502F88CF988092E055":{n:"Inca Gold (Zellers)"},F137211537438B1FCE3D811BAEF25457:{n:"Incoming (02-10-2002) (Ben Larson) (PD)"},FE870018332A0221EB59FB18B0C6BCCC:{n:"Incoming (08-11-2002) (Ben Larson) (PD)"},"86B4AA76BBEB70E1A4F9211A9880BA8E":{n:"Incoming (1 Player Version) (05-11-2002) (Ben Larson)"},"3556E125681AEA864E17B09F3F3B2A75":{n:"Incoming (2 Player Demo) (PD)"},"15BCD74F2F1F2A63E1AA93E90D2C0555":{n:"Incoming (22-08-2002) (Ben Larson) (PD)"},"03B1051C9374678363C899914412CFC5":{n:"Incoming (30-10-2002) (Ben Larson) (PD)"},"76C88341017EAE660EFC6E49C4B6AB40":{n:"Indiana Pitfall (Hack)"},C5301F549D0722049BB0ADD6B10D1E09:{n:"Indy 500 (1977) (Atari)"},"08188785E2B8300983529946DBEFF4D2":{n:"Indy 500 (1977) (Atari) (4K)"},DAC762E4D01D445BDEF20B7771F6570E:{n:"Indy 500 (1977) (Atari) (4K) [a]"},"81591A221419024060B890665BEB0FB8":{n:"Indy 500 (1977) (Atari) (PAL)"},"63166867F75869A3592B7A94EA62D147":{n:"Indy 500 (Hack) [a1]"},"30E012E8D50330C8972F126B8E913BC4":{n:"Indy 500 (Hack) [a2]"},"4F781F0476493C50DC578336F1132A67":{n:"Indy 500 (Unknown) (PAL) (4K)"},"0C7BD935D9A7F2522155E48315F44FA0":{n:"Infernal Tower (1983) (Carrere Video) (PAL)",c:1},AFE88AAE81D99E0947C0CFB687B16251:{n:"Infiltrate (1981) (Apollo)",c:1},"3B69F8929373598E1752F43F8DA61AA4":{n:"Infiltrate (1981) (Apollo) (PAL)",c:1},FB5C8AF97BD8FFE88323656F462645A7:{n:"Interlace Demo (Glenn Saunders)",c:1},"463E66AD98806A49106CFFA49C08E2ED":{n:"Interlace Game Demo (01-09-2002) (Billy Eno)"},"91FDB6541F70C40B16AABF8308123BE8":{n:"Interlacing Game (19-08-2002) (Billy Eno)"},"888DEBB162D7D1AE71025B4AB794257F":{n:"Interleaved ChronoColour - Nude Art (17-04-2003) (AD)"},A25BB76E9E773117E567FD4300B1BB23:{n:"Interleaved ChronoColour Demo (NTSC) (05-03-2003) (AD)"},"3B097A7ED5BD2A84DC3D3ED361E9C31C":{n:"Interleaved ChronoColour Demo (PAL) (05-03-2003) (AD)"},FB0E84CEE4C108D24253BCB7E382CFFD:{n:"Interleaved ChronoColour Demo (SECAM) (05-03-2003) (AD)"},B4030C38A720DD84B84178B6CE1FC749:{n:"International Soccer (1982) (M Network)"},"29630A20D356FB58685B150BFA8F00C3":{n:"International Soccer (1982) (Mattel) [a]"},CE904C0AE58D36D085CD506989116B0B:{n:"International Soccer (1989) (Telegames) (PAL)"},A0185C06297B2818F786D11A3F9E42C3:{n:"International Soccer (Unknown) (PAL)"},ADB770FF70E9ADF08BBB907A7ECCD240:{n:"Inv Demo 3 (2001) (Erik Mooney) (PD)"},E0CF2DCC4C1348C468F5BB1E421C9164:{n:"Invader Sprites in a Line Demo (PD)"},"425EE444A41D218598893D6B6E03431A":{n:"Invaders Demo (2001) (TJ)"},"46C43FDCBCE8FDE3A91EBEAFC05B7CBD":{n:"Invaders Demo (PAL) (2001) (Eckhard Stolberg)"},CD139AE6D09F3665AD09EB79DA3F9E49:{n:"Invaders by Erik Mooney (4-24-97) (PD)"},"8874B68751FD2BA6D3306A263AE57A7D":{n:"Invaders by Erik Mooney (Alpha 1) (PD)"},"6D475019EA30D0B29F695E9DCFD8F730":{n:"Invaders by Erik Mooney (Alpha 2) (PD)"},"62992392EA651A16AA724A92E4596ED6":{n:"Invaders by Erik Mooney (Beta) (PD)"},"4868A81E1B6031ED66ECD60547E6EC85":{n:"Invaders by Erik Mooney (V2.1) (1-3-98) (PD)"},"80CEC82239913CB8C4016EB13749DE44":{n:"Invaders from Space by David Marli (Space Invaders Hack)"},"850FFD5849C911946B24544EA1E60496":{n:"Invasion (07-10-2002) (CT)"},"273CE50DB5A0D6DA7EA827A54F44DEE9":{n:"Island Flyer Demo (PD)"},C2778507B83D9540E9BE5713758FF945:{n:"Island Flyer Demo 2 (PD)"},"2F0546C4D238551C7D64D884B618100C":{n:"Ixion (1984) (Sega) (Prototype)"},"9C729017DD2F9CCBADCB511187F80E6B":{n:"J-Pac (Hack)"},A5262FE6D01D6A1253692682A47F79DD:{n:"JKH Text Scrolling Demo (PD)"},CE243747BF34A2DE366F846B3F4CA772:{n:"Jacky Jump (1983) (Home Vision) (PAL)"},"98EA10C47C13F1B3306C7B13DB304865":{n:"Jam Demo 1 (PD)"},"60D304582D33E2957B73EB300A7495BB":{n:"Jam Demo 2 (PD)"},E51030251E440CFFAAB1AC63438B44AE:{n:"James Bond 007 (1983) (Parker Bros)",c:1},"04DFB4ACAC1D0909E4C360FD2AC04480":{n:"Jammed (2001) (XYPE) (NTSC)"},BA317F83CDFCD58CBC65AAC1CCB87BC5:{n:"Jammed (2001) (XYPE) [a1]"},"911D385EE0805FF5B8F96C5A63DA7DE5":{n:"Jammed (V0.1) (Demo) (2001) (TJ)"},"15B498199ED0ED28057BF0DBDCE9B8D8":{n:"Jammed (V0.2) (Demo) (2001) (TJ)"},EF5C02C95A1E7ED24F24193935755CD3:{n:"Jammed Demo (1999) (Hozer Video Games)"},"58A82E1DA64A692FD727C25FAEF2ECC9":{n:"Jaw Breaker (1983) (CCE)"},A406D2F6D84E61D842F4CB13B2B1CFA7:{n:"Jawbreaker (1982) (Tigervision) (PAL)"},"97327D6962F8C64E6F926F79CD01C6B9":{n:"Jawbreaker (Unknown) (PAL)"},"8F33BCE5BA1053DCF4CEA9C1C69981E4":{n:"Jawbreaker (Unknown) (PAL) [a]"},EB4252FAFF7A4F2BA5284A98B8F78D1A:{n:"John K Harvey's Equalizer (NTSC) (PD)",c:1},"30997031B668E37168D4D0E299CCC46F":{n:"John K Harvey's Equalizer (PAL) (PD)",c:1},"4FC1B85B8074B4B9436D097900E34F29":{n:"John K. Harvey's Equalizer (John K. Harvey)",c:1},E39843C56B7A4A08B18FA7949EC3EE6B:{n:"Joshua Invaders (Hack)"},"718AE62C70AF4E5FD8E932FEE216948A":{n:"Journey Escape (1982) (Data Age)",c:1},"6B4EB5B3DF80995B8D9117CB7E9AEB3C":{n:"Journey Escape (1983) (Gameworld) (PAL)",c:1},B2D3BCEE001CFF2BD2D8A21B2CB55109:{n:"Joust (08-09-1983) (Atari) (Prototype)",c:1},"3276C777CBE97CDD2B4A63FFC16B7151":{n:"Joust (1983) (Atari)",c:1},"640A08E9CA019172D612DF22A9190AFB":{n:"Joust (1983) (Atari) (PAL)",c:1},"17EE158D15E4A34F57A837BC1CE2B0CE":{n:"Joust (1983) (Atari) (PAL) [a]",c:1},"22319BE7A640AF5314EC3C482CCEB676":{n:"Joustpong (05-07-2002) (Kirk Israel) (PD)"},"706E3CC4931F984447213B92D1417AFF":{n:"Joustpong (06-07-2002) (Kirk Israel) (PD)"},"94102FEBC53B4A78342D11B645342ED4":{n:"Joustpong (14-07-2002) (Kirk Israel) (PD)"},"814210C0E121F7DBC25661B93C06311C":{n:"Joustpong (16-09-2002) (Kirk Israel) (PD)"},C225ABFB584960EFE1F359FC94B73379:{n:"Joustpong (21-09-2002) (Kirk Israel) (PD)"},"36C29CEEE2C151B23A1AD7AA04BD529D":{n:"Jr. Pac-Man (1984) (Atari)"},"297C405AFD01F3AC48CDB67B00D273FE":{n:"Jr. Pac-Man (1984) (Atari) (PAL)"},"25265D0E7F88B3026003809F25EE025E":{n:"Jr. Pac-Man (1984) (Atari) [a]"},"161DED4A85D3C78E44FFFD40426F537F":{n:"JtzBall (Alpha) (TJ)"},"80E1410EC98089E0733CC09E584DBA4B":{n:"Jumping Jack (1983) (Dynamics) (PAL)"},"2CCCC079C15E9AF94246F867FFC7E9BF":{n:"Jungle Fever (1982) (PlayAround)",c:1},FD16949913AAAB5BEAEFED73BF2CA67C:{n:"Jungle Hunt (02-03-1983) (Atari) (Prototype)"},"0EC93F519BB769E0D9F80E61F6CC8023":{n:"Jungle Hunt (02-25-1983) (Atari) (Prototype)"},"2BB9F4686F7E08C5FCC69EC1A1C66FE7":{n:"Jungle Hunt (1983) (Atari)"},"9FC2D1627DCDD8925F4C042E38EB0BC9":{n:"Jungle Hunt (1983) (Atari) (PAL)"},C47244F5557AE12C61E8E01C140E2173:{n:"Jungle Hunt (1983) (Atari) (PAL) [a1]"},"2DCF9CE486393CD36CA0928CD53B96CB":{n:"Jungle Hunt (1983) (Atari) (PAL) [a2]"},"88A6C9C88CB329EE5FA7D168BD6C7C63":{n:"Jungle Hunt (1983) (CCE)"},"2496D404BFC561A40A80BEA6A69695C3":{n:"Jungle Hunt (1983) (CCE) [a]"},"000509D1ED2B8D30A9D94BE1B3B5FEBB":{n:"Jungle Jane (2003) (Greg Zumwalt) (Hack)"},E1D5C8213E82820128FA9C4775F1E166:{n:"Jungle King (2003) (Jess Ragan) (Hack)"},"65917AE29A8C9785BB1F2ACB0D6AAFD0":{n:"Junkosoft One Year Demo (1999) (PD)"},"90B647BFB6B18AF35FCF613573AD2EEC":{n:"Juno First (2009)",c:1},FA98D48CD609C9BABC819E0A1BD8D598:{n:"Juno First (2009) (PAL60)",c:1},"72A5B5052272AC785FA076709D16CEF4":{n:"KC Munckin (29-01-2003) (J. Parlee)"},B9D1E3BE30B131324482345959AED5E5:{n:"Kabobber (07-25-1983) (Activision) (Prototype)"},"5428CDFADA281C569C74C7308C7F2C26":{n:"Kaboom! (1981) (Activision)",p:1},E14DC36B24FE22C04FA076E298F2E15F:{n:"Kaboom! (1981) (Activision) (16K)",p:1},AF6AB88D3D7C7417DB2B3B3C70B0DA0A:{n:"Kaboom! (1981) (Activision) (4K)",p:1},ED8F319E82D355832195EB7715644795:{n:"Kaboom! (1981) (Activision) (8K)",p:1},F9E99596345A84358BC5D1FBE877134B:{n:"Kaboom! (1981) (Activision) (PAL)",p:1},B09B79C9628878BE051E89F7F1E77378:{n:"Kaboom! (1981) (Activision) (PAL) (4K)",p:1},DBDAF82F4F0C415A94D1030271A9EF44:{n:"Kaboom! (CCE)",p:1},E49AC0EC879A0D7820BC2598FC2CFCD4:{n:"Kaboom! (CCE) (4K)",p:1},A93E8EA1F565C3C1E86B708CF0DC2FA9:{n:"Kabul! (Jess Ragan) (Hack)",p:1},"7B43C32E3D4FF5932F39AFCB4C551627":{n:"Kamikaze Saucers (1983) (Syncro) (Prototype)"},"73AA02458B413091AC940C0489301710":{n:"Kampf dem Steinfresser (1983) (Quelle) (PAL)"},"4326EDB70FF20D0EE5BA58FA5CB09D60":{n:"Kangaroo (1983) (Atari)"},"6FE67F525C39200A798985E419431805":{n:"Kangaroo (1983) (Atari) (PAL)"},DD08E18CFEE87A0E7FC19A684B36E124:{n:"Kangaroo (1983) (Atari) (PAL) [a]"},"4431428A7500C96FC0E2798A5DBD36D6":{n:"Kangaroo (Genesis)"},"6D8A04EE15951480CB7C466E5951EEE0":{n:"Kanguru (1983) (Zirok)"},"10EAE73A07B3DA044B72473D8D366267":{n:"Karate (1982) (Funvision) (PAL)"},CEDBD67D1FF321C996051EEC843F8716:{n:"Karate (1982) (Ultravision)"},DD17711A30AD60109C8BEACE0D4A76E8:{n:"Karate (Unknown) (PAL)"},"65BA1A4C643D1AB44481BDDDEB403827":{n:"Katastrophen-Einsatz (1983) (Quelle) (PAL)"},A1770EF47146AB7B12E2C4BECCD68806:{n:"Kaystone Kapers (1983) (Digitel)"},"810D8952AF5A6036FCA8D0C4E1B23DB6":{n:"Keystone (Tiger Vision)"},BE929419902E21BD7830A7A7D746195D:{n:"Keystone Kapers (1983) (Activision)"},"6C1F3F2E359DBF55DF462CCBCDD2F6BF":{n:"Keystone Kapers (1983) (Activision) (PAL)"},BEDFBDE71FB606601F936B5B057F26F7:{n:"Keystone Kapers (1983) (Activision) (PAL) (16K)"},"91925ABCE3A29E33B6A8B81482F4F5AF":{n:"Keystone Kapers (1983) (Activision) (PAL) (8K)"},"1351C67B42770C1BD758C3E42F553FEA":{n:"Keystone Kapers (Digivision)"},F5A3E051730D45FEA518F2E8B926565B:{n:"Keystone Kapers (Robby)"},E558BE88EEF569F33716E8E330D2F5BC:{n:"Keystone Kapers (Shock Vision)"},"8DB152458ABAEF3CFA7A4E420DDBDA59":{n:"Keystone Kapers (Unknown)"},"05AEDF04803C43EB5E09DFD098D3FD01":{n:"Keystone Kapers (Unknown) (PAL)"},"4FBE0F10A6327A76F83F83958C3CBEFF":{n:"Keystone Kappers (1983) (CCE)"},E28113D10C0C14CC3B5F430B0D142FCB:{n:"Keystone Kappers (1983) (CCE) [a]"},"7187118674FF3C0BB932E049D9DBB379":{n:"Keystone Keypers (1983) (Zirok)"},"7A7F6AB9215A3A6B5940B8737F116359":{n:"Killer Satellites (1983) (Arcadia)"},"75E276BA12DC4504659481C31345703A":{n:"Killer Satellites (1983) (Arcadia) (PAL)"},C0A68837C60E15D1FC5A40C9A62894BC:{n:"Killer Satellites (1983) (Arcadia) (Prototype)"},"9C27EF3BD01C611CDB80182A59463A82":{n:"Killer Satellites (1983) (Arcadia) [a]"},"05CCF96247AF12EEF59698F1A060A54F":{n:"King Arthur (1983) (Quelle) (PAL)"},E21EE3541EBD2C23E817FFB449939C37:{n:"King Kong (1982) (Tigervision)"},"0DD4C69B5F9A7AE96A7A08329496779A":{n:"King Kong (1982) (Tigervision) (PAL)"},"0B1056F1091CFDC5EB0E2301F47AC6C3":{n:"King Kong (1982) (Tigervision) (PAL) [a]"},E4D41F2D59A56A9D917038682B8E0B8C:{n:"Kiss Meets Pacman (Cody Pittman) (Hack)"},B5EFE0271D2214E4D5DC798881486884:{n:"Klax (06-14-1990) (Atari) (Prototype)"},"2C29182EDF0965A7F56FE0897D2F84BA":{n:"Klax (08-18-1990) (Atari) (Prototype)"},EED9EAF1A0B6A2B9BC4C8032CB43E3FB:{n:"Klax (1990) (Atari) (PAL)"},"7FCD1766DE75C614A3CCC31B25DD5B7A":{n:"Knight on the Town (1982) (PlayAround)",c:1},ED0451010D022B96A464FEBCBA70B9C4:{n:"Knight on the Town (1982) (PlayAround) (PAL)",c:1},A2EB84CFEED55ACD7FECE7FEFDC83FBB:{n:"Kool Aid Man (Fixed) (15-11-2002) (CT)"},"2C8C11295D8613F875B7BCF5253AB9BB":{n:"Kool Aid Man (PAL Conversion) (16-11-2002) (Fabrizio Zavagli) (PAL60)"},"534E23210DD1993C828D944C6AC4D9FB":{n:"Kool-Aid Man (1983) (M Network)"},"071F84D10B343C7C05CE3E32AF631687":{n:"Krieg der Sterne (Ariola) (PAL)"},CC724EBE74A109E39C0B2784DDC980CA:{n:"Krull (05-27-1983) (Atari) (Prototype)"},"4BAADA22435320D185C95B7DD2BCDB24":{n:"Krull (1983) (Atari)"},"00DC28B881989C39A6CF87A892BD3C6B":{n:"Krull (CCE)"},"6805734A0B7BCC8925D9305B071BF147":{n:"Kung Fu (4 Game in One Dark Green) (1983) (BitCorp) (PAL)"},"0B4E793C9425175498F5A65A3E960086":{n:"Kung Fu Master (CCE)"},A9E3C23599C0D77151602F8E31DAF879:{n:"Kung Fu Master (Genesis)"},A8101CB667E50A46165C6FB48C608B6B:{n:"Kung Fu Sprite Demo (PD)",c:1},CE89529D6E98A13DDF3D84827BBDFE68:{n:"Kung Fu Sprite Demo 2 (PD)",c:1},"3F58F972276D1E4E0E09582521ED7A5B":{n:"Kung Fu Superkicks (1989) (Telegames)"},E5D72FF8BAB4450BE57785CC9E83F3C0:{n:"Kung Fu Superkicks (1989) (Telegames) (PAL)"},"5B92A93B23523FF16E2789B820E2A4C5":{n:"Kung-Fu Master (1987) (Activision)"},"4474B3AD3BF6AABE719A2D7F1D1FB4CC":{n:"Kung-Fu Master (1987) (Activision) (PAL)"},"9945A22F60BBAF6D04A8D73B3CF3DB75":{n:"Kung-Fu Master (1987) (Activision) (PAL) [a]"},"7AD782952E5147B88B65A25CADCDF9E0":{n:"Kwibble (1983) (Imagic) (Prototype)"},B86552198F52CFCE721BAFB496363099:{n:"Kyphus (1982) (Apollo) (Prototype)"},"0FBF618BE43D4396856D4244126FE7DC":{n:"Labyrinth (1983) (Quelle) (PAL)"},"01F584BF67B0E464014A8C8B5EA470E3":{n:"Labyrinth (Escape from the Mindmaster Beta) (1982) (Arcadia)"},"710497DF2CAAB69CDCC45E919C69E13F":{n:"Labyrinth (Escape from the Mindmaster Beta) (1982) (Arcadia) [a]"},ADFBD2E8A38F96E03751717F7422851D:{n:"Lady Bug (NTSC)",c:1},F1489E27A4539A0C6C8529262F9F7E18:{n:"Lady Bug (PAL60)",c:1},"95A89D1BF767D7CC9D0D5093D579BA61":{n:"Lady in Wading (1982) (PlayAround)",c:1},EC407A206B718A0A9F69B03E920A0185:{n:"Landung in der Normandie (1983) (Quelle) (PAL)"},B7345220A0C587F3B0C47AF33EBE533C:{n:"Landungskommando (1983) (Quelle) (PAL)"},"85564DD0665AA0A1359037AEF1A48D58":{n:"Laser Base (1983) (ITT Family Games) (PAL) [a]",c:1},"8C103A79B007A2FD5AF602334937B4E1":{n:"Laser Base (Thomas Jentzsch)"},D2C8E6AA8172B16C8AA9AAE739AC9C5E:{n:"Laser Blast (08-08-1980) (Activision) (Prototype)"},"931B91A8EA2D39FE4DCA1A23832B591A":{n:"Laser Blast (1981) (Activision)"},"9EC1B259A1BCFFA63042A3C2B3B90F0A":{n:"Laser Blast (1981) (Activision) (16K)"},D5E27051512C1E7445A9BF91501BDA09:{n:"Laser Blast (1981) (Activision) (4K)"},F6676E3FE901EB8515FC7AE310302C3C:{n:"Laser Blast (1981) (Activision) (8K)"},"8A8E401369E2B63A13E18A4D685387C6":{n:"Laser Blast (1981) (Activision) (PAL)"},F7F50D9C9D28BCC9F7D3075668B7AC89:{n:"Laser Blast (1981) (Activision) (PAL) (4K)"},"0D1B3ABF681A2FC9A6AA31A9B0E8B445":{n:"Laser Blast (32 in 1) (1988) (Atari) (PAL)"},"303242C239474F2D7763B843DE58C1C3":{n:"Laser Blast (CCE)"},F9420173EFCB4B9F2B01C2A7B595CCA7:{n:"Laser Blast (CCE) (4K)"},D078674AFDF24A4547B4B32890FDC614:{n:"Laser Blast (Jone Yuan)"},"3F6938AA6CE66E6F42E582C1EB19B18C":{n:"Laser Blast (Jone Yuan) (4K) (Hack)"},"91B007F33F9B790BE64F57220EC52E80":{n:"Laser Blast (Jone Yuan) (Hack)"},D339B95F273F8C3550DC4DAA67A4AA94:{n:"Laser Blast (Unknown) (PAL) (4K)"},"0277C449FAE63F6F1C8F94DEDFCF0058":{n:"Laser Demo (B. Watson)"},"68760B82FC5DCF3FEDF84376A4944BF9":{n:"Laser Gate (1983) (CCE)"},CD4DED1EDE63C4DD09F3DD01BDA7458C:{n:"Laser Gate (Future Video Games) (PAL)"},"1FA58679D4A39052BD9DB059E8CDA4AD":{n:"Laser Gates (1983) (Imagic)"},"8E4CD60D93FCDE8065C1A2B972A26377":{n:"Laser Gates (1983) (Imagic) (PAL)"},"48287A9323A0AE6AB15E671AC2A87598":{n:"Laser Volley (Zellers)"},"1FAB68FD67FE5A86B2C0A9227A59BB95":{n:"Lasercade (1983) (20th Century Fox) (Prototype)"},"19098C46DA0640F2B5763167DEA6C716":{n:"Laseresal 2002 (NTSC) (PD)"},F9655ED51462ECFC690C7B97CEC649F9:{n:"Laseresal 2002 (PAL) (PD)"},"02DCBA28C614FEC7CA25955327128ABB":{n:"Laseresal 2002 (PAL) (PD) [a]"},"9C6FD6ED3599978AB7B6F900484B9BE6":{n:"Laseresal 2002 (PAL60) (PD)"},FABCA526D57DE46768B392F758F1A008:{n:"Laseresal 2600 (16-12-2001) (Andrew Wallace) (PD)"},"31E518DEBBA46DF6226B535FA8BD2543":{n:"Last Starfighter (1984) (Atari) (Prototype)"},BB579404924C40CA378B4AFF6CCF302D:{n:"Lightbulb Lightens, The (PD) (Non Functional)"},D0CDAFCB000B9AE04AC465F17788AD11:{n:"Lilly Adventure (1983) (Quelle) (PAL)"},"3947EB7305B0C904256CDBC5C5956C0F":{n:"Lilly Adventure (Jone Yuan)"},"64D43859258DC8CA54949E9FF4174202":{n:"Lilly Adventure (Thomas Jentzsch)"},FE0B7F27E3AD50BBF9FF468EE56D553D:{n:"Lines Demo (Eckhard Stolberg) (PAL) (PD)"},"86128001E69AB049937F265911CE7E8A":{n:"Lochjaw (1981) (Apollo)"},"71464C54DA46ADAE9447926FDBFC1ABE":{n:"Lock 'n' Chase (1982) (M Network)"},"493E90602A4434B117C91C95E73828D1":{n:"Lock 'n' Chase (1989) (Telegames) (PAL)"},E88340F5BD2F03E2E9CE5ECFA9C644F5:{n:"Lock 'n' Chase (Unknown) (PAL)"},B4E2FD27D3180F0F4EB1065AFC0D7FC9:{n:"London Blitz (1983) (Avalon Hill)"},"5BABE0CAD3EC99D76B0AA1D36A695D2F":{n:"Looping (1983) (Coleco) (Prototype)"},E24D7D879281FFEC0641E9C3F52E505A:{n:"Lord of the Rings (1983) (Parker Bros) (Prototype)"},C6D7FE7A46DC46F962FE8413C6F53FC9:{n:"Lord of the Rings (1983) (Parker Bros) (Prototype) [a]"},DAEF7D8E5A09981C4AA81573D4DBB380:{n:"Lord of the Rings (Adam Thornton) (Hack)",c:1},E4B12DEAAFD1DBF5AC31AFE4B8E9C233:{n:"Lord of the Rings (Adam Thornton) (Hack) [a]",c:1},"7C00E7A205D3FDA98EB20DA7C9C50A55":{n:"Lost Luggage (1981) (Apollo)"},D0B26E908370683AD99BC6B52137A784:{n:"Lost Luggage (1981) (Apollo) (PAL)"},"2D76C5D1AAD506442B9E9FB67765E051":{n:"Lost Luggage (1981) (Apollo) [no opening scene]"},DF5CC5CCCDC140EB7107F5B8ADFACDA1:{n:"Lumberman (Cracker Jack) (Hack)"},"97D0151BEB84ACBE82AA6DB18CD91B98":{n:"Lunar Attack (2002) (Steve Engelhardt) (Hack)"},"393E41CA8BDD35B52BF6256A968A9B89":{n:"M.A.D. (1982) (U.S. Games)"},"090F0A7EF8A3F885048D213FAA59B2F8":{n:"M.A.D. (1983) (Carrere Video) (PAL)"},"835759FF95C2CDC2324D7C1E7C5FA237":{n:"M.A.S.H (1983) (20th Century Fox)"},"43C6CFFFEDDAB6B3787357FED9D44529":{n:"M.A.S.H (1983) (20th Century Fox) (PAL)"},E97EAFD0635651D3999CECE953C06BD5:{n:"M.A.S.H (208 in 1) (Unknown) (PAL)"},"9193B6FFF6897D43274741D4F9855B6D":{n:"M.A.S.H (Unknown) (PAL) (Hack)"},CF63FFAC9DA89EF09C6C973083061A47:{n:"MASH (1983) (CCE)"},"1423F560062C4F3C669D55891A2BCBE7":{n:"MASH (1983) (CCE) [a]"},E9BE3E8E4A7E73DD63ED4235A3A1A25F:{n:"MMetall (Hack)"},"47AAD247CCE2534FD70C412CB483C7E0":{n:"Mafia (Rainbow Vision) (PAL)"},CDDABFD68363A76CD30BEE4E8094C646:{n:"MagiCard (1981) (CommaVid)"},"7DA9DE8D62FCDD3A2C545B2E720C2A61":{n:"MagiCard (1981) (CommaVid) (4K)"},CCB5FA954FB76F09CAAE9A8C66462190:{n:"Malagai (1983) (Answer Software)",c:1},"402D876EC4A73F9E3133F8F7F7992A1E":{n:"Man Goes Down (2006) (A. Herbert) (Prototype)"},"54A1C1255ED45EB8F71414DADB1CF669":{n:"Mangia' (1983) (Spectravideo)"},D8295EFF5DCC43360AFA87221EA6021F:{n:"Mangia' (1983) (Spectravideo) (PAL)"},E4C2077A18E3C27F4819AA7757903AA0:{n:"Many Blue Bars Demo (PD)"},CEF01595000627EE50863D4290372C27:{n:"Many Blue Bars and Text Demo (PD)"},"163E7E757E2DC44469123FF0E5DAEC5E":{n:"Many Blue Bars and Text Demo 2 (PD)"},F032B2F2D8323404A6B4541F92DD1825:{n:"Many Blue Bars and Text Demo 3 (PD)"},EF60B06FDDB675B0D783AFBFA5FC5232:{n:"Many Blue Bars and Text Demo 4 (PD)"},"13895EF15610AF0D0F89D588F376B3FE":{n:"Marauder (1982) (Tigervision)"},"512E874A240731D7378586A05F28AEC6":{n:"Marauder (1982) (Tigervision) (PAL)"},CC03C68B8348B62331964D7A3DBEC381:{n:"Marauder (Jone Yuan)"},"319A142AAB6260842AB616382848C204":{n:"Marble Craze (05-02-2002) (Paul Slocum)"},F777444FC21A5925E066B68B1D350575:{n:"Marble Craze (Kernel Works) (Paul Slocum)"},F2E4FB2D3600C0F76D05864E658CC57B:{n:"Marble Craze (Kernel) (17-02-2002) (Paul Slocum)"},"89A65B83203980D5D4D60F52A584A5B8":{n:"Marble Craze (PAL) (02-02-2003) (Paul Slocum)"},"21B09C40295C2D7074A83AE040F22EDF":{n:"Marble Craze (V0.90) (Easy Version) (Paul Slocum)"},"097074F24CDE141FE6A0F26A10333265":{n:"Marble Craze (V0.90) (Paul Slocum)"},"34B269387FA1AA5A396636F5ECDD63DD":{n:"Marble Craze (mc7_23) (Paul Slocum)"},CD9FEA12051E414A6DFE17052067DA8E:{n:"Marble Craze Demo (PD)"},"966B11D3C147D894DD9E4EBB971EA309":{n:"Marble Craze Song (Paul Slocum) (PD)"},"6141C095D0AEE4E734BEBFAAC939030A":{n:"Mariana (Rainbow Vision) (PAL)"},EE84BDC5DAE268E227E407C7B5E6B6B7:{n:"Marilyn Monroe Demo (PD)"},CADE123747426DF69570A2BC871D3BAF:{n:"Marine Wars (1983) (Gakken) (PAL)"},B00E8217633E870BF39D948662A52AAC:{n:"Marine Wars (1983) (Konami)"},"1B8D35D93697450EA26EBF7FF17BD4D1":{n:"Marineflieger (1983) (Quelle) (PAL)"},E908611D99890733BE31733A979C62D8:{n:"Mario Bros. (1983) (Atari)"},C49FE437800AD7FD9302F3A90A38FB7D:{n:"Mario Bros. (1983) (Atari) (PAL)"},"2A9F9001540C55A302BEFD8E9D54B47B":{n:"Mario Bros. (1983) (Atari) (PAL) [a]"},"9A165C39AF3F050FDEE6583FDFCDC9BE":{n:"Mario Bros. (Zirok)"},B1D1E083DC9E7D9A5DC1627869D2ADE7:{n:"Mario's Bros. (1983) (CCE)"},C446288FE62C0C2737639FD788AE4A21:{n:"Mark's Sound Demo (PD)",c:1},B2F0D7217147160B2F481954CEDF814B:{n:"Marquee Drawer (2001) (B. Watson)",c:1},B1486E12DE717013376447AC6F7F3A80:{n:"Marspatrouille (1983) (Quelle) (PAL)"},"36E47ED74968C365121EAB60F48C6517":{n:"Master Builder (1983) (Quelle) (PAL)"},AE4BE3A36B285C1A1DFF202157E2155D:{n:"Master Builder (1983) (Spectravideo)"},"3B76242691730B2DD22EC0CEAB351BC6":{n:"Masters of the Universe (1983) (M Network)",c:1},"470878B9917EA0348D64B5750AF149AA":{n:"Math Gran Prix (1982) (Atari)"},"45BEEF9DA1A7E45F37F3F445F769A0B3":{n:"Math Gran Prix (1982) (Atari) (PAL)"},"7996B8D07462A19259BAA4C811C2B4B4":{n:"Math Gran Prix (208 in 1) (Unknown) (PAL)"},"5E2495D43B981010304AF55EFED1E798":{n:"Math Gran Prix (Jone Yuan)"},"244C6DE27FAFF527886FC7699A41C3BE":{n:"Matt Demo (PD)"},DDD1EFC1862CD3EB3BAF4CBA81FF5050:{n:"Max3 (2001) (Maxime Beauvais) (PD)"},AE83541CF4A4C0BCE0ADCCD2C1BF6288:{n:"Maze 003 Demo (PD)"},F825C538481F9A7A46D1E9BC06200AAF:{n:"Maze Craze (1980) (Atari)"},ED2218B3075D15EAA34E3356025CCCA3:{n:"Maze Craze (1980) (Atari) (PAL)"},"8108AD2679BD055AFEC0A35A1DCA46A4":{n:"Maze Craze (Unknown)"},"69EBF910AB9B63E5B8345F016095003B":{n:"Maze Demo 1 (PD)"},F9DE91D868D6EBFB0076AF9063D7195E:{n:"Maze Demo 2 (PD)"},"35B43B54E83403BB3D71F519739A9549":{n:"McDonald's (06-06-1983) (Parker Bros) (Prototype)"},F7FAC15CF54B55C5597718B6742DBEC2:{n:"Medieval Mayhem (NTSC)",p:1},D00F6F8BA89559E4B20972A478FC0370:{n:"Medieval Mayhem (PAL)",p:1},DAEB54957875C50198A7E616F9CC8144:{n:"Mega Force (1982) (20th Century Fox)"},ECF51385384B468834611D44A8429C03:{n:"Mega Force (1982) (20th Century Fox) (PAL)"},BDBAEFF1F7132358EA64C7BE9E46C1AC:{n:"Mega Force (1982) (20th Century Fox) (PAL) [a]"},E37C8055D70979AF354251EBE9F1B7DD:{n:"Mega Funpak - Gorf, P. Patrol, Pacman, Skeet Shoot (HES) (PAL)"},"28A2BEA8F84936CB2E063F857414CDA0":{n:"Mega Mania Raid (1999) (Thiago Paiva) (Hack)"},B65D4A38D6047735824EE99684F3515E:{n:"MegaBoy (Dynacom)"},"318A9D6DDA791268DF92D72679914AC3":{n:"MegaMania (1982) (Activision)"},A35D47898B2B16EC641D1DFA8A45C2B7:{n:"MegaMania (1982) (Activision) (16K)"},D45BF71871B196022829AA3B96BFCFD4:{n:"MegaMania (1982) (Activision) (8K)"},"3D934BB980E2E63E1EAD3E7756928CCD":{n:"MegaMania (1982) (Activision) (PAL)"},"6604F72A966CA6B2DF6A94EE4A68EB82":{n:"MegaMania (208 in 1) (Unknown) (PAL)"},"049626CBFB1A5F7A5DC885A0C4BB758E":{n:"MegaMania (Unknown) (PAL)"},FC92D74F073A44BC6E46A3B3FA8256A2:{n:"Megademo (19xx) (PD)"},"6BB22EFA892B89B69B9BF5EA547E62B8":{n:"Megamania (1982) (Dynacom)"},D5618464DBDC2981F6AA8B955828EEB4:{n:"Megamania (1983) (CCE)"},"12937DB3D4A80DA5C4452B752891252D":{n:"Megamania (1983) (Digitel)"},"1E0EF01E330E5B91387F75F700CCAF8F":{n:"Mein Weg (1983) (Quelle) (PAL)"},"96E798995AF6ED9D8601166D4350F276":{n:"Meltdown (1983) (20th Century Fox) (Prototype)"},"50568C80AC61CAB789D9923C9B05B68E":{n:"Merlin's Walls - Standard Edition (1999) (Ebivision)"},"8FBABAA87941CDF3A377C15E95BDB0F3":{n:"Meteor Smasher (SnailSoft)"},"08BF437D012DB07B05FF57A0C745C49E":{n:"Meteoroids (1982) (Arcadia) (Prototype)",c:1},F1554569321DC933C87981CF5C239C43:{n:"Midnight Magic (1984) (Atari)",c:1},DA732C57697AD7D7AF414998FA527E75:{n:"Midnight Magic (1984) (Atari) (PAL)",c:1},C47B7389E76974FD0DE3F088FEA35576:{n:"Mighty Mouse (Funvision)"},"0BF19E40D5CD8AA5AFB33B16569313E6":{n:"Millipede (01-04-1984) (Atari) (Prototype)"},"3C57748C8286CF9E821ECD064F21AAA9":{n:"Millipede (1984) (Atari)"},A7673809068062106DB8E9D10B56A5B3:{n:"Millipede (1984) (Atari) (PAL)"},"11BCF5C752088B5AAF86D6C7A6A11E8D":{n:"Millipede (1984) (Atari) (Prototype)"},EFD387430A35A659FF569A9A0EC22209:{n:"Millipede (1984) (Atari) (Prototype) (PAL)"},"0E224EA74310DA4E7E2103400EB1B4BF":{n:"Mind Maze (10-10-1984) (Atari) (Prototype)"},FA0570561AA80896F0EAD05C46351389:{n:"Miner 2049er (1982) (Tigervision)"},C517144E3D3AC5C06F2F682EBF212DD7:{n:"Miner 2049er (1982) (Tigervision) (PAL)"},"598A4E6E12F8238B7E7555F5A7777B46":{n:"Miner 2049er (1982) (Tigervision) (Prototype)"},"3B040ED7D1EF8ACB4EFDEEBEBDAA2052":{n:"Miner 2049er (1982) (Tigervision) [fixed]"},"2A1B454A5C3832B0240111E7FD73DE8A":{n:"Miner 2049er Volume II (1983) (Tigervision)",c:1},"468F2DEC984F3D4114EA84F05EDF82B6":{n:"Miner 2049er Volume II (1983) (Tigervision) (PAL)",c:1},"4543B7691914DFD69C3755A5287A95E1":{n:"Mines of Minos (1982) (CommaVid)",c:1},B5CB9CF6E668EA3F4CC2BE00EA70EC3C:{n:"Mines of Minos (1982) (CommaVid) (PAL)",c:1},"73CB1F1666F3FD30B52B4F3D760C928F":{n:"Mines of Minos (Unknown) (PAL)",c:1},"635CC7A0DB33773959D739D04EFF96C2":{n:"Minesweeper (V.90) (Soren Gust) (PD)"},AC5F78BAE0638CF3F2A0C8D07EB4DF69:{n:"Minesweeper (V.99) (Soren Gust) (PD)"},"2982E655DFFC89D218A0A3072CFC6811":{n:"Mini Golf 812631 (Hack)"},DF62A658496AC98A3AA4A6EE5719C251:{n:"Miniature Golf (1979) (Atari)"},"384DB97670817103DD8C0BBDEF132445":{n:"Miniature Golf (1979) (Atari) (4K)"},ED5CCFC93AD4561075436EE42A15438A:{n:"Miniature Golf (1979) (Atari) (PAL)"},"8B8152D6081F31365406CB716BD95567":{n:"Miniature Golf (1979) (Atari) (PAL) (4K)"},"4F82D8D78099DD71E8E169646E799D05":{n:"Miniature Golf (Unknown) (PAL) (4K)"},"73521C6B9FED6A243D9B7B161A0FB793":{n:"Miniaturer Golf (32 in 1) (1988) (Atari) (PAL)"},"6979F30204149BE3E227558CFFE21C1D":{n:"Miniaturer Golf (32 in 1) (1988) (Atari) (PAL) (4K)"},"391764720140C432AEC454A468F77A40":{n:"Miss Pack Man (Video Game Program) (PAL)"},"4181087389A79C7F59611FB51C263137":{n:"Miss Piggy's Wedding (06-24-1983) (Atari) (Prototype) (8K)"},"855A42078B14714BCFD490D2CF57E68D":{n:"Miss Piggy's Wedding (1983) (Atari) (Prototype)"},"25E73EFB9A6EDF119114718BD2F646BA":{n:"Miss Piggy's Wedding (1983) (Atari) (Prototype) [a]"},"3A2E2D0C6892AA14544083DFB7762782":{n:"Missile Command (1981) (Atari)",l:"missile command",c:1},"9364AD51C321E0F15C96A8C0AFF47CEB":{n:"Missile Command (1981) (Atari) (PAL)",l:"missile command",c:1},"1A8204A2BCD793F539168773D9AD6230":{n:"Missile Command (1981) (Atari) [no initials]",l:"missile command"},"94E7CC6342D11E508E7E8B2DDF53C255":{n:"Missile Command (208 in 1) (Unknown) (PAL) (Hack)"},"8D1E2A6D2885966E6D86717180938F87":{n:"Missile Command (Amiga Mouse) (2002) (TJ)",l:"missile command",c:1},"183020A80848E06A1238A1AB74079D52":{n:"Missile Command (Amiga Mouse) (2002) (TJ) (PAL)",l:"missile command",c:1},"8CE9126066F2DDD5173E9F1F9CE1494E":{n:"Missile Command (CX-22 Trackball) (2002) (TJ)",l:"missile command",c:1},"8BEBAC614571135933116045204F0F00":{n:"Missile Command (CX-22 Trackball) (2002) (TJ) (PAL)",l:"missile command",c:1},"2365E1534D67F94D8670394AB99150CE":{n:"Missile Command (CX-80 Trackball) (2002) (TJ)",l:"missile command",c:1},"96ECCC2277043508A6C481EA432D7DD9":{n:"Missile Command (CX-80 Trackball) (2002) (TJ) (PAL)",l:"missile command",c:1},F6A9EA814D15B85BFFE980C927DF606B:{n:"Missile Command (Unknown) (PAL)",l:"missile command",c:1},CB24210DC86D92DF97B38CF2A51782DA:{n:"Missile Control (1983) (Video Gems) (PAL)"},E6E5BB0E4F4350DA573023256268313D:{n:"Missile Control (Thomas Jentzsch)"},"53D181CDE2E0219B5754CAAD246FCB66":{n:"Missile Demo (1998) (Ruffin Bailey) (PD)"},"317A4CDBAB090DCC996833D07CB40165":{n:"Missile War (1983) (Goliath) (PAL)"},"4C6AFB8A44ADF8E28F49164C84144BFE":{n:"Mission 3,000 A.D. (1983) (BitCorp)"},"6EFE876168E2D45D4719B6A61355E5FE":{n:"Mission 3,000 A.D. (1983) (BitCorp) (PAL)",c:1},CFAD2B9CA8B8FEC7FB1611D656CC765B:{n:"Mission 3,000 A.D. (1983) (BitCorp) (PAL) [demo cart]",c:1},B83579C4450FCBDF2B108903731FA734:{n:"Mission 3,000 A.D. (208 in 1) (Unknown) (PAL)",c:1},CF9069F92A43F719974EE712C50CD932:{n:"Mission Survive (1983) (Video Gems) (PAL)",c:1},B5CDBAB514EA726A14383CFF6DB40E26:{n:"Mission Survive (1983) (Video Gems) (PAL) [a]",c:1},"3783F12821B88B08814DA8ADB1A9F220":{n:"Mission Survive (PAL) (Genesis)",c:1},B676A9B7094E0345A76EF027091D916B:{n:"Mission Survive (Thomas Jentzsch)",c:1},E13818A5C0CB2F84DD84368070E9F099:{n:"Misterious Thief, A (1983) (CCE)",c:1},"5D9592756425192EC621D2613D0E683D":{n:"Misterious Thief, A (1983) (CCE) [a]"},B4A4C87840613F102ACB5B3A647D0A67:{n:"Mobile 48 Sprite Kernel (04-01-2003) (Eric Ball)"},"073CB76B006AF034FD150BE3F5E0E7E6":{n:"Mobile 48 Sprite Kernel (Bug Fixed) (10-01-2003) (Eric Ball)"},"63E9E612BBEE31045F8D184A4E53F8EC":{n:"Moby Blues (2002) (ATARITALIA) (Hack)"},"7AF40C1485CE9F29B1A7B069A2EB04A7":{n:"Mogul Maniac (1983) (Amiga)"},F802FA61011DD9EB6F80B271BAC479D0:{n:"Mole Hunter (Suntek) (PAL)"},"6BDE3F6AC31ACEEF447CE57D4D2C2EC0":{n:"Mondo Pong V1 (Piero Cavina) (PD)",p:1},"1F60E48AD98B659A05CE0C1A8E999AD9":{n:"Mondo Pong V2 (Piero Cavina) (PD)",p:1},"6913C90002636C1487538D4004F7CAC2":{n:"Monster Cise (1984) (Atari) (Prototype)"},"3347A6DD59049B15A38394AA2DAFA585":{n:"Montezuma's Revenge (1984) (Parker Bros)"},"4AB2EBD95A8F861EA451ABEBDAD914A5":{n:"Montezuma's Revenge (PAL) (Genesis)"},"9F59EDDF9BA91A7D93BCE7EE4B7693BC":{n:"Montezuma's Revenge (Thomas Jentzsch) (PAL60)"},"7B8A481E0C5AA78150B5555DFF01F64E":{n:"Moon Patrol (05-16-1983) (Atari) (Prototype)"},AC3DD22DD945724BE705DDD2785487C2:{n:"Moon Patrol (06-15-1983) (Atari) (Prototype)"},E2C1B60EAA8EDA131632D73E4E0C146B:{n:"Moon Patrol (07-04-1983) (Atari) (Prototype)"},"5256F68D1491986AAE5CFDFF539BFEB5":{n:"Moon Patrol (07-26-1983) (Atari) (Prototype)"},"94FF6B7489ED401DCAAF952FECE10F67":{n:"Moon Patrol (07-31-1983) (Atari) (Prototype)"},"515046E3061B7B18AA3A551C3AE12673":{n:"Moon Patrol (1983) (Atari)"},"65490D61922F3E3883EE1D583CE10855":{n:"Moon Patrol (1983) (Atari) (PAL)"},"0AFE6AE18966795B89314C3797DD2B1E":{n:"Moon Patrol (1983) (Atari) (PAL) [a]"},"6DE924C2297C8733524952448D54A33C":{n:"Moon Patrol (1983) (CCE)"},"2854E5DFB84173FAFC5BF485C3E69D5A":{n:"Moon Patrol (Canal 3)"},"5643EE916F7DC760148FCA4DB3AA7D10":{n:"Moon Patrol (Genesis)"},"1B22A3D79DDD79335B69C94DD9B3E44E":{n:"Moon Patrol (Tron)"},"44E9C4A047C348DBEB7ACE60F45484B4":{n:"Moon Patrol Arcade (Genesis)"},"203ABB713C00B0884206DCC656CAA48F":{n:"Moonsweeper (1983) (Imagic)",c:1},"4AF4103759D603C82B1C9C5ACD2D8FAF":{n:"Moonsweeper (1983) (Imagic) (PAL)",c:1},B79FE32320388A197AC3A0B932CC2189:{n:"Moonsweeper (1983) (Imagic) (PAL) [a]",c:1},B06050F686C6B857D0DF1B79FEA47BB4:{n:"Moonsweeper (1988) (Activision)",c:1},AE6CB335470788B94BEB5787976E8818:{n:"Mortal Kurling (02-01-2003) (CT)"},EB503CC64C3560CD78B7051188B7BA56:{n:"Moto Laser (Star Game)"},"378A62AF6E9C12A760795FF4FC939656":{n:"MotoRodeo (1990) (Atari)",c:1},B1E2D5DC1353AF6D56CD2FE7CFE75254:{n:"MotoRodeo (1990) (Atari) (PAL)",c:1},A20B7ABBCDF90FBC29AC0FAFA195BD12:{n:"Motocross (1983) (Quelle) (PAL)"},"5641C0FF707630D2DD829B26A9F2E98F":{n:"Motocross (Joystik)"},F5A2F6EFA33A3E5541BC680E9DC31D5B:{n:"Motocross (Suntek) (PAL)"},DE0173ED6BE9DE6FD049803811E5F1A8:{n:"Motocross Racer (1983) (Xonox)"},DB4EB44BC5D652D9192451383D3249FC:{n:"Mountain King (1983) (CBS Electronics)",c:1},"7E51A58DE2C0DB7D33715F518893B0DB":{n:"Mountain King (1983) (CBS Electronics) [a]",c:1},"23D445EA19A18FB78D5035878D9FB649":{n:"Mouse Trap (1982) (CBS Electronics) (PAL)",c:1},"5678EBAA09CA3B699516DBA4671643ED":{n:"Mouse Trap (1982) (Coleco)",c:1},"35156407E54F67EB1F625450D5C093E1":{n:"Mouse Trap (Genesis)"},"24FBF8250A71611E40EF18552E61B009":{n:"Movable Grid Demo (PD)"},"6342AFE9C9AD1B6120B8F6FB040D0926":{n:"Move a Blue Blob Demo (PD)"},F69A39B215852A0C2764D2A923C1E463:{n:"Move a Blue Blob Demo 2 (PD)"},"140909D204ABD6841C64CDAD4D7765B4":{n:"Moving Blue Ladder Demo (PD)"},"703D32062436E4C20C48313DFF30E257":{n:"Moving Maze Demo (PD)",c:1},AA7BB54D2C189A31BB1FA20099E42859:{n:"Mr. Do! (1983) (CBS Electronics) (PAL)",c:1},"0164F26F6B38A34208CD4A2D0212AFC3":{n:"Mr. Do! (1983) (Coleco)",c:1},B7A7E34E304E4B7BC565EC01BA33EA27:{n:"Mr. Do!'s Castle (1984) (Parker Bros)",c:1},"0CB7AF80FD0DDEF84844481D85E5D29B":{n:"Mr. Pac-Man (El Destructo)"},"0DFBDADF8F1BC718E7E1BB3CCD5FEF3D":{n:"Mr. Pac-Man (New start tune) (El Destructo)"},"603C7A0D12C935DF5810F400F3971B67":{n:"Mr. Postman (1983) (BitCorp) (PAL)"},"8644352B806985EFDE499AE6FC7B0FEC":{n:"Mr. Postman (1983) (CCE)"},"9A4274409216FF09ECDE799F2A56AC73":{n:"Mr. Postman (1983) (CCE) [a]"},"2327456F86D7E0DEDA94758C518D05B3":{n:"Mr. Postman (Digitel)"},F0DAAA966199EF2B49403E9A29D12C50:{n:"Mr. Postman (Unknown)"},CFF9950D4E650094F65F40D179A9882D:{n:"Mr. Roboto (Paul Slocum) (Hack)",c:1},"87E79CD41CE136FD4F72CC6E2C161BEE":{n:"Ms. Pac-Man (1982) (Atari)"},"1EE9C1BA95CEF2CF987D63F176C54AC3":{n:"Ms. Pac-Man (1982) (Atari) (PAL)"},D4942F4B55313FF269488527D84CE35C:{n:"Ms. Pac-Man (1982) (Atari) (PAL) [a]"},"1EA980574416BFD504F62575BA524005":{n:"Ms. Pac-Man (1982) (Atari) (Prototype)"},AEB104F1E7B166BC0CBACA0A968FDE51:{n:"Ms. Pac-Man (1999) (Hack)"},"9469D18238345D87768E8965F9F4A6B2":{n:"Ms. Pac-Man (CCE)"},"4066309EB3FA3E7A725585B9814BC375":{n:"Multi Ball Demo (PD)"},"079FE9103515D15BC108577E234A484D":{n:"Multi-Color Demo 0 (Bob Colbert) (PD)"},"4AFE528A082F0D008E7319EBD481248D":{n:"Multi-Color Demo 1 (Bob Colbert) (PD)"},"191449E40B0C56411C70772706F79224":{n:"Multi-Color Demo 2 (Bob Colbert) (PD)"},AE18C11E4D7ED2437F0BF5D167C0E96C:{n:"Multi-Color Demo 3 (Bob Colbert) (PD)"},C28B29764C2338B0CF95537CC9AAD8C9:{n:"Multi-Color Demo 4 (Bob Colbert) (PD)"},D34B933660E29C0A0A04004F15D7E160:{n:"Multi-Color Demo 5 (Bob Colbert) (PD)"},"14163EB2A3DDD35576BD8527EAE3B45E":{n:"Multi-Color Demo 6 (Bob Colbert) (PD)"},B1FD0B71DE9F6EEB5143A97963674CB6:{n:"Multi-Color Demo 7 (Bob Colbert) (PD)"},"25F9CF703575C5D63048C222F5463758":{n:"Multi-Sprite Demo 1 (PD)"},"42AE81AE8AC51E5C238639F9F77D91AE":{n:"Multi-Sprite Demo 2 (Piero Cavina) (PD)"},"17515A4D0B7EA5029FFFF7DFA8456671":{n:"Multi-Sprite Demo V1.1 (Piero Cavina) (PD)"},EF71E9FB0D8D477226D8D42261FBF0A7:{n:"Multi-Sprite Demo V2.0 (Piero Cavina) (PD)"},B958D5FD9574C5CF9ECE4B9421C28ECD:{n:"Multi-Sprite Game V1.0 (Piero Cavina) (PD)"},"59135F13985B84C4F13CC9E55EEC869A":{n:"Multi-Sprite Game V2.0 (Piero Cavina) (PD)"},"7197B6CBDE6ECD10376155E6B848E80D":{n:"Multi-Sprite Game V2.1 (Piero Cavina) (PD)"},"585600522B1F22F617652C962E358A5D":{n:"Multi-Sprite Game V2.2 (Piero Cavina) (PD)"},E609E8A007127B8FCFF79FFC380DA6B1:{n:"Multi-Sprite Game V2.3 (Piero Cavina) (PD)"},"50EF88F9A5E0E1E6B86E175362A27FDB":{n:"Multi-Sprite Game V2.4 (Piero Cavina) (PD)"},"157356F80C709AB675961D8B8B207E20":{n:"Multi-Sprite Game V2.5 (Piero Cavina) (PD)"},"072A6EA2181CA0DF88AC0DEDC67B239D":{n:"Multiple Missiles Demo (19-12-2002) (CT)"},"7550B821EE56FB5833DCA2BE88622D5A":{n:"Multiple Moving Objects Demo (B. Watson)"},CD3E26786136A4692FD2CB2DFBC1927E:{n:"Multiple Moving Objects Demo 2 (B. Watson)"},A100EFF2D7AE61CA2B8E65BAF7E2AAE8:{n:"Muncher (David Marli) (Hack)"},"5BBA254E18257E578C245ED96F6B003B":{n:"Music Effects Demo (21-01-2003) (Paul Slocum)",c:1},F5AA6BD10F662199C42E43863A30106C:{n:"Music Kit (V1.0) - Song Player (Paul Slocum)",c:1},"6F084DAF265599F65422EF4173B69BC7":{n:"Music Kit (V2.0) - Song Player (Paul Slocum)",c:1},"65B106EBA3E45F3DAB72EA907F39F8B4":{n:"Music Machine, The (1983) (Sparrow)",p:1},"04FCCC7735155A6C1373D453B110C640":{n:"My Golf (1990) (HES) (PAL)"},"936F555B4B1A2CD061B659FF63F4F5F2":{n:"My Golf (1990) (HES) (PAL) [a1]"},DFAD86DD85A11C80259F3DDB6151F48F:{n:"My Golf (1990) (HES) (PAL) [fixed]"},EE6CBEDF6C0AAC90FAA0A8DBC093FFBE:{n:"My Golf (CCE) (PAL)"},"0546F4E6B946F38956799DD00CAAB3B1":{n:"My Golf (Thomas Jentzsch)"},FCBBD0A407D3FF7BF857B8A399280EA1:{n:"Mysterious Thief, A (1983) (ZiMAG) (Prototype)",c:1},"48F18D69799A5F5451A5F0D17876ACEF":{n:"Mysterious Thief, A (1983) (ZiMAG) (Prototype) [a]",c:1},FA7E11A3DBEA4365975CD2F094E61D25:{n:"Mystery Science Theater 2600 (1999) (Tim Snider) (Hack)"},"7608ABDFD9B26F4A0ECEC18B232BEA54":{n:"NFL Football (32 in 1) (1988) (Atari) (PAL)"},"67C05AE94BF8B83A666C3AE2C4BC14DE":{n:"NFL Football (32 in 1) (1988) (Atari) (PAL) (4K)"},C58708C09CCB61625CDA9D15DDCD8BE6:{n:"NOIZ Invaders (SPIKE) (2002) (Hack)"},"36306070F0C90A72461551A7A4F3A209":{n:"Name This Game (1982) (U.S. Games)"},F98D2276D4A25B286135566255AEA9D0:{n:"Name This Game (1983) (Digitel)"},"2F7949F71076DB42480D3F5036B4A332":{n:"Name This Game (208 in 1) (Unknown) (PAL) (Hack)"},B392964E8B1C9C2BED12246F228011B2:{n:"Name This Game (Unknown) (PAL)"},"0614ED51ACD027D531E7C85C4F435292":{n:"Narnia (Glenn Saunders) (PD)"},"709910C2E83361BC4BF8CD0C20C34FBF":{n:"Netmaker (Rainbow Vision) (PAL)"},"3F9CB1ABA8EC20E2C243AE642F9942BF":{n:"New Questions (1998) (John K. Harvey) (PD)"},"1201C18CF00D2C236F42E4D7D8C86AA1":{n:"Nick Bensema Demo (Nick Bensema)"},"392F00FD1A074A3C15BC96B0A57D52A1":{n:"Night Driver (1980) (Atari)",p:1,c:1},F48022230BB774A7F22184B48A3385AF:{n:"Night Driver (1980) (Atari) (4K)",p:1,c:1},FEEC54AAC911887940B47FE8C9F80B11:{n:"Night Driver (1980) (Atari) (PAL)",p:1,c:1},D9DA2AE7C7894A29B43B3C6B79F3B7A2:{n:"Night Driver (1980) (Atari) (PAL) (4K)",p:1,c:1},BD39598F067A1193AE81BD6182E756D1:{n:"Night Stalker (1989) (Telegames) (PAL)"},"2783006EE6519F15CBC96ADAE031C9A9":{n:"Night Stalker (1989) (Telegames) (PAL) [a]"},EAD60451C28635B55CA8FEA198444E16:{n:"Nightmare (1983) (Sancho) (PAL)"},"27F9E2E1B92AF9DC17C6155605C38E49":{n:"Nightmare (CCE)"},BDB4B584DDC90C9D2EC7E21632A236B6:{n:"Nitemare at Sunshine Bowl-a-Rama (Atari Freak 1) (Hack)"},DDA23757407C4E217F64962C87AD0C82:{n:"Nitemare at Sunshine Bowl-a-Rama (Atari Freak 1) (Hack) [a]"},B6D52A0CF53AD4216FEB04147301F87D:{n:"No Escape! (1982) (Imagic)"},DC81C4805BF23959FCF2C649700B82BF:{n:"No Escape! (1982) (Imagic) (PAL)"},D8DF256C0D89E494A9FB3E9ABB8E44AC:{n:"No Escape! (1982) (Imagic) (PAL) [a]"},"9912D06EEA42200A198DD3E2BE18C601":{n:"No Escape! (1982) (Imagic) [a]"},"637EFAC676FF063F2FBB0ABFF77C4FA5":{n:"Noize Maker Demo (PD)"},"34F4B1D809AA705ACE6E46B13253FD3B":{n:"Nothern Alliance (Aaron Bergstrom) (Hack)"},E3C35EAC234537396A865D23BAFB1C84:{n:"Nuts (1983) (TechnoVision) (PAL)"},DE7A64108074098BA333CC0C70EEF18A:{n:"Nuts (Unknown)"},"9ED0F2AA226C34D4F55F661442E8F22A":{n:"Nuts (Unknown) (PAL)"},"133A4234512E8C4E9E8C5651469D4A09":{n:"Obelix (1983) (Atari)"},"19E739C2764A5AB9ED08F9095AA2AF0B":{n:"Obelix (1983) (Atari) (PAL)"},"669840B0411BFBAB5C05B786947D55D4":{n:"Obelix (1983) (Atari) (PAL) [a]"},A189F280521F4E5224D345EFB4E75506:{n:"Obelix (1983) (Thomas Jentzsch)"},"4CABC895EA546022C2ECAA5129036634":{n:"Ocean City (Funvision)"},"45CB0F41774B78DEF53331E4C3BF3362":{n:"Octopus (1983) (Carrere Video) (PAL)"},B6166F15720FDF192932F1F76DF5B65D:{n:"Off Your Rocker (1983) (Amiga) (Prototype)"},"98F63949E656FF309CEFA672146DC1B8":{n:"Off the Wall (1989) (Atari)"},"36EDEF446AB4C2395666EFC672B92ED0":{n:"Off the Wall (1989) (Atari) (PAL)"},"0BF1E354304F46C0CAF8FC0F6F5E9525":{n:"Official Frogger (1983) (Arcadia) [a]"},E823B13751E4388F1F2A375D3560A8D7:{n:"Official Frogger (Preview) (1983) (Arcadia) [a]"},C73AE5BA5A0A3F3AC77F0A9E14770E73:{n:"Official Frogger, The (1983) (Arcadia)"},A74689A08746A667A299B0507E1E6DD9:{n:"Official Frogger, The (1983) (Arcadia) (PAL)"},F5D103A9AE36D1D4EE7EEF657B75D2B3:{n:"Official Frogger, The (Preview) (1983) (Arcadia)"},"95FD6097DC27C20666F039CFE34F7C69":{n:"Oh No! (Version 1) (17-01-2003) (AD)"},"5A734779D797CCEF25DC8ACFA47244C7":{n:"Oh No! (Version 2) (18-01-2003) (AD)"},FDD4995A50395DB14F518F63C2D63438:{n:"Oh No! (Version 3) (18-01-2003) (AD)"},DE07E9CB43AD8D06A35F6506E22C62E9:{n:"Oh No! (Version 4) (22-01-2003) (AD)"},C9C25FC536DE9A7CDC5B9A916C459110:{n:"Oink! (1982) (Activision)"},"06B6C5031B8353F3A424A5B86B8FE409":{n:"Oink! (1982) (Activision) (PAL)"},"3DA7CC7049D73D34920BB73817BD05A9":{n:"Oink! (1983) (Activision) (16K)"},"2CF20F82ABCAE2DECFF88DB99331E071":{n:"Oink! (1983) (Activision) (8K)"},F8648D0C6AD1266434F6C485FF69EC40:{n:"Oink! (CCE)"},"853C11C4D07050C22EF3E0721533E0C5":{n:"Oink! (Unknown) (PAL)"},"8101EFAFCF0AF32FEDDA4579C941E6F4":{n:"Okie Dokie (4K) (PD)"},CE4BBE11D682C15A490AE15A4A8716CF:{n:"Okie Dokie (Older) (PD)"},CCA33AE30A58F39E3FC5D80F94DC0362:{n:"Okie Dokie (PD)"},"9947F1EBABB56FD075A96C6D37351EFA":{n:"Omega Race (1983) (CBS Electronics)"},"257BC3B72A6B5DB3FD0D47619125B387":{n:"Omega Race (1983) (CBS Electronics) [a]"},"5B5D04887922B430DE0B7B2A21F9CD25":{n:"Omega Race (Genesis)"},A9784C24CDDB33BD0D14442B97784F3D:{n:"Omega Race DC (2003) (TJ) (Omega Race Hack)"},"3B6DBA1A24BB2893BD3BD0593F92016B":{n:"Omega Race JS (TJ)"},"61426CEE013306E7F7367534AB124747":{n:"One Blue Bar Demo (PD)"},B83DF1F32B4539C324BDF94851B4DB55:{n:"One On One by Angelino (Basketball Hack)"},"8786F4609A66FBEA2CD9AA48CA7AA11C":{n:"Open Sesame (1983) (Goliath) (PAL)",c:1},"28D5DF3ED036ED63D33A31D0D8B85C47":{n:"Open Sesame (1983) (Goliath) (PAL) [a]",c:1},"90578A63441DE4520BE5324E8F015352":{n:"Open Sesame (4 Game in One Dark Green) (1983) (BitCorp) (PAL)",c:1},C880C659CDC0F84C4A66BC818F89618E:{n:"Open Sesame (Thomas Jentzsch)",c:1},"52385334AC9E9B713E13FFA4CC5CB940":{n:"Open, Sesame! (1983) (CCE)",c:1},CC7138202CD8F6776212EBFC3A820ECC:{n:"Oscar's Trash Race (03-30-1983) (Atari) (Prototype)"},"4B94FD272785D7EC6C95FB7279D0F522":{n:"Oscar's Trash Race (12-03-1982) (Atari) (Prototype)"},FA1B060FD8E0BCA0C2A097DCFFCE93D3:{n:"Oscar's Trash Race (1983) (Atari)"},"47911752BF113A2496DBB66C70C9E70C":{n:"Oscar's Trash Race (1983) (Atari) (PAL)"},"55949CB7884F9DB0F8DFCF8707C7E5CB":{n:"Othello (1981) (Atari)"},"02CEE0B140D2F1A1EFCFB1D482A5C392":{n:"Othello (1981) (Atari) (4K)"},"2C3B9C171E214E9E46BBAA12BDF8977E":{n:"Othello (1981) (Atari) (4K) [a]"},A0E2D310E3E98646268200C8F0F08F46:{n:"Othello (1981) (Atari) (PAL)"},"95956108289A917F80667ECCD3CE98A9":{n:"Othello (1981) (Atari) (PAL) (4K)"},"00E19EBF9D0817CCFB057E262BE1E5AF":{n:"Othello (1981) (Atari) (PAL) [no grid markers]"},"113CD09C9771AC278544B7E90EFE7DF2":{n:"Othello (1981) (Atari) [no grid markers]"},"7D9C96B215D1941E87B6FB412EB9204F":{n:"Othello (Unknown) (PAL) (4K)"},F97DEE1AA2629911F30F225CA31789D4:{n:"Out of Control (1983) (Avalon Hill)"},"890C13590E0D8D5D6149737D930E4D95":{n:"Outlaw (1978) (Atari)"},F060826626AAC9E0D8CDA0282F4B7FC3:{n:"Outlaw (1978) (Atari) (4K)"},"22675CACD9B71DEA21800CBF8597F000":{n:"Outlaw (1978) (Atari) (PAL)"},"3EAE062A9B722BDA1255D474A87ECA5C":{n:"Outlaw (1978) (Atari) (PAL) (4K)"},"2E3728F3086DC3E71047FFD6B2D9F015":{n:"Outlaw (32 in 1) (1988) (Atari) (PAL)"},F661F129644F338B13D9F4510D816C03:{n:"Outlaw (32 in 1) (1988) (Atari) (PAL) (4K)"},"7F819454734DDF93F83FEFCFFCD3E212":{n:"Outlaw (Jone Yuan) (4K)"},"1EC5BEF77B91E59313CBA205F15B06D7":{n:"Overhead Adventure Demo 1 (PD)"},"4066D7D88EC4A2C656127A67FA52DCF1":{n:"Overhead Adventure Demo 2 (PD)"},"3C7A96978F52B2B15426CDD50F2C4048":{n:"Overhead Adventure Demo 3 (PD)"},"0CFDD2F3B243CAC21F38A0F09F54BEAD":{n:"Overhead Adventure Demo 4 (PD)"},D5AA7472E7F2CC17E893A1A36F8DADF0:{n:"Overhead Adventure Demo 5 (PD)"},F45644FF82B533A781A1EE50F2E95F3C:{n:"Overhead Adventure Demo 6 (PD)"},"4689081B7363721858756FE781CC7713":{n:"Oystron (V2.6) (Piero Cavina) (PD)"},"26F4F8B098609164EFFEF7809E0121E1":{n:"Oystron (V2.7) (Piero Cavina) (PD)"},E6508B878145187B87B9CDED097293E7:{n:"Oystron (V2.8) (Piero Cavina) (PD)"},"70D14C66C319683B4C19ABBE0E3DB57C":{n:"Oystron (V2.82) (Piero Cavina) (PD)"},"5360693F1EB90856176BD1C0A7B17432":{n:"Oystron (V2.85) (Piero Cavina) (PD)"},"91F0A708EEB93C133E9672AD2C8E0429":{n:"Oystron (V2.9) (Piero Cavina) (PD)"},AA2C4B32656BDE9A75042A4D158583E1:{n:"Oystron X (Piero Cavina) (PD)"},C7E43AD79C5E5C029D9F5FFDE23E32CF:{n:"PAL-NTSC Detector (15-11-2002) (CT)"},"106326C262DFD3E8EAEABD961D2A0519":{n:"PAL-NTSC Detector (15-11-2002) (CT)[a1]"},"6AC3FD31A51730358708C7FDC62487F8":{n:"PC Invaders (Matthias Jaap) (Hack)"},"9C7FA3CFCAAAFB4E6DAF1E2517D43D88":{n:"PIEROXM Demo (PD)"},D0498BACA989E792DB4B8270A02B9624:{n:"Pac Ghost Sprite Demo (PD)"},BD430C2193045C68D1A20A018A976248:{n:"Pac Ghost Sprite Demo 2 (PD)"},F9DA42F91A1C5CFA344D2FF440C6F8D4:{n:"Pac Invaders (ZUT)"},"88D300A38BDD7CAB9EDAD271C18CD02B":{n:"Pac Kong (Funvision) (PAL)"},"936EF1D6F8A57B9FF575DC195EE36B80":{n:"Pac Kong (Unknown)"},CA53FC8FD8B3C4A7DF89AC86B222EBA0:{n:"Pac Man (1983) (CCE)",l:"PAC-MAN",lc:"#f0f010"},"651D2B6743A3A18B426BCE2C881AF212":{n:"Pac Man (1983) (CCE) [a]",l:"PAC-MAN",lc:"#f0f010"},B36040A2F9ECAFA73D835D804A572DBF:{n:"Pac Man (1983) (Digitel)",l:"PAC-MAN",lc:"#f0f010"},EBF9038E927E6A0DB3E0D170C59911E6:{n:"Pac-2600 (PD)"},D223BC6F13358642F02DDACFAF4A90C9:{n:"Pac-Kong (Rainbow Vision) (PAL)"},A4B99AA5ED85CFDB7D101923147DE035:{n:"Pac-Law (Jim Goebel) (Hack)"},"3B8AACF5F5638492B926B5124DE19F18":{n:"Pac-Man (1981) (Atari) (8K)",l:"PAC-MAN",lc:"#f0f010"},"72DB1194B1CC7D45B242F25EB1C148D3":{n:"Pac-Man (1981) (Atari) (Hack)",l:"PAC-MAN",lc:"#f0f010"},"6E372F076FB9586AFF416144F5CFE1CB":{n:"Pac-Man (1982) (Atari)",l:"PAC-MAN",lc:"#f0f010"},FC2233FC116FAEF0D3C31541717CA2DB:{n:"Pac-Man (1982) (Atari) (PAL)",l:"PAC-MAN",lc:"#f0f010"},C2410D03820E0FF0A449FA6170F51211:{n:"Pac-Man (Unknown) (PAL) (Hack)"},"6B6CA32228AE352B4267E4BD2CDDF10C":{n:"Pac-Man 4 (Pac-Man Hack)"},C569E57DCA93D3BEE115A49923057FD7:{n:"Pac-Space (Pac-Man Hack)"},D7B58303EC8D8C4DBCBF54D3B9734C7E:{n:"Paddle Demo (Joe Grand) (PD)",p:1},"82BF0DFF20CEE6A1ED4BB834B00074E6":{n:"Panda (Quest) (Suntek) (PAL)"},"0E713D4E272EA7322C5B27D645F56DD0":{n:"Panda Chase (1983) (Home Vision) (PAL)"},F8582BC6CA7046ADB8E18164E8CECDBC:{n:"Panda Chase (Unknown) (PAL)"},"714E13C08508EE9A7785CEAC908AE831":{n:"Parachute (1983) (Home Vision) (PAL)"},"245F07C8603077A0CAF5F83EE6CF8B43":{n:"Parachute (Thomas Jentzsch)"},"012B8E6EF3B5FD5AABC94075C527709D":{n:"Party Mix (1983) (Arcadia)",p:1},"7EF3CA08ABDE439C6CCCA84693839C57":{n:"Party Mix (1983) (Arcadia) (PAL)",p:1},"4C0FB2544AE0F8B5F7AE8BCE7BD7F134":{n:"Party Mix (Preview) (1983) (Arcadia)",p:1},"7D940D749E55B96B7B746519FA06F2DE":{n:"Party Mix (Preview) (1983) (Arcadia) (PAL)",p:1},"36C31BB5DAEB103F488C66DE67AC5075":{n:"Party Mix - Bop a Buggy (1 of 3) (1983) (Arcadia)",p:1},FF86FC8FFA717BB095E8471638C1C31C:{n:"Party Mix - Bop a Buggy (1 of 3) (1983) (Arcadia) (PAL)",p:1},"6ED5012793F5DDF4353A48C11EA9B8D3":{n:"Party Mix - Down on the Line (3 of 3) (1983) (Arcadia)",p:1},"0E86470791B26292ABE1C64545C47985":{n:"Party Mix - Down on the Line (3 of 3) (1983) (Arcadia) (PAL)",p:1},AAEA37B65DB9E492798F0105A6915E96:{n:"Party Mix - Tug of War (2 of 3) (1983) (Arcadia)",p:1},"08F4DC6F118F7C98E2406C180C08E78E":{n:"Party Mix - Tug of War (2 of 3) (1983) (Arcadia) (PAL)",p:1},E40A818DAC4DD851F3B4AAFBE2F1E0C1:{n:"Peek-A-Boo (1984) (Atari) (Prototype)"},"17BBE288C3855C235950FEA91C9504E9":{n:"Pega Ladrao (Dismac)"},ACE319DC4F76548659876741A6690D57:{n:"Pele's Soccer (1981) (Atari)"},"7A09299F473105AE1EF3AD6F9F2CD807":{n:"Pele's Soccer (1981) (Atari) (PAL)"},"4BCC7F6BA501A26EE785B7EFBFB0FDC8":{n:"Pengo (1983) (Atari) (Prototype)"},"04014D563B094E79AC8974366F616308":{n:"Pengo (1984) (Atari)"},"87B6A17132FC32F576BC49EA18729506":{n:"Pengo (1984) (Atari) (PAL)"},"212D0B200ED8B45D8795AD899734D7D7":{n:"Pepsi Invaders (1983) (Atari)"},"6CE2110AC5DD89AB398D9452891752AB":{n:"Persian Gulf War (Funvision)"},"09388BF390CD9A86DC0849697B96C7DC":{n:"Pete Rose Baseball (1988) (Absolute)"},CB4A7B507372C24F8B9390D22D54A918:{n:"Peter Penguin (1983) (ITT Family Games) (PAL)"},"3685060707DF27D4091BA0EA2DC4B059":{n:"PezZerk - PezMan in Ghost Manor (Hack)"},E959B5A2C882CCAACB43C32790957C2D:{n:"Phantom II & Pirate (NTSC)"},"069C17BEB1E8E0557ADB8539FDCF6CBA":{n:"Phantom II & Pirate (PAL60)"},"6B1FC959E28BD71AED7B89014574BDC2":{n:"Phantom Tank (1982) (BitCorp) (PAL)"},B29359F7DE62FED6E6AD4C948F699DF8:{n:"Phantom Tank (1982) (Puzzy) (PAL)"},"5A9D188245AFF829EFDE816FCADE0B16":{n:"Phantom Tank (1983) (CCE) (PAL)"},"7454786AF7126CCC7A0C31FCF5AF40F1":{n:"Phantom Tank (Unknown) (PAL)"},"4D38E1105C3A5F0B3119A805F261FCB5":{n:"Phantom UFO (4 Game in One Light Green) (1983) (BitCorp) (PAL)"},"08BD4C1DCC843F6A0B563D9FD80B3B11":{n:"Phantompanzer II (1983) (Quelle) (PAL)"},E9034B41741DCEE64AB6605ABA9DE455:{n:"Phanton Tank (Digivision)"},"3577E19714921912685BB0E32DDF943C":{n:"Pharaoh's Curse (1983) (TechnoVision) (PAL)",c:1},"2AE700C9DBA843A68DFDCA40D7D86BD6":{n:"Pharaoh's Curse (Thomas Jentzsch)",c:1},"62F74A2736841191135514422B20382D":{n:"Pharaoh's Curse (Unknown)",c:1},A69F5B1761A8A11C98E706EC7204937F:{n:"Pharaoh's Curse (Unknown) (PAL)",c:1},"3AB5D138E26D88C8190E7CC629A89493":{n:"Phased Color Demo (PD)",c:1},"7DCBFD2ACC013E817F011309C7504DAA":{n:"Phaser Patrol (1982) (Arcadia)",c:1},"72305C997F2CEC414FE6F8C946172F83":{n:"Phaser Patrol (1982) (Arcadia) (PAL)",c:1},"7867EE819B53D69CFCFE740F7DDCA574":{n:"Phaser Patrol (1982) (Arcadia) (Prototype)",c:1},A7A58E9291AEFA1064E933071F60D4EF:{n:"Phaser Patrol (1982) (Arcadia) (Prototype) [a]",c:1},A412C8577B2D57B09185AE51739AC54F:{n:"Phaser Patrol (1982) (Arcadia) [a]",c:1},CA54DE69F7CDF4D7996E86F347129892:{n:"Philly Flasher (1982) (PlayAround)",p:1},"7E52A95074A66640FCFDE124FFFD491A":{n:"Phoenix (1982) (Atari)"},"79FCDEE6D71F23F6CF3D01258236C3B9":{n:"Phoenix (1982) (Atari) (PAL)"},FD8B4EE0D57605B35E236E814F706FF1:{n:"Phoenix (1982) (Atari) (PAL) [a]"},A00EC89D22FCC0C1A85BB542DDCB1178:{n:"Phoenix (1983) (CCE)"},"00E55B27FE2E96354CD21B8B698D1E31":{n:"Phoenix (Unknown)"},A8633050A686270FCF6C0CC4DCBAD630:{n:"Phoenix (Zirok)"},C4060A31D61BA857E756430A0A15ED2E:{n:"Pick 'n Pile (2003) (TJ)",c:1},DA79AAD11572C80A96E261E4AC6392D0:{n:"Pick 'n' Pile (1990) (Salu) (PAL)",c:1},"1D4E0A034AD1275BC4D75165AE236105":{n:"Pick Up (1983) (20th Century Fox) (Prototype)"},"17C0A63F9A680E7A61BEBA81692D9297":{n:"Picnic (1982) (U.S. Games)",p:1},"24544EE5D76F579992D9522E9B238955":{n:"Picnic (1983) (Carrere Video) (PAL)",p:1},D3423D7600879174C038F53E5EBBF9D3:{n:"Piece o' Cake (1982) (U.S. Games)",p:1},"8E4FA8C6AD8D8DCE0DB8C991C166CDAA":{n:"Pigs in Space (1983) (Atari)"},"95E1D834C57CDD525DD0BD6048A57F7B":{n:"Pigs in Space (1983) (Atari) (PAL)"},CC3D942C6958BD16B1C602623F59E6E1:{n:"Pigs in Space (1983) (Atari) (PAL) [a]"},F04EE80011D95798006378643650AAA7:{n:"Pigs in Space (1983) (Atari) (Prototype)"},E3533684A7EF930A7FBD0C4DD8EC4847:{n:"Pimball (1983) (CCE)"},DBC7485AD5814D466DE780A3E7ED3B46:{n:"Pink Floyd (Kyle Pittman) (PD)"},"69E79B1352B9EE1754BBE63B4A7062C3":{n:"Pink Floyd - The Wall (2003) (Barry Laws Jr.) (Hack)"},"798CC114F1623C14085868CD3494FE8E":{n:"Pins Revenge (Atari Freak 1)"},F73D2D0EFF548E8FC66996F27ACF2B4B:{n:"Pitfall (1983) (CCE)",l:"PITFALL!",lc:"#ececec #272"},D20E61C86ED729780FECA162166912CA:{n:"Pitfall (1984) (Supergame)",l:"PITFALL!",lc:"#ececec #272"},"2D405DA70AF82B20A6B3ECC3D1D2C4EC":{n:"Pitfall (Genus)",l:"PITFALL!",lc:"#ececec #272"},"5A272012A62BECABCD52920348C7C60B":{n:"Pitfall (Star Game)",l:"PITFALL!",lc:"#ececec #272"},"39A6A5A2E1F6297CCEAA48BB03AF02E9":{n:"Pitfall 2 Plus (Hack)"},"7B79BEB378D1B4471DEF90CECCF413DE":{n:"Pitfall Cupcake (Hack)"},"6D842C96D5A01967BE9680080DD5BE54":{n:"Pitfall II (1983) (Activision)"},E34C236630C945089FCDEF088C4B6E06:{n:"Pitfall II (1983) (Activision) (PAL)"},"448C2A175AFC8DF174D6FF4CCE12C794":{n:"Pitfall II (1983) (Activision) [a2]"},"490EED07D4691B27F473953FBEA6541A":{n:"Pitfall II (1983) (Activision) [a]"},"268F46038E29301568FA9E443E16E960":{n:"Pitfall Unlimited (Atarius Maximus) (Hack)"},AAD91BE0BF78D33D29758876D999848A:{n:"Pitfall! (1981) (Activision) (Prototype)",l:"PITFALL!",lc:"#ececec #272"},"3E90CF23106F2E08B2781E41299DE556":{n:"Pitfall! (1982) (Activision)",l:"PITFALL!",lc:"#ececec #272"},"6FD7C7057EEAB273B29C7AAFC7429A96":{n:"Pitfall! (1982) (Activision) (16K)",l:"PITFALL!",lc:"#ececec #272"},"98EC0FA4199B9C01F7B8FA3732E43372":{n:"Pitfall! (1982) (Activision) (8K)",l:"PITFALL!",lc:"#ececec #272"},"791BC8ACEB6B0F4D9990D6062B30ADFA":{n:"Pitfall! (1982) (Activision) (PAL)",l:"PITFALL!",lc:"#ececec #272"},"1782929E1C214B70FB6884F77C207A55":{n:"Pitfall! (1982) (Activision) (Prototype)",l:"PITFALL!",lc:"#ececec #272"},"2B430C00DC79E495762AC59B2F9B4FCD":{n:"Pitfall! (1982) (Activision) (Prototype)",l:"PITFALL!",lc:"#ececec #272"},E42B937C30C617241CA9E01E4510C3F6:{n:"Pitfall! (No Walls Hack)",l:"PITFALL!",lc:"#ececec #272"},"177504ABD4260C4265E1338955E9FA47":{n:"Pitfall! (Steroids Hack)"},"55EF6AB2321CA0C3D369E63D59C059C8":{n:"Pitfall! (Unknown) (PAL)",l:"PITFALL!",lc:"#ececec #272"},"5BBAB3F3E4B47E3E23F9820765DBB45C":{n:"Pitfall! (says 1985) [h1]",l:"PITFALL!",lc:"#ececec #272"},"82EFE7984783E23A7C55266A5125C68E":{n:"Pizza Chef (1983) (CCE)"},D9FBF1113114FB3A3C97550A0689F10F:{n:"Pizza Chef (1983) (ZiMAG) (Prototype)"},"2F77F015FC880B05F28E84156F989A0C":{n:"Plane Demo (Gonzalo) (PD)"},AE10527840A1AC24DE43730645ED508D:{n:"Planet Invaders (Charles Morgan) (Hack)"},BB745C893999B0EFC96EA9029E3C62CA:{n:"Planet Patrol (1982) (Play Video) (PAL)"},"043F165F384FBEA3EA89393597951512":{n:"Planet Patrol (1982) (Spectravision)"},"69FAC82CD2312DD9CE5D90E22E2F070A":{n:"Planet Patrol (1982) (Spectravision) (PAL)"},D6ACFF6AED0F04690FE4024D58FF4CE3:{n:"Planet Patrol (1982) (Spectravision) (PAL) [different spaceship]"},"79004F84BDEEE78D142E445057883169":{n:"Planet Patrol (1983) (CCE)"},"1C3F3133A3E5B023C77ECBA94FD65995":{n:"Planet Patrol (1983) (CCE) [a]"},AAFC79FFC32C4C9B2D73C8ADA7602CFE:{n:"Planet Patrol (Unknown) (PAL)"},"9EFB4E1A15A6CDD286E4BCD7CD94B7B8":{n:"Planet of the Apes (1983) (20th Century Fox) (Prototype)"},DA4E3396AA2DB3BD667F83A1CB9E4A36:{n:"Plaque Attack (1983) (Activision)"},"32244E55CE6EC6BFBD763F33384BDC2E":{n:"Plaque Attack (1983) (Activision) (16K)"},"2ABA6A1B01A5859E96D6A66D2286772F":{n:"Plaque Attack (1983) (Activision) (8K)"},"7CED6709F091E79A2AB9575D3516A4AC":{n:"Plaque Attack (1983) (Activision) (PAL)"},B64426E787F04FF23EE629182C168603:{n:"Plaque Attack (1983) (Dynacom)"},DE24F700FD28D5B8381DE13ABD091DB9:{n:"Plaque Attack (CCE)"},"8B8789C6669A4CEE86C579A65332F852":{n:"Plaque Attack (Digivision)"},"3ECCF9F363F5C5DE0C8B174A535DC83B":{n:"Plaque Attack (Unknown) (PAL)"},"6A76D5F0ED721639474AA9BBDE69EBF0":{n:"Play Demo (PD)",c:1},"5C3A6D27C026F59A96B7AF91E8B1BF26":{n:"PlayAround Demo (PlayAround) (1982)"},"103E9D616328969F5D7B4E0A381B25D5":{n:"Playfield Illustration and Logo Demo (2001) (Jake Patterson) (PD)"},CBA56E939252B05DF7B7DE87307D12CA:{n:"Playfield Text Demo (2001) (Roger Williams)"},"8BBFD951C89CC09C148BFABDEFA08BEC":{n:"Pleiades (1983) (UA Limited) (Prototype)",c:1},"9AFDFE1CFF7F37F1C971FE3F0C900606":{n:"Plug Attack (Funvision)"},"7C4A499D343FCA0CEF2D59DD16AF621A":{n:"Poker Card Demo (PD)"},D74A81FCD89C5CF0BD4C88EB207EBD62:{n:"Poker Squares (V0.00a) (2001) (B. Watson)"},"12D7E0D6B187889F8D150BF7034D1DB2":{n:"Poker Squares (V0.0e) (2001) (B. Watson)"},E879B7093AC4CFAD74C88D636CA97D00:{n:"Poker Squares (V0.0f) (2001) (B. Watson)"},"6E7ED74082F39AD4166C823765A59909":{n:"Poker Squares (V0.14) (2001) (B. Watson)"},"78297DB7F416AF3052DD793B53FF014E":{n:"Poker Squares (V0.17) (2001) (B. Watson)"},"54785FA29E28AAE6038929BA29D33D38":{n:"Poker Squares (V0.19) (2001) (B. Watson)"},"675AE9C23FA1AAE376CEA86CAD96F9A5":{n:"Poker Squares (V0.25) (2001) (B. Watson)"},CCCFE9E9A11B1DAD04BEBA46EEFB7351:{n:"Poker Squares (V0.25) (PAL) (2001) (B. Watson)"},"8C136E97C0A4AF66DA4A249561ED17DB":{n:"Poker Squares (V0.27) (2001) (B. Watson)"},"08D60A58A691C7F690162850302DC0E1":{n:"Poker Squares (V0.27) (PAL) (2001) (B. Watson)"},EA832E2CB6AAE6F525F07452C381FA48:{n:"Polar to Cartesian and VV (2001) (Roger Williams)"},"8953BC11352D794431D3303E31D3B892":{n:"Polaris (02-17-1983) (Tigervision) (Prototype) (4K)"},"87BEA777A34278D29B3B6029833C5422":{n:"Polaris (1983) (Thomas Jentzsch)"},"44F71E70B89DCC7CF39DFD622CFB9A27":{n:"Polaris (1983) (Tigervision)"},"203049F4D8290BB4521CC4402415E737":{n:"Polaris (1983) (Tigervision) (PAL)"},"9048CCB7E0802CD8FA5BFC2609F292D8":{n:"Polaris (1983) (Tigervision) (Prototype)"},"7F0209CFCC3D181715463F4D6451CECF":{n:"Pole Position (05-15-1983) (Atari) (Prototype)"},A4FF39D513B993159911EFE01AC12EBA:{n:"Pole Position (1983) (Atari)"},B56264F738B2EB2C8F7CF5A2A75E5FDC:{n:"Pole Position (1983) (Atari) (PAL)"},"25B52BF8DD215BCBD59C9ABDB55C44F8":{n:"Pole Position (1983) (Atari) (PAL) [a]"},"5F39353F7C6925779B0169A87FF86F1E":{n:"Pole Position (1983) (Atari) [a]"},"3225676F5C0C577AECCFAA7E6BEDD765":{n:"Pole Position (1983) (CCE)"},"5DA8FD0B5ED33A360BFF37F8B5D0CD58":{n:"Pole Position (Tron)"},EE28424AF389A7F3672182009472500C:{n:"Polo (1978) (Atari) (Prototype)"},"14B1E30982962C72F426E2E763EB4274":{n:"Polo (1978) (Atari) (Prototype) (4K)"},A83B070B485CF1FB4D5A48DA153FDF1A:{n:"Pompeii (1983) (Apollo) (Prototype)"},"668DC528B7EA9345140F4FCFBECF7066":{n:"Pooyan (1983) (Gakken) (PAL)"},"4799A40B6E889370B7EE55C17BA65141":{n:"Pooyan (1983) (Konami)"},F70E3F3BB2D19EC2AAEC8F78DC43744F:{n:"Pooyan (Jone Yuan) (Hack)"},"89AFFF4A10807093C105740C73E9B544":{n:"Pooyan (Unknown) (PAL)"},C7F13EF38F61EE2367ADA94FDCC6D206:{n:"Popeye (1983) (Parker Bros)",c:1},E9CB18770A41A16DE63B124C1E8BD493:{n:"Popeye (1983) (Parker Bros) (PAL)",c:1},F93D7FEE92717E161E6763A88A293FFA:{n:"Porky's (1983) (20th Century Fox)"},"4A5FDDF89801336637AC8E57A7C9A881":{n:"Power Play Arcade Video Game Album IV (1984) (Amiga) (Prototype)"},BBF8C7C9ED280151934AABE138E41BA7:{n:"Power Play Arcade Video Game Album V (1984) (Amiga) (Prototype)"},"97D079315C09796FF6D95A06E4B70171":{n:"Pressure Cooker (1983) (Activision)"},"525EA747D746F3E80E3027720E1FA7AC":{n:"Pressure Cooker (1983) (Activision) (PAL)"},D57913088E0C49AC3A716BF9837B284F:{n:"Pressure Cooker (1983) (Activision) (PAL) [a]"},"027A59A575B78860AED780B2AE7D001D":{n:"Pressure Cooker (CCE)"},DE1A636D098349BE11BBC2D090F4E9CF:{n:"Pressure Gauge (Hozer Video Games)"},"6A03C28D505BAB710BF20B954E14D521":{n:"Pressure Gauge 2 Beta (Hozer Video Games)"},EF3A4F64B6494BA770862768CAF04B86:{n:"Private Eye (1983) (Activision)"},"1266B3FD632C981F3EF9BDBF9F86CE9A":{n:"Private Eye (1983) (Activision) (PAL)"},F9CEF637EA8E905A10E324E582DD39C2:{n:"Private Eye (CCE)"},"22F6B40FC82110D68E50A1208AE0BB97":{n:"Purple Bar Demo (PD)"},"9CA2DEB61318EBA4FB784D4BF7441D8B":{n:"Purple Bar Demo 2 (PD)"},"6E19428387686A77D8C8D2F731CB09E0":{n:"Purple Cross Demo (PD)"},CFF1E9170BDBC29859B815203EDF18FA:{n:"Push (V0.01) (1998) (AD)",c:1},B7E459D5416EEB196AAA8E092DB14463:{n:"Push (V0.02) (1998) (AD)"},C482F8EEBD45E0B8D479D9B71DD72BB8:{n:"Push (V0.03) (1998) (AD)",c:1},BEFCE0DE2012B24FD6CB8B53C17C8271:{n:"Push (V0.03) (No Illegal Opcodes) (1998) (AD)"},"0375F589F7DA06D2D2BE532E0D4D4B94":{n:"Push (V0.04) (2001) (AD)"},"96F806FC62005205D851E758D050DFCA":{n:"Push (V0.05) (2001) (AD)"},"9D2F05D0FE8B2DFCF770B02EDA066FC1":{n:"Push (V0.06) (2001) (AD)"},"9F93734C68F6479EB022CAB40814142E":{n:"Push (V0.07) (2001) (AD)"},"78963290052FD17C6C7998305AB3A6A0":{n:"Push (V0.08) (2001) (AD)"},"679D30C7886B283CBE1DB4E7DBE5F2A6":{n:"Puzzle (Colin Hughes) (PD)"},"3FF5165378213DAB531FFA4F1A41AE45":{n:"Pygmy (1983) (Quelle) (PAL)"},"6FC0176CCF53D7BCE249AEB56D59D414":{n:"Pyramid War (Rainbow Vision) (PAL)"},"37FD7FA52D358F66984948999F1213C5":{n:"Pyramid War (Rainbow Vision) (PAL) [a2]"},"8B40A9CA1CFCD14822E2547EAA9DF5C1":{n:"Q-bert (1983) (Parker Bros) (PAL)"},"1EDE4F365CE1386D58F121B15A775E24":{n:"Q-bert (1983) (Parker Bros) (PAL) [a]"},"484B0076816A104875E00467D431C2D2":{n:"Q-bert (1987) (Atari)"},EB6D6E22A16F30687ADE526D7A6F05C5:{n:"Q-bert (1987) (Atari) (PAL)"},A91D0858A52DE3A2E6468437212D93E8:{n:"Q-bert (208 in 1) (Unknown) (PAL)"},"517592E6E0C71731019C0CEBC2CE044F":{n:"Q-bert's Qubes (1984) (Parker Bros)"},B15026B43C6758609667468434766DD8:{n:"Qb (0.06) (Retroactive)",c:1},"6803FA7C2C094B428B859A58DC1DD06A":{n:"Qb (0.11) (Retroactive)",c:1},"5A5390F91437AF9951A5F8455B61CD43":{n:"Qb (0.11) (Retroactive) (PAL)",c:1},"376944889DCFA96C73D3079F308E3D32":{n:"Qb (0.11) (Retroactive) (Stella)",c:1},"292A0BB975B2587F9AC784C960E1B453":{n:"Qb (05-02-2001) (AD)",c:1},D0E9BEB2347595C6C7D158E9D83D2DA8:{n:"Qb (2.00) (Retroactive)",c:1},C866C995C0D2CA7D017FEF0FC0C2E268:{n:"Qb (2.00) (Retroactive) (PAL)",c:1},F33F1D0F7819C74148DACB48CBF1C597:{n:"Qb (2.00) (Retroactive) (Stella)",c:1},"2E0AED5BB619EDCEFA3FAFB4FBE7C551":{n:"Qb (2.06) (Retroactive) (NTSC)",c:1},"05EB4347F0EC8F4783983CA35FFD8D1B":{n:"Qb (2.06) (Retroactive) (PAL)",c:1},E800E4AEC7C6C54C9CF3DB0D1D030058:{n:"Qb (2.06) (Retroactive) (Stella)",c:1},"3A51A6860848E36E6D06FFE01B71FB13":{n:"Qb (2.07) (Retroactive) (NTSC)",c:1},FAE0B86934A7C5A362281DFFEBDB43A0:{n:"Qb (2.07) (Retroactive) (PAL)",c:1},CEA9F72036DC6F7AF5EFF52459066290:{n:"Qb (2.07) (Retroactive) (Stella)",c:1},"67BD3D4DC5AC6A42A99950B4245BDC81":{n:"Qb (2.11) (Retroactive)",c:1},"283DEE88F295834C4C077D788F151125":{n:"Qb (2.11) (Retroactive) (PAL)",c:1},"2808DC745FF4321DC5C8122ABEF6711F":{n:"Qb (2.11) (Retroactive) (Stella)",c:1},"35163B56F4A692A232AE96AD3E23310F":{n:"Qb (2.12) (Retroactive)",c:1},B3017E397F74EFD53CAF8FAE0A38E3FE:{n:"Qb (2.12) (Retroactive) (PAL)",c:1},"6E5D5BA193D2540AEC2E847AAFB2A5FB":{n:"Qb (2.14) (Retroactive) (NTSC)",c:1},"4F634893D54E9CABE106E0EC0B7BDCDF":{n:"Qb (2.14) (Retroactive) (PAL)",c:1},"52E1954DC01454C03A336B30C390FB8D":{n:"Qb (2.14) (Retroactive) (Stella)",c:1},AC53B83E1B57A601EEAE9D3CE1B4A458:{n:"Qb (2.15) (Retroactive) (NTSC)",c:1},"9281ECCD7F6EF4B3EBDCFD2204C9763A":{n:"Qb (2.15) (Retroactive) (PAL)",c:1},"34E37EAFFC0D34E05E40ED883F848B40":{n:"Qb (2.15) (Retroactive) (Stella)",c:1},"2D69A5F23784F1C2230143292A073B53":{n:"Qb (Fixed background animation) (2001) (AD)",c:1},"17512D0C38F448712F49F36F9D185C4E":{n:"Qb (Release Candidate #1) (Retroactive)",c:1},"687C23224E26F81C56E431C24FAEA36D":{n:"Qb (Simple Background Animation) (2001) (AD)",c:1},"3F01BD6D059396F495A4CDE7DE0AB180":{n:"Qb (Special Edition) (NTSC) (Retroactive)",c:1},F49A34F1FDD7DC147CBF96CE2CE71B76:{n:"Qb (Special Edition) (PAL) (Retroactive)",c:1},E01E00504E6D4B88FA743C0BBE8A96E5:{n:"Qb (Special Edition, some bugfixes) (Retroactive)",c:1},D787EC6785B0CCFBD844C7866DB9667D:{n:"Qb (V0.04) (2001) (Retroactive)",c:1},"3C4A6F613CA8BA27CE9E43C6C92A3128":{n:"Qb (V0.04) (Non-Lax Version) (2001) (Retroactive)",c:1},CF0C593C563C84FDAF0F741ADB367445:{n:"Qb (V0.05) (2001) (Retroactive)",c:1},"35FA32256982774A4F134C3347882DFF":{n:"Qb (V0.05) (Macintosh) (2001) (Retroactive)",c:1},"8712CCEEC5644AACC2C21203D9EBE2EC":{n:"Qb (V0.10) (NTSC) (2001) (Retroactive)",c:1},"4233EB824C2B4811ABEF9B6D00355AE9":{n:"Qb (V0.10) (PAL) (2001) (Retroactive)",c:1},D010E3DFE7366E47561C088079A59439:{n:"Qb (V0.10) (Stella) (2001) (Retroactive)",c:1},"0906C6E0E4BDA9C10CFA4C5FC64D2F4B":{n:"Qb (V0.12) (NTSC) (2001) (Retroactive)",c:1},AE682886058CD6981C4B8E93E7B019CF:{n:"Qb (V0.12) (PAL) (2001) (Retroactive)",c:1},CDC1A5C61D7488EADC9ABA36166B253D:{n:"Qb (V0.12) (Stella) (2001) (Retroactive)",c:1},"8B504B417C8626167A7E02F44229F0E7":{n:"Qb (V1.00) (NTSC) (2001) (Retroactive)",c:1},"8FFFC8F15BB2E6D24E211884A5479AA5":{n:"Qb (V1.00) (PAL) (2001) (Retroactive)",c:1},"7BC4FD254EC8C0A25A13F02FD3F762FF":{n:"Qb (V1.00) (Stella) (2001) (Retroactive)",c:1},"8CCAA442D26B09139685F5B22BF189C4":{n:"Qb (V1.01) (NTSC) (2001) (Retroactive)",c:1},ABB740BEA0A6842831B4F53112FB8145:{n:"Qb (V1.01) (PAL) (2001) (Retroactive)",c:1},AE0D4F3396CB49DE0FABDFF03CB2756F:{n:"Qb (V2.02) (PAL) (2001) (Retroactive)",c:1},C504A71C411A601D1FC3173369CFDCA4:{n:"Qb (V2.02) (Stella) (2001) (Retroactive)",c:1},"693137592A7F5CCC9BAAE2D1041B7A85":{n:"Qb (V2.02) (Stella) (2001) (Retroactive) [a1]",c:1},"98CCD15345B1AEE6CAF51E05955F0261":{n:"Qb (V2.03) (NTSC) (2001) (Retroactive)",c:1},"4C030667D07D1438F0E5C458A90978D8":{n:"Qb (V2.03) (PAL) (2001) (Retroactive)",c:1},CE64812EB83C95723B04FB56D816910B:{n:"Qb (V2.04) (NTSC) (2001) (Retroactive)",c:1},EB9712E423B57F0B07CCD315BB9ABF61:{n:"Qb (V2.04) (PAL) (2001) (Retroactive)",c:1},"4DD6C7AB9EF77F2B4950D8FC7CD42EE1":{n:"Qb (V2.04) (Stella) (2001) (Retroactive)",c:1},"659A20019DE4A23C748EC2292EA5F221":{n:"Qb (V2.05) (NTSC) (2001) (Retroactive)",c:1},C92CFA54B5D022637FDCBDC1EF640D82:{n:"Qb (V2.05) (PAL) (2001) (Retroactive)",c:1},DCBA0E33AA4AED67630A4B292386F405:{n:"Qb (V2.08) (Half Speed Version) (NTSC) (2001) (Retroactive)",c:1},"57A66B6DB7EFC5DF17B0B0F2F2C2F078":{n:"Qb (V2.08) (NTSC) (2001) (Retroactive)",c:1},"876A953DAAE0E946620CF05ED41989F4":{n:"Qb (V2.08) (PAL) (2001) (Retroactive)",c:1},"318046AE3711C05FD16E479B298E5FCC":{n:"Qb (V2.08) (Stella) (2001) (Retroactive)",c:1},E2389C0BE5B5B84E0D3CA36EC7E67514:{n:"Qb (V2.09) (NTSC) (2001) (Retroactive)",c:1},"008543AE43497AF015E9428A5E3E874E":{n:"Qb (V2.09) (PAL) (2001) (Retroactive)",c:1},"67CE6CDF788D324935FD317D064ED842":{n:"Qb (V2.09) (Stella) (2001) (Retroactive)",c:1},"94E4C9B924286038527F49CDC20FDA69":{n:"Qb (V2.12) (Stella) (2001) (Retroactive)",c:1},"4FAE08027365D31C558E400B687ADF21":{n:"Qb (V2.17) (NTSC) (2001) (Retroactive)",c:1},"8388D6FE59C38C0B3A6AB2C58420036A":{n:"Quadrun (12-06-1982) (Atari) (Prototype)"},"024365007A87F213CBE8EF5F2E8E1333":{n:"Quadrun (1983) (Atari)"},"392D34C0498075DD58DF0CE7CD491EA2":{n:"Quadrun (1983) (Atari) (Prototype)"},"955C408265AD6994F61F9B66657BBAE9":{n:"Quadrun (Video Conversion) (Fabrizio Zavagli)"},"152C253478B009C275E18CD731B48561":{n:"Quest (11-10-2002) (Chris Larkin)"},A0675883F9B09A3595DDD66A6F5D3498:{n:"Quest for Quintana Roo (1989) (Telegames)"},F736864442164B29235E8872013180CD:{n:"Quest for Quintana Roo (1989) (Telegames) (PAL)"},"7EBA20C2291A982214CC7CBE8D0B47CD":{n:"Quick Step! (1983) (Imagic)"},E72EE2D6E501F07EC5E8A0EFBE520BEE:{n:"Quick Step! (1983) (Imagic) (PAL)"},"84290E333FF7567C2380F179430083B8":{n:"Quick Step! (1983) (Imagic) (PAL) [a]"},"7836794B79E8060C2B8326A2DB74EEF0":{n:"RIOT RAM Test (26-11-2002) (Dennis Debro)"},"6CCD8CA17A0E4429B446CDCB66327BF1":{n:"RPG Engine (12-05-2003) (Paul Slocum) (PD)",c:1},"9C6D65BD3B477AACE0376F705B354D68":{n:"RPG Kernal (18-04-2003) (Paul Slocum) (PD)",c:1},"0F341D1F4E144E3163D9A5FC5A662B79":{n:"RUN Platform Demo (PD)",c:1},"2E5B184DA8A27C4D362B5A81F0B4A68F":{n:"Rabbit Transit (08-29-1983) (Atari) (Prototype)"},FB4CA865ABC02D66E39651BD9ADE140A:{n:"Rabbit Transit (1983) (Arcadia)"},"7481F0771BFF13885B2FF2570CF90D7B":{n:"Rabbit Transit (1983) (Arcadia) (PAL)"},A779B9FA02C62D00D7C31ED51268F18A:{n:"Rabbit Transit (1983) (Arcadia) [a]"},CD399BC422992A361BA932CC50F48B65:{n:"Rabbit Transit (Preview) (1983) (Arcadia)"},"1A23540D91F87584A04F184304A00648":{n:"Race Demo (PD)"},AAB840DB22075AA0F6A6B83A597F8890:{n:"Racing Car (1983) (Home Vision) (PAL)"},"4DF9D7352A56A458ABB7961BF10ABA4E":{n:"Racing Car (Unknown)"},CBCED209DD0575A27212D3EEE6AEE3BC:{n:"Racquetball (1981) (Apollo)",c:1},"4F7B07EC2BEF5CCFFE06403A142F80DB":{n:"Racquetball (1981) (Apollo) (PAL)",c:1},A20D931A8FDDCD6F6116ED21FF5C4832:{n:"Racquetball (1981) (Apollo) [a]",c:1},F0D393DBF4164A688B2346770C9BBD12:{n:"Racquetball (Unknown)",c:1},"97933C9F20873446E4C1F8A4DA21575F":{n:"Racquetball (Unknown) (PAL)",c:1},"56300ED31FEF018BD96768CCC982F7B4":{n:"Rad Action Pak - Kung-Fu Master, Freeway, Frostbite (1990) (HES) (PAL)"},"247FA1A29AD90E64069EE13D96FEA6D6":{n:"Radar (1983) (CCE)"},"74F623833429D35341B7A84BC09793C0":{n:"Radar (Zellers)"},BAF4CE885AA281FD31711DA9B9795485:{n:"Radar Lock (1989) (Atari)"},"04856E3006A4F5F7B4638DA71DAD3D88":{n:"Radar Lock (1989) (Atari) (PAL)"},"200309C8FBA0F248C13751ED4FC69BAB":{n:"Radial Pong - Version 1 (Jeffry Johnston) (PD)"},"0F14C03050B35D6B1D8850B07578722D":{n:"Radial Pong - Version 10 (Jeffry Johnston) (PD)"},"43F33C6DFDEAF5138CE6E6968AD7C5CE":{n:"Radial Pong - Version 11 (Jeffry Johnston) (PD)"},"32199271DC980EB31A2CC96E10A9E244":{n:"Radial Pong - Version 12 (Jeffry Johnston) (PD)"},"6337927AD909AA739D6D0044699A916D":{n:"Radial Pong - Version 2 (Jeffry Johnston) (PD)"},F1E375D921858467166E53BCEC05803F:{n:"Radial Pong - Version 3 (Jeffry Johnston) (PD)"},"481F9A742052801CC5F3DEFB41CB638E":{n:"Radial Pong - Version 4 (Jeffry Johnston) (PD)"},FD9B321CEE5FBB32C39BA3CA5D9EC7CF:{n:"Radial Pong - Version 5 (Jeffry Johnston) (PD)"},"64B8E19C767191CCDC97ACC6904C397B":{n:"Radial Pong - Version 6 (Jeffry Johnston) (PD)"},"2450DFA1DF70D12B60683185775EFED8":{n:"Radial Pong - Version 7 (Jeffry Johnston) (PD)"},"9F9EE0F60C119C831E80694B6678CA1A":{n:"Radial Pong - Version 8 (Jeffry Johnston) (PD)"},"05824FCBE615DBCA836D061A140A50E0":{n:"Radial Pong - Version 9 (Jeffry Johnston) (PD)"},"92A1A605B7AD56D863A56373A866761B":{n:"Raft Rider (1982) (U.S. Games)"},"438968A26B7CFE14A499F5BBBBF844DB":{n:"Raft Rider (208 in 1) (Unknown) (PAL)"},"1E750000AF77CC76232F4D040F4AB060":{n:"Raft Rider (Jone Yuan)"},"025668E36A788E8AF8AC4F1BE7E72043":{n:"Raiders of the Lost Ark (06-14-82) (Atari) (Prototype)"},F724D3DD2471ED4CF5F191DBB724B69F:{n:"Raiders of the Lost Ark (1982) (Atari)"},"1CAFA9F3F9A2FCE4AF6E4B85A2BBD254":{n:"Raiders of the Lost Ark (1982) (Atari) (PAL)"},CB96B0CF90AB7777A2F6F05E8AD3F694:{n:"Rainbow Invaders"},"8F98519A91DBBF4864F135A10050D9ED":{n:"Rainbow Invaders (non-playable demo) (PD)"},"0B577E63B0C64F9779F315DCA8967587":{n:"Raketen-Angriff (Ariola) (PAL)"},"7096A198531D3F16A99D518AC0D7519A":{n:"Ram It (1982) (Telesys)"},"63E42D576800086488679490A833E097":{n:"Ram It (1982) (Telesys) (PAL)"},F2F2CB35FDEF063C966C1F5481050EA2:{n:"Ram It (Unknown) (PAL)"},"9EEB40F04A27EFB1C68BA1D25E606607":{n:"Rambo II (2003) (Kyle Pittman) (Hack)"},"2EDA6A49A49FCB2B674EA9E160B6A617":{n:"Rambo in Afghanistan (Kyle Pittman) (Hack)"},"5E1B4629426F4992CF3B2905A696E1A7":{n:"Rampage! (1989) (Activision)"},A11099B6EC24E4B00B8795744FB12005:{n:"Rampage! (1989) (Activision) (PAL)"},"9F8FAD4BADCD7BE61BBD2BCAEEF3C58F":{n:"Reactor (1982) (Parker Bros)",c:1},"4904A2550759B9B4570E886374F9D092":{n:"Reactor (1982) (Parker Bros) (PAL)",c:1},C6DB733E0B108C2580A1D65211F06DBF:{n:"RealSports Baseball (07-09-1982) (Atari) (Prototype)"},EB634650C3912132092B7AEE540BBCE3:{n:"RealSports Baseball (1982) (Atari)",c:1},"20D4457BA22517253FCB62967AF11B37":{n:"RealSports Baseball (1982) (Atari) (Prototype)"},"8A183B6357987DB5170C5CF9F4A113E5":{n:"RealSports Basketball (1983) (Atari) (Prototype) (PAL)"},"5524718A19107A04EC3265C93136A7B5":{n:"RealSports Basketball (Thomas Jentzsch)"},"3177CC5C04C1A4080A927DFA4099482B":{n:"RealSports Boxing (1987) (Atari)"},"4ABB4C87A4C5F5D0C14EAD2BB36251BE":{n:"RealSports Boxing (1987) (Atari) (PAL)"},"7AD257833190BC60277C1CA475057051":{n:"RealSports Football (1982) (Atari)",c:1},"277FA4B9A6BB7A8DCEA2C5F38A4C25F0":{n:"RealSports Football (1982) (Atari) (Prototype)",c:1},"08F853E8E01E711919E734D85349220D":{n:"RealSports Soccer (1983) (Atari)"},B9336ED6D94A5CC81A16483B0A946A73:{n:"RealSports Soccer (1983) (Atari) (PAL)",c:1},"6272F348A9A7F2D500A4006AA93E0D08":{n:"RealSports Soccer (1983) (Atari) (PAL) [a]",c:1},"6706A00F9635508CFEDA20639156E66E":{n:"RealSports Soccer (1983) (Atari) (Prototype)"},F7856E324BC56F45B9C8E6FF062EC033:{n:"RealSports Soccer (1983) (Atari) [no opening tune]",c:1},C5DD8399257D8862F3952BE75C23E0EB:{n:"RealSports Tennis (1982) (Atari) (Prototype)"},DAC5C0FE74531F077C105B396874A9F1:{n:"RealSports Tennis (1983) (Atari)"},"4E66C8E7C670532569C70D205F615DAD":{n:"RealSports Tennis (1983) (Atari) (PAL)"},"13AA1F9AC4249947E4AF61319D9A08F2":{n:"RealSports Tennis (1983) (Atari) (PAL) [a1]"},C7EAB66576696E11E3C11FFFF92E13CC:{n:"RealSports Tennis (1983) (Atari) (PAL) [a2]"},"435FD469F088468C4D66BE6B5204D887":{n:"RealSports Tennis (1983) (Atari) (PAL) [a]"},AED0B7BD64CC384F85FDEA33E28DAF3B:{n:"RealSports Volleyball (1982) (Atari)"},"4CA0959F846D2BEADA18ECF29EFE137E":{n:"RealSports Volleyball (1982) (Atari) (PAL)"},A8D4A9500B18B0A067A1F272F869E094:{n:"Red And White Checkerboard Demo (PD)"},"13DFB095E519A555A5B60B7D9D7169F9":{n:"Red Line Demo (PD)"},"874C76726F68C166FCFAC48CE78EEF95":{n:"Red Pong Number 2 Demo (PD)",c:1},"79B649FB812C50B4347D12E7DDBB8400":{n:"Red Pong Number 2 Demo 2 (PD)",c:1},DD1422FFD538E2E33B339EBEEF4F259D:{n:"Red Vs. Blue (1981) (Atari) (Prototype)"},EB9F8B84C193D9D93A58FCA112AA39ED:{n:"Register Twiddler Demo (PD)"},"7450AE4E10BA8380C55B259D7C2B13E8":{n:"Register Twiddler Demo 2 (PD)"},"8A9D874A38608964F33EC0C35CAB618D":{n:"Rescue Bira Bira (Chris Cracknell)",c:1},"60A61DA9B2F43DD7E13A5093EC41A53D":{n:"Rescue Terra I (1982) (VentureVision)"},"42249EC8043A9A0203DDE0B5BB46D8C4":{n:"Resgate Espacial (CCE)",c:1},"5E1CD11A6D41FC15CF4792257400A31E":{n:"Return of Mario Bros (Philip R. Frey) (Hack)"},"0B01909BA84512FDAF224D3C3FD0CF8D":{n:"Revenge of the Apes (Hack)"},"96BCB3D97CE4FF7586326D183AC338A2":{n:"Revenge of the Apes (Hack) [h2]"},"4F64D6D0694D9B7A1ED7B0CB0B83E759":{n:"Revenge of the Beefsteak Tomatoes (1982) (20th Century Fox)"},"6468D744BE9984F2A39CA9285443A2B2":{n:"Reversi (32 in 1) (1988) (Atari) (PAL)"},A995B6CBDB1F0433ABC74050808590E6:{n:"Riddle of the Sphinx (1982) (Imagic)"},"083E7CAE41A874B2F9B61736C37D2FFE":{n:"Riddle of the Sphinx (1982) (Imagic) (PAL)"},"3D2652CBEA462A886A41791DD7C8D073":{n:"Ritorno dei frattelli di Mario (Mario Bros Hack)"},"31512CDFADFD82BFB6F196E3B0FD83CD":{n:"River Patrol (1984) (Tigervision)"},"393948436D1F4CC3192410BB918F9724":{n:"River Raid (1982) (Activision)",l:"RIVER RAID",lc:"#ececec #833"},"291CC37604BC899E8E065C30153FC4B9":{n:"River Raid (1982) (Activision) (16K)",l:"RIVER RAID"},BCCB4E2CFAD5EFC93F6D55DC992118CE:{n:"River Raid (1982) (Activision) (8K)",l:"RIVER RAID"},"927D422D6335018DA469A9A07CD80390":{n:"River Raid (1982) (Activision) (PAL)",l:"RIVER RAID"},"33ED6DFAC4B9EA2F81F778CEDDBB4A75":{n:"River Raid (1982) (SpkSoft) [t1]",l:"RIVER RAID"},"59F596285D174233C84597DEE6F34F1F":{n:"River Raid (1983) (CCE)",l:"RIVER RAID"},"39D36366AE7E6DFD53393FB9EBAB02A0":{n:"River Raid (1983) (CCE) [a]",l:"RIVER RAID"},DA5096000DB5FDAA8D02DB57D9367998:{n:"River Raid (1983) (Digitel)",l:"RIVER RAID"},"01B09872DCD9556427761F0ED64AA42A":{n:"River Raid (1984) (Galaga Games)",l:"RIVER RAID"},FADB89F9B23BEB4D43A7895C532757E2:{n:"River Raid (1984) (Galaga Games) (PAL)",l:"RIVER RAID"},"8C8B15B3259E60757987ED13CDD74D41":{n:"River Raid (1984) (Supergame)",l:"RIVER RAID"},B1C14B5AC896400CC91C8E5DD67ACB59:{n:"River Raid (208 in 1) (Unknown) (PAL) (Hack)"},A539B9FD1BA57E46442B3E9351E6383B:{n:"River Raid (208 in 1) (Unknown) (PAL) (Hack) [a]"},"8C941FA32C7718A10061D8C328909577":{n:"River Raid (Digivision)",l:"RIVER RAID"},A94528AE05DD051894E945D4D2349B3B:{n:"River Raid (Genus)",l:"RIVER RAID"},CD4423BD9F0763409BAE9111F888F7C2:{n:"River Raid (Jone Yuan)",l:"RIVER RAID"},C29D17EEF6B0784DB4586C12CB5FD454:{n:"River Raid (Jone Yuan) (Hack)"},"39FE316952134B1277B6A81AF8E05776":{n:"River Raid (Robby)",l:"RIVER RAID"},EDF69B123E06EAF8663CC78D8AEBA06E:{n:"River Raid (SpkSoft 98) [h1]",l:"RIVER RAID"},DD92D6AD50976F881D86B52D38616118:{n:"River Raid (SpkSoft) [h1]",l:"RIVER RAID"},D5E5B3EC074FFF8976017EF121D26129:{n:"River Raid (Star Game)",l:"RIVER RAID"},"1E89F722494608D6EA15A00D99F81337":{n:"River Raid (Unknown) (PAL)",l:"RIVER RAID"},"90F502CBF4438A95F69F848CEF36EB64":{n:"River Raid II (1985) (Digitel)"},AB56F1B2542A05BEBC4FBCCFC4803A38:{n:"River Raid II (1988) (Activision)"},B049FC8AC50BE7C2F28418817979C637:{n:"River Raid II (1988) (Activision) (PAL)"},DEB39482E77F984D4CE73BE9FD8ADABD:{n:"River Raid II (1988) (Activision) [a]"},F2D4D6187903CAC2D5EA8ED90DAD120D:{n:"River Raid II (Digimax)"},D5F965C159E26A1FB49A22A47FBD1DD0:{n:"River Raid II (Supergame)"},FBB4F3DEBF48DC961B559384467F2057:{n:"River Raid III (1985) (Digitel)"},"4E86866D9CDE738D1630E2E35D7288CE":{n:"River Raid III (Supergame)"},"304512528A5530A9361E8A231ED9A6DE":{n:"River Raid Plus (Thomas Jentzsch) (Hack)"},C74BFD02C7F1877BBE712C1DA5C4C194:{n:"River Raid Tanks (Thomas Jentzsch) (Hack)"},"322B29E84455AA41E7CC9AF463BFFA89":{n:"Road Runner (06-25-1984) (Atari) (Prototype)"},CE5CC62608BE2CD3ED8ABD844EFB8919:{n:"Road Runner (1989) (Atari)"},C3A9550F6345F4C25B372C42DC865703:{n:"Road Runner (1989) (Atari) (PAL)"},"7D3CDDE63B16FA637C4484E716839C94":{n:"Road Runner (CCE)"},"0F8043715D66A4BBED394EF801D99862":{n:"Robin Hood (1983) (Quelle) (PAL)"},"72A46E0C21F825518B7261C267AB886E":{n:"Robin Hood (1983) (Xonox)"},DD7598B8BCB81590428900F71B720EFB:{n:"Robin Hood (1983) (Xonox) (PAL)"},DB76F7A0819659D9E585F2CDDE9175C7:{n:"Robin Hood (1983) (Xonox) (PAL) [a]"},"3E1682DDAEC486D8B6B90B527AAA0FC4":{n:"Robot City (V0.12) (TJ)"},F954381F9E0F2009D1AC40DEDD777B1A:{n:"Robot City (V0.18) (01-09-2002) (TJ)"},"97CD63C483FE3C68B7CE939AB8F7A318":{n:"Robot City (V0.21) (15-09-2002) (TJ)"},D82675CE67CAF16AFE5ED6B6FAC8AA37:{n:"Robot City (V0.23) (13-11-2002) (TJ)"},"82337E5FE0F418CA9484CA851DFC226A":{n:"Robot City (V1.0) (Alpha) (TJ)"},"4251B4557EA6953E88AFB22A3A868724":{n:"Robot City (V1.1) (TJ)"},"913D5D959B5021F879033C89797BAB5E":{n:"Robot Player Graphic (1996) (J.V. Matthews) (PD)"},"4F618C2429138E0280969193ED6C107E":{n:"Robot Tank (1983) (Activision)"},F687EC4B69611A7F78BD69B8A567937A:{n:"Robot Tank (1983) (Activision) (PAL)"},FBB0151EA2108E33B2DBAAE14A1831DD:{n:"Robot Tank TV (Thomas Jentzsch) (Hack)"},"568371FBAE6F5E5B936AF80031CD8888":{n:"Robotfindskitten2600 (26-04-2003) (Jeremy Penner)"},"39790A2E9030751D7DB414E13F1B6960":{n:"Robotfindskitten2600 (26-04-2003) (Jeremy Penner) [a1]"},D100B11BE34A1E5B7832B1B53F711497:{n:"Robotfindskitten2600 (26-04-2003) (Jeremy Penner) [a2]"},"0173675D40A8D975763EE493377CA87D":{n:"Roc 'n Rope (1984) (CBS Electronics) (PAL)"},"65BD29E8AB1B847309775B0DE6B2E4FE":{n:"Roc 'n Rope (1984) (Coleco)"},D97FD5E6E1DAACD909559A71F189F14B:{n:"Rocky & Bullwinkle (04-20-1983) (M Network) (Prototype)"},A89A3E0547D6887279C34ABA4B17A560:{n:"Rocky & Bullwinkle (1983) (Mattel) (Prototype)"},DB80D8EF9087AF4764236F7B5649FA12:{n:"Rocky & Bullwinkle (1983) (Mattel) (Prototype) (4K)"},"2F16663B01591539624D0EF52934A17D":{n:"Rocky and Bullwinkle"},"3F96EB711928A6FAC667C04ECD41F59F":{n:"Rodeo Champ (4 Game in One Dark Green) (1983) (BitCorp) (PAL)"},"67931B0D37DC99AF250DD06F1C095E8D":{n:"Room of Doom (1982) (CommaVid)",c:1},"685E9668DC270B6DEEB9CFBFD4D633C3":{n:"Room of Doom (1982) (CommaVid) (PAL)",c:1},A936D80083E99D48752AD15C2B5F7C96:{n:"Room of Doom (208 in 1) (Unknown) (PAL)",c:1},CBB0EE17C1308148823CC6DA85BFF25C:{n:"Rotating Colors Demo 1 (Junkosoft) (PD)"},C1B038CE5CB6D85E956C5509B0E0D0D8:{n:"Rotating Colors Demo 2 (Junkosoft) (PD)"},"1F2AE0C70A04C980C838C2CDC412CF45":{n:"Rubik's Cube (1984) (Atari)"},"40B1832177C63EBF81E6C5B61AAFFD3A":{n:"Rubik's Cube 3-D (1982) (Atari) (Prototype)"},B6821AC51C4C1DCB283F01BE2F047DC1:{n:"Rubik's Cube 3D Demo (25-11-2002) (TJ)"},B731D35E4AC6B3B47EBA5DD0991F452F:{n:"Rubik's Cube 3D Demo (Final) (08-01-2003) (TJ)"},"6058E40CE79D7434C7F7477B29ABD4A5":{n:"Rubik's Cube Demo (23-12-2002) (CT)"},"3A35D7F1DC2A33565C8DCA52BAA86BC4":{n:"Rubik's Cube Demo 2 (23-12-2002) (CT)"},"73B4E8F8B04515D91937510E680214BC":{n:"Rubik's Cube Demo 3 (24-12-2002) (CT)"},"6847CE70819B74FEBCFD03E99610243B":{n:"Ruby Runner 4A50"},E18ABE87035379C56B435BFE8175077B:{n:"Rumble 2600 (Grimlock) (Hack)"},B9B4612358A0B2C1B4D66BB146767306:{n:"Rush Hour (1983) (Commavid) (Prototype)"},F3CD0F886201D1376F3ABAB2DF53B1B9:{n:"Rush Hour (1983) (Commavid) (Prototype)"},AAD61898633F470CE528E3D7EF3D0ADB:{n:"Rush Hour (1983) (Commavid) (Prototype) [a1]"},EBF2DFF78A08733251BF3838F02F7938:{n:"Rush Hour (1983) (Commavid) (Prototype) [a2]"},"3391F7C4C656793F92299F4187E139F7":{n:"Rush Hour (1983) (Commavid) (Prototype) [a4]"},"8749A0D088DF25218C149DC325ABC7CA":{n:"Rush Hour (1983) (Commavid) (Prototype) [a5]"},C529E63013698064149B9E0468AFD941:{n:"S.I.PLIX 2 (Hack)",p:1},"298387B0637173D2002770A649B4FBCA":{n:"S.I.PLIX 2 (Hack) [a]",p:1},"17BA72433DD41383065D4AA6DEDB3D91":{n:"SCSIcide (09-06-2001) (Joe Grand)"},"523F5CBB992F121E2D100F0F9965E33F":{n:"SCSIcide (1.30) (CGE 2001 Release) (Joe Grand)",p:1},"843435EB360ED72085F7AB9374F9749A":{n:"SCSIcide (1.31) (Joe Grand)",p:1},"9EFA877A98DD5A075E058214DA428ABB":{n:"SCSIcide (1.32) (Hozer Video Games)",p:1},FECE458A8023A809A5006867FECA40E8:{n:"SCSIcide (24-02-2001) (Joe Grand) (PD)"},"742DE93B8D849220F266B627FBABBA82":{n:"SCSIcide (25-02-2001) (Chris Wilkson) (PD)"},FF87D58125AE517EB7B09A0475A1CCDC:{n:"SCSIcide (Score Hack 1) (24-02-2001) (Joe Grand) (PD)"},E9C5D04643855949A23FF29349AF74EA:{n:"SCSIcide (Score Hack 2) (24-02-2001) (Joe Grand) (PD)"},"62921652F6634EB1A0940ED5489C7E18":{n:"SCSIcide (V1.09) (2001) (Joe Grand)",p:1},EAE0C06EE61C63B81CD016096FC901B0:{n:"SCSIcide (v1.0) (2001) (Joe Grand)"},"7991E1797E5E9F311FD957E62D889DFF":{n:"SCSIcide (v1.1) (2001) (Joe Grand)",p:1},"6538E454B0498AD2BEFE1EF0F87815C0":{n:"SCSIcide (v1.2) (2001) (Joe Grand)",p:1},B1A6C96E9093352106BC335E96CAA154:{n:"SCSIcide Pre-release 1 (Joe Grand)"},"07A3AF1E18B63765B6807876366F5E8A":{n:"SCSIcide Pre-release 2 (Joe Grand)"},D483F65468D9A265661917BAE1A54F3E:{n:"SCSIcide Pre-release 3 (Joe Grand)"},"34340C8EECD1E557314789CC6477E650":{n:"SCSIcide Pre-release 4 (Joe Grand)"},F34DD3B8156AAF113CB621B2E51D90B8:{n:"SCSIcide Pre-release 5 (Joe Grand)"},A0028F057D496F22B549FD8DEECC6F78:{n:"SCSIcide Pre-release 6 (Joe Grand)"},"0AC0D491763153FAC75F5337CE32A9D6":{n:"SPAM Image Demo (PD)"},"504688D49A41BF03D8A955512609F3F2":{n:"SWOOPS! (TJ)",p:1},"278F14887D601B5E5B620F1870BC09F6":{n:"SWOOPS! (v0.96) (TJ)",p:1},"5D8F1AB95362ACDF3426D572A6301BF2":{n:"SWOOPS! (v0.96) (TJ) (PAL)",p:1},"88D8A1ACCAB58CF1ABB043613CF185E9":{n:"Sabotage (Ultravison)"},"64FAB9D15DF937915B1C392FC119B83B":{n:"Saboteur (05-20-1983) (Atari) (Prototype)"},"350E0F7B562EC5E457B3F5AF013648DB":{n:"Saboteur (06-09-1983) (Atari) (Prototype)"},"4E01D9072C500331E65BB87C24020D3F":{n:"Saboteur (06-15-1983) (Atari) (Prototype)"},"1EC57BBD27BDBD08B60C391C4895C1CF":{n:"Saboteur (09-02-1983) (Atari) (Prototype)"},A4ECB54F877CD94515527B11E698608C:{n:"Saboteur (12-20-1983) (Atari) (Prototype)"},E723AD8F406CB258B89681EF4CEF0EFF:{n:"Sadoom (TJ) (PAL) (Hack)",p:1},"81073D0377A2BADEF8D5E74FC44FC323":{n:"Sadoom (TJ) (PAL60) (Hack)",p:1},"7AB0917107B6EC768A5EBAADF28C497A":{n:"Santa's Helper (Hack)",p:1},"7BB286CB659D146AF3966D699B51F509":{n:"Save Mary! (04-03-1989) (Atari) (Prototype)"},"4884B1297500BD1243659E43C7E7579E":{n:"Save Mary! (10-24-1991) (Atari) (Prototype) (PAL)"},"4D502D6FB5B992EE0591569144128F99":{n:"Save Mary! (11-21-1989) (Atari) (Prototype)"},"01297D9B450455DD716DB9658EFB2FAE":{n:"Save Our Ship (1983) (TechnoVision) (PAL)"},"49571B26F46620A85F93448359324C28":{n:"Save Our Ship (Unknown)"},ED1A784875538C7871D035B7A98C2433:{n:"Save Our Ship (Unknown) (Hack)"},E377C3AF4F54A51B85EFE37D4B7029E6:{n:"Save the Whales (1983) (20th Century Fox) (Prototype)"},"2516F4F4B811EDE4ECF6FBEB5D54A299":{n:"Schiessbude (1983) (Quelle) (PAL)"},F6F1B27EFC247A0E8D473DDB4269FF9E:{n:"Schnapp die Apfeldiebe (1983) (Quelle) (PAL)"},E040DF95A055B18EBDB094E904CB71B2:{n:"Score Demo (B. Watson)"},EE67DC0B01746372D2B983D88F48E24F:{n:"Scroller Demo (02-01-2003) (CT)"},"0F2E09C71CC216F79D22A804152BA24B":{n:"Scroller Demo (Bob Colbert) (PD)",c:1},"0D07D2C1BE1A5EAAEA235A533BCDA781":{n:"Scrolling Playfield 1 (Junkosoft) (PD)"},F6C13E816E58C8C62F82B2C8B91A2D67:{n:"Scrolling Playfield 2 (Junkosoft) (PD)"},A6737C81542A99EE71CB5F5FF14703D9:{n:"Scrolling Playfield 3 (Junkosoft) (PD)"},"0D786A41695E5FC8CFFD05A6DBB3F659":{n:"Scrolling Playfield With Score (10-02-2003) (Aaron Bergstrom)"},"19E761E53E5EC8E9F2FCEEA62715CA06":{n:"Scuba Diver (1983) (Panda)"},"1BC2427AC9B032A52FE527C7B26CE22C":{n:"Sea Battle (1983) (M Network)"},"624E0A77F9EC67D628211AAF24D8AEA6":{n:"Sea Hawk (1983) (Panda)"},"3FD53BFEEE39064C945A769F17815A7F":{n:"Sea Hawk (CCE)"},"8FA47E5242776E841DF7E708B12EB998":{n:"Sea Hawk (Genesis)"},"07F42847A79E4F5AE55CC03304B18C25":{n:"Sea Hawk (Zellers)"},"5DCCF215FDB9BBF5D4A6D0139E5E8BCB":{n:"Sea Hunt (1987) (Froggo)"},D8ACAA980CDA94B65066568DD04D9EB0:{n:"Sea Hunt (CCE)"},"68489E60268A5E6E052BAD9C62681635":{n:"Sea Monster (1982) (BitCorp) (PAL)"},DF6A46714960A3E39B57B3C3983801B5:{n:"Sea Monster (1982) (Puzzy) (PAL)"},A4B9423877A0B86CA35B52CA3C994AC5:{n:"Sea Monster (1983) (CCE)"},"2124CF92978C46684B6C39CCC2E33713":{n:"Sea Monster (Unknown) (PAL)"},"74D072E8A34560C36CACBC57B2462360":{n:"Seahawk (1982) (Sancho) (PAL)"},A8C48B4E0BF35FE97CC84FDD2C507F78:{n:"Seamonster (1982) (Puzzy)"},"240BFBAC5163AF4DF5AE713985386F92":{n:"Seaquest (1983) (Activision)"},EBCBC8A181A738E13DF6216E5C329230:{n:"Seaquest (1983) (Activision) (16K)"},"026180BF641FF17D8577C33FACF0EDEA":{n:"Seaquest (1983) (Activision) (8K)"},FD0E5148162E8EC6719445D559F018A9:{n:"Seaquest (1983) (Activision) (PAL)"},"0B24658714F8DFF110A693A2052CC207":{n:"Seaquest (1983) (CCE)"},"79C27F90591E3FDC7D2ED020ECBEDEB3":{n:"Seaquest (1983) (CCE) [a]"},BC33C685E6FFCED83ABE7A43F30DF7F9:{n:"Seaquest (1983) (Dynacom)"},"94D90F63678E086F6B6D5E1BC6C4C8C2":{n:"Seaquest (Digivision)"},"10AF8728F975AA35A99D0965DE8F714C":{n:"Seaquest (Dinatronic)"},"5B6F5BCBBDE42FC77D0BDB3146693565":{n:"Seaquest (Unknown) (PAL)"},"40EB4E263581B3DFEC6DD8920B68E00F":{n:"Seawolf 3 (03-23-1981) (Sears) (Prototype) (PAL)"},"605FD59BFEF88901C8C4794193A4CBAD":{n:"Secret Agent (1983) (Data Age) (Prototype)",p:1},FC24A94D4371C69BC58F5245ADA43C44:{n:"Secret Quest (1989) (Atari)"},"2D2C5F0761E609E3C5228766F446F7F8":{n:"Secret Quest (1989) (Atari) (PAL)"},F3DFAE774F3BD005A026E29894DB40D3:{n:"See Saw (Double-Game Package) (1983) (Quelle) (PAL)"},"8DA51E0C4B6B46F7619425119C7D018E":{n:"Sentinel (1990) (Atari)"},"55ACE3C775F42EB46F08BB1DCA9114E7":{n:"Shadow Keep (04-03-2003) (Andrew Towers)"},D7DD56677E4EC1E6627419478A4A9668:{n:"Shadow Keep (Fixed) (04-03-2003) (Andrew Towers)"},"54F7EFA6428F14B9F610AD0CA757E26C":{n:"Shark Attack (1982) (Apollo)"},"5069FECBE4706371F17737B0357CFA68":{n:"Shark Attack (1982) (Apollo) (PAL)"},"90B1799DDDB8BF748EE286D22E609480":{n:"Ship Demo (PD)"},"1DB3BC4601F22CF43BE7CE015D74F59A":{n:"Ship Demo (V 10) (PD)"},"85E48D68C8D802E3BA9D494A47D6E016":{n:"Ship Demo (V 15) (PD)"},A0563DD6D8215C38C488FBBD61435626:{n:"Ship Demo (V 1501) (PD)"},"1B1DAAA9AA5CDED3D633BFCBEB06479C":{n:"Ship Demo (V 1502) (PD)"},B5A1A189601A785BDB2F02A424080412:{n:"Shootin' Gallery (1982) (Imagic)"},"557E893616648C37A27AAB5A47ACBF10":{n:"Shooting Arcade (01-16-1990) (Atari) (Prototype) (PAL)"},"15C11AB6E4502B2010B18366133FC322":{n:"Shooting Arcade (09-19-1989) (Atari) (Prototype)"},"25B6DC012CDBA63704EA9535C6987BEB":{n:"Shuttle Orbiter (1983) (Avalon Hill)"},E3C0451D29DAD724231BC5818EC4BAE0:{n:"Single-Scanline Positioning Demo 1 (2001) (Roger Williams)"},"4C205F166157154DF2F1EF60D87E552F":{n:"Single-Scanline Positioning Demo 2 (2001) (Roger Williams)"},DE8443FF47283E7B274A7838CB071FB6:{n:"Sinistar (01-04-1984) (Atari) (Prototype)"},"3E88CCA5B860D0BD8947479E74C44284":{n:"Sinistar (01-23-1984) (Atari) (Prototype)"},"1E85F8BCCB4B866D4DAA9FCF89306474":{n:"Sinistar (02-13-1984) (Atari) (Prototype)"},EA38FCFC06AD87A0AED1A3D1588744E4:{n:"Sinistar (1984) (Atari) (Prototype)"},"4C8970F6C294A0A54C9C45E5E8445F93":{n:"Sir Lancelot (1983) (Xonox)"},DD0CBE5351551A538414FB9E37FC56E8:{n:"Sir Lancelot (1983) (Xonox) (PAL)"},"7EAD257E8B5A44CAC538F5F54C7A0023":{n:"Sir Lancelot (1983) (Xonox) [a1]"},"8490E1014C2BAA0D3A3A08854E5D68B3":{n:"Sir Lancelot (1983) (Xonox) [a2]"},F847FB8DBA6C6D66D13724DBE5D95C4D:{n:"Skate Boardin' (1987) (Absolute)"},ABE40542E4FF2D1C51AA2BB033F09984:{n:"Skate Boardin' (1987) (Absolute) (PAL)"},"7F9FBE3E00A21EA06E6AE5E0E5DB2143":{n:"Skate Boardin' (2002) (Skyworks)"},"39C78D682516D79130B379FA9DEB8D1C":{n:"Skeet Shoot (1981) (Apollo)"},"5F2B4C155949F01C06507FB32369D42A":{n:"Skeet Shoot (1981) (Apollo) (4K)"},"0832FB2EE654BF9382BC57D2B16D2FFC":{n:"Skeet Shoot (1981) (Apollo) (PAL)"},"4189ADFC1B30C121248876E3A1A3AC7E":{n:"Skeleton (Complete) (06-09-2002) (Eric Ball)"},"40E12C008037A323A1290C8FA4D2FE7F":{n:"Skeleton (NTSC) (06-09-2002) (Eric Ball)"},"647162CCEB550FD49820E2206D9EE7E8":{n:"Skeleton (NTSC) (2002) (Eric Ball)"},"8E42674972D6805068FC653E014370FD":{n:"Skeleton (PAL) (15-10-2002) (Eric Ball)"},C033DC1D7B6FDE41B9CADCE9638909BB:{n:"Skeleton (V1.1) (06-09-2002) (Eric Ball)"},"28A4CD87FB9DE4EE91693A38611CB53C":{n:"Skeleton (V1.1) (NTSC) (24-10-2002) (Eric Ball)"},"8E887D1BA5F3A71AE8A0EA16A4AF9FC9":{n:"Skeleton (V1.1) (PAL) (24-10-2002) (Eric Ball)"},F20BD756F3990E06C492F53CD0168E68:{n:"Skeleton+ (03-05-2003) (Eric Ball) (NTSC)"},"22B22C4CE240303012E8A9596AE8D189":{n:"Skeleton+ (03-05-2003) (Eric Ball) (PAL)"},CFEF1A2D1F6A5EE7A5E1F43F3056F112:{n:"Skeleton+ (05-05-2003) (Eric Ball) (NTSC)"},"75B22FDF632D76E246433DB1EBCCD3C4":{n:"Skeleton+ (05-05-2003) (Eric Ball) (PAL)"},F98D869F287D2CE4F8FB36E0686929D9:{n:"Skeleton+ (17-04-2003) (Eric Ball) (NTSC)"},"43F8459D39FB4EDDF9186D62722FF795":{n:"Skeleton+ (17-04-2003) (Eric Ball) (PAL)"},EAFE8B40313A65792E88FF9F2FE2655C:{n:"Skeleton+ (NTSC)"},"63C7395D412A3CD095CCDD9B5711F387":{n:"Skeleton+ (PAL)"},"8654D7F0FB351960016E06646F639B02":{n:"Ski Hunt (1983) (Home Vision) (PAL)"},F10E3F45FB01416C87E5835AB270B53A:{n:"Ski Run (Ariola) (PAL)"},"5305F69FBF772FAC4760CDCF87F1AB1F":{n:"Ski Run (Jone Yuan)"},B76FBADC8FFB1F83E2CA08B6FB4D6C9F:{n:"Skiing (1980) (Activision)"},"0D90A0EE73D55539B7DEF24C88CAA651":{n:"Skiing (1980) (Activision) (16K)"},"60BBD425CB7214DDB9F9A31948E91ECB":{n:"Skiing (1980) (Activision) (4K)"},"7623A639A6FFFDB246775FE2EABC8D01":{n:"Skiing (1980) (Activision) (8K)"},EEC61CC4250DF70939D48FE02D7122AC:{n:"Skiing (1980) (Activision) (PAL)"},E1F88DA6DA8A7D521CA1DCBF2BC6978B:{n:"Skiing (1980) (Activision) (PAL) (4K)"},"0E4B2B6E014A93EF8BE896823DA0D4EC":{n:"Skiing (208 in 1) (Unknown) (PAL)"},"367411B78119299234772C08DF10E134":{n:"Skiing (32 in 1) (1988) (Atari) (PAL)"},"40B59249E05135BCA33861E383735E9E":{n:"Skiing (32 in 1) (1988) (Atari) (PAL) (4K)"},"40D9F5709877ECF3DD1184F9791DD35E":{n:"Skiing (Dactari - Milmar)"},"7ED61A18CEBDECA0A93BE1F5461731E5":{n:"Skiing (Dactari) (4K)"},C118854D670289A8B5D5156AA74B0C49:{n:"Skiing (Jone Yuan)"},"13584411DA0A8D431991035423FDC0DC":{n:"Skiing (Jone Yuan) (4K)"},"340F546D59E72FB358C49AC2CA8482BB":{n:"Skindiver (1983) (Sancho) (PAL)"},C31A17942D162B80962CB1F7571CD1D5:{n:"Sky Alien (1983) (Home Vision) (PAL)"},BC97D544F1D4834CC72BCC92A37B8C1B:{n:"Sky Demo (PD)"},"46C021A3E9E2FD00919CA3DD1A6B76D8":{n:"Sky Diver (1979) (Atari)"},"3D8A2D6493123A53ADE45E3E2C5CAFA0":{n:"Sky Diver (1979) (Atari) (4K)"},"756CA07A65A4FBBEDEB5F0DDFC04D0BE":{n:"Sky Diver (1979) (Atari) (PAL)"},"5EF303B9F0AA8CF20720C560E5F9BAA1":{n:"Sky Diver (1979) (Atari) (PAL) (4K)"},"3F75A5DA3E40D486B21DFC1C8517ADC0":{n:"Sky Diver (32 in 1) (1988) (Atari) (PAL)"},F1FE06EBE2900EAC4CDD17799389A102:{n:"Sky Diver (32 in 1) (1988) (Atari) (PAL) (4K)"},B23EBF427713DD0198B7EF47DBD07EF4:{n:"Sky Diver (Jone Yuan) (4K) (Hack)"},"5A81AD4E184050851E63C8E16E3DAC77":{n:"Sky Diver (Jone Yuan) (Hack)"},"37252757A79DC5B174E3C03D6EA0BDCB":{n:"Sky Diver (Unknown) (PAL) (4K) (Hack)"},"8190B403D67BF9792FE22FA5D22F3556":{n:"Sky Diver (Unknown) (PAL) (Hack)"},"2A0BA55E56E7A596146FA729ACF0E109":{n:"Sky Jinks (1982) (Activision)"},"05AFF8F626EF870432AE3B3D9D5AA301":{n:"Sky Jinks (1982) (Activision) (16K)"},"8BD8F65377023BDB7C5FCF46DDDA5D31":{n:"Sky Jinks (1982) (Activision) (4K)"},A4790224BD5AFABD53CBE93E46A7F241:{n:"Sky Jinks (1982) (Activision) (8K)"},"50A410A5DED0FC9AA6576BE45A04F215":{n:"Sky Jinks (1982) (Activision) (PAL)"},"502168660BFD9C1D2649D415DC89C69D":{n:"Sky Jinks (1982) (Activision) (PAL) (4K)"},"93DC15D15E77A7B23162467F95A5F22D":{n:"Sky Jinks (CCE)"},"8764462D7D19A33B0717AF22B99FC88F":{n:"Sky Jinks (CCE) (4K)"},E1B90F1E01B1A316D7BBF141525CC00E:{n:"Sky Jinks (Unknown) (PAL) (4K) (Hack)"},F992A39B46AA48188FAB12AD3809AE4A:{n:"Sky Jinks (Unknown) (PAL) (Hack)"},"4C9307DE724C36FD487AF6C99CA078F2":{n:"Sky Patrol (1982) (Imagic) (Prototype)"},"3B91C347D8E6427EDBE942A7A405290D":{n:"Sky Skipper (1983) (Parker Bros)"},"514F911ECFF2BE5EEFF2F39C49A9725C":{n:"Sky Skipper (1983) (Parker Bros) (PAL)"},"1AA7344B563C597EECFBFCF8E7093C27":{n:"Slot Invaders (David Marli) (Hack)"},F90B5DA189F24D7E1A2117D8C8ABC952:{n:"Slot Machine (1979) (Atari)"},"81254EBCE88FA46C4FF5A2F4D2BAD538":{n:"Slot Machine (1979) (Atari) (4K)"},"705FE719179E65B0AF328644F3A04900":{n:"Slot Machine (1979) (Atari) (4K) [a]"},FC6052438F339AEA373BBC999433388A:{n:"Slot Machine (1979) (Atari) (PAL)"},"75EA128BA96AC6DB8EDF54B071027C4E":{n:"Slot Machine (32 in 1) (1988) (Atari) (PAL)"},"1E272D09C0E55F5EF14FCB76A735F6D7":{n:"Slot Machine (32 in 1) (1988) (Atari) (PAL) (4K)"},DBDD21E1EE3D72119E8CD14D943C585B:{n:"Slot Machine (Unknown) (PAL) (4K)"},AED82052F7589DF05A3F417BB4E45F0C:{n:"Slot Racers (1978) (Atari)"},"5F708CA39627697E859D1C53F8D8D7D2":{n:"Slot Racers (1978) (Atari) (4K)"},A7ED7DC5CBC901388AFA59030FB11D26:{n:"Slot Racers (1978) (Atari) (PAL)"},"7A64A8B727C8215D945E37D565CA95A5":{n:"Slot Racers (1978) (Atari) (PAL) (4K)"},D1D704A7146E95709B57B6D4CAC3F788:{n:"Slot Racers (32 in 1) (1988) (Atari) (PAL)"},F6D512BEF1BF253DC935D0E13C3D1462:{n:"Slot Racers (Unknown) (PAL) (4K)"},"92D1F6AC179EBE5963868D6BC1BDDA8D":{n:"Smash Hit Pak - Frogger, Boxing, Seaquest, Skiing, Stampede (HES) (PAL)"},"73C545DB2AFD5783D37C46004E4024C2":{n:"Smurf (1982) (CBS Electronics) (PAL)"},"24AFF972D58990F9B88A6D787C796F1E":{n:"Smurf (1982) (CBS Electronics) (PAL) [a]"},"3D1E83AFDB4265FA2FB84819C9CFD39C":{n:"Smurf - Rescue in Gargamel's Castle (1982) (Coleco)"},A204CD4FB1944C86E800120706512A64:{n:"Smurfs Save the Day (1983) (Coleco)"},"898B5467551D32AF48A604802407B6E8":{n:"Snail Against Squirrel (1983) (BitCorp) (PAL)"},AC26D7D37248D1D8EAC5ECCACDBEF8DB:{n:"Snail Against Squirrel (Unknown) (PAL)"},"9C6FAA4FF7F2AE549BBCB14F582B70E4":{n:"Sneak 'n Peek (1982) (U.S. Games)"},F21813AA050437F0DBC8479864ACEC6D:{n:"Sneak 'n Peek (Unknown) (PAL)"},C54B4207CE1D4BF72FADBB1A805D4A39:{n:"Sniper (Feb 30) (2001) (Prototype)"},"01293BD90A4579ABB7AED2F7D440681F":{n:"Snoopy (1983) (Century) (PAL)"},"45A095645696A217E416E4BD2BAEA723":{n:"Snoopy (Digivision)"},"0F39FC03D579D0D93A6B729A3746843E":{n:"Snoopy and the Red Baron (05-27-1983) (Atari) (Prototype)"},"57939B326DF86B74CA6404F64F89FCE9":{n:"Snoopy and the Red Baron (1983) (Atari)"},F844F4C6F3BAAAF5322657442D6F29EB:{n:"Snoopy and the Red Baron (1983) (Atari) (PAL)"},BDA1463E02AE3A6E1107FFE1B572EFD2:{n:"Snoopy and the Red Baron (1983) (Atari) (PAL) [a]"},C5D2834BF98E90245E545573EB7E6BBC:{n:"Snoopy and the Red Baron (CCE)"},D2DEDDB77C8B823E4BE9C57CB3C69ADC:{n:"Snoopy and the Red Baron (Canal 3)"},"75028162BFC4CC8E74B04E320F9E6A3F":{n:"Snow White and the Seven Dwarfs (02-09-1983) (Atari) (Prototype)"},"75EE371CCFC4F43E7D9B8F24E1266B55":{n:"Snow White and the Seven Dwarfs (11-09-1982) (Atari) (Prototype)"},"3F6DBF448F25E2BD06DEA44248EB122D":{n:"Soccer (1989) (Telegames)"},"604E09724555807C28108049EFE34A13":{n:"Sokoban (01-01-2003) (Adam Wozniak)"},B4DAEDB43511521DB9036D503B3C1B69:{n:"Sokoban (01-01-2003) (Adam Wozniak) [a1]"},"947317A89AF38A49C4864D6BDD6A91FB":{n:"Solar Fox (1983) (CBS Electronics)"},E03B0B091BEA5BC9D3F14EE0221E714D:{n:"Solar Fox (1983) (CBS Electronics) (PAL)"},DF753CB87D3AF4D03F694AB848638108:{n:"Solar Fox (1983) (CBS Electronics) (PAL) [a]"},"97842FE847E8EB71263D6F92F7E122BD":{n:"Solar Storm (1983) (Imagic)",p:1},E6DE4EF9AB62E2196962AA6B0DEDAC59:{n:"Solar Storm (1983) (Imagic) (PAL)",p:1},E72EB8D4410152BDCB69E7FBA327B420:{n:"Solaris (1986) (Atari)"},BC4CF38A4BEE45752DC466C98ED7AD09:{n:"Solaris (1986) (Atari) (PAL)"},"0ADB21206DE92E8AEC5EF295805EBB90":{n:"Solaris (Genesis)"},F19ABA18F86E415812480AD2BE221425:{n:"Solaris Trainer (2002) (Chris Larkin) (Hack)"},"2DFEC1615C49501FEFC02165C81955E6":{n:"Song (05-11-2002) (Paul Slocum)",c:1},CAD982C9B45BC5EFF34E4EA982D5F1CA:{n:"Song (17-02-2003) (Paul Slocum)",c:1},D2C4F8A4A98A905A9DEEF3BA7380ED64:{n:"Sorcerer (1983) (Mythicon)"},"5F7AE9A7F8D79A3B37E8FC841F65643A":{n:"Sorcerer's Apprentice (1983) (Atari)"},"2E82A1628EF6C735C0AB8FA92927E9B0":{n:"Sorcerer's Apprentice (1983) (Atari) (PAL)"},"27C4C2AF4B46394BB98638AF8E0F6E9D":{n:"Sorcerer's Apprentice (1983) (Atari) (Prototype)"},"101AB60F4000A5D13792EF0ABAD5F74B":{n:"Sorcerer's Apprentice (1983) (Atari) [a]"},F78C125B5DA483C41E51522947D6C4CE:{n:"Sound Paddle V1 (Dennis Caswell & Jim Nitchals) (PD)",p:1},EEE7695AE3EEA7818321DF0B790B31F3:{n:"Sound Paddle V2 (Dennis Caswell & Jim Nitchals) (PD)",p:1},"32F4E47A71601AB06CFB59E1C6A0B846":{n:"Sound X (1994) (Ed Federmeyer)"},"7DBC8FA2E488E3F6B87FBE0F76C5B89F":{n:"Sound X (1996) (Ed Federmeyer)"},"310BA30E25EA8957E58180B663503C0C":{n:"Sound X6 (1994) (Ed Federmeyer)"},"24B9ADAC1B4F85B0BAC9BF9B9E180906":{n:"Space 2002 (Angelino) (Hack)"},"17BADBB3F54D1FC01EE68726882F26A6":{n:"Space Attack (1982) (M Network)"},ABB741C83F665D73C86D90A7D9292A9B:{n:"Space Attack (1989) (Telegames) (PAL)"},F047DF70D3D08E331122CD2DE61D6AF8:{n:"Space Battle (NTSC)"},CC12581E079CD18330A89902625B8347:{n:"Space Battle (PAL)"},"559317712F989F097EA464517F1A8318":{n:"Space Canyon (1983) (Panda)"},DF6A28A89600AFFE36D94394EF597214:{n:"Space Cavern (1981) (Apollo)"},D9548AD44E67EDEC202D1B8B325E5ADF:{n:"Space Cavern (1981) (Apollo) (PAL)"},"7AC4F4FB425DB38288FA07FB8FF4B21D":{n:"Space Eagle (1983) (Goliath) (PAL)"},"0D27C7F5DB349B592F70F68DAF5E8F3B":{n:"Space Instigators (21-10-2002) (CT)"},B2A6F31636B699AEDA900F07152BAB6E:{n:"Space Instigators (Public Release 2) (06-01-2003) (CT)"},"18BEBBBD41C234F82B1717B1905E6027":{n:"Space Instigators (Public Release) (02-01-2003) (CT)"},CDA38714267978B9A8B0B24BEE3529AE:{n:"Space Instigators (V1.6) (17-10-2002) (CT)"},"98E6E34AF45A0664597972C3BB31180F":{n:"Space Instigators (V1.7) (17-10-2002) (CT)"},"52BAE1726D2D7A531C9CA81E25377FC3":{n:"Space Instigators (V1.8 Fixed) (20-10-2002) (CT)"},CFEE10BD7119F10B136921CED2EE8972:{n:"Space Instigators (V1.8) (19-10-2002) (CT)"},E927ECF80F3784D745ABD8368D78F2F3:{n:"Space Instigators (V1.8) (19-10-2002) (CT) [a1]"},DD10B5EE37FDBF909423F2998A1F3179:{n:"Space Instigators (V1.9) (21-10-2002) (CT)"},E10BF1AF6BF3B4A253C5BEF6577FE923:{n:"Space Invaders (1978) (Atari) [h1]"},"07F91E33E76F53BB9D2731FD5D8A35A5":{n:"Space Invaders (1978) (Atari) [t1]"},"72FFBEF6504B75E69EE1045AF9075F66":{n:"Space Invaders (1980) (Atari)"},F1B7EDFF81CEEF5AF7AE1FA76C8590FC:{n:"Space Invaders (1980) (Atari) (PAL)"},"8747BA79CD39FA83A529BB26010DB21B":{n:"Space Invaders (1980) (Atari) (PAL) [different speed and colors]"},"7CC77F6745E1F2B20DF4A4327D350545":{n:"Space Invaders (1980) (Atari) (PAL) [fixed]"},"61DBE94F110F30CA4EC524AE5CE2D026":{n:"Space Invaders (1983) (CCE)"},C126656DF6BADFA519CC63E681FB3596:{n:"Space Invaders (2002) (Ron Corcoran) (Hack)"},"2EF36341D1BF42E02C7EA2F71E024982":{n:"Space Invaders (Explosion Hack)"},"270229C6D5578446E6A588492E4E5910":{n:"Space Invaders 2 (Hack)"},"0963AA9F7F6CF5A36FF700001583624E":{n:"Space Invaders 2 (Hack) [o1]"},"2CFB188C1091CC7EC2A7E60064D2A758":{n:"Space Invaders Hack Demo (2003) (SnailSoft)"},"6F2AAFFAAF53D23A28BF6677B86AC0E3":{n:"Space Jockey (1982) (U.S. Games)"},D1A9478B99D6A55E13A9FD4262DA7CD4:{n:"Space Jockey (1982) (U.S. Games) (4K)"},"457E7D4FCD56EBC47F5925DBEA3EE427":{n:"Space Jockey (1983) (Carrere Video) (PAL)"},EE9CAEE4EB958284FB10C277B14537F1:{n:"Space Jockey (1983) (Carrere Video) (PAL) (4K)"},E1D79E4E7C150F3861256C541EC715A1:{n:"Space Jockey (208 in 1) (Unknown) (PAL)"},"822A950F27FF0122870558A89A49CAD3":{n:"Space Jockey (Unknown) (PAL)"},C689148AD9275667924AB334107B517E:{n:"Space Raid (Jone Yuan)"},"690A6049DB78B9400C13521646708E9C":{n:"Space Raid (King Tripod) (PAL)"},"345769D085113D57937198262AF52298":{n:"Space Raid (Rainbow Vision) (PAL)"},"1A624E236526C4C8F31175E9C89B2A22":{n:"Space Raid (Rainbow Vision) (PAL) [a]"},"1BEF389E3DD2D4CA4F2F60D42C932509":{n:"Space Robot (1983) (Dimax - Sinmax) (PAL)",c:1},"3DFB7C1803F937FADC652A3E95FF7DC6":{n:"Space Robot (Dimax - Sinmax)",c:1},"82E7AAB602C378CFFDD8186A099E807E":{n:"Space Robot (Unknown)"},C4D888BCF532E7C9C5FDEAFBB145266A:{n:"Space Robot (Unknown) (PAL)",c:1},"5894C9C0C1E7E29F3AB86C6D3F673361":{n:"Space Shuttle (1983) (Activision)"},"4F6702C3BA6E0EE2E2868D054B00C064":{n:"Space Shuttle (1983) (Activision) (PAL)"},"898143773824663EFE88D0A3A0BB1BA4":{n:"Space Shuttle (1983) (Activision) [FE]"},FF5A9E340D96DF6F5A5B6EB038E923BD:{n:"Space Shuttle (1983) (Activision) [t1]"},A8D0A4A77CD71AC601BD71DF5A060E4C:{n:"Space Shuttle (1983) (Activision) [t2] (Fuel)"},D97E3D0B4575CE0B9A6132E19CFEAC6E:{n:"Space Treat (061002) (PD)"},"2683D29A282DD059535AC3BB250F540D":{n:"Space Treat (12-01-2003) (Fabrizio Zavagli)"},DED26E1CB17F875A9C17515C900F9933:{n:"Space Treat (29-12-2002) (Fabrizio Zavagli)"},"3367EEBA3269AA04720ABE6169767502":{n:"Space Treat (30-12-2002) (Fabrizio Zavagli)"},"75B557BE7F08DB84EC5B242207B9F241":{n:"Space Treat (30-12-2002) (Fabrizio Zavagli) [a1]"},E74022CFE31EC8908844718DFBDEDF7A:{n:"Space Treat (30-12-2002) (Fabrizio Zavagli) [a2]"},D49AFF83F77A1B9041AD7185DF3C2277:{n:"Space Treat (60% complete) (PD)"},"6C9A32AD83BCFDE3774536E52BE1CCE7":{n:"Space Treat (NTSC) (13-08-2002) (Fabrizio Zavagli)"},B0C47E426C7F799AEE2C40422DF8F56A:{n:"Space Treat (PAL) (Fabrizio Zavagli)"},DFAFA3FA58F5CC3F0342CCA475DF6095:{n:"Space Treat (V1.1 Beta) (24-12-2002) (Fabrizio Zavagli)"},"562ACB1B7FF182ABA133BDA8E21AD7C1":{n:"Space Treat Deluxe (08-03-2003) (Fabrizio Zavagli)"},DF2745D585238780101DF812D00B49F4:{n:"Space Tunnel (1982) (BitCorp)"},C5387FC1AA71F11D2FA82459E189A5F0:{n:"Space Tunnel (1982) (BitCorp) (PAL)"},"8917F7C1AC5EB05B82331CF01C495AF2":{n:"Space Tunnel (1982) (BitCorp) (PAL) [a]"},BE3F0E827E2F748819DAC2A22D6AC823:{n:"Space Tunnel (1982) (Puzzy)"},D73AD614F1C2357997C88F37E75B18FE:{n:"Space Tunnel (1982) (Puzzy) (PAL)"},"7FCD5FB59E88FC7B8473C641F44226C3":{n:"Space Tunnel (1983) (CCE)"},A7EF44CCB5B9000CAF02DF3E6DA71A92:{n:"Space War (1978) (Atari)"},"7E9DA5CB84D5BC869854938FE3E85FFA":{n:"Space War (1978) (Atari) (4K)"},F9677B2EC8728A703EB710274474613D:{n:"Space War (1978) (Atari) (PAL)"},"0519F395D5F7D76BE813B834AA51C0BE":{n:"Space War (1978) (Atari) (PAL) (4K)"},"77887E4192A6B0A781530E6CF9BE7199":{n:"Space War (1978) (Atari) [b1]"},E505BD8E59E31AAED20718D47B15C61B:{n:"Space War (1982) (Funvision) (PAL)"},"63D6247F35902BA32AA49E7660B0ECAA":{n:"Space War (208 in 1) (Unknown) (PAL)"},B702641D698C60BCDC922DBD8C9DD49C:{n:"Space War (32 in 1) (1988) (Atari) (PAL)"},"8F60551DB6D1535EF0030F155018C738":{n:"Space War (Unknown) (PAL) (4K)"},"45040679D72B101189C298A864A5B5BA":{n:"SpaceMaster X-7 (1983) (20th Century Fox)"},E14FEDDEB82F5160ED5CF9CA4078E58D:{n:"SpaceMaster X-7 (208 in 1) (Unknown) (PAL)"},EC5C861B487A5075876AB01155E74C6C:{n:"Spacechase (1981) (Apollo)"},"89EABA47A59CBFD26E74AAD32F553CD7":{n:"Spacechase (1981) (Apollo) (PAL)"},FAFFD84F3A8ECEEE2FA5EA5B0A3E6678:{n:"Spectracube Invasion (Suntek) (PAL)"},F3F92AAD3A335F0A1EAD24A0214FF446:{n:"Spectrum Color Demo (PD)"},"327FE8CF94F3A45C35A840A453DF1235":{n:"Spice Girls Rule Demo (PD)"},A8A703E073183A89C94D4D99B9661B7F:{n:"Spice Invaders (Franklin Cruz) (Hack)"},"24D018C4A6DE7E5BD19A36F2B879B335":{n:"Spider Fighter (1982) (Activision)"},"8786F229B974C393222874F73A9F3206":{n:"Spider Fighter (1982) (Activision) (PAL)"},BA3A17EFD26DB8B4F09C0CF7AFDF84D1:{n:"Spider Fighter (1983) (Activision) (16K)"},D25018349C544320BF3FD5092EE072BC:{n:"Spider Fighter (1983) (Activision) (8K)"},"0FC161704C46E16F7483F92B06C1558D":{n:"Spider Fighter (1983) (CCE)"},C41E7735F6701DD50E84EE71D3ED1D8F:{n:"Spider Fighter (1983) (Dynacom)"},"92E72F7CC569584C44C9530D645AE04E":{n:"Spider Fighter (Canal 3)"},B40DEA357D41C5408546E4E4D5F27779:{n:"Spider Fighter (Digivision)"},"7778AC65D775A079F537E97CBDAD541C":{n:"Spider Fighter (Unknown) (PAL)"},F14D5E96EC3380AEF57A4B70132C6677:{n:"Spider Kong (1983) (Goliath) (PAL) [a]"},"672012D40336B403EDEA4A98CE70C76D":{n:"Spider Kong (208 in 1) (Unknown) (PAL)"},AE465044DFBA287D344BA468820995D7:{n:"Spider Kong (Unknown) (PAL)"},"21299C8C3AC1D54F8289D88702A738FD":{n:"Spider Maze (1982) (K-Tel Vision)"},"37B98344C8E0746C486CAF5AAEEC892A":{n:"Spider Maze (1982) (K-Tel Vision) (PAL)"},D39E29B03AF3C28641084DD1528AAE05:{n:"Spider Monster (1982) (Funvision) (PAL)"},"199EB0B8DCE1408F3F7D46411B715CA9":{n:"Spider-Man (1982) (Parker Bros)"},E77EC259E1387BC308B0534647A89198:{n:"Spider-Man (1982) (Parker Bros) (PAL)"},"8454ED9787C9D8211748CCDDB673E920":{n:"Spiderdroid (1987) (Froggo)"},F7AF41A87533524D9A478575B0D873D0:{n:"Spiderman (1983) (Quelle) (PAL)"},A4E885726AF9D97B12BB5A36792EAB63:{n:"Spike's Peak (1983) (Xonox)"},B37F0FE822B92CA8F5E330BF62D56EA9:{n:"Spike's Peak (1983) (Xonox) (PAL)"},"9BB136B62521C67AC893213E01DD338F":{n:"Spike's Peak (1983) (Xonox) (PAL) [a]"},"542C6DD5F7280179B51917A4CBA4FAFF":{n:"Spinning Fireball (1983) (ZiMAG) (Prototype)"},D3171407C3A8BB401A3A62EB578F48FB:{n:"Spinning Fireball (1983) (ZiMAG) (Prototype) [a]",c:1},"98555B95CB38E0E0B22B482B2B60A5B6":{n:"Spinning Fireball (Unknown) (PAL)",c:1},CEF2287D5FD80216B2200FB2EF1ADFA8:{n:"Spitfire Attack (1983) (Milton Bradley)"},FFEBB0070689B9D322687EDD9C0A2BAE:{n:"Spitfire Attack (1983) (Milton Bradley) [h1]"},FB91DA78455D9B1606913FBF8C859772:{n:"Split Screen (Ballblazer) Demo (PD)"},A4D026A5C200EF98518EBB77719FE8DC:{n:"SpongeBob SquarePants (2003) (Kyle Pittman) (Hack)"},"2C3B2843295C9D6B16996971180A3FE9":{n:"Sports Action Pak - Enduro, Ice Hockey, Fishing Derby, Dragster (1988) (HES) (PAL)"},"4CD796B5911ED3F1062E805A3DF33D98":{n:"Springer (1982) (Tigervision)"},"133456269A03E3FDAE6CDDD65754C50D":{n:"Springer (1982) (Tigervision) (PAL)"},"5A8AFE5422ABBFB0A342FB15AFD7415F":{n:"Sprint Master (1988) (Atari)"},B2D5D200F0AF8485413FAD957828582A:{n:"Sprint Master (1988) (Atari) (PAL)"},"6B75F8FA4FD011A6698C58315F83D2AC":{n:"Sprintmaster DC (TJ)"},D597D35C6022C590D6E75E865738558A:{n:"Sprite Color Demo (PD)"},F1B2EA568B3E156E3F2849DAC83591F6:{n:"Sprite Demo (1997) (Bob Colbert) (PD)"},E15B5525CF8F77297B322838DF8D999C:{n:"Sprite Demo 0 (PD)"},D5C6B81212AD86FD9542A1FEDAF57CAE:{n:"Sprite Demo 1 (PD)"},FE0BC4BB92C1C4DE7D5706AAA8D8C10D:{n:"Sprite Demo 2 (PD)"},DBABB80E92FF18D8EECF615C0539151E:{n:"Sprite Demo 3 (PD)"},"61728C6CFB052E62A9ED088C5BF407BA":{n:"Sprite Demo 4 (PD)"},AD7E97C19BD25D5AA3999430845C755B:{n:"Sprite Demo 5 (PD)"},ACAA27D214039D89D7031609AAFA55C3:{n:"Sprite Demo 6 (PD)"},"2D6DA0EB85EABC93270E5BB8A466CA51":{n:"Sprite Demo 7 (PD)"},DFE034297200DFF672DF9533ED1449A9:{n:"Sprite Movement Demo 1 (2001) (Roger Williams)"},D4C590CCFB611A73B3331359700C01A3:{n:"Sprite Movement Demo 2 (2001) (Roger Williams)"},"37AB3AFFC7987995784B59FCD3FCBD31":{n:"Sprite Test (29-11-2002) (Eric Ball)"},"3105967F7222CC36A5AC6E5F6E89A0B4":{n:"Spy Hunter (1984) (Sega)"},"6A8C6940D3BE6FD01274363C4D4B298E":{n:"Spy Hunter (Genesis)"},"2A360BC85BF22DE438651CF92FFDA1DE":{n:"Spy Vs. Spy (4 Game in One) (1983) (BitCorp) (PAL)"},BA257438F8A78862A9E014D831143690:{n:"Squeeze Box (1982) (U.S. Games)"},"68878250E106EB6C7754BC2519D780A0":{n:"Squirrel (1983) (CCE)"},"34C808AD6577DBFA46169B73171585A3":{n:"Squoosh (1983) (Apollo) (Prototype)"},"22ABBDCB094D014388D529352ABE9B4B":{n:"Squoosh (1983) (Apollo) (Prototype) [a]"},"21A96301BB0DF27FDE2E7EEFA49E0397":{n:"Sssnake (1982) (Data Age)"},B3203E383B435F7E43F9492893C7469F:{n:"Sssnake (1983) (Gameworld) (PAL)"},"21D7334E406C2407E69DBDDD7CEC3583":{n:"Stampede (1981) (Activision)"},"9057694DCE8449521E6164D263702185":{n:"Stampede (1981) (Activision) (16K)"},E66E5AF5DEA661D58420088368E4EF0D:{n:"Stampede (1981) (Activision) (4K)"},"53F147B9746FDC997C62F3DD67888EE5":{n:"Stampede (1981) (Activision) (8K)"},"75511BB694662301C9E71DF645F4B5A7":{n:"Stampede (1981) (Activision) (PAL)"},F52F40299FD238C6FFD9E6107050DC76:{n:"Stampede (1981) (Activision) (PAL) (4K)"},C9196E28367E46F8A55E04C27743148F:{n:"Stampede (32 in 1) (1988) (Atari) (PAL)"},F20675C8B98518367B9F5B8EE6F7C8EA:{n:"Stampede (32 in 1) (1988) (Atari) (PAL) (4K)"},F77F5FC3893DA5D00198E4CD96544AAD:{n:"Stampede (Canal 3)"},"866E5150C995C4AE5172E5207BA948C7":{n:"Stampede (Canal 3) (16K)"},"43ADF60EBDD6B5A0FAE21594ECF17154":{n:"Stampede (Jone Yuan)"},D170317AE4C7D997A989C7D6567C2840:{n:"Stampede (Jone Yuan) (4K) (Hack)"},"1EA1ABCD2D3D3D628F59A99A9D41B13B":{n:"Stampede (Jone Yuan) (Hack)"},"869ABE0426E6E9FCB6D75A3C2D6E05D1":{n:"Stampede (Unknown) (PAL)"},"0945081A6BD00345FF3D58EB7A07330A":{n:"Stampede (Unknown) (PAL) (4K)"},A8916734FF8C64EC3342F4C73FD5B57D:{n:"Stand Alone Test Cart (1982) (Atari) [a]"},D9C9CECE2E769C7985494B1403A25721:{n:"Star Castle 2600 (SolidCorp)",c:1},"54BAFC299423F5A50B8BC3A797914706":{n:"Star Castle 2600 (SolidCorp) (PAL)",c:1},CE8467AE2A3A5BC88CA72A2CE44CE28C:{n:"Star Castle 2600 (SolidCorp) (PAL) [015]",c:1},DD0DE0F61AF2A2A4878E377B880A3933:{n:"Star Castle 2600 (SolidCorp) [013]",c:1},C0589BB73858924389077FA3C2E9441A:{n:"Star Castle 2600 (SolidCorp) [014]",c:1},"39B94D41BD3B01C12B4054C1A8733783":{n:"Star Castle 2600 (SolidCorp) [016]",c:1},"2AEEDCC6EB1602EFB77161B0CEF832AB":{n:"Star Castle 2600 (SolidCorp) [025]",c:1},"1EF04E7E508296A8D9EB61CC7DAE2E5D":{n:"Star Castle 2600 (SolidCorp) [069]",c:1},"6E4521989A60A0DDF4FF1FC6E6E5FC3D":{n:"Star Fire (01-05-2002) (MP)"},A443D8557D712845C8CD3699363A42E6:{n:"Star Fire (07-01-2003) (MP)"},"1E1817D9CBCC3BA75043B7DB4E6C228F":{n:"Star Fire (07-10-2002) (MP)"},DBA2692A216CB6C262C78F8B111A813E:{n:"Star Fire (08-10-2002) (MP)"},"47BB1C677FE7BA5F376372AE7358E790":{n:"Star Fire (10-10-2002) (MP)"},"43E6C5159C3A093FCA88656628C6EF34":{n:"Star Fire (17-02-2003) (MP)"},"6F75D72E4CF996100CCDD163D57BDAC2":{n:"Star Fire (200203) (MP)"},"18760F1F9CA5E18610115CF7B815B824":{n:"Star Fire (23-10-2002) (MP)"},"539B7038ACEC0CCEDEAE40F238998579":{n:"Star Fire (25-10-2002) (MP)"},"16FBB36A6124567405A235821E8F69EE":{n:"Star Fire (28-11-2002) (MP)"},C473B222B7C5308D0773326416094272:{n:"Star Fire (28-11-2002) (MP) [a1]"},BC6432CBED32C695658514C4EB41D905:{n:"Star Fire (MP) (2002) (PD)"},BF5E2079586CB307BF5EB2413E2E61AF:{n:"Star Fire - 1LK Intro (13-11-2002) (TJ)"},"0890A5B089191F45D0F08DD1E3235687":{n:"Star Fire - 4K Version (25-10-2002) (MP)"},D2C305A443DFC49E8430964D7C1BD1B7:{n:"Star Fire - Advice on radar needed (16-10-2002) (MP)"},"09D19274C20768F842E8FAE84B766ABE":{n:"Star Fire - Animated Patricles (06-10-2002) (MP)"},BF9DDC5DD9056633D4AC0DAC8B871DFE:{n:"Star Fire - Cockpit View (10-10-2002) (MP)"},EC26FDC87B1D35F1D60EA89CDA4F4DD4:{n:"Star Fire - Crash Scene (04-11-2002) (MP)"},BFCABC6995EF42D0B6C06786993DC4D6:{n:"Star Fire - Creating a Universe (09-09-2002) (MP)"},"86F5E55CA9A9BDE7338A157570828E79":{n:"Star Fire - Creating a Universe (09-09-2002) (MP) [a1]"},"11CF751BC8173DB105EABD119C5844BA":{n:"Star Fire - Crosshair (12-02-2002) (MP)"},"06953ED762220DBA63D63930D4AD0CC3":{n:"Star Fire - Eckhard WIP (MP)"},"40D7CCD460C9B1198238AF6CEEA1737D":{n:"Star Fire - Enemy Mine (2002) (MP)"},D79DF06894E3C1585A47C2807332B319:{n:"Star Fire - Explosions! (10-10-2002) (MP)"},"5E2928F089490017E88E9F9E5A881A25":{n:"Star Fire - Faster Skipping 1 (24-10-2002) (MP)"},"44560E324FFB30741A483218BA5B4342":{n:"Star Fire - Faster Skipping 2 (24-10-2002) (MP)"},"562BF02F5031D51C6B53B03972A56B22":{n:"Star Fire - Framework Done (30-10-2002) (MP)"},DC6AA0BB21A6E66E80E75BA5EDC5C0DD:{n:"Star Fire - Kernel Done (MP)"},"9E6FA031ECE07919C816FBA5DC8DE43E":{n:"Star Fire - Meteor Dance (13-11-2002) (MP)"},BB9F06B288B5275BC0D38B6731B2526A:{n:"Star Fire - Meteor Dance 2 (18-11-2002) (MP)"},"551EF75593EC18D078E8F5CC0229E1C4":{n:"Star Fire - New Paulstar WIP (MP)"},"74CA9BDC91EE387A5BD929B73AEC5C2C":{n:"Star Fire - New Shields (03-04-2003) (MP)"},A23FFC86804240CE77134A1C91926685:{n:"Star Fire - Paulstar WIP (MP)"},C6CEDB25B7D390B580EA8EDB614B168B:{n:"Star Fire - Radar Completed (22-10-2002) (MP)"},"5F69453A69F21DC49697A80D2E933491":{n:"Star Fire - Reduced Flickering (06-10-2002) (MP)"},"2E2885E68FA1045871CE1382B68F6EFC":{n:"Star Fire - Return of the Crosshair (MP)"},DA64F33D0521D5C9958E5D2D4434FF95:{n:"Star Fire - Return of the Starfield (MP)"},"92EDE72ED8F61D255BC58D2F166DC6B6":{n:"Star Fire - Shootable (26-09-2002) (MP)"},ED9999911B406DC5F75C850DCC17BDF4:{n:"Star Fire - Shootable (Friendlier Collision Detection) (26-09-2002) (MP)"},"92C5ABB7A8BB1C3FC66C92BA353A3D21":{n:"Star Fire - Sorting Fixed (MP)"},"103D4C890C2108CB536372C98D093E5F":{n:"Star Fire - Star Background (MP)"},"7F73AC39E5E3E13E40FD8AD885561A0F":{n:"Star Fire - Warping Star (13-04-2003) (MP)"},FBD6102E17A5C02C6E1911381B7203F9:{n:"Star Fire - Warping!! (10-04-2003) (MP)"},BB07F917611CDE42B7D83746EE27147D:{n:"Star Fire - Warping!! (13-04-2003) (MP)"},F526D0C519F5001ADB1FC7948BFBB3CE:{n:"Star Fox (1983) (Mythicon)"},C541A5F6FC23B40A211196DD78233780:{n:"Star Raiders (1981) (Atari) (Prototype)"},CBD981A23C592FB9AB979223BB368CD5:{n:"Star Raiders (1982) (Atari)"},C1A83F44137EA914B495FC6AC036C493:{n:"Star Raiders (1982) (Atari) (PAL)"},E363E467F605537F3777AD33E74E113A:{n:"Star Ship (1977) (Atari)"},"7B938C7DDF18E8362949B62C7EAA660A":{n:"Star Ship (1977) (Atari) (4K)"},"79E5338DBFA6B64008BB0D72A3179D3C":{n:"Star Strike (1983) (M Network)"},"405F8591B6941CFF56C9B392C2D5E4E5":{n:"Star Strike (1989) (Telegames) (PAL)"},AB8D318DA4ADDD39C65B7F9C408DF2A6:{n:"Star Trek (Genesis)",c:1},"03C3F7BA4585E349DD12BFA7B34B7729":{n:"Star Trek - Strategic Operations Simulator (1983) (Sega)",c:1},"30F0B49661CFCFD4EC63395FAB837DC3":{n:"Star Trek - Strategic Operations Simulator (1983) (Sega) (PAL)",c:1},"813985A940AA739CC28DF19E0EDD4722":{n:"Star Voyager (1982) (Imagic)"},"0ACEB7C3BD13FE048B77A1928ED4267D":{n:"Star Voyager (1982) (Imagic) (PAL)"},D912312349D90E9D41A9DB0D5CD3DB70:{n:"Star Voyager (1983) (CCE)"},"2E7E9C6DCFCCEAFFC6FA73F0D08A402A":{n:"Star Voyager (1983) (CCE) [a]"},"9D33D31FB1DE58C5460D8A67B57B36DA":{n:"Star Voyager (Genesis)"},"5336F86F6B982CC925532F2E80AA1E17":{n:"Star Wars - Death Star Battle (1983) (Parker Bros)",c:1},CB9B2E9806A7FBAB3D819CFE15F0F05A:{n:"Star Wars - Death Star Battle (1983) (Parker Bros) (PAL)"},D44D90E7C389165F5034B5844077777F:{n:"Star Wars - Ewok Adventure (1983) (Parker Bros) (Prototype)"},"2E2ACEF8513EDCCA991E7E5149412E11":{n:"Star Wars - Ewok Adventure (1983) (Parker Bros) (Prototype) (16K)"},"6DFAD2DD2C7C16AC0FA257B6CE0BE2F0":{n:"Star Wars - Ewok Adventure (1983) (Parker Bros) (Prototype) (PAL)"},"9D7F04618BB4043F531D087E3AAA7AC8":{n:"Star Wars - Ewok Adventure (1983) (Parker Bros) (Prototype) (PAL) (16K)"},C246E05B52F68AB2E9AEE40F278CD158:{n:"Star Wars - Ewok Adventure (Thomas Jentzsch) (Prototype)"},C9F6E521A49A2D15DAC56B6DDB3FB4C7:{n:"Star Wars - Jedi Arena (1983) (Parker Bros)",p:1},"05B45BA09C05BEFA75AC70476829EDA0":{n:"Star Wars - Jedi Arena (1983) (Parker Bros) (PAL)",p:1},F4B8A47A95B61895E671C3EC86FFD461:{n:"Star Wars - The Arcade Game (01-03-1984) (Parker Bros) (Prototype)",c:1},"6651E2791D38EDC02C5A5FD7B47A1627":{n:"Star Wars - The Arcade Game (04-05-1984) (Parker Bros) (Prototype) (8K)",c:1},E8A3473BF786CF796D1336D2D03A0008:{n:"Star Wars - The Arcade Game (12-05-1983) (Parker Bros) (Prototype)",c:1},"1E1290EA102E12D7AC52820961457E2B":{n:"Star Wars - The Arcade Game (12-15-1983) (Parker Bros) (Prototype)",c:1},AE2F1F69BB38355395C1C75C81ACC644:{n:"Star Wars - The Arcade Game (12-23-1983) (Parker Bros) (Prototype)",c:1},"6339D28C9A7F92054E70029EB0375837":{n:"Star Wars - The Arcade Game (1984) (Parker Bros)",c:1},"6CF054CD23A02E09298D2C6F787EB21D":{n:"Star Wars - The Arcade Game (1984) (Parker Bros) (PAL)",c:1},FFC0FF4305DD46B4B459885BD1818E2E:{n:"Star Wars - The Battle of Alderaan (Star Strike Hack)"},"3C8E57A246742FA5D59E517134C0B4E6":{n:"Star Wars - The Empire Strikes Back (1982) (Parker Bros)"},BE060A704803446C02E6F039AB12EB91:{n:"Star Wars - The Empire Strikes Back (1982) (Parker Bros) (PAL)"},D69559F9C9DC6EF528D841BF9D91B275:{n:"StarMaster (1982) (Activision)"},"73C839AFF6A055643044D2CE16B3AAF7":{n:"StarMaster (1982) (Activision) (PAL)"},"348615FFA30FAB3CEC1441B5A76E9460":{n:"StarMaster (1982) (Activision) (PAL) [fixed]"},D62D7D1A974C31C5803F96A8C1552510:{n:"StarMaster (Unknown) (PAL)"},"1542662F665D2FFAA77B4B897DD2E2AF":{n:"Starfield (V1.0) (2002) (MP)"},"91D1C82CEAF8AF2ADD3973A3C34BC0CB":{n:"Starfield Demo 1 (20-12-2002) (CT)"},"68FEB6D6FF63E80DF1302D8547979AEC":{n:"Starfield Demo 2 (20-12-2002) (CT)"},"0C48E820301251FBB6BCDC89BD3555D9":{n:"Stargate (1984) (Atari)"},"493DE059B32F84AB29CDE6213964AEEE":{n:"Stargate (1984) (Atari) (PAL)"},A3C1C70024D7AABB41381ADBFB6D3B25:{n:"Stargunner (1982) (Telesys)"},E5BACF526036D3C8C99DB5B030CF00E7:{n:"Starmaster (Genesis)"},C5BAB953AC13DBB2CBA03CD0684FB125:{n:"Stay Frosty (SpiceWare)",c:1},"1FA86282403FA35D103AB88A9D603C31":{n:"Stay Frosty (SpiceWare) (PAL60)",c:1},"1619BC27632F9148D8480CD813AA74C3":{n:"Steeple Chase (Thomas Jentzsch)",c:1},F75872946E82AD74D48EAE5BC28F5F0E:{n:"Steeplechase (04-15-1980) (Sears) (Prototype)",p:1},"656DC247DB2871766DFFD978C71DA80C":{n:"Steeplechase (1980) (Sears)",p:1},A174CECE06B3ABC0AEC3516913CDF9CC:{n:"Steeplechase (1980) (Sears) (4K)",p:1},F1EEECCC4BBA6999345A2575AE96508E:{n:"Steeplechase (1983) (Video Gems) (PAL)",c:1},"3CDD91E1C28D28E856C0063D602DA166":{n:"Stell-A-Sketch (03-11-1997) (Bob Colbert) (PD)",c:1},"47AEF18509051BAB493589CB2619170B":{n:"Stell-A-Sketch (Bob Colbert) (PD)",c:1},"18ED63E3CE5BC3DD2D8BD188B807F1A2":{n:"Stell-A-Sketch (Bob Colbert) (PD) [a1]",c:1},"0B8D3002D8F744A753BA434A4D39249A":{n:"Stellar Track (1980) (Sears)",c:1},"23FAD5A125BCD4463701C8AD8A0043A9":{n:"Stone Age (1983) (CCE)"},B17B9CC4103844DCDA54F77F44ACC93A:{n:"Stopp die Gangster (1983) (Quelle) (PAL)"},F240BA9F8092D2E8A4C7D82C554BF509:{n:"Strahlen der Teufelsvoegel (1983) (Quelle) (PAL)"},"807A8FF6216B00D52ABA2DFEA5D8D860":{n:"Strat-O-Gems Deluxe (2005) (J. Payson)"},EF76EA05655A0B62CB1018C92B9B4B7D:{n:"Strategy X (1983) (Gakken) (PAL)"},"9333172E3C4992ECF548D3AC1F2553EB":{n:"Strategy X (1983) (Konami)"},E10D2C785AADB42C06390FAE0D92F282:{n:"Strawberry Shortcake - Musical Match-Ups (1983) (Parker Bros)"},"516FFD008057A1D78D007C851E6EFF37":{n:"Strawberry Shortcake - Musical Match-Ups (1983) (Parker Bros) (PAL)"},"8A6C84F481ACF42ABCB78BA5064AD755":{n:"Street Racer (128-in-1 Junior Console) (PAL) (4K)",p:1},"396F7BC90AB4FA4975F8C74ABE4E81F0":{n:"Street Racer (1977) (Atari)",p:1},"6FF4156D10B357F61F09820D03C0F852":{n:"Street Racer (1977) (Atari) (4K)",p:1},E12E32DEE68201B6765FCD0ED54D6646:{n:"Street Racer (1977) (Atari) (PAL)",p:1},"7B3CF0256E1FA0FDC538CAF3D5D86337":{n:"Stronghold (1983) (CommaVid)"},C3BBC673ACF2701B5275E85D9372FACF:{n:"Stunt Cycle (07-21-1980) (Atari) (Prototype)"},D7759FA91902EDD93F1568A37DC70CDB:{n:"Stunt Cycle (1980) (Atari) (Prototype) (4K)"},ED0AB909CF7B30AFF6FC28C3A4660B8E:{n:"Stunt Man (1983) (Panda)"},"5AF9CD346266A1F2515E1FBC86F5186A":{n:"Sub-Scan (1982) (Sega)"},B095009004DF341386D22B2A3FAE3C81:{n:"Sub-Scan (Unknown) (PAL)"},F3F5F72BFDD67F3D0E45D097E11B8091:{n:"Submarine Commander (1982) (Sears)"},"93C52141D3C4E1B5574D072F1AFDE6CD":{n:"Subterranea (1983) (Imagic)"},"38DE7B68379770B9BD3F7BF000136EB0":{n:"Subterranea (1983) (Imagic) (PAL)"},D8E4C8E2D210270CD1E0F6D1B4582B91:{n:"Subterranea (1983) (Imagic) (PAL) [a]"},"4AB4AF3ADCDAE8CDACC3D06084FC8D6A":{n:"Sucky Zepplin (Nick Bensema) (PD)"},CFF578E5C60DE8CAECBEE7F2C9BBB57B:{n:"Suicide Adventure (George Veeder) (Hack)"},E4C666CA0C36928B95B13D33474DBB44:{n:"Suicide Mission (1982) (Arcadia)",c:1},EB92193F06B645DF0B2A15D077CE435F:{n:"Suicide Mission (1982) (Arcadia) (PAL)",c:1},CD98BE8A48EBF610C9609A688B9C57F2:{n:"Suicide Mission (1982) (Arcadia) (Prototype)",c:1},"753375D183C713CFA0AA7298D1F3067B":{n:"Suicide Mission (1982) (Arcadia) [a]",c:1},"463DD4770506E6C0EF993A40C52C47BE":{n:"Suicide Mission (Preview) (1982) (Arcadia)",c:1},B4F05E544834D0238A0C263491775EDF:{n:"Suicide Mission (Preview) (1982) (Arcadia) (PAL)",c:1},"45027DDE2BE5BDD0CAB522B80632717D":{n:"Summer Games (1987) (Epyx)"},"12BCA8305D5AB8EA51FE1CFD95D7AB0E":{n:"Summer Games (1987) (Epyx) (PAL)"},"4F2D47792A06DA224BA996C489A87939":{n:"Super Action Pak - Pitfall, Barnstorming, Grand Prix, Laser Blast (1988) (HES) (PAL)"},"7ADBCF78399B19596671EDBFFC3D34AA":{n:"Super Baseball (1988) (Atari)"},"0751F342EE4CF28F2C9A6E8467C901BE":{n:"Super Baseball (1988) (Atari) (PAL)"},FAED2EF6B44894F8C83F2B50891C35C6:{n:"Super Baseball (CCE)"},"1C85C0FC480BBD69DC301591B6ECB422":{n:"Super Box (CCE)"},"8885D0CE11C5B40C3A8A8D9ED28CEFEF":{n:"Super Breakout (1982 - 1981) (Atari)",p:1},EE4C186123D31A279ED7A84D3578DF23:{n:"Super Breakout (1982 - 1981) (Atari) (PAL)",p:1},"0AD9A358E361256B94F3FB4F2FA5A3B1":{n:"Super Breakout (1982 - 1981) (Atari) [a]",p:1},"9D37A1BE4A6E898026414B8FEE2FC826":{n:"Super Challenge Baseball (1982) (M Network)"},DAB844DEED4C752632B5E786B0F47999:{n:"Super Challenge Baseball (208 in 1) (Unknown) (PAL)"},"1D6ED6FE9DFBDE32708E8353548CBB80":{n:"Super Challenge Baseball (Jone Yuan)"},E275CBE7D4E11E62C3BFCFB38FCA3D49:{n:"Super Challenge Football (1982) (M Network)"},FEBA8686FD0376015258D1152923958A:{n:"Super Circus (Unknown) (PAL)"},C29F8DB680990CB45EF7FEF6AB57A2C2:{n:"Super Cobra (1982) (Parker Bros)"},D326DB524D93FA2897AB69C42D6FB698:{n:"Super Cobra (1982) (Parker Bros) (PAL)"},"5F7DE62A408B9DE3A1168898298FD31D":{n:"Super Cobra (Genesis)"},C7900A7FE95A47EEF3B325072AD2C232:{n:"Super Congo Bongo (2003) (Larry Petit) (Hack)"},"638CC82EA96F67674595BA9AE05DA6C6":{n:"Super Ferrari (Rainbow Vision) (PAL)"},"09ABFE9A312CE7C9F661582FDF12EAB6":{n:"Super Football (1988) (Atari)"},"262CCB882FF617D9B4B51F24AEE02CBE":{n:"Super Football (1988) (Atari) (PAL)"},"2447E17A4E18E6B609DE498FE4AB52BA":{n:"Super Futebol (CCE)",c:1},"2F0A8BB4E18839F9B1DCAA2F5D02FD1D":{n:"Super Futebol (CCE) [a]",c:1},C08D0CEE43077D3055FEBB00E5745C1D:{n:"Super Hit Pak - River Raid, Sky Jinks, Grand Prix, Fishing Derby, Checkers (HES) (PAL)"},"08D1B6D75206EDB999252CAF542A2C7F":{n:"Super Home Run (2003) (Larry Petit) (Hack)"},"645BF7F9146F0E4811FF9C7898F5CD93":{n:"Super Kung-Fu (1983) (Xonox) (PAL)"},"3B2C32FCD331664D037952BCAA62DF94":{n:"Super Kung-Fu (1983) (Xonox) (PAL) [a]"},"0E7E73421606873B544E858C59DC283E":{n:"Super Soccer (Digivision)",c:1},"3E7D10D0A911AFC4B492D06C99863E65":{n:"Super Tenis (VGS)"},"53B66F11F67C3B53B2995E0E02017BD7":{n:"Super Tennis (1983) (CCE)"},"517923E655755086A3B72C0B17B430E6":{n:"Super Tennis (Tron)"},CBC373FBCB1653B4C56BFABBA33EA50D:{n:"Super Voleyball (CCE)"},BDECC81F740200780DB04A107C3A1EBA:{n:"Super-Cowboy beim Rodeo (1983) (Quelle) (PAL)"},CC2973680C150886CCE1ED8693C3ACA2:{n:"Super-Cowboy beim Rodeo (1983) (Quelle) (PAL) (4K)"},"2B27EB194E13F3B38D23C879CC1E3ABF":{n:"Super-Ferrari (1983) (Quelle) (PAL)"},"85502D69FE46B7F54EF2598225678B47":{n:"Super-Ferrari (Jone Yuan)"},"724613EFFAF7743CBCD695FAB469C2A8":{n:"Super-Ferrari (Unknown)"},"4565C1A7ABCE773E53C75B35414ADEFD":{n:"Supercharger BIOS (1982) (Arcadia)"},A9531C763077464307086EC9A1FD057D:{n:"Superman (1979) (Atari)"},"3619786F6A32EFC1E4A262D5ACA8A070":{n:"Superman (1979) (Atari) (8K)"},DBB10B904242FCFB8428F372E00C01AF:{n:"Superman (1979) (Atari) (PAL)"},FD10915633AEA4F9CD8B518A25D62B55:{n:"Superman (1979) (Atari) (PAL) [a]"},"5DE8803A59C36725888346FDC6E7429D":{n:"Superman (1979) (Atari) [fixed]"},"149B543C917C180A1B02D33C12415206":{n:"Superman (1983) (CCE)"},CCB807EB79B0ED0F5FDC460445EF703A:{n:"Superman (Stunt_Cycle_Rules!) (Hack)"},"6FAC680FC9A72E0E54255567C72AFE34":{n:"Superman (Unknown) (PAL)"},"169D4C7BD3A4D09E184A3B993823D048":{n:"Superman (Unknown) (PAL) [a]"},AEC9B885D0E8B24E871925630884095C:{n:"Surf's Up (1983) (Amiga) (Prototype)"},A2170318A8EF4B50A1B1D38567C220D6:{n:"Surf's Up (1983) (Amiga) (Prototype) [a]"},C20F15282A1AA8724D70C117E5C9709E:{n:"Surfer's Paradise (1983) (Video Gems) (PAL)"},"59B70658F9DD0E2075770B07BE1A35CF":{n:"Surfer's Paradise (Thomas Jentzsch)"},"4D7517AE69F95CFBC053BE01312B7DBA":{n:"Surround (1977) (Atari)"},"31D08CB465965F80D3541A57EC82C625":{n:"Surround (1977) (Atari) (4K)"},"52A0003EFB3B1C49FCDE4DBC2C685D8F":{n:"Surround (1977) (Atari) (4K) [a]"},C370C3268AD95B3266D6E36FF23D1F0C:{n:"Surround (1977) (Atari) (PAL)"},A60598AD7EE9C5CCAD42D5B0DF1570A1:{n:"Surround (32 in 1) (1988) (Atari) (PAL)"},"5C86E938E0845B9D61F458539E9A552B":{n:"Surround (32 in 1) (1988) (Atari) (PAL) (4K)"},D89FEDDED0436FDEDA7C3C37E2FB7CF1:{n:"Surround (Unknown) (PAL) (4K)"},"4C462B2B6FB0A19A1437EB2C3DC20783":{n:"Survival Island (1 of 3) (1983) (Arcadia)"},B6E40BCE550672E5495A8CDDE7075B8B:{n:"Survival Island (1 of 3) (1983) (Arcadia) (PAL)"},"045035F995272EB2DEB8820111745A07":{n:"Survival Island (1983) (Arcadia)"},"84DB818CD4111542A15C2A795369A256":{n:"Survival Island (1983) (Arcadia) (PAL)"},"691D67910B08B63DE8631901D1887C1F":{n:"Survival Island (1983) (Arcadia) [a]"},B31DC989F594764EACFA7931CEAD0050:{n:"Survival Island (2 of 3) (1983) (Arcadia)"},"277C7281AC945B8331E2E6FCAD560C11":{n:"Survival Island (2 of 3) (1983) (Arcadia) (PAL)"},"4A9009620038F7F30AAEB2A00AE58FDE":{n:"Survival Island (3 of 3) (1983) (Arcadia)"},"76C685D1A60C0107AA54A772113A2972":{n:"Survival Island (3 of 3) (1983) (Arcadia) (PAL)"},"59E53894B3899EE164C91CFA7842DA66":{n:"Survival Run (1983) (Data Age) (Prototype)"},"85E564DAE5687E431955056FBDA10978":{n:"Survival Run (1983) (Milton Bradley)",c:1},C7600D72247C5DFA1EC1A88D23E6C85E:{n:"Sweat! - The Decathlon Game (1 of 3) (1983) (Arcadia) (Prototype)",p:1},E51C23389E43AB328CCFB05BE7D451DA:{n:"Sweat! - The Decathlon Game (1983) (Arcadia) (Prototype)",p:1},"5EC73AC7D2AC95AC9530C6D33E713D14":{n:"Sweat! - The Decathlon Game (2 of 3) (1983) (Arcadia) (Prototype)",p:1},"1E060A8025512AD2127E3DA11E212CCC":{n:"Sweat! - The Decathlon Game (3 of 3) (1983) (Arcadia) (Prototype)",p:1},"528400FAD9A77FD5AD7FC5FDC2B7D69D":{n:"Sword of Saros (1983) (Arcadia)"},"8B7CA29A55432F886CEE3D452FB00481":{n:"Sword of Saros (1983) (Arcadia) (PAL)"},"545048CCB045F9EFC6CF2B125CD0DFA8":{n:"Sword of Saros (1983) (Arcadia) [a]"},"5AEA9974B975A6A844E6DF10D2B861C4":{n:"SwordQuest - EarthWorld (1982) (Atari)"},A875F0A919129B4F1B5103DDD200D2FE:{n:"SwordQuest - EarthWorld (1982) (Atari) (PAL)"},"05EBD183EA854C0A1B56C218246FBBAE":{n:"SwordQuest - EarthWorld (1982) (Atari) [a]"},F9D51A4E5F8B48F68770C89FFD495ED1:{n:"SwordQuest - FireWorld (1982) (Atari)"},BF976CF80BCF52C5F164C1D45F2B316B:{n:"SwordQuest - FireWorld (1982) (Atari) (PAL)"},"3882224ADBD0CA7C748B2A1C9B87263E":{n:"SwordQuest - FireWorld (1982) (Atari) (PAL) [a]"},BC5389839857612CFABEB810BA7EFFDC:{n:"SwordQuest - WaterWorld (1983) (Atari)"},"87662815BC4F3C3C86071DC994E3F30E":{n:"Swordfight (1983) (Intellivision)"},D0B9F705AA5F61F47A748A66009AE2D2:{n:"Synthcart (14-01-2002) (Paul Slocum)",c:1},"2C2AEA31B01C6126C1A43E10CACBFD58":{n:"Synthcart (2002) (Paul Slocum)",c:1},"8B556C3D9CA8E5E6E665BD759B93FFAE":{n:"Synthcart (2002) (Paul Slocum) (PAL) [!]",c:1},"896EC58F26E930E02F5E4F046602C3A1":{n:"Synthcart (Beta) (2002) (Paul Slocum)",c:1},"8933976F2029C0D8492EBD8F4EB21492":{n:"Synthcart Plus (09-02-2003) (Paul Slocum)"},"294762000E853B4319F9991C1CED5DFC":{n:"T.F. Space Invaders (Hack)"},BECD908F9D7BB361982C3DC02D6475C6:{n:"THX-1138 (Kyle Pittman) (Hack)"},"6FFC95108E5ADD6F9B8ABCAF330BE835":{n:"TP Bug (Charles Morgan) (Hack)"},FB27AFE896E7C928089307B32E5642EE:{n:"TRON - Deadly Discs (1982) (M Network)"},"9E5007131695621D06902AB3C960622A":{n:"Tac Scan (1983) (Sega) [h1]",p:1,c:1},D45EBF130ED9070EA8EBD56176E48A38:{n:"Tac-Scan (1982) (Sega)",p:1,c:1},"06E5DC181A8EDA1C31CC7C581C68B6EF":{n:"Tac-Scan (Unknown) (PAL)",c:1},C77D3B47F2293E69419B92522C6F6647:{n:"Tank Brigade (1983) (Panda)"},AD8072675109D13FDD31A2E0403D5CFF:{n:"Tank City (Funvision)"},FA6FE97A10EFB9E74C0B5A816E6E1958:{n:"Tanks But No Tanks (1983) (ZiMAG)"},"082FDC8BD47FEF01482CE5883C4FFDB8":{n:"Tanks DX (Charles Morgan) (Hack)"},"1A613CE60FC834D4970E1E674B9196B3":{n:"Tanks War (1983) (Home Vision) (PAL)"},DE3D0E37729D85AFCB25A8D052A6E236:{n:"Tapeworm (1982) (Spectravision)",c:1},"8ED73106E2F42F91447FB90B6F0EA4A4":{n:"Tapeworm (1982) (Spectravision) (PAL)",c:1},"33CAC5E767A534C95D292B04F439DC37":{n:"Tapeworm (Jone Yuan)"},C0D2434348DE72FA6EDCC6D8E40F28D7:{n:"Tapper (1984) (Sega)"},"2D6741CDA3000230F6BBDD5E31941C01":{n:"Targ (1983) (CBS Electronics) (Prototype)"},"3D6FC7A19BE76D808AA233415CB583FC":{n:"Target Practice (1983) (CCE)"},"7DD9C5284422F729066AB22A284C8283":{n:"Target Practice (1983) (CCE) [a]"},"0C35806FF0019A270A7ACAE68DE89D28":{n:"Task Force (1987) (Froggo)"},A1EAD9C181D67859AA93C44E40F1709C:{n:"Tax Avoiders (1982) (American Videogame)"},"360BA640F6810EC902B01A09CC8AB556":{n:"Taz (06-15-1983) (Atari) (Prototype) (PAL)"},B31F178AA0D569CCCAC7959F84E0A724:{n:"Taz (07-13-1983) (Atari) (Prototype)"},"9A01115206F32EB0B539C7E5A47CCAFA":{n:"Taz (07-15-1983) (Atari) (Prototype)"},"7574480AE2AB0D282C887E9015FDB54C":{n:"Taz (1983) (Atari)"},"0D09CFF0D28033C02C3290EDFC3A5CEA":{n:"Taz (1983) (Atari) (Prototype)"},"76809EB1EE0DB8A318308A5CDDA0F4E2":{n:"Taz (1983) (Atari) (Prototype) [a]"},"4702D8D9B48A332724AF198AEAC9E469":{n:"Taz (1983) (Atari) [a]"},AB60EA7B707C58D356CAD858EB18DB43:{n:"Tazer (John K. Harvey)"},"8C2FA33048F055F38358D51EEFE417DB":{n:"Teddy Apple (1983) (Home Vision) (PAL)",c:1},"3D7AAD37C55692814211C8B590A0334C":{n:"Telepathy (1983) (Atari) (Prototype)"},AE97CF8ED21F4154B4360A3CF6C95C5E:{n:"Teleterm 2600 (John K. Harvey) (PD)"},"203B1EFC6101D4B9D83BB6CC1C71F67F":{n:"Teller-Jonglieren! (1983) (Quelle) (PAL)",c:1},C830F6AE7EE58BCC2A6712FB33E92D55:{n:"Tempest (01-05-1984) (Atari) (Prototype)"},"42CDD6A9E42A3639E190722B8EA3FC51":{n:"Tennis (1981) (Activision)"},"961112B74A920A5242E233480326C356":{n:"Tennis (1981) (Activision) (16K)"},ACA09FFEA77174B148B96B205109DB4D:{n:"Tennis (1981) (Activision) (4K)"},"74EBACA101CC428CF219F15DDA84B6F8":{n:"Tennis (1981) (Activision) (8K)"},A5C96B046D5F8B7C96DAAA12F925BEF8:{n:"Tennis (1981) (Activision) (PAL)"},CA7F166A94EED1A349DEC6D6A358BCAD:{n:"Tennis (1981) (Activision) (PAL) (4K)"},"73EFA9F3CBE197F26E0FB87132829232":{n:"Tennis (1983) (CCE) (4K)"},"04B488D4EEF622D022A0021375E7E339":{n:"Tennis (1983) (Home Vision) (PAL) (4K)"},A3F8AEBB38182749CB8DA85CFBC63D7C:{n:"Tennis (208 in 1) (Unknown) (PAL) (Hack)"},"16E04823887C547DC24BC70DFF693DF4":{n:"Tennis (32 in 1) (1988) (Atari) (PAL)"},"30685B9B6EBD9BA71536DD7632A1E3B6":{n:"Tennis (Dactari)"},"736388D73198552D77D423962000006F":{n:"Tennis (Dactari) (4K)"},"1F5A2927A0B2FAF87540B01D9D7D7FD1":{n:"Tennis (Pet Boat) (PAL)"},"61E0F5E1CC207E98704D0758C68DF317":{n:"Tennis (Star Game)"},A3873D7C544AF459F40D58DFCFB78887:{n:"Tennis (Unknown)"},"6697F177847C70505824422E76AAD586":{n:"Tennis (Unknown) (PAL) (4K)"},E3ED4BA3361756970F076E46E9CAD1D2:{n:"Tennis (Unknown) (PAL) (4K) [a]"},"20AE62FB69C6CC6E8098CCA8CD080487":{n:"Tennis (Zirok)"},"67631EA5CFE44066A1E76DDCB6BCB512":{n:"Termool (Unknown) (PAL)"},"05C60458EC69E7FE8B1BE973852D84F1":{n:"Test (1996) (J.V. Matthews) (PD)"},F0631C6675033428238408885D7E4FDE:{n:"Test Cart (2002) (Paul Slocum)",c:1},B0E1EE07FBC73493EAC5651A52F90F00:{n:"Tetris 2600 (Colin Hughes)",c:1},CAE8F83C06831EC7BB6A3C07E98E9342:{n:"Tetris 2600 (Colin Hughes) [o1]",c:1},"5EEB81292992E057B290A5CD196F155D":{n:"Texas Chainsaw Massacre, The (1983) (Wizard Video)"},"3316EE2F887E9CB9B54DD23C5B98C3E2":{n:"Texas Golf (miniature Gold Hack)"},"4476C39736090DABAC09F6CAF835FC49":{n:"Text Screen (25-01-2003) (AD)"},"3B64A00CE147C3C29F7F8F8E531D08D8":{n:"This Planet Sucks (16K) (Greg Troutman)"},"5FB71CC60E293FE10A5023F11C734E55":{n:"This Planet Sucks (Fix) (27-12-2002) (Greg Troutman)"},A98B649912B6CA19EAF5C2D2FAF38562:{n:"This Planet Sucks (Greg Troutman) (PAL) [!]"},DFE6AA7443BB813CEFA35A4CF4887422:{n:"This Planet Sucks (Greg Troutman) [a1]"},"0ACAF71E60B89F6B6EAB63DB6AB84510":{n:"This Planet Sucks (Greg Troutman) [a2]"},"225522777DC7155627808BDE0C1D0EF0":{n:"This Planet Sucks Demo 1 (Greg Troutman) (PD)"},"8530CAAAF40ACBDCD118C282B5F8A37A":{n:"This Planet Sucks Demo 2 (Greg Troutman) (PD)"},"7F790939F7EAA8C47A246C4283981F84":{n:"This Planet Sucks Demo 3 (Greg Troutman) (PD)"},E56DA674188BA2F02C7A0A343A01236F:{n:"This Planet Sucks Demo 4 (Greg Troutman) (PD)"},"65C6406F5AF934590097C8C032EBB482":{n:"Three Hugger (Pave Demo) (20-12-2002) (Billy Eno)"},E63A87C231EE9A506F9599AA4EF7DFB9:{n:"Threshold (1982) (Tigervision)"},"67684A1D18C85FFA5D82DAB48FD1CB51":{n:"Threshold (1982) (Tigervision) (PAL)"},"346555779A2D51B48833463B5433472F":{n:"Thrust (V0.1) (2000) (TJ)"},"1442D1B35A6478FBA22AE7DD1FCB5634":{n:"Thrust (V0.2) (2000) (TJ)"},BA3B0EEBCCC7B791107DE5B4ABB671B4:{n:"Thrust (V0.9) (2000) (TJ)"},"041B5E56BBC650DB574BD8DB3FAE2696":{n:"Thrust (V1.0) (2000) (TJ)"},"98FA3AD778A668A79449350DE4B3B95B":{n:"Thrust (V1.1) (2000) (TJ)"},FC668A2251DD79CBD903D4FA0E558F96:{n:"Thrust (V1.1) (2000) (TJ) [a1]"},E1E09E2F280E8E142121A377D0DC1B46:{n:"Thrust (V1.21) (2000) (TJ)"},DE7BCA4E569AD9D3FD08FF1395E53D2D:{n:"Thrust (V1.22) (2000) (TJ)"},CF507910D6E74568A68AC949537BCCF9:{n:"Thunderground (1983) (Sega)",c:1},"1428029E762797069AD795CE7C6A1A93":{n:"Thunderground (Unknown) (PAL)",c:1},C032C2BD7017FDFBBA9A105EC50F800E:{n:"Thwocker (04-09-1984) (Activision) (Prototype)"},"79D6F61DA3C64688AC8E075667F8A39F":{n:"Tie-Fighters (MP)"},"7576DD46C2F8D8AB159D97E3A3F2052F":{n:"Time Machine (1983) (Goliath) (PAL)"},FC2104DD2DADF9A6176C1C1C8F87CED9:{n:"Time Pilot (1983) (Coleco)"},"4E99EBD65A967CABF350DB54405D577C":{n:"Time Pilot (1983) (Coleco) [b1]"},"5DB9E5BF663CAD6BF159BC395F6EAD53":{n:"Time Race (1983) (Goliath) (PAL)"},"71F09F128E76EB14E244BE8F44848759":{n:"Time Race (Funvision) (PAL)"},"00EAEE22034AFF602F899B684C107D77":{n:"Time Race (Rainbow Vision) (PAL)"},EFB47D70B2965CE689E2C5757616B286:{n:"Time Test Demo (Eckhard Stolberg) (PAL) (PD)"},D6D1DDD21E9D17EA5F325FA09305069C:{n:"Time Warp (1982) (Funvision) (PAL)"},BC3057A35319AAE3A5CD87A203736ABE:{n:"Time Warp (1983) (CCE)"},"619DE46281EB2E0ADBB98255732483B4":{n:"Time Warp (Unknown)"},"6D9AFD70E9369C2A6BFF96C4964413B7":{n:"Time Warp (Unknown) (PAL)"},B879E13FD99382E09BCAF1D87AD84ADD:{n:"Time Warp (Zellers)"},FB09EE4CCD47AE74A3C314F0D8A40344:{n:"Titans (SnailSoft)"},"12123B534BDEE79ED7563B9AD74F1CBD":{n:"Title Match Pro Wrestling (1987) (Absolute)"},"153F40E335E5CB90F5CE02E54934AB62":{n:"Title Match Pro Wrestling (1987) (Absolute) (PAL)"},DA6465A34D2E44D26AA9A2A0CD1BCE4D:{n:"Title Match Pro Wrestling (1987) (Absolute) [a]"},"784176346E9422733D55C427230E5BAD":{n:"Title Match Pro Wrestling (1989) (Activision)"},"3B9480BB6FB1E358C9C0A64E86945AEE":{n:"Title Match Pro Wrestling (2002) (Skyworks)"},DE61A0B171E909A5A4CFCF81D146DBCB:{n:"Tom Boy (Rainbow Vision) (PAL)"},ECE908D77AB944F7BAC84322B9973549:{n:"Tom Boy (Unknown) (PAL60)"},D85F1E35C5445AC898746719A3D93F09:{n:"Tom's Eierjagd (1983) (Quelle) (PAL)"},C05F367FA4767CEB27ABADF0066DF7F4:{n:"TomInv (31-07-2001) (TJ)"},"32DCD1B535F564EE38143A70A8146EFE":{n:"Tomarc the Barbarian (1983) (Xonox)"},"8BC0D2052B4F259E7A50A7C771B45241":{n:"Tomarc the Barbarian (1983) (Xonox) [a]"},BE2870A0120FD28D25284E9CCDCBDC99:{n:"Tomb Raider 2600 [REV 01] (Montezuma's Revenge Hack)"},E0221C95AA657F5764EEEB64C8429258:{n:"Tomb Raider 2600 [REV 02] (Montezuma's Revenge Hack)"},"5B574FAA56836DA0866BA32AE32547F2":{n:"Tomb Raider 2600 [REV 03] (Montezuma's Revenge Hack)"},"3AC6C50A8E62D4CE71595134CBD8035E":{n:"Tomcat (1988) (Absolute)"},"155FA7F479DCBA3B10B1494E236D6010":{n:"Tomcat (2002) (Skyworks) (PAL)"},FA2BE8125C3C60AB83E1C0FE56922FCB:{n:"Tooth Protectors (1983) (DSD-Camelot)",c:1},E0B24C3F40A46CDA52E29835AB7AD660:{n:"Top Gun (1983) (Quelle) (PAL)"},"01ABCC1D2D3CBA87A3AA0EB97A9D7B9C":{n:"Topy (Jone Yuan)"},"0AA208060D7C140F20571E3341F5A3F8":{n:"Towering Inferno (1982) (U.S. Games)",c:1},"15FE28D0C8893BE9223E8CB2D032E557":{n:"Towering Inferno (208 in 1) (Unknown) (PAL)",c:1},F39E4BC99845EDD8621B0F3C7B8C4FD9:{n:"Toyshop Trouble (AtariAge)",p:1},"6AE4DC6D7351DACD1012749CA82F9A56":{n:"Track and Field (1984) (Atari)"},"66706459E62514D0C39C3797CBF73FF1":{n:"Treasure Below (1983) (Video Gems) (PAL)"},"81414174F1816D5C1E583AF427AC89FC":{n:"Treasure Below (Thomas Jentzsch)"},B86A12E53AB107B6CAEDD4E0272AA034:{n:"Treasure Hunting (Funvision)"},"1BB91BAE919DDBD655FA25C54EA6F532":{n:"Treasure Island (Suntek) (PAL)"},D6A44277C3EB4F9D039185E0ECF7BFA6:{n:"Trick (1997) (Eckhard Stolberg)"},"0CC8224FF1EDFE458E8629E9E5FE3F5B":{n:"Trick 12 (2001) (TJ)"},"24DF052902AA9DE21C2B2525EB84A255":{n:"Trick Shot (1982) (Imagic)",c:1},"097936B07E0E0117B9026AE6835EB168":{n:"Trick Shot (1982) (Imagic) (PAL)",c:1},DCA90EA1084A2FDBE300D7178CA1A138:{n:"Trick Shot (1982) (Imagic) (PAL) [a]",c:1},"8F613EA7C32A587D6741790E32872DDD":{n:"Troll Demo (PD)"},E7A758BB0B43D0F7004E92B9ABF4BC83:{n:"Troll's Adventure (Hack)"},DF3E6A9B6927CF59B7AFB626F6FD7EEA:{n:"Tuby Bird (208 in 1) (Unknown) (PAL)"},E957EB4612D6BD5940D3492DFA749668:{n:"Tunnel Demo (27-03-2003) (CT)"},A14D8A388083C60283E00592B18D4C6C:{n:"Tunnel Demo (28-03-2003) (AD)"},"18D26111CEF66DFF0C8AF8CF0E117843":{n:"Tunnel Demo (Cycling Colours 2) (29-03-2003) (AD)"},"265A85F66544EAF95FDA06C3D9E48ABF":{n:"Tunnel Demo (Cycling Colours) (29-03-2003) (AD)"},AE047E9468BDA961D8E9E9D8FF52980F:{n:"Tunnel Demo (Red Spiral) (30-03-2003) (AD)"},D8B2C81CEA5AF04F795EB3DC6573D72B:{n:"Tunnel Demo 2 (27-03-2003) (CT)"},B2737034F974535F5C0C6431AB8CAF73:{n:"Tunnel Runner (1983) (CBS Electronics)"},"7648E72A5B5899076688DF18A1DDCF72":{n:"Tunnel Runner (1983) (CBS Electronics) (Prototype)"},EFEFC02BBC5258815457F7A5B8D8750A:{n:"Tunnel Runner (1983) (CBS Electronics) [a]"},D9AB6B67A17DA51E5AD13717E93FA2E2:{n:"Turbo (Coleco) Prototype Fake v0.1 (TJ)"},DD4F4E0FBD81762533E39E6F5B55BB3A:{n:"Turbo WIP (TJ)"},"7A5463545DFB2DCFDAFA6074B2F2C15E":{n:"Turmoil (1982) (20th Century Fox)"},"46258BD92B1F66F4CB47864D7654F542":{n:"Turmoil (Zellers)"},"085322BAE40D904F53BDCC56DF0593FC":{n:"Tutankham (1983) (Parker Bros)"},"66C2380C71709EFA7B166621E5BB4558":{n:"Tutankham (1983) (Parker Bros) (PAL)"},"6FC27A9233FC69D28D3F190B4FF80F03":{n:"UFO #6 (Charles Morgan) (Hack)"},"6BB09BC915A7411FE160D0B2E4D66047":{n:"UFO (32 in 1) (1988) (Atari) (PAL)"},B290C2B139344FCFF5B312C71B9AC3B2:{n:"UFO (32 in 1) (1988) (Atari) (PAL) (4K)"},CA50CC4B21B0155255E066FCD6396331:{n:"UFO Patrol (Suntek) (PAL)",c:1},"1278F74CA1DFAA9122DF3ECA3C5BCAAD":{n:"Ungeheuer der Tiefe (Quelle) (PAL)"},"81A010ABDBA1A640F7ADF7F84E13D307":{n:"Universal Chaos (1989) (Telegames)",c:1},E020F612255E266A8A6A9795A4DF0C0F:{n:"Universal Chaos (1989) (Telegames) (PAL)"},"5F950A2D1EB331A1276819520705DF94":{n:"Unknown 20th Century Fox Game (1983) (20th Century Fox) (Prototype)",c:1},"841B7BC1CAD05F5408302308777D49DC":{n:"Unknown Activision Game #1 (10-22-1982) (Activision) (Prototype)"},EE681F566AAD6C07C61BBBFC66D74A27:{n:"Unknown Activision Game #1 (10-29-1982) (Activision) (Prototype)"},"8055B9C2622136FD91EDFEA6DF642DAF":{n:"Unknown Activision Game #1 (1983) (Activision) (Prototype) (PAL)"},"700A786471C8A91EC09E2F8E47F14A04":{n:"Unknown Activision Game #2 (1983) (Activision) (Prototype)"},"06B0194CE992584C365278E0D7323279":{n:"Unknown Activision Game #2 (Prototype) (PAL)"},"73E66E82AC22B305EB4D9578E866236E":{n:"Unknown Datatech Game (Jone Yuan)"},C3205E3707F646E1A106E09C5C49C1BF:{n:"Unknown Title (bin00003 (200206)) (PD)"},"3C3A2BB776DEC245C7D6678B5A56AC10":{n:"Unknown Title (bin00003) (PD)"},B00088418FC891F3FAA3D4DDDE6ACE94:{n:"Unknown Title (bin00007 (200102)) (PD)"},"143918368F4F4DFFF90999188C0197C9":{n:"Unknown Title (bin00016 (200110)) (PD)"},"4DCC7E7C2EC0738E26C817B9383091AF":{n:"Unknown Title (bin00026 (200110)) (PD)"},C150C76CBDE2C9B5A97EB5399D46C64F:{n:"Unknown Title (xxx00000 (200203)) (PD)"},A499D720E7EE35C62424DE882A3351B6:{n:"Up 'n Down (1984) (Sega)"},C6556E082AAC04260596B4045BC122DE:{n:"Vanguard (1982) (Atari)"},"3CAA902AC0CE4509308990645876426A":{n:"Vanguard (1982) (Atari) (PAL)"},"9D0BEFA555F003069A21D2F6847AD962":{n:"Vanguard (1982) (Atari) (PAL) [a]"},"88D7B6B3967DE0DB24CDAE1C7F7181BD":{n:"Vanguard (1982) (Atari) (Prototype)"},"7EF74879D7CB9FA0EF161B91AD55B3BB":{n:"Vanguard (CCE)"},F9660EBED66FEE8BDFDF07B4FAA22941:{n:"Vanguard (VGS)"},"787EBC2609A31EB5C57C4A18837D1AEE":{n:"Vault Assault (19xx) (Prescott)"},D08FCCFBEBAA531C4A4FA7359393A0A9:{n:"Venetian Blinds Demo (1982) (Activision)"},FB884FFD89013331A6F01AE3F6ABD214:{n:"Venetian Blinds Demo (1982) (Activision) (PAL)"},"39DA69FF9833F8C143F03B6E0E7A996B":{n:"Ventrra Invaders 2002 (Charles Morgan) (Hack)"},"345758747B893E4C9BDDE8877DE47788":{n:"Venture (1982) (CBS Electronics) (PAL)",c:1},"3E899EBA0CA8CD2972DA1AE5479B4F0D":{n:"Venture (1982) (Coleco)",c:1},"82DE957D155FC041FC6AFB8315A28550":{n:"Venture (1982) (Coleco) (Prototype)"},C63A98CA404AA5EE9FCFF1DE488C3F43:{n:"Venture (1987) (Atari)",c:1},"7CA7A471D70305C673FEDD08174A81E8":{n:"Venture II (2001) (Tim Snider)",c:1},"6CD1DC960E3E8D5C5E0FBE67AB49087A":{n:"Vertical Playfield Demo 1 (PD)"},EA6D40DB5498D6386571A76DF448AA4C:{n:"Vertical Playfield Demo 2 (PD)"},CE6C4270F605AD3CE5E82678B0FC71F8:{n:"Vertical Rainbow Demo (PD)"},BDC381BAF7C252C63739C5E9ED087A5C:{n:"Vertical Ship Demo 1 (PD)"},"6A091B8FFEACD0939850DA2094B51564":{n:"Vertically Scrolling Playfield (02-02-2003) (Aaron Bergstrom)"},"0956285E24A18EFA10C68A33846CA84D":{n:"Viagem Espacial (Dismac)"},"539D26B6E9DF0DA8E7465F0F5AD863B7":{n:"Video Checkers (1980) (Atari)"},"193F060553BA0A2A2676F91D9EC0C555":{n:"Video Checkers (1980) (Atari) (PAL)"},F0B7DB930CA0E548C41A97160B9F6275:{n:"Video Chess (1979) (Atari)"},"3EF9573536730DCD6D9C20B6822DBDC4":{n:"Video Chess (1979) (Atari) (PAL)"},A58B11148C18D85E4C2AEF4FF46ADE67:{n:"Video Chess (Unknown) (PAL)"},ED1492D4CAFD7EBF064F0C933249F5B0:{n:"Video Cube (CCE)"},"4191B671BCD8237FC8E297B4947F2990":{n:"Video Jogger (1983) (Exus)"},"497F3D2970C43E5224BE99F75E97CBBB":{n:"Video Life (1981) (CommaVid)",c:1},"3EC12372CA3E870B11CA70EDC7EC26A4":{n:"Video Life (1981) (CommaVid) (4K)",c:1},"4209E9DCDF05614E290167A1C033CFD2":{n:"Video Life (1981) (CommaVid) [higher sounds]",c:1},"14D365BBFAAC3D20C6119591F57ACCA4":{n:"Video Life (Unknown) (4K) (Hack)",c:1},"60E0EA3CBE0913D39803477945E9E5EC":{n:"Video Olympics (1977) (Atari)",p:1},C00B65D1BAE0AEF6A1B5652C9C2156A1:{n:"Video Olympics (1977) (Atari) (4K)",p:1},"77D0A577636E1C9212AECCDE9D0BAA4B":{n:"Video Olympics (1977) (Atari) (PAL)",p:1},FE3B461D4C8B179FE68BC77760294C25:{n:"Video Olympics (1977) (Atari) (PAL) (4K)",p:1},"107CC025334211E6D29DA0B6BE46AEC7":{n:"Video Pinball (1981) (Atari)"},"6E59DD52F88C00D5060EAC56C1A0B0D3":{n:"Video Pinball (1981) (Atari) (PAL)"},A2424C1A0C783D7585D701B1C71B5FDC:{n:"Video Pinball (Unknown) (PAL)"},EE659AE50E9DF886AC4F8D7AD10D046A:{n:"Video Reflex (1983) (Exus)"},"16F494F20AF5DC803BC35939EF924020":{n:"Video Simon (Mark De Smet)"},"93ACD5020AE8EB5673601E2EDECBC158":{n:"Video Time Machine (Chris Cracknell)"},"3B80B8F52A0939E16B5059F93A3FC19A":{n:"Virtual Pet (V007) (after Demo 2) (CRACKERS) (PD)"},"4F0071946E80CA68EDFDCCBAC86DCCE0":{n:"Virtual Pet Demo 1 (CRACKERS) (PD)"},"1F349DD41C3F93C4214E5E308DCCB056":{n:"Virtual Pet Demo 2 (CRACKERS) (PD)"},E17699A54C90F3A56AE4820F779F72C4:{n:"Vogel Flieh (1983) (Quelle) (PAL)"},"6C128BC950FCBDBCAF0D99935DA70156":{n:"Volleyball (1983) (Digitel)"},"4D8396DEEABB40B5E8578276EB5A8B6D":{n:"Volleyball (1983) (Quelle) (PAL)"},"5FAFFE1C4C57430978DEC5CED32B9F4A":{n:"Volleyball (Dactari - Milmar)"},"42B3AB3CF661929BDC77B621A8C37574":{n:"Volleyball (Robby)"},"8108162BC88B5A14ADC3E031CF4175AD":{n:"Vom Himmel durch die Hoelle (1983) (Quelle) (PAL)"},"1F21666B8F78B65051B7A609F1D48608":{n:"Vulture Attack (1982) (K-Tel Vision)"},B00A8BC9D7FE7080980A514005CBAD13:{n:"Vulture Attack (1982) (K-Tel Vision) (PAL)"},"6041F400B45511AA3A69FAB4B8FC8F41":{n:"Wabbit (1982) (Apollo)"},"38CF93EACFB2FA9A2C5E39059FF35A74":{n:"WacMan (2003) (Greg Zumwalt) (Hack)"},"1C5796D277D9E4DF3F6648F7012884C4":{n:"Wachroboter jagt Jupy (Quelle) (PAL)"},"7FF53F6922708119E7BF478D7D618C86":{n:"Walker (Suntek) (PAL)"},D175258B2973B917A05B46DF4E1CF15D:{n:"Walker (Suntek) (PAL) [a]"},D3456B4CF1BD1A7B8FB907AF1A80EE15:{n:"Wall Ball (1983) (Avalon Hill)",c:1},C16FBFDBFDF5590CC8179E4B0F5F5AEB:{n:"Wall Break (Unknown)"},EAE6A5510055341D3ABEB45667BB3E9B:{n:"Wall Defender (HES) (PAL)"},"03FF9E8A7AF437F16447FE88CEA3226C":{n:"Wall-Defender (1983) (Bomb)"},"372BDDF113D088BC572F94E98D8249F5":{n:"Wall-Defender (1983) (Bomb) (PAL)"},"6522717CFD75D1DBA252CBDE76992090":{n:"War 2000 (1983) (Home Vision) (PAL)"},"9436B7AD131B5A1F7753CE4309BA3DEE":{n:"War of The Worlds (Kyle Pittman) (Hack)"},CBE5A166550A8129A5E6D374901DFFAD:{n:"Warlords (1981) (Atari)",p:1},"0C80751F6F7A3B370CC9E9F39AD533A7":{n:"Warlords (1981) (Atari) (PAL)",p:1},"679E910B27406C6A2072F9569AE35FC8":{n:"Warplock (1982) (Data Age)",p:1,c:1},D1C3520B57C348BC21D543699BC88E7E:{n:"Warplock (1983) (Gameworld) (PAL)",p:1,c:1},D88691C995008B9AB61A44BB686B32E4:{n:"Warring Worms (07-02-2002) (Billy Eno)"},FA3DE71841C0841DB6A741884A6B6B2F:{n:"Warring Worms (17-02-2002) (Billy Eno)"},"2351D26D0BFDEE3095BEC9C05CBCF7B0":{n:"Warring Worms (19-01-2002) (Billy Eno)"},"7E7C4C59D55494E66EEF5E04EC1C6157":{n:"Warring Worms (2002) (Baroque Gaming)"},A2F296EA2D6D4B59979BAC5DFBF4EDF0:{n:"Warring Worms (28-01-2002) (Billy Eno)"},"7A64B5A6E90619C6AACF244CDD7502F8":{n:"Warring Worms (Beta 1) (2002) (Baroque Gaming)"},"2F66EBF037321ED0442AC4B89CE22633":{n:"Warring Worms (Beta 2) (2002) (Baroque Gaming)"},D17A8C440D6BE79FAE393A4B46661164:{n:"Warring Worms (Beta 3) (2002) (Billy Eno)"},"4A2FE6F0F6317F006FD6D4B34515448B":{n:"Warring Worms (Midwest Classic Edition) (08-06-2002) (Billy Eno)"},E171558C51BB3BAC97BFA79FA2C1A19C:{n:"Warring Worms (Tim Strauss Edition) (20-12-2002) (Billy Eno)"},"0D7E630A14856F4D52C9666040961D4D":{n:"Wavy Line Test (PD)"},"5C73693A89B06E5A09F1721A13176F95":{n:"Wavy Line Test 2 (PD)"},BCE4C291D0007F16997FAA5C4DB0A6B8:{n:"Weltraumtunnel (1983) (Quelle) (PAL)"},D47387658ED450DB77C3F189B969CC00:{n:"Westward Ho (1982) (PlayAround) (PAL)"},"4C39A2C97917D3D71739B3E21F60BBA5":{n:"Whale (Sub Scan Hack)"},AB10F2974DEE73DAB4579F0CAB35FCA6:{n:"Wilma Wanderer (1983) (ITT Family Games) (PAL)"},"4E02880BEEB8DBD4DA724A3F33F0971F":{n:"Wing War (1983) (Imagic) (PAL)"},"9D2938EB2B17BB73E9A79BBC06053506":{n:"Wing War (1983) (Imagic) (PAL) [a]"},"0CDD9CC692E8B04BA8EB31FC31D72E5E":{n:"Wing War (Thomas Jentzsch)"},"8E48EA6EA53709B98E6F4BD8AA018908":{n:"Wings (06-03-1983) (CBS Electronics) (Prototype)",c:1},"827A22B9DFFEE24E93ED0DF09FF8414A":{n:"Wings (10-10-1983) (CBS Electronics) (Prototype) (PAL)",c:1},"83FAFD7BD12E3335166C6314B3BDE528":{n:"Winter Games (1987) (Epyx)"},"8C36ED2352801031516695D1EEEFE617":{n:"Winter Games (1987) (Epyx) (PAL)"},"6C1553CA90B413BF762DFC65F2B881C7":{n:"Winterjagd (1983) (Quelle) (PAL)"},"7B24BFE1B61864E758ADA1FE9ADAA098":{n:"Wizard (1980) (Atari) (Prototype)"},"3B86A27132FB74D9B35D4783605A1BCB":{n:"Wizard (1980) (Atari) (Prototype) (4K)"},"1F40EEFC7447336AE6CD8FFA5EB325BE":{n:"Wizard (1980) (Atari) (Prototype) (4K) [a]"},C43BD363E1F128E73BA5F0380B6FD7E3:{n:"Wizard (1980) (Atari) (Prototype) [a]"},"7E8AA18BC9502EB57DAAF5E7C1E94DA7":{n:"Wizard of Wor (1982) (CBS Electronics)",c:1},"663EF22EB399504D5204C543B8A86BCD":{n:"Wizard of Wor (1982) (CBS Electronics) (PAL)",c:1},EC3BEB6D8B5689E867BAFB5D5F507491:{n:"Word Zapper (1982) (U.S. Games)"},"3A53963F053B22599DB6AC9686F7722F":{n:"Word Zapper (208 in 1) (Unknown) (PAL)"},E1143B72A30D4D3FEE385EEC38B4AA4D:{n:"Word Zapper (Unknown)"},"37527966823EE9243D34C7DA8302774F":{n:"Word Zapper (Unknown) (PAL)"},"2FACD460A6828E0E476D3AC4B8C5F4F7":{n:"Words-Attack (1983) (Sancho) (PAL)",c:1},"130C5742CD6CBE4877704D733D5B08CA":{n:"World End (1983) (Home Vision) (PAL)"},E62E60A3E6CB5563F72982FCD83DE25A:{n:"World End (Jone Yuan)"},"87F020DAA98D0132E98E43DB7D8FEA7E":{n:"Worm War I (1982) (20th Century Fox)"},"007D18DEDC1F0565F09C42AA61A6F585":{n:"Worm War I (1983) (CCE)"},FB531FEBF8E155328EC0CD39EF77A122:{n:"Worm War I (208 in 1) (Unknown) (PAL)",c:1},"52B448757081FD9FABF859F4E2F91F6B":{n:"Worm War I (Unknown) (PAL)"},"5C0520C00163915A4336E481CA4E7EF4":{n:"Wuestenschlacht (1983) (Quelle) (PAL)"},"332F01FD18E99C6584F61AA45EE7791E":{n:"X'Mission (Unknown) (PAL)",c:1},"0D35618B6D76DDD46D2626E9E3E40DB5":{n:"X-Doom V.26 (PD)"},F613AAD84D2163D6B197B220BFEC1B7E:{n:"X-Doom V.27 (PD)"},"5961D259115E99C30B64FE7058256BCF":{n:"X-Man (1983) (Universal)"},"5E201D6BFC520424A28F129EE5E56835":{n:"X-Man (1983) (Universal) (PAL)"},F38358CD8F5ECFEDFFD5ACA1AA939F18:{n:"X-Man (1983) (Universal) [a]"},"9E2C7299C69B602443D327C7DAD51CBF":{n:"Xaxyrax Road (Charles Morgan) (Hack)"},"972486110933623039A3581DB308FDA6":{n:"Xeno Plus (Hack)"},EAF744185D5E8DEF899950BA7C6E7BB5:{n:"Xenophobe (1990) (Atari)"},F02BA8B5292BF3017D10553C9B7B2861:{n:"Xenophobe (1990) (Atari) (PAL)"},"5494B9EE403D9757F0FD1F749E80214A":{n:"Xenophobe Arcade (2003) (Larry Petit) (Hack)"},"284CA61B2407BDBA3938048B0A559015":{n:"Xevious (05-25-1983) (Atari) (Prototype)",c:1},C6688781F4AB844852F4E3352772289B:{n:"Xevious (08-02-1983) (Atari) (Prototype)",c:1},"24385BA7F5109FBE76AADC0A375DE573":{n:"Xevious (CCE)",c:1},D090836F0A4EA8DB9AC7ABB7D6ADF61E:{n:"Yahtzee (Hozer Video Games)",c:1},"096649575E451508006B17E0353259A5":{n:"Yar Vs. Yar (2002) (Justin J. Scott) (Hack)",c:1},"159E5CD6CCB968015F49AED5ADBC91EB":{n:"Yar's Defeat (2002) (Justin J. Scott) (Hack)",c:1},C5930D0E8CDAE3E037349BFA08E871BE:{n:"Yars' Revenge (1982) (Atari)",c:1},E91D2ECF8803AE52B55BBF105AF04D4B:{n:"Yars' Revenge (1982) (Atari) (PAL)",c:1},"75EA60884C05BA496473C23A58EDF12F":{n:"Yars' Revenge (1982) (Atari) (PAL) [a]",c:1},"5F681403B1051A0822344F467B05A94D":{n:"Yars' Revenge (1982) (Atari) [a]",c:1},"2F7772879A1ED04F660AA9D77A86A4BD":{n:"Yars' Revenge (Genesis)",c:1},"522C9CF684ECD72DB2F85053E6F6F720":{n:"Year 1999, The (Rainbow Vision) (PAL)"},"2179DFD7EDEE76EFAFE698C1BC763735":{n:"Yellow Submarine (Cody Pittman) (PD)"},"3856B9425CC0185ED770376A62AF0282":{n:"Yellow Submarine (Kyle Pittman) (Hack)"},C1E6E4E7EF5F146388A090F1C469A2FA:{n:"Z-Tack (1983) (Bomb)"},D6DC9B4508DA407E2437BFA4DE53D1B2:{n:"Z-Tack (1983) (Bomb) (PAL)"},"25BB080457351BE724AAC8A02021AA92":{n:"Zaxxon (1982) (CBS Electronics) (PAL)"},EEA0DA9B987D661264CCE69A7C13C3BD:{n:"Zaxxon (1982) (Coleco)"},"1367E41858BE525710EB04D0DAB53505":{n:"Zelda (2003) (Kyle Pittman) (Hack)"},C5A76BAFC4676EDB76E0126FB9F0FB2D:{n:"Zero Patrol (Charles Morgan) (Hack)"},"692202772D8B38CCF85A90C8003A1324":{n:"Zi - The Flie Buster (2002) (Fernando Mora) (PD)"},FB833ED50C865A9A505A125FC9D79A7E:{n:"Zoo Fun (1983) (Home Vision) (PAL)"},"0FCFF6FE3B0769AD5D0CF82814D2A6D9":{n:"Zoo Fun (Suntek) (PAL)"},A336BEAC1F0A835614200ECD9C41FD70:{n:"Zoo Keeper Sounds (1984) (Atari) (Prototype)"},"527B2893F202E0B4930E18E739C81EF4":{n:"Star Castle Arcade 124cu",l:"Star Castle Arcade",c:1},"2CEE5D587E6A2240233C93A5035D5748":{n:"Star Castle Arcade 124",l:"Star Castle Arcade",c:1},DCBDD2C1E201637C30369CE657E1B5CC:{n:"Star Castle Arcade 133cu",l:"Star Castle Arcade",c:1},B503531C719AECEF6E97C4961F97F5E8:{n:"Star Castle Arcade 133",l:"Star Castle Arcade",c:1},"33AB116244C57F6726D0D64BA9F5B6A4":{n:"Star Castle Arcade 140cu",l:"Star Castle Arcade",c:1},"15A6D61D04D50B5C4DC77964AF812469":{n:"Star Castle Arcade 140",l:"Star Castle Arcade",c:1}},jt.Cartridge=function(){this.powerOn=function(){},this.powerOff=function(){},this.connectBus=function(n){},this.connectSaveStateSocket=function(n){},this.read=function(n){},this.write=function(n,e){},this.needsBusMonitoring=function(){return!1},this.monitorBusBeforeRead=function(n,e){},this.monitorBusBeforeWrite=function(n,e){},this.needsAudioClock=function(){return!1},this.audioClockPulse=function(){},this.controlStateChanged=function(n,e){},this.controlValueChanged=function(n,e){},this.controlsStateReport=function(n){},this.saveState=function(){},this.loadState=function(n){},this.rom=null},jt.Cartridge.base=new jt.Cartridge,jt.Cartridge4K=function(r,a){var i;this.read=function(n){return i[n&e]},this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(i))}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),i=jt.Util.byteStringToUInt8Array(atob(n.b))};var e=4095;r&&function(n){n.rom=r,n.format=a,i=new Array(4096);for(var e=r.content.length,t=0;t<i.length;t+=e)jt.Util.arrayCopy(r.content,0,i,t,e)}(this)},jt.Cartridge4K.prototype=jt.Cartridge.base,jt.Cartridge4K.createFromSaveState=function(n){var e=new jt.Cartridge4K;return e.loadState(n),e},jt.Cartridge2K_CV=function(r,a){this.read=function(n){var e=o(n);return e<1024?A[e]:i[e]},this.write=function(n,e){var t=o(n);1024<=t&&t<=2047&&(A[t-1024]=e)};var i,o=function(n){return n&e};this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(i)),ra:btoa(jt.Util.uInt8ArrayToByteString(A))}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),i=jt.Util.byteStringToUInt8Array(atob(n.b)),A=jt.Util.byteStringToUInt8Array(atob(n.ra))};var A=jt.Util.arrayFill(new Array(1024),0),e=4095;r&&function(n){n.rom=r,n.format=a,i=new Array(4096);for(var e=r.content.length,t=0;t<i.length;t+=e)jt.Util.arrayCopy(r.content,0,i,t,e)}(this)},jt.Cartridge2K_CV.prototype=jt.Cartridge.base,jt.Cartridge2K_CV.createFromSaveState=function(n){var e=new jt.Cartridge2K_CV;return e.loadState(n),e},jt.CartridgeBankedByMaskedRange=function(t,r,a,i,o){this.read=function(n){var e=C(n);return l&&F<=e&&e<2*F?B[e-F]:A[c+e]},this.write=function(n,e){var t=C(n);t<F&&(l||s)&&(l=l||!0,B[t]=e)};var A,C=function(n){var e=n&u;return D<=e&&e<=E&&(c=d*(e-D)),e};this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(A)),bo:c,bb:D,es:F,tb:E,s:0|l,sa:0|s,e:B&&btoa(jt.Util.uInt8ArrayToByteString(B))}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),A=jt.Util.byteStringToUInt8Array(atob(n.b)),c=n.bo,D=n.bb,F=n.es,E=n.tb,l=!!n.s,s=!!n.sa,B=n.e&&jt.Util.byteStringToUInt8Array(atob(n.e))};var D,E,s,F,B,c=0,l=!1,u=4095,d=4096;t&&function(n){n.rom=t,n.format=r;var e=(A=t.content).length/d;E=(D=a)+e-1,F=o,s=null==i||null==i?!(l=!1):(l=!!i,!1),B=!1!==i?jt.Util.arrayFill(new Array(F),0):null}(this)},jt.CartridgeBankedByMaskedRange.prototype=jt.Cartridge.base,jt.CartridgeBankedByMaskedRange.createFromSaveState=function(n){var e=new jt.CartridgeBankedByMaskedRange;return e.loadState(n),e},jt.Cartridge8K_E0=function(n,e){this.read=function(n){var e=r(n);return e<1024?t[i+e]:e<2048?t[o+e-1024]:e<3072?t[A+e-2048]:t[4096+e]},this.write=function(n,e){r(n)};var t,r=function(n){var e=n&C;return 4064<=e&&e<=4087&&(e<=4071?i=1024*(e-4064):e<=4079?o=1024*(e-4072):e<=4087&&(A=1024*(e-4080))),e};this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),s0:i,s1:o,s2:A}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),i=n.s0,o=n.s1,A=n.s2};var a,i=0,o=0,A=0,C=4095;n&&((a=this).rom=n,a.format=e,t=n.content)},jt.Cartridge8K_E0.prototype=jt.Cartridge.base,jt.Cartridge8K_E0.createFromSaveState=function(n){var e=new jt.Cartridge8K_E0;return e.loadState(n),e},jt.Cartridge64K_F0=function(n,e){this.read=function(n){var e=r(n);return t[i+e]},this.write=function(n,e){r(n)};var t,r=function(n){var e=n&o;return e==D&&A<=(i+=C)&&(i=0),e};this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:i}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),i=n.bo};var a,i=0,o=4095,A=65536,C=4096,D=4080;n&&((a=this).rom=n,a.format=e,t=n.content)},jt.Cartridge64K_F0.prototype=jt.Cartridge.base,jt.Cartridge64K_F0.createFromSaveState=function(n){var e=new jt.Cartridge64K_F0;return e.loadState(n),e},jt.Cartridge8K_FE=function(n,e){this.read=function(n){var e=r(n);return t[i+e]},this.write=function(n,e){r(n)};var t,r=function(n){return 0!=(8192&n)?0!==i&&(i=0):i!=A&&(i=A),n&o};this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:i}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),i=n.bo};var a,i=0,o=4095,A=4096;n&&((a=this).rom=n,a.format=e,t=n.content)},jt.Cartridge8K_FE.prototype=jt.Cartridge.base,jt.Cartridge8K_FE.createFromSaveState=function(n){var e=new jt.Cartridge8K_FE;return e.loadState(n),e},jt.Cartridge16K_E7=function(n,e){this.read=function(n){var e=r(n);return 2304<=e&&e<=2559?A[D+e-2304]:C&&1024<=e&&e<=2047?A[e-1024]:e<F?t[i+e]:t[B+e]},this.write=function(n,e){var t=r(n);2048<=t&&t<=2303?A[D+t-2048]=e:C&&t<=1023&&(A[t]=e)};var t,r=function(n){var e=n&E;return 4064<=e&&e<=4075&&(e<=4070?i=s*(e-4064):4071==e?C=!0:e<=4075&&(D=o+c*(e-4072))),e};this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:i,rs:C,ro:D,ra:btoa(jt.Util.uInt8ArrayToByteString(A))}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),i=n.bo,C=n.rs,D=n.ro,A=jt.Util.byteStringToUInt8Array(atob(n.ra))};var a,i=0,o=1024,A=jt.Util.arrayFill(new Array(2048),0),C=!1,D=o,E=4095,s=2048,F=2048,B=16384-s-F,c=256;n&&((a=this).rom=n,a.format=e,t=n.content)},jt.Cartridge16K_E7.prototype=jt.Cartridge.base,jt.Cartridge16K_E7.createFromSaveState=function(n){var e=new jt.Cartridge16K_E7;return e.loadState(n),e},jt.Cartridge10K_DPCa=function(n,e){this.powerOn=function(){S=l,v=0},this.connectBus=function(n){E=n.getTia().getAudioOutput().getChannel0()},this.needsAudioClock=function(){return!0},this.read=function(n){var e=r(n);return e<=63||2048<=e&&e<=2111?a(255&e):s[d+e]},this.write=function(n,e){var t=r(n);(64<=t&&t<=127||2112<=t&&t<=2175)&&i(255&t,e)},this.audioClockPulse=function(){if((0|v)<(v+S|0))for(var n=5;n<=7;n++)g[n]&&(h[n]--,255==(255&h[n])&&o(n,65280&h[n]|p[n]),C(n),y=y||!0);v+=S,y&&(t(),E.setVolume(k))};var r=function(n){var e=n&c;return 4088==e?d=0:4089==e&&(d=4096),e},t=function(){k=B[(g[5]?4&m[5]:0)|(g[6]?2&m[6]:0)|(g[7]?1&m[7]:0)],y=!1},a=function(n){var e;return 0<=n&&n<=3?(D(),f):4<=n&&n<=7?(y&&t(),k):8<=n&&n<=15?(e=s[u-h[n-8]],A(n-8),e):16<=n&&n<=23?(e=s[u-h[n-16]]&m[n-16],A(n-16),e):24<=n&&n<=31?(e=s[u-h[n-24]]&m[n-24],A(n-24),e=240&e|15&e):32<=n&&n<=39?(e=s[u-h[n-32]]&m[n-32],A(n-32),e=128&e|64&e|32&e|16&e|8&e|4&e|2&e|1&e):40<=n&&n<=47?(e=s[u-h[n-40]]&m[n-40],A(n-40),e=255&(e>>>1|e<<7)):48<=n&&n<=55?(e=s[u-h[n-48]]&m[n-48],A(n-48),e=255&(e<<1|e>>7&1)):56<=n&&n<=63?m[n-56]:0},i=function(n,e){if(64<=n&&n<=71){var t=n-64;return p[t]=e,void((255&h[t])===p[t]&&(m[t]=255))}if(72<=n&&n<=79)return P[n-72]=e,void(m[n-72]=0);if(80<=n&&n<=87)o(n-80,65280&h[n-80]|255&e);else if(88<=n&&n<=91)o(n-88,255&h[n-88]|(7&e)<<8);else{if(92!=n)return 93<=n&&n<=95?(o(n-88,(255&h[n-88])+((7&e)<<8)),void(g[n-88]=(16&e)>>>4)):void(96<=n&&n<=103||112<=n&&n<=119&&(f=0));o(4,255&h[4]|(7&e)<<8)}},o=function(n,e){h[n]=e},A=function(n){var e=h[n]-1;e<0&&(e=2047),o(n,e),C(n)},C=function(n){var e=255&h[n];e==p[n]?m[n]=255:e==P[n]&&(m[n]=0)},D=function(){255===(f=255&(f<<1|1&~(f>>7^f>>5^f>>4^f>>3)))&&(f=0)};this.controlStateChanged=function(n,e){if(e)switch(n){case jt.ConsoleControls.CARTRIDGE_CLOCK_DEC:S<1&&(S+=.01),jt.Util.log("DPC audio clock factor: "+S);break;case jt.ConsoleControls.CARTRIDGE_CLOCK_INC:.3<S&&(S-=.01),jt.Util.log("DPC audio clock factor: "+S)}},this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(s)),bo:d,rn:f,fp:btoa(jt.Util.uInt8ArrayToByteString(h)),fs:btoa(jt.Util.uInt8ArrayToByteString(p)),fe:btoa(jt.Util.uInt8ArrayToByteString(P)),fm:btoa(jt.Util.uInt8ArrayToByteString(m)),a:btoa(jt.Util.uInt8ArrayToByteString(g))}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),s=jt.Util.byteStringToUInt8Array(atob(n.b)),d=n.bo,f=n.rn,h=jt.Util.byteStringToUInt8Array(atob(n.fp)),p=jt.Util.byteStringToUInt8Array(atob(n.fs)),P=jt.Util.byteStringToUInt8Array(atob(n.fe)),m=jt.Util.byteStringToUInt8Array(atob(n.fm)),g=jt.Util.byteStringToUInt8Array(atob(n.a))};var E,s,F,B=[0,5,5,10,5,10,10,15],c=4095,l=.62,u=10239,d=0,f=0,h=jt.Util.arrayFill(new Array(8),0),p=jt.Util.arrayFill(new Array(8),0),P=jt.Util.arrayFill(new Array(8),0),m=jt.Util.arrayFill(new Array(8),0),g=jt.Util.arrayFill(new Array(8),0),S=l,v=0,y=!0,k=0;n&&((F=this).rom=n,F.format=e,s=n.content)},jt.Cartridge10K_DPCa.prototype=jt.Cartridge.base,jt.Cartridge10K_DPCa.createFromSaveState=function(n){var e=new jt.Cartridge10K_DPCa;return e.loadState(n),e},jt.Cartridge24K_28K_32K_FA2=function(t,r,a){var n=this;this.connectBus=function(n){e=n},this.connectSaveStateSocket=function(n){i=n},this.read=function(n){var e=A(n),t=256<=e&&e<512?d[e-256]:o[l+e];if(e!==g)return t;if(0===h){var r=d[S];if(1===r||2===r)return C(r),64|t}return 0===h?191&t:(s(),0!==h?64|t:191&t)},this.write=function(n,e){var t=A(n);t<256&&(d[t]=e)};var e,i,o,A=function(n){var e=n&P;return u<=e&&e<=B&&(l=c+m*(e-u)),e},C=function(n){h=n,f=Date.now(),1===n?D():2===n&&E()},D=function(){var n;e.getTia().getVideoOutput().showOSD("Reading from Cartridge Flash Memory...",!0),!i||(n=i.getMedia().loadResourceFromFile(F()))&&(p=jt.Util.byteStringToUInt8Array(atob(n))),d=p.slice(0)},E=function(){e.getTia().getVideoOutput().showOSD("Writing to Cartridge Flash Memory...",!0),p=d.slice(0),i&&i.getMedia().saveResourceToFile(F(),btoa(jt.Util.uInt8ArrayToByteString(p)))},s=function(){1100<Date.now()-f&&(f=Date.now(),h=0,d[S]=0,e.getTia().getVideoOutput().showOSD("Done.",!0),i&&i.externalStateChange())},F=function(){return"hfm"+n.rom.info.h};this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(o)),rs:c,bo:l,tb:B,e:btoa(jt.Util.uInt8ArrayToByteString(d)),ho:h,ht:f}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),o=jt.Util.byteStringToUInt8Array(atob(n.b)),c=n.rs||0,l=n.bo,B=n.tb,d=jt.Util.byteStringToUInt8Array(atob(n.e)),h=n.ho||0,f=Date.now()};var B,c=0,l=0,u=4085,d=jt.Util.arrayFill(new Array(256),0),f=Date.now(),h=0,p=jt.Util.arrayFill(new Array(256),0),P=4095,m=4096,g=4084,S=255;t&&function(n){n.rom=t,n.format=r,o=t.content,l=c=a||0;var e=(o.length-c)/m;B=u+e-1}(this)},jt.Cartridge24K_28K_32K_FA2.prototype=jt.Cartridge.base,jt.Cartridge24K_28K_32K_FA2.createFromSaveState=function(n){var e=new jt.Cartridge24K_28K_32K_FA2;return e.loadState(n),e},jt.CartridgeBankedByBusMonitoring=function(n,e){this.needsBusMonitoring=function(){return!0},this.monitorBusBeforeRead=function(n,e){this.performBankSwitchOnMonitoredAccess(n)},this.monitorBusBeforeWrite=function(n,e){this.performBankSwitchOnMonitoredAccess(n)},this.performBankSwitchOnMonitoredAccess=function(n){}},jt.CartridgeBankedByBusMonitoring.prototype=jt.Cartridge.base,jt.CartridgeBankedByBusMonitoring.base=new jt.CartridgeBankedByBusMonitoring,jt.Cartridge8K_512K_3F=function(n,e){var t;this.read=function(n){var e=n&A;return D<=e?t[a+e]:t[o+e]},this.monitorBusBeforeWrite=function(n,e){var t;n<=63&&((t=255&e)<=r&&(o=t*C))},this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:o,sm:r,fo:a}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),o=n.bo,r=n.sm,a=n.fo};var r,a,i,o=0,A=4095,C=2048,D=2048;n&&((i=this).rom=n,i.format=e,t=n.content,r=(t.length-C)/C-1,a=t.length-2*C)},jt.Cartridge8K_512K_3F.prototype=jt.CartridgeBankedByBusMonitoring.base,jt.Cartridge8K_512K_3F.createFromSaveState=function(n){var e=new jt.Cartridge8K_512K_3F;return e.loadState(n),e},jt.Cartridge8K_512K_3E=function(n,e){this.read=function(n){var e=r(n);return B<=e?t[i+e]:0<=D&&e<1024?E[D+e]||0:t[C+e]},this.write=function(n,e){var t;D<0||1024<=(t=r(n))&&t<=2047&&(E[D+t-1024]=e)};var t,r=function(n){return n&s};this.monitorBusBeforeWrite=function(n,e){var t;63!==n?62===n&&(D=(255&e)*A):(t=255&e)<=a&&(C=t*F,D=-1)},this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:C,sm:a,fo:i,ro:D,ra:btoa(jt.Util.uInt8ArrayToByteString(E))}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),C=n.bo,a=n.sm,i=n.fo,D=n.ro,E=jt.Util.byteStringToUInt8Array(atob(n.ra))};var a,i,o,A=1024,C=0,D=-1,E=jt.Util.arrayFill(new Array(A),0),s=4095,F=2048,B=2048;n&&((o=this).rom=n,o.format=e,t=n.content,a=(t.length-F)/F-1,i=t.length-2*F)},jt.Cartridge8K_512K_3E.prototype=jt.CartridgeBankedByBusMonitoring.base,jt.Cartridge8K_512K_3E.createFromSaveState=function(n){var e=new jt.Cartridge8K_512K_3E;return e.loadState(n),e},jt.Cartridge8K_256K_SB=function(n,e){var t;this.read=function(n){return t[i+(n&o)]},this.performBankSwitchOnMonitoredAccess=function(n){var e;2048==(6144&n)&&(r<(e=127&n)||(i=e*A))},this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:i,m:r}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),i=n.bo,r=n.m};var r,a,i=0,o=4095,A=4096;n&&((a=this).rom=n,a.format=e,t=n.content,r=t.length/A-1)},jt.Cartridge8K_256K_SB.prototype=jt.CartridgeBankedByBusMonitoring.base,jt.Cartridge8K_256K_SB.createFromSaveState=function(n){var e=new jt.Cartridge8K_256K_SB;return e.loadState(n),e},jt.Cartridge8K_64K_AR=function(o,n){this.powerOn=function(){a(0),y=0},this.connectBus=function(n){t=n},this.read=function(n){return r<I?A[l+r]:A[u+r-I]},this.write=function(n,e){u===M&&w<=r&&r<w+256&&i(r-w)},this.performBankSwitchOnMonitoredAccess=function(n){r=n&U,8184!=(n&=8191)?0<P?n!==p&&(p=n,0==--P&&(n&x)===V&&(r<I?A[l+r]=f:u<M&&(A[u+r-I]=f))):(n&x)===V&&r<=255&&(f=r,h&&(p=n,P=5)):a(f)};var t,A,r,C,e,a=function(n){switch(n>>2&7){case 0:l=2*I,u=M;break;case 1:l=0*I,u=M;break;case 2:l=2*I,u=0*I;break;case 3:l=0*I,u=2*I;break;case 4:l=2*I,u=M;break;case 5:l=+I,u=M;break;case 6:l=2*I,u=+I;break;case 7:l=+I,u=2*I;break;default:throw new Error("Invalid bank configuration")}h=(P=0)!=(2&n),0},i=function(n){for(var e=!1;;){if(y>o.content.length-1){if(e)return 0===n?t.getTia().getVideoOutput().showOSD("Could not load Tape from Start. Not a Start Tape ROM!",!0):t.getTia().getVideoOutput().showOSD("Could not find next Part to load in Tape!",!0),void B(!1);e=!(y=0)}if(jt.Cartridge8K_64K_AR.peekPartNoOnTape(o.content,y)===n)return 0===n?t.getTia().getVideoOutput().showOSD("Loaded Tape from Start",!0):t.getTia().getVideoOutput().showOSD("Loaded next Part from Tape",!0),void D();y+=K}},D=function(){E(),s(),F()},E=function(){jt.Util.arrayCopy(o.content,y+4*I,d,0,d.length),m=d[1]<<8|255&d[0],g=d[2],S=d[3],d[4],v=d[5],d[7],d[6],C=jt.Util.arrayFill(new Array(S),0),jt.Util.arrayCopy(d,16,C,0,S)},s=function(){jt.Util.arrayFillSegment(A,7*R,8*R-1,0);for(var n=y,e=0,t=C.length;e<t;e++){var r=C[e],a=(3&r)*I,i=(r>>2)*R;a+i+255<M&&jt.Util.arrayCopy(o.content,n,A,a+i,R),n+=R}y+=K},F=function(){A[M+L-63488]=g,A[M+k-63488]=v,A[M+T-63488]=256*Math.random()|0,A[M+b-63488]=255&m,A[M+b+1-63488]=m>>8&255,B(!0)},B=function(n){A[M+_-63488]=n?1:0},c=function(){var n=JSZip.compressions.DEFLATE.uncompress(jt.Util.byteStringToUInt8Array(atob(O)));jt.Util.arrayCopy(n,0,A,M,I)},l=0,u=0,d=jt.Util.arrayFill(new Array(256),0),f=0,h=!1,p=-1,P=0,m=0,g=0,S=0,v=0,y=0,k=64256,L=64257,b=64258,T=64260,_=64261,w=3072,R=256,I=8*R,M=3*I,K=4*I+256,O="7dSxCsIwEAbgv6niGkeddPVZ8kCOXc43yCIokkGIUN+gLxAoZHTxHRxjYq2xk7vSIPS75bb7uYNTuOJWu/bod3iU42BzUTiBe9sTzSjToBnNBVxfQz/nQ+2NhA2a05KYmhhjmxhoQZymxGil8gpeesOdyioW5DN25yxsiri3chQOUO1WeCSI/hPx9AJ/m/576KROMUhlfdE4dQ+AfJoPNBikgOZdLw==",U=4095,x=4096,V=4096;this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(A))}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),A=jt.Util.byteStringToUInt8Array(atob(n.b))},o&&((e=this).rom=o,e.format=n,A=jt.Util.arrayFill(new Array(4*I)),c())},jt.Cartridge8K_64K_AR.prototype=jt.CartridgeBankedByBusMonitoring.base,jt.Cartridge8K_64K_AR.createFromSaveState=function(n){var e=new jt.Cartridge8K_64K_AR;return e.loadState(n),e},jt.Cartridge8K_64K_AR.HEADER_SIZE=256,jt.Cartridge8K_64K_AR.PAGE_SIZE=256,jt.Cartridge8K_64K_AR.BANK_SIZE=8*jt.Cartridge8K_64K_AR.PAGE_SIZE,jt.Cartridge8K_64K_AR.PART_SIZE=4*jt.Cartridge8K_64K_AR.BANK_SIZE+jt.Cartridge8K_64K_AR.HEADER_SIZE,jt.Cartridge8K_64K_AR.peekPartNoOnTape=function(n,e){return n[e+4*jt.Cartridge8K_64K_AR.BANK_SIZE+5]},jt.Cartridge8K_64K_AR.checkTape=function(n){if(0!=jt.Cartridge8K_64K_AR.peekPartNoOnTape(n.content,0)){var e=new Error("Wrong Supercharger Tape Part ROM!\nPlease load a Full Tape ROM file.");throw e.formatDenial=!0,e}},jt.Cartridge64K_X07=function(n,e){var t;this.read=function(n){return t[a+(n&i)]},this.performBankSwitchOnMonitoredAccess=function(n){2061==(6159&n)?a=((240&n)>>4)*o:A<=a&&0==(6272&n)&&(a=(0==(64&n)?14:15)*o)},this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:a}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),a=n.bo};var r,a=0,i=4095,o=4096,A=14*o;n&&((r=this).rom=n,r.format=e,t=n.content)},jt.Cartridge64K_X07.prototype=jt.CartridgeBankedByBusMonitoring.base,jt.Cartridge64K_X07.createFromSaveState=function(n){var e=new jt.Cartridge64K_X07;return e.loadState(n),e},jt.Cartridge8K_0840=function(n,e){var t;this.read=function(n){return t[a+(n&i)]},this.performBankSwitchOnMonitoredAccess=function(n){var e=6208&n;2048==e?0!==a&&(a=0):2112==e&&a!==o&&(a=o)},this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:a}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),a=n.bo};var r,a=0,i=4095,o=4096;n&&((r=this).rom=n,r.format=e,t=n.content)},jt.Cartridge8K_0840.prototype=jt.CartridgeBankedByBusMonitoring.base,jt.Cartridge8K_0840.createFromSaveState=function(n){var e=new jt.Cartridge8K_0840;return e.loadState(n),e},jt.Cartridge8K_UA=function(n,e){var t;this.read=function(n){return t[a+(n&i)]},this.performBankSwitchOnMonitoredAccess=function(n){544===n?0!==a&&(a=0):576===n&&a!==o&&(a=o)},this.saveState=function(){return{f:this.format.name,r:this.rom.saveState(),b:btoa(jt.Util.uInt8ArrayToByteString(t)),bo:a}},this.loadState=function(n){this.format=jt.CartridgeFormats[n.f],this.rom=jt.ROM.loadState(n.r),t=jt.Util.byteStringToUInt8Array(atob(n.b)),a=n.bo};var r,a=0,i=4095,o=4096;n&&((r=this).rom=n,r.format=e,t=n.content)},jt.Cartridge8K_UA.prototype=jt.CartridgeBankedByBusMonitoring.base,jt.Cartridge8K_UA.createFromSaveState=function(n){var e=new jt.Cartridge8K_UA;return e.loadState(n),e},jt.CartridgeFormats={"4K":{name:"4K",desc:"4K Atari",priority:101,tryFormat:function(n){if(8<=n.content.length&&n.content.length<=4096&&4096%n.content.length==0)return this},createCartridgeFromRom:function(n){return new jt.Cartridge4K(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge4K.createFromSaveState(n)}},CV:{name:"CV",desc:"2K Commavid +RAM",priority:102,tryFormat:function(n){if(2048===n.content.length||4096===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge2K_CV(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge2K_CV.createFromSaveState(n)}},E0:{name:"E0",desc:"8K Parker Bros.",priority:102,tryFormat:function(n){if(8192===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge8K_E0(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge8K_E0.createFromSaveState(n)}},F0:{name:"F0",desc:"64K Dynacom Megaboy",priority:101,tryFormat:function(n){if(65536===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge64K_F0(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge64K_F0.createFromSaveState(n)}},FE:{name:"FE",desc:"8K Robotank/Decathlon",priority:103,tryFormat:function(n){if(8192===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge8K_FE(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge8K_FE.createFromSaveState(n)}},E7:{name:"E7",desc:"16K M-Network",priority:102,tryFormat:function(n){if(16384===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge16K_E7(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge16K_E7.createFromSaveState(n)}},F8:{name:"F8",desc:"8K Atari (+RAM)",priority:101,tryFormat:function(n){if(8192===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.CartridgeBankedByMaskedRange(n,this,4088,null,128)},createCartridgeFromSaveState:function(n){return jt.CartridgeBankedByMaskedRange.createFromSaveState(n)}},F6:{name:"F6",desc:"16K Atari (+RAM)",priority:101,tryFormat:function(n){if(16384===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.CartridgeBankedByMaskedRange(n,this,4086,null,128)},createCartridgeFromSaveState:function(n){return jt.CartridgeBankedByMaskedRange.createFromSaveState(n)}},F4:{name:"F4",desc:"32K Atari (+RAM)",priority:101,tryFormat:function(n){if(32768===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.CartridgeBankedByMaskedRange(n,this,4084,null,128)},createCartridgeFromSaveState:function(n){return jt.CartridgeBankedByMaskedRange.createFromSaveState(n)}},FA2cu:{name:"FA2cu",desc:"32K CBS RAM Plus CU Image",priority:103,tryFormat:function(n){if(32768===n.content.length){var e=jt.Util.arraysEqual(n.content.slice(32,36),this.cuMagicWord);return this.priority=103-(e?30:0),this}},createCartridgeFromRom:function(n){return new jt.Cartridge24K_28K_32K_FA2(n,this,1024)},createCartridgeFromSaveState:function(n){return jt.Cartridge24K_28K_32K_FA2.createFromSaveState(n)},cuMagicWord:[30,171,173,16]},FA2:{name:"FA2",desc:"24K/28K/32K CBS RAM Plus",priority:102,tryFormat:function(n){if(24576===n.content.length||28672===n.content.length||32768===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge24K_28K_32K_FA2(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge24K_28K_32K_FA2.createFromSaveState(n)}},FA:{name:"FA",desc:"12K CBS RAM Plus",priority:101,tryFormat:function(n){if(12288===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.CartridgeBankedByMaskedRange(n,this,4088,!0,256)},createCartridgeFromSaveState:function(n){return jt.CartridgeBankedByMaskedRange.createFromSaveState(n)}},EF:{name:"EF",desc:"8K-64K H. Runner (+RAM)",priority:114,tryFormat:function(n){if(n.content.length%4096==0&&8192<=n.content.length&&n.content.length<=65536)return this},createCartridgeFromRom:function(n){return new jt.CartridgeBankedByMaskedRange(n,this,4064,null,128)},createCartridgeFromSaveState:function(n){return jt.CartridgeBankedByMaskedRange.createFromSaveState(n)}},DPCa:{name:"DPCa",desc:"10K DPC Pitfall 2 (Enhanced Audio)",priority:101,tryFormat:function(n){if(10240<=n.content.length&&n.content.length<=10496)return this},createCartridgeFromRom:function(n){return new jt.Cartridge10K_DPCa(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge10K_DPCa.createFromSaveState(n)}},"3F":{name:"3F",desc:"8K-512K Tigervision",priority:112,tryFormat:function(n){if(n.content.length%2048==0&&n.content.length<=524288)return this},createCartridgeFromRom:function(n){return new jt.Cartridge8K_512K_3F(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge8K_512K_3F.createFromSaveState(n)}},"3E":{name:"3E",desc:"8K-512K Tigervision (+RAM)",priority:111,tryFormat:function(n){if(n.content.length%2048==0&&n.content.length<=524288)return this},createCartridgeFromRom:function(n){return new jt.Cartridge8K_512K_3E(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge8K_512K_3E.createFromSaveState(n)}},X07:{name:"X07",desc:"64K AtariAge",priority:102,tryFormat:function(n){if(65536===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge64K_X07(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge64K_X07.createFromSaveState(n)}},"0840":{name:"0840",desc:"8K Econobanking",priority:116,tryFormat:function(n){if(8192===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge8K_0840(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge8K_0840.createFromSaveState(n)}},UA:{name:"UA",desc:"8K UA Limited",priority:115,tryFormat:function(n){if(8192===n.content.length)return this},createCartridgeFromRom:function(n){return new jt.Cartridge8K_UA(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge8K_UA.createFromSaveState(n)}},SB:{name:"SB",desc:"8K-256K Superbanking",priority:113,tryFormat:function(n){if(n.content.length%4096==0&&8192<=n.content.length&&n.content.length<=262144)return this},createCartridgeFromRom:function(n){return new jt.Cartridge8K_256K_SB(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge8K_256K_SB.createFromSaveState(n)}},AR:{name:"AR",desc:"8K-64K Arcadia/Starpath/Supercharger",priority:101,tryFormat:function(n){if(n.content.length%jt.Cartridge8K_64K_AR.PART_SIZE==0&&1<=n.content.length/jt.Cartridge8K_64K_AR.PART_SIZE&&n.content.length/jt.Cartridge8K_64K_AR.PART_SIZE<=8)return jt.Cartridge8K_64K_AR.checkTape(n),this},createCartridgeFromRom:function(n){return new jt.Cartridge8K_64K_AR(n,this)},createCartridgeFromSaveState:function(n){return jt.Cartridge8K_64K_AR.createFromSaveState(n)}}},jt.CartridgeDatabase=function(){this.createCartridgeFromRom=function(n){var e=r(n);if(0!==e.length){var t=e[0];return jt.Util.log(t.name+": "+t.desc+", priority: "+t.priority+(t.priorityBoosted?" ("+t.priorityBoosted+")":"")),t.createCartridgeFromRom(n)}},this.createCartridgeFromSaveState=function(n){var e=jt.CartridgeFormats[n.f];if(e)return e.createCartridgeFromSaveState(n);var t=new Error("Unsupported ROM Format: "+n.f);throw t.javatari=!0,t},this.produceInfo=function(n){var e=n.content.length,t=jt.MD5(n.content);n.content.length>e&&n.content.splice(e);var r=jt.CartridgeInfoLibrary[t];return r?jt.Util.log(""+r.n):(r=a(n.source),jt.Util.log("Unknown ROM: "+r.n)),i(r,n.source,t),r};var r=function(n){var e,t,r=[];for(var a in jt.CartridgeFormats)try{if(!(e=jt.CartridgeFormats[a].tryFormat(n)))continue;o(e,n.info),r.push(e)}catch(i){if(!i.formatDenial)throw i;t=t||i}if(0!==r.length)return r.sort(function(n,e){return(n.priorityBoosted||n.priority)-(e.priorityBoosted||e.priority)}),r;var i=t||new Error("Unsupported ROM Format. Size: "+n.content.length);throw i.javatari=!0,i},a=function(n){var e={n:"Unknown"};if(!n||!n.trim())return e;var t=n,r=t.lastIndexOf("/"),a=t.lastIndexOf("\\"),i=t.lastIndexOf("?"),o=Math.max(r,Math.max(a,i));0<=o&&o<t.length-1&&(t=t.substring(o+1));var A=t.lastIndexOf(".");return 0<=A&&(t=t.substring(0,A)),e.n=t.trim()||"Unknown",e},i=function(n,e,t){n.h=t,n.l||(n.l=A(n.n));var r=n.n.toUpperCase();n:if(!n.p&&(n.p=0,!r.match(B+"JOYSTICK(S)?"+c)))if(r.match(B+"PADDLE(S)?"+c))n.p=1;else for(var a=0;a<s.length;a++)if(r.match(s[a])){n.p=1;break n}n:if(!n.c)if(r.match(B+"CRT(_|-)?MODE"+c))n.c=1;else for(a=0;a<F.length;a++)if(r.match(F[a])){n.c=1;break n}n:if(!n.f){var i=e.toUpperCase();for(var o in jt.CartridgeFormats)if(C(o,r)||C(o,i)){n.f=o;break n}for(o in E)if(D(o,r)){n.f=o;break n}}},o=function(n,e){e.f&&n.name===e.f?n.priorityBoosted=n.priority-t:n.priorityBoosted=void 0},A=function(n){return n.split(/(\(|\[)/)[0].trim()},C=function(n,e){return e.match(B+n+c)},D=function(n,e){var t=E[n];if(!t)return!1;for(var r=0;r<t.length;r++)if(e.match(t[r]))return!0;return!1},E={E0:["^.*MONTEZUMA.*$","^.*MONTZREV.*$","^.*GYRUS.*$","^.*TOOTH.*PROTECTORS.*$","^.*TOOTHPRO.*$","^.*DEATH.*STAR.*BATTLE.*$","^.*DETHSTAR.*$","^.*JAMES.*BOND.*$","^.*JAMEBOND.*$","^.*SUPER.*COBRA.*$","^.*SPRCOBRA.*$","^.*TUTANKHAM.*$","^.*TUTANK.*$","^.*POPEYE.*$","^.*(SW|STAR.?WARS).*ARCADE.*GAME.*$","^.*SWARCADE.*$","^.*Q.*BERT.*QUBES.*$","^.*QBRTQUBE.*$","^.*FROGGER.?(2|II).*$","^.*DO.*CASTLE.*$"],FE:["^.*ROBOT.*TANK.*$","^.*ROBOTANK.*$","^.*DECATHLON.*$","^.*DECATHLN.*$"],E7:["^.*BUMP.*JUMP.*$","^.*BNJ.*$","^.*BURGER.*TIME.*$","^.*BURGTIME.*$","^.*POWER.*HE.?MAN.*$","^.*HE_MAN.*$"],"3F":["^.*POLARIS.*$","^.*RIVER.*PATROL.*$","^.*RIVERP.*$","^.*SPRINGER.*$","^.*MINER.*2049.*$","^.*MNR2049R.*$","^.*MINER.*2049.*VOLUME.*$","^.*MINRVOL2.*$","^.*ESPIAL.*$","^.*ANDREW.*DAVIE.*$","^.*DEMO.*IMAGE.*AD.*$"],"3E":["^.*BOULDER.*DASH.*$","^.*BLDRDASH.*$"],DPCa:["^.*PITFALL.*(2|II).*$"]},s=["^.*PADDLES.*$","^.*BREAKOUT.*$","^.*SUPER.*BREAKOUT.*$","^.*SUPERB.*$","^.*WARLORDS.*$","^.*STEEPLE.*CHASE.*$","^.*STEPLCHS.*$","^.*VIDEO.*OLYMPICS.*$","^.*VID(|_)OLYM(|P).*$","^.*CIRCUS.*ATARI.*$","^.*CIRCATRI.*$","^.*KABOOM.*$","^.*BUGS((?!BUNNY).)*","^.*BACHELOR.*PARTY.*$","^.*BACHELOR.*$","^.*BACHELORETTE.*PARTY.*$","^.*BACHLRTT.*$","^.*BEAT.*EM.*EAT.*EM.*$","^.*BEATEM.*$","^.*PHILLY.*FLASHER.*$","^.*PHILLY.*$","^.*JEDI.*ARENA.*$","^.*JEDIAREN.*$","^.*EGGOMANIA.*$","^.*EGGOMANA.*$","^.*PICNIC.*$","^.*PIECE.*O.*CAKE.*$","^.*PIECECKE.*$","^.*BACKGAMMON.*$","^.*BACKGAM.*$","^.*BLACKJACK.*$","^.*BLACK(|_)J.*$","^.*CANYON.*BOMBER.*$","^.*CANYONB.*$","^.*CASINO.*$","^.*DEMONS.*DIAMONDS.*$","^.*DEMONDIM.*$","^.*DUKES.*HAZZARD.*2.*$","^.*STUNT.?2.*$","^.*ENCOUNTER.*L.?5.*$","^.*ENCONTL5.*$","^.*G.*I.*JOE.*COBRA.*STRIKE.*$","^.*GIJOE.*$","^.*GUARDIAN.*$","^.*MARBLE.*CRAZE.*$","^.*MARBCRAZ.*$","^.*MEDIEVAL.*MAYHEM.*$","^.*MONDO.*PONG.*$","^.*NIGHT.*DRIVER.*$","^.*NIGHTDRV.*$","^.*PARTY.*MIX.*$","^.*POKER.*PLUS.*$","^.*PONG.*SPORTS.*$","^.*SCSICIDE.*$","^.*SECRET.*AGENT.*$","^.*SOLAR.*STORM.*$","^.*SOLRSTRM.*$","^.*SPEEDWAY.*$","^.*STREET.*RACER.*$","^.*STRTRACE.*$","^.*STUNT.*CYCLE.*$","^.*STUNT.?1.*$","^.*TAC.?SCAN.*$","^.*MUSIC.*MACHINE.*$","^.*MUSCMACH.*$","^.*VONG.*$","^.*WARPLOCK.*$"],F=["^.*STAR.*CASTLE.*$","^.*SEAWEED.*$","^.*ANDREW.*DAVIE.*$","^.*DEMO.*IMAGE.*AD.*$"],B="^(|.*?(\\W|_|%20))",c="(|(\\W|_|%20).*)$",t=50},jt.CartridgeDatabase=new jt.CartridgeDatabase,jt.MD5=function(n){function B(n,e,t){return n&e|~n&t}function c(n,e,t){return t&n|~t&e}function l(n,e){return n[e+3]<<24|n[e+2]<<16|n[e+1]<<8|n[e]}function r(n){for(var e=[],t=0;t<n.length;t++)if(n.charCodeAt(t)<=127)e.push(n.charCodeAt(t));else for(var r=encodeURIComponent(n.charAt(t)).substr(1).split("%"),a=0;a<r.length;a++)e.push(parseInt(r[a],16));return e}function e(n){for(var e=new Array(n.length),t=0;t<n.length;t++)e[t]=n[t];return e}function u(n,e){return 4294967295&n+e}var d=null,t=null;return"string"==typeof n?d=r(n):n.constructor==Array?0===n.length?d=n:"string"==typeof n[0]?d=function(n){for(var e=[],t=0;t<n.length;t++)e=e.concat(r(n[t]));return e}(n):"number"==typeof n[0]?d=n:t=typeof n[0]:"undefined"!=typeof ArrayBuffer?n instanceof ArrayBuffer?d=e(new Uint8Array(n)):n instanceof Uint8Array||n instanceof Int8Array?d=e(n):n instanceof Uint32Array||n instanceof Int32Array||n instanceof Uint16Array||n instanceof Int16Array||n instanceof Float32Array||n instanceof Float64Array?d=e(new Uint8Array(n.buffer)):t=typeof n:t=typeof n,t&&alert("MD5 type mismatch, cannot process "+t),function(){function n(n,e,t,r){var a,i,o=s;s=E,D=u(E=D,(a=u(C,u(n,u(e,t))))<<(i=r)&4294967295|a>>>32-i),C=o}var e=d.length;d.push(128);var t=d.length%64;if(56<t){for(var r=0;r<64-t;r++)d.push(0);t=d.length%64}for(r=0;r<56-t;r++)d.push(0);d=d.concat(function(n){for(var e=[],t=0;t<8;t++)e.push(255&n),n>>>=8;return e}(8*e));for(var a=1732584193,i=4023233417,o=2562383102,A=271733878,C=0,D=0,E=0,s=0,r=0;r<d.length/64;r++){C=a;var F=64*r;n(B(D=i,E=o,s=A),3614090360,l(d,F),7),n(B(D,E,s),3905402710,l(d,4+F),12),n(B(D,E,s),606105819,l(d,8+F),17),n(B(D,E,s),3250441966,l(d,12+F),22),n(B(D,E,s),4118548399,l(d,16+F),7),n(B(D,E,s),1200080426,l(d,20+F),12),n(B(D,E,s),2821735955,l(d,24+F),17),n(B(D,E,s),4249261313,l(d,28+F),22),n(B(D,E,s),1770035416,l(d,32+F),7),n(B(D,E,s),2336552879,l(d,36+F),12),n(B(D,E,s),4294925233,l(d,40+F),17),n(B(D,E,s),2304563134,l(d,44+F),22),n(B(D,E,s),1804603682,l(d,48+F),7),n(B(D,E,s),4254626195,l(d,52+F),12),n(B(D,E,s),2792965006,l(d,56+F),17),n(B(D,E,s),1236535329,l(d,60+F),22),n(c(D,E,s),4129170786,l(d,4+F),5),n(c(D,E,s),3225465664,l(d,24+F),9),n(c(D,E,s),643717713,l(d,44+F),14),n(c(D,E,s),3921069994,l(d,F),20),n(c(D,E,s),3593408605,l(d,20+F),5),n(c(D,E,s),38016083,l(d,40+F),9),n(c(D,E,s),3634488961,l(d,60+F),14),n(c(D,E,s),3889429448,l(d,16+F),20),n(c(D,E,s),568446438,l(d,36+F),5),n(c(D,E,s),3275163606,l(d,56+F),9),n(c(D,E,s),4107603335,l(d,12+F),14),n(c(D,E,s),1163531501,l(d,32+F),20),n(c(D,E,s),2850285829,l(d,52+F),5),n(c(D,E,s),4243563512,l(d,8+F),9),n(c(D,E,s),1735328473,l(d,28+F),14),n(c(D,E,s),2368359562,l(d,48+F),20),n(D^E^s,4294588738,l(d,20+F),4),n(D^E^s,2272392833,l(d,32+F),11),n(D^E^s,1839030562,l(d,44+F),16),n(D^E^s,4259657740,l(d,56+F),23),n(D^E^s,2763975236,l(d,4+F),4),n(D^E^s,1272893353,l(d,16+F),11),n(D^E^s,4139469664,l(d,28+F),16),n(D^E^s,3200236656,l(d,40+F),23),n(D^E^s,681279174,l(d,52+F),4),n(D^E^s,3936430074,l(d,F),11),n(D^E^s,3572445317,l(d,12+F),16),n(D^E^s,76029189,l(d,24+F),23),n(D^E^s,3654602809,l(d,36+F),4),n(D^E^s,3873151461,l(d,48+F),11),n(D^E^s,530742520,l(d,60+F),16),n(D^E^s,3299628645,l(d,8+F),23),n(E^(D|~s),4096336452,l(d,F),6),n(E^(D|~s),1126891415,l(d,28+F),10),n(E^(D|~s),2878612391,l(d,56+F),15),n(E^(D|~s),4237533241,l(d,20+F),21),n(E^(D|~s),1700485571,l(d,48+F),6),n(E^(D|~s),2399980690,l(d,12+F),10),n(E^(D|~s),4293915773,l(d,40+F),15),n(E^(D|~s),2240044497,l(d,4+F),21),n(E^(D|~s),1873313359,l(d,32+F),6),n(E^(D|~s),4264355552,l(d,60+F),10),n(E^(D|~s),2734768916,l(d,24+F),15),n(E^(D|~s),1309151649,l(d,52+F),21),n(E^(D|~s),4149444226,l(d,16+F),6),n(E^(D|~s),3174756917,l(d,44+F),10),n(E^(D|~s),718787259,l(d,8+F),15),n(E^(D|~s),3951481745,l(d,36+F),21),a=u(a,C),i=u(i,D),o=u(o,E),A=u(A,s)}return function(n,e,t,r){for(var a,i="",o=0,A=0,C=3;0<=C;C--)o=255&(A=arguments[C]),o<<=8,o|=255&(A>>>=8),o<<=8,o|=255&(A>>>=8),o<<=8,i+=(a=void 0,a=((o|=A>>>=8)>>>0).toString(16),"00000000".substr(0,8-a.length)+a);return i}(A,o,i,a).toUpperCase()}()},function(n){var e;"object"==typeof exports&&"undefined"!=typeof module?module.exports=n():"function"==typeof define&&define.amd?define([],n):("undefined"!=typeof window?e=window:"undefined"!=typeof global?e=global:"undefined"!=typeof self&&(e=self),e.JSZip=n())}(function(){return function a(i,o,A){function C(t,n){if(!o[t]){if(!i[t]){var e="function"==typeof require&&require;if(!n&&e)return e(t,!0);if(D)return D(t,!0);throw new Error("Cannot find module '"+t+"'")}var r=o[t]={exports:{}};i[t][0].call(r.exports,function(n){var e=i[t][1][n];return C(e||n)},r,r.exports,a,i,o,A)}return o[t].exports}for(var D="function"==typeof require&&require,n=0;n<A.length;n++)C(A[n]);return C}({1:[function(n,e,t){"use strict";var E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";t.encode=function(n){for(var e,t,r,a,i,o,A,C="",D=0;D<n.length;)a=(e=n.charCodeAt(D++))>>2,i=(3&e)<<4|(t=n.charCodeAt(D++))>>4,o=(15&t)<<2|(r=n.charCodeAt(D++))>>6,A=63&r,isNaN(t)?o=A=64:isNaN(r)&&(A=64),C=C+E.charAt(a)+E.charAt(i)+E.charAt(o)+E.charAt(A);return C},t.decode=function(n){var e,t,r,a,i,o,A="",C=0;for(n=n.replace(/[^A-Za-z0-9\+\/\=]/g,"");C<n.length;)e=E.indexOf(n.charAt(C++))<<2|(a=E.indexOf(n.charAt(C++)))>>4,t=(15&a)<<4|(i=E.indexOf(n.charAt(C++)))>>2,r=(3&i)<<6|(o=E.indexOf(n.charAt(C++))),A+=String.fromCharCode(e),64!=i&&(A+=String.fromCharCode(t)),64!=o&&(A+=String.fromCharCode(r));return A}},{}],2:[function(n,e){"use strict";function t(){this.compressedSize=0,this.uncompressedSize=0,this.crc32=0,this.compressionMethod=null,this.compressedContent=null}t.prototype={getContent:function(){return null},getCompressedContent:function(){return null}},e.exports=t},{}],3:[function(n,e,t){"use strict";t.STORE={magic:"\0\0",compress:function(n){return n},uncompress:function(n){return n},compressInputType:null,uncompressInputType:null},t.DEFLATE=n("./flate")},{"./flate":8}],4:[function(n,e){"use strict";var o=n("./utils"),A=[0,1996959894,3993919788,2567524794,124634137,1886057615,3915621685,2657392035,249268274,2044508324,3772115230,2547177864,162941995,2125561021,3887607047,2428444049,498536548,1789927666,4089016648,2227061214,450548861,1843258603,4107580753,2211677639,325883990,1684777152,4251122042,2321926636,335633487,1661365465,4195302755,2366115317,997073096,1281953886,3579855332,2724688242,1006888145,1258607687,3524101629,2768942443,901097722,1119000684,3686517206,2898065728,853044451,1172266101,3705015759,2882616665,651767980,1373503546,3369554304,3218104598,565507253,1454621731,3485111705,3099436303,671266974,1594198024,3322730930,2970347812,795835527,1483230225,3244367275,3060149565,1994146192,31158534,2563907772,4023717930,1907459465,112637215,2680153253,3904427059,2013776290,251722036,2517215374,3775830040,2137656763,141376813,2439277719,3865271297,1802195444,476864866,2238001368,4066508878,1812370925,453092731,2181625025,4111451223,1706088902,314042704,2344532202,4240017532,1658658271,366619977,2362670323,4224994405,1303535960,984961486,2747007092,3569037538,1256170817,1037604311,2765210733,3554079995,1131014506,879679996,2909243462,3663771856,1141124467,855842277,2852801631,3708648649,1342533948,654459306,3188396048,3373015174,1466479909,544179635,3110523913,3462522015,1591671054,702138776,2966460450,3352799412,1504918807,783551873,3082640443,3233442989,3988292384,2596254646,62317068,1957810842,3939845945,2647816111,81470997,1943803523,3814918930,2489596804,225274430,2053790376,3826175755,2466906013,167816743,2097651377,4027552580,2265490386,503444072,1762050814,4150417245,2154129355,426522225,1852507879,4275313526,2312317920,282753626,1742555852,4189708143,2394877945,397917763,1622183637,3604390888,2714866558,953729732,1340076626,3518719985,2797360999,1068828381,1219638859,3624741850,2936675148,906185462,1090812512,3747672003,2825379669,829329135,1181335161,3412177804,3160834842,628085408,1382605366,3423369109,3138078467,570562233,1426400815,3317316542,2998733608,733239954,1555261956,3268935591,3050360625,752459403,1541320221,2607071920,3965973030,1969922972,40735498,2617837225,3943577151,1913087877,83908371,2512341634,3803740692,2075208622,213261112,2463272603,3855990285,2094854071,198958881,2262029012,4057260610,1759359992,534414190,2176718541,4139329115,1873836001,414664567,2282248934,4279200368,1711684554,285281116,2405801727,4167216745,1634467795,376229701,2685067896,3608007406,1308918612,956543938,2808555105,3495958263,1231636301,1047427035,2932959818,3654703836,1088359270,936918e3,2847714899,3736837829,1202900863,817233897,3183342108,3401237130,1404277552,615818150,3134207493,3453421203,1423857449,601450431,3009837614,3294710456,1567103746,711928724,3020668471,3272380065,1510334235,755167117];e.exports=function(n,e){if(void 0===n||!n.length)return 0;var t="string"!==o.getTypeOf(n);void 0===e&&(e=0);var r;e^=-1;for(var a=0,i=n.length;a<i;a++)r=t?n[a]:n.charCodeAt(a),e=e>>>8^A[255&(e^r)];return-1^e}},{"./utils":21}],5:[function(n,e){"use strict";function t(){this.data=null,this.length=0,this.index=0}var r=n("./utils");t.prototype={checkOffset:function(n){this.checkIndex(this.index+n)},checkIndex:function(n){if(this.length<n||n<0)throw new Error("End of data reached (data length = "+this.length+", asked index = "+n+"). Corrupted zip ?")},setIndex:function(n){this.checkIndex(n),this.index=n},skip:function(n){this.setIndex(this.index+n)},byteAt:function(){},readInt:function(n){var e,t=0;for(this.checkOffset(n),e=this.index+n-1;e>=this.index;e--)t=(t<<8)+this.byteAt(e);return this.index+=n,t},readString:function(n){return r.transformTo("string",this.readData(n))},readData:function(){},lastIndexOfSignature:function(){},readDate:function(){var n=this.readInt(4);return new Date(1980+(n>>25&127),(n>>21&15)-1,n>>16&31,n>>11&31,n>>5&63,(31&n)<<1)}},e.exports=t},{"./utils":21}],6:[function(n,e,t){"use strict";t.base64=!1,t.binary=!1,t.dir=!1,t.createFolders=!1,t.date=null,t.compression=null,t.comment=null},{}],7:[function(n,e,t){"use strict";var r=n("./utils");t.string2binary=function(n){return r.string2binary(n)},t.string2Uint8Array=function(n){return r.transformTo("uint8array",n)},t.uint8Array2String=function(n){return r.transformTo("string",n)},t.string2Blob=function(n){var e=r.transformTo("arraybuffer",n);return r.arrayBuffer2Blob(e)},t.arrayBuffer2Blob=function(n){return r.arrayBuffer2Blob(n)},t.transformTo=function(n,e){return r.transformTo(n,e)},t.getTypeOf=function(n){return r.getTypeOf(n)},t.checkSupport=function(n){return r.checkSupport(n)},t.MAX_VALUE_16BITS=r.MAX_VALUE_16BITS,t.MAX_VALUE_32BITS=r.MAX_VALUE_32BITS,t.pretty=function(n){return r.pretty(n)},t.findCompression=function(n){return r.findCompression(n)},t.isRegExp=function(n){return r.isRegExp(n)}},{"./utils":21}],8:[function(n,e,t){"use strict";var r="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Uint32Array,a=n("pako");t.uncompressInputType=r?"uint8array":"array",t.compressInputType=r?"uint8array":"array",t.magic="\b\0",t.compress=function(n){return a.deflateRaw(n)},t.uncompress=function(n){return a.inflateRaw(n)}},{pako:24}],9:[function(n,e){"use strict";function t(n,e){return this instanceof t?(this.files={},this.comment=null,this.root="",n&&this.load(n,e),void(this.clone=function(){var n=new t;for(var e in this)"function"!=typeof this[e]&&(n[e]=this[e]);return n})):new t(n,e)}var r=n("./base64");(t.prototype=n("./object")).load=n("./load"),t.support=n("./support"),t.defaults=n("./defaults"),t.utils=n("./deprecatedPublicUtils"),t.base64={encode:function(n){return r.encode(n)},decode:function(n){return r.decode(n)}},t.compressions=n("./compressions"),e.exports=t},{"./base64":1,"./compressions":3,"./defaults":6,"./deprecatedPublicUtils":7,"./load":10,"./object":13,"./support":17}],10:[function(n,e){"use strict";var o=n("./base64"),A=n("./zipEntries");e.exports=function(n,e){var t,r,a,i;for((e=e||{}).base64&&(n=o.decode(n)),t=(r=new A(n,e)).files,a=0;a<t.length;a++)i=t[a],this.file(i.fileName,i.decompressed,{binary:!0,optimizedBinaryString:!0,date:i.date,dir:i.dir,comment:i.fileComment.length?i.fileComment:null,createFolders:e.createFolders});return r.zipComment.length&&(this.comment=r.zipComment),this}},{"./base64":1,"./zipEntries":22}],11:[function(n,e){(function(t){"use strict";e.exports=function(n,e){return new t(n,e)},e.exports.test=function(n){return t.isBuffer(n)}}).call(this,"undefined"!=typeof Buffer?Buffer:void 0)},{}],12:[function(n,e){"use strict";function t(n){this.data=n,this.length=this.data.length,this.index=0}var r=n("./uint8ArrayReader");(t.prototype=new r).readData=function(n){this.checkOffset(n);var e=this.data.slice(this.index,this.index+n);return this.index+=n,e},e.exports=t},{"./uint8ArrayReader":18}],13:[function(n,e){"use strict";function t(n){var e;return n._data instanceof D&&(n._data=n._data.getContent(),n.options.binary=!0,n.options.base64=!1,"uint8array"===f.getTypeOf(n._data))&&(e=n._data,n._data=new Uint8Array(e.length),0!==e.length&&n._data.set(e,0)),n._data}function a(n){var e=t(n);return"string"===f.getTypeOf(e)?!n.options.binary&&i.nodebuffer?o(e,"utf-8"):n.asBinary():e}function r(n){var e=t(this);return null==e?"":(this.options.base64&&(e=u.decode(e)),e=n&&this.options.binary?B.utf8decode(e):f.transformTo("string",e),n||this.options.binary||(e=f.transformTo("string",B.utf8encode(e))),e)}function A(n,e,t){this.name=n,this.dir=t.dir,this.date=t.date,this.comment=t.comment,this._data=e,this.options=t,this._initialMetadata={dir:t.dir,date:t.date}}var i=n("./support"),f=n("./utils"),h=n("./crc32"),p=n("./signature"),C=n("./defaults"),u=n("./base64"),d=n("./compressions"),D=n("./compressedObject"),o=n("./nodeBuffer"),P=n("./utf8"),m=n("./stringWriter"),g=n("./uint8ArrayWriter");A.prototype={asText:function(){return r.call(this,!0)},asBinary:function(){return r.call(this,!1)},asNodeBuffer:function(){var n=a(this);return f.transformTo("nodebuffer",n)},asUint8Array:function(){var n=a(this);return f.transformTo("uint8array",n)},asArrayBuffer:function(){return this.asUint8Array().buffer}};function S(n,e){for(var t="",r=0;r<e;r++)t+=String.fromCharCode(255&n),n>>>=8;return t}function v(){for(var n,e={},t=0;t<arguments.length;t++)for(n in arguments[t])arguments[t].hasOwnProperty(n)&&void 0===e[n]&&(e[n]=arguments[t][n]);return e}function E(n,e,t){var r,a,i=f.getTypeOf(e);if(!0!==(a=(a=t)||{}).base64||null!==a.binary&&void 0!==a.binary||(a.binary=!0),(a=v(a,C)).date=a.date||new Date,null!==a.compression&&(a.compression=a.compression.toUpperCase()),(t=a).createFolders&&(r=s(n))&&F.call(this,r,!0),t.dir||null==e)t.base64=!1,t.binary=!1,e=null;else if("string"===i)t.binary&&!t.base64&&!0!==t.optimizedBinaryString&&(e=f.string2binary(e));else{if(t.base64=!1,t.binary=!0,!(i||e instanceof D))throw new Error("The data of '"+n+"' is in an unsupported format !");"arraybuffer"===i&&(e=f.transformTo("uint8array",e))}var o=new A(n,e,t);return this.files[n]=o}function y(n,e){var t,r=new D;return n._data instanceof D?(r.uncompressedSize=n._data.uncompressedSize,r.crc32=n._data.crc32,0===r.uncompressedSize||n.dir?(e=d.STORE,r.compressedContent="",r.crc32=0):n._data.compressionMethod===e.magic?r.compressedContent=n._data.getCompressedContent():(t=n._data.getContent(),r.compressedContent=e.compress(f.transformTo(e.compressInputType,t)))):((t=a(n))&&0!==t.length&&!n.dir||(e=d.STORE,t=""),r.uncompressedSize=t.length,r.crc32=h(t),r.compressedContent=e.compress(f.transformTo(e.compressInputType,t))),r.compressedSize=r.compressedContent.length,r.compressionMethod=e.magic,r}function k(n,e,t,r){var a,i,o,A=(t.compressedContent,f.transformTo("string",P.utf8encode(e.name))),C=e.comment||"",D=f.transformTo("string",P.utf8encode(C)),E=A.length!==e.name.length,s=D.length!==C.length,F=e.options,B="",c=e._initialMetadata.dir!==e.dir?e.dir:F.dir,l=e._initialMetadata.date!==e.date?e.date:F.date,u=l.getHours();u<<=6,u|=l.getMinutes(),u<<=5,u|=l.getSeconds()/2,a=l.getFullYear()-1980,a<<=4,a|=l.getMonth()+1,a<<=5,a|=l.getDate(),E&&(i=S(1,1)+S(h(A),4)+A,B+="up"+S(i.length,2)+i),s&&(o=S(1,1)+S(this.crc32(D),4)+D,B+="uc"+S(o.length,2)+o);var d="";return d+="\n\0",d+=E||s?"\0\b":"\0\0",d+=t.compressionMethod,d+=S(u,2),d+=S(a,2),d+=S(t.crc32,4),d+=S(t.compressedSize,4),d+=S(t.uncompressedSize,4),d+=S(A.length,2),d+=S(B.length,2),{fileRecord:p.LOCAL_FILE_HEADER+d+A+B,dirRecord:p.CENTRAL_FILE_HEADER+"\0"+d+S(D.length,2)+"\0\0\0\0"+(!0===c?"\0\0\0":"\0\0\0\0")+S(r,4)+A+B+D,compressedObject:t}}var s=function(n){"/"==n.slice(-1)&&(n=n.substring(0,n.length-1));var e=n.lastIndexOf("/");return 0<e?n.substring(0,e):""},F=function(n,e){return"/"!=n.slice(-1)&&(n+="/"),e=void 0!==e&&e,this.files[n]||E.call(this,n,null,{dir:!0,createFolders:e}),this.files[n]},B={load:function(){throw new Error("Load method is not defined. Is the file jszip-load.js included ?")},filter:function(n){var e,t,r,a,i=[];for(e in this.files)this.files.hasOwnProperty(e)&&(r=this.files[e],a=new A(r.name,r._data,v(r.options)),t=e.slice(this.root.length,e.length),e.slice(0,this.root.length)===this.root&&n(t,a)&&i.push(a));return i},file:function(t,n,e){if(1!==arguments.length)return t=this.root+t,E.call(this,t,n,e),this;if(f.isRegExp(t)){var r=t;return this.filter(function(n,e){return!e.dir&&r.test(n)})}return this.filter(function(n,e){return!e.dir&&n===t})[0]||null},folder:function(t){if(!t)return this;if(f.isRegExp(t))return this.filter(function(n,e){return e.dir&&t.test(n)});var n=this.root+t,e=F.call(this,n),r=this.clone();return r.root=e.name,r},remove:function(t){t=this.root+t;var n=this.files[t];if(n||("/"!=t.slice(-1)&&(t+="/"),n=this.files[t]),n&&!n.dir)delete this.files[t];else for(var e=this.filter(function(n,e){return e.name.slice(0,t.length)===t}),r=0;r<e.length;r++)delete this.files[e[r].name];return this},generate:function(n){n=v(n||{},{base64:!0,compression:"STORE",type:"base64",comment:null}),f.checkSupport(n.type);var e=[],t=0,r=0,a=f.transformTo("string",this.utf8encode(n.comment||this.comment||""));for(var i in this.files)if(this.files.hasOwnProperty(i)){var o=this.files[i],A=o.options.compression||n.compression.toUpperCase(),C=d[A];if(!C)throw new Error(A+" is not a valid compression method !");var D=y.call(this,o,C),E=k.call(this,i,o,D,t);t+=E.fileRecord.length+D.compressedSize,r+=E.dirRecord.length,e.push(E)}for(var s=p.CENTRAL_DIRECTORY_END+"\0\0\0\0"+S(e.length,2)+S(e.length,2)+S(r,4)+S(t,4)+S(a.length,2)+a,F=n.type.toLowerCase(),B=new("uint8array"===F||"arraybuffer"===F||"blob"===F||"nodebuffer"===F?g:m)(t+r+s.length),c=0;c<e.length;c++)B.append(e[c].fileRecord),B.append(e[c].compressedObject.compressedContent);for(c=0;c<e.length;c++)B.append(e[c].dirRecord);B.append(s);var l=B.finalize();switch(n.type.toLowerCase()){case"uint8array":case"arraybuffer":case"nodebuffer":return f.transformTo(n.type.toLowerCase(),l);case"blob":return f.arrayBuffer2Blob(f.transformTo("arraybuffer",l));case"base64":return n.base64?u.encode(l):l;default:return l}},crc32:function(n,e){return h(n,e)},utf8encode:function(n){return f.transformTo("string",P.utf8encode(n))},utf8decode:function(n){return P.utf8decode(n)}};e.exports=B},{"./base64":1,"./compressedObject":2,"./compressions":3,"./crc32":4,"./defaults":6,"./nodeBuffer":11,"./signature":14,"./stringWriter":16,"./support":17,"./uint8ArrayWriter":19,"./utf8":20,"./utils":21}],14:[function(n,e,t){"use strict";t.LOCAL_FILE_HEADER="PK",t.CENTRAL_FILE_HEADER="PK",t.CENTRAL_DIRECTORY_END="PK",t.ZIP64_CENTRAL_DIRECTORY_LOCATOR="PK",t.ZIP64_CENTRAL_DIRECTORY_END="PK",t.DATA_DESCRIPTOR="PK\b"},{}],15:[function(n,e){"use strict";function t(n,e){this.data=n,e||(this.data=a.string2binary(this.data)),this.length=this.data.length,this.index=0}var r=n("./dataReader"),a=n("./utils");(t.prototype=new r).byteAt=function(n){return this.data.charCodeAt(n)},t.prototype.lastIndexOfSignature=function(n){return this.data.lastIndexOf(n)},t.prototype.readData=function(n){this.checkOffset(n);var e=this.data.slice(this.index,this.index+n);return this.index+=n,e},e.exports=t},{"./dataReader":5,"./utils":21}],16:[function(n,e){"use strict";function t(){this.data=[]}var r=n("./utils");t.prototype={append:function(n){n=r.transformTo("string",n),this.data.push(n)},finalize:function(){return this.data.join("")}},e.exports=t},{"./utils":21}],17:[function(n,e,r){(function(n){"use strict";if(r.base64=!0,r.array=!0,r.string=!0,r.arraybuffer="undefined"!=typeof ArrayBuffer&&"undefined"!=typeof Uint8Array,r.nodebuffer=void 0!==n,r.uint8array="undefined"!=typeof Uint8Array,"undefined"==typeof ArrayBuffer)r.blob=!1;else{var e=new ArrayBuffer(0);try{r.blob=0===new Blob([e],{type:"application/zip"}).size}catch(n){try{var t=new(window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder);t.append(e),r.blob=0===t.getBlob("application/zip").size}catch(n){r.blob=!1}}}}).call(this,"undefined"!=typeof Buffer?Buffer:void 0)},{}],18:[function(n,e){"use strict";function t(n){n&&(this.data=n,this.length=this.data.length,this.index=0)}var r=n("./dataReader");(t.prototype=new r).byteAt=function(n){return this.data[n]},t.prototype.lastIndexOfSignature=function(n){for(var e=n.charCodeAt(0),t=n.charCodeAt(1),r=n.charCodeAt(2),a=n.charCodeAt(3),i=this.length-4;0<=i;--i)if(this.data[i]===e&&this.data[i+1]===t&&this.data[i+2]===r&&this.data[i+3]===a)return i;return-1},t.prototype.readData=function(n){if(this.checkOffset(n),0===n)return new Uint8Array(0);var e=this.data.subarray(this.index,this.index+n);return this.index+=n,e},e.exports=t},{"./dataReader":5}],19:[function(n,e){"use strict";function t(n){this.data=new Uint8Array(n),this.index=0}var r=n("./utils");t.prototype={append:function(n){0!==n.length&&(n=r.transformTo("uint8array",n),this.data.set(n,this.index),this.index+=n.length)},finalize:function(){return this.data}},e.exports=t},{"./utils":21}],20:[function(n,e,t){"use strict";for(var A=n("./utils"),C=n("./support"),r=n("./nodeBuffer"),D=new Array(256),a=0;a<256;a++)D[a]=252<=a?6:248<=a?5:240<=a?4:224<=a?3:192<=a?2:1;D[254]=D[254]=1;function i(n){for(var e,t,r=n.length,a=new Array(2*r),i=0,o=0;o<r;)if((e=n[o++])<128)a[i++]=e;else if(4<(t=D[e]))a[i++]=65533,o+=t-1;else{for(e&=2===t?31:3===t?15:7;1<t&&o<r;)e=e<<6|63&n[o++],t--;1<t?a[i++]=65533:e<65536?a[i++]=e:(e-=65536,a[i++]=55296|e>>10&1023,a[i++]=56320|1023&e)}return a.length!==i&&(a.subarray?a=a.subarray(0,i):a.length=i),A.applyFromCharCode(a)}t.utf8encode=function(n){return C.nodebuffer?r(n,"utf-8"):function(n){for(var e,t,r,a,i=n.length,o=0,A=0;A<i;A++)55296==(64512&(t=n.charCodeAt(A)))&&A+1<i&&(56320==(64512&(r=n.charCodeAt(A+1)))&&(t=65536+(t-55296<<10)+(r-56320),A++)),o+=t<128?1:t<2048?2:t<65536?3:4;for(e=new(C.uint8array?Uint8Array:Array)(o),A=a=0;a<o;A++)55296==(64512&(t=n.charCodeAt(A)))&&A+1<i&&(56320==(64512&(r=n.charCodeAt(A+1)))&&(t=65536+(t-55296<<10)+(r-56320),A++)),t<128?e[a++]=t:(t<2048?e[a++]=192|t>>>6:(t<65536?e[a++]=224|t>>>12:(e[a++]=240|t>>>18,e[a++]=128|t>>>12&63),e[a++]=128|t>>>6&63),e[a++]=128|63&t);return e}(n)},t.utf8decode=function(n){if(C.nodebuffer)return A.transformTo("nodebuffer",n).toString("utf-8");for(var e=[],t=0,r=(n=A.transformTo(C.uint8array?"uint8array":"array",n)).length;t<r;){var a=function(n,e){var t;for((e=e||n.length)>n.length&&(e=n.length),t=e-1;0<=t&&128==(192&n[t]);)t--;return!(t<0)&&0!==t&&t+D[n[t]]>e?t:e}(n,Math.min(t+65536,r));e.push(C.uint8array?i(n.subarray(t,a)):i(n.slice(t,a))),t=a}return e.join("")}},{"./nodeBuffer":11,"./support":17,"./utils":21}],21:[function(n,e,D){"use strict";function t(n){return n}function r(n,e){for(var t=0;t<n.length;++t)e[t]=255&n.charCodeAt(t);return e}function a(n){var e=65536,t=[],r=n.length,a=D.getTypeOf(n),i=0,o=!0;try{switch(a){case"uint8array":String.fromCharCode.apply(null,new Uint8Array(0));break;case"nodebuffer":String.fromCharCode.apply(null,E(0))}}catch(n){o=!1}if(!o){for(var A="",C=0;C<n.length;C++)A+=String.fromCharCode(n[C]);return A}for(;i<r&&1<e;)try{t.push("array"===a||"nodebuffer"===a?String.fromCharCode.apply(null,n.slice(i,Math.min(i+e,r))):String.fromCharCode.apply(null,n.subarray(i,Math.min(i+e,r)))),i+=e}catch(n){e=Math.floor(e/2)}return t.join("")}function i(n,e){for(var t=0;t<n.length;t++)e[t]=n[t];return e}var o=n("./support"),A=n("./compressions"),E=n("./nodeBuffer");D.string2binary=function(n){for(var e="",t=0;t<n.length;t++)e+=String.fromCharCode(255&n.charCodeAt(t));return e},D.arrayBuffer2Blob=function(e){D.checkSupport("blob");try{return new Blob([e],{type:"application/zip"})}catch(n){try{var t=new(window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder);return t.append(e),t.getBlob("application/zip")}catch(n){throw new Error("Bug : can't construct the Blob.")}}},D.applyFromCharCode=a;var C={};C.string={string:t,array:function(n){return r(n,new Array(n.length))},arraybuffer:function(n){return C.string.uint8array(n).buffer},uint8array:function(n){return r(n,new Uint8Array(n.length))},nodebuffer:function(n){return r(n,E(n.length))}},C.array={string:a,array:t,arraybuffer:function(n){return new Uint8Array(n).buffer},uint8array:function(n){return new Uint8Array(n)},nodebuffer:function(n){return E(n)}},C.arraybuffer={string:function(n){return a(new Uint8Array(n))},array:function(n){return i(new Uint8Array(n),new Array(n.byteLength))},arraybuffer:t,uint8array:function(n){return new Uint8Array(n)},nodebuffer:function(n){return E(new Uint8Array(n))}},C.uint8array={string:a,array:function(n){return i(n,new Array(n.length))},arraybuffer:function(n){return n.buffer},uint8array:t,nodebuffer:function(n){return E(n)}},C.nodebuffer={string:a,array:function(n){return i(n,new Array(n.length))},arraybuffer:function(n){return C.nodebuffer.uint8array(n).buffer},uint8array:function(n){return i(n,new Uint8Array(n.length))},nodebuffer:t},D.transformTo=function(n,e){if(e=e||"",!n)return e;D.checkSupport(n);var t=D.getTypeOf(e);return C[t][n](e)},D.getTypeOf=function(n){return"string"==typeof n?"string":"[object Array]"===Object.prototype.toString.call(n)?"array":o.nodebuffer&&E.test(n)?"nodebuffer":o.uint8array&&n instanceof Uint8Array?"uint8array":o.arraybuffer&&n instanceof ArrayBuffer?"arraybuffer":void 0},D.checkSupport=function(n){if(!o[n.toLowerCase()])throw new Error(n+" is not supported by this browser")},D.MAX_VALUE_16BITS=65535,D.MAX_VALUE_32BITS=-1,D.pretty=function(n){for(var e,t="",r=0;r<(n||"").length;r++)t+="\\x"+((e=n.charCodeAt(r))<16?"0":"")+e.toString(16).toUpperCase();return t},D.findCompression=function(n){for(var e in A)if(A.hasOwnProperty(e)&&A[e].magic===n)return A[e];return null},D.isRegExp=function(n){return"[object RegExp]"===Object.prototype.toString.call(n)}},{"./compressions":3,"./nodeBuffer":11,"./support":17}],22:[function(n,e){"use strict";function t(n,e){this.files=[],this.loadOptions=e,n&&this.load(n)}var r=n("./stringReader"),a=n("./nodeBufferReader"),i=n("./uint8ArrayReader"),o=n("./utils"),A=n("./signature"),C=n("./zipEntry"),D=n("./support"),E=n("./object");t.prototype={checkSignature:function(n){var e=this.reader.readString(4);if(e!==n)throw new Error("Corrupted zip or bug : unexpected signature ("+o.pretty(e)+", expected "+o.pretty(n)+")")},readBlockEndOfCentral:function(){this.diskNumber=this.reader.readInt(2),this.diskWithCentralDirStart=this.reader.readInt(2),this.centralDirRecordsOnThisDisk=this.reader.readInt(2),this.centralDirRecords=this.reader.readInt(2),this.centralDirSize=this.reader.readInt(4),this.centralDirOffset=this.reader.readInt(4),this.zipCommentLength=this.reader.readInt(2),this.zipComment=this.reader.readString(this.zipCommentLength),this.zipComment=E.utf8decode(this.zipComment)},readBlockZip64EndOfCentral:function(){this.zip64EndOfCentralSize=this.reader.readInt(8),this.versionMadeBy=this.reader.readString(2),this.versionNeeded=this.reader.readInt(2),this.diskNumber=this.reader.readInt(4),this.diskWithCentralDirStart=this.reader.readInt(4),this.centralDirRecordsOnThisDisk=this.reader.readInt(8),this.centralDirRecords=this.reader.readInt(8),this.centralDirSize=this.reader.readInt(8),this.centralDirOffset=this.reader.readInt(8),this.zip64ExtensibleData={};for(var n,e,t,r=this.zip64EndOfCentralSize-44;0<r;)n=this.reader.readInt(2),e=this.reader.readInt(4),t=this.reader.readString(e),this.zip64ExtensibleData[n]={id:n,length:e,value:t}},readBlockZip64EndOfCentralLocator:function(){if(this.diskWithZip64CentralDirStart=this.reader.readInt(4),this.relativeOffsetEndOfZip64CentralDir=this.reader.readInt(8),this.disksCount=this.reader.readInt(4),1<this.disksCount)throw new Error("Multi-volumes zip are not supported")},readLocalFiles:function(){for(var n,e=0;e<this.files.length;e++)n=this.files[e],this.reader.setIndex(n.localHeaderOffset),this.checkSignature(A.LOCAL_FILE_HEADER),n.readLocalPart(this.reader),n.handleUTF8()},readCentralDir:function(){var n;for(this.reader.setIndex(this.centralDirOffset);this.reader.readString(4)===A.CENTRAL_FILE_HEADER;)(n=new C({zip64:this.zip64},this.loadOptions)).readCentralPart(this.reader),this.files.push(n)},readEndOfCentral:function(){var n=this.reader.lastIndexOfSignature(A.CENTRAL_DIRECTORY_END);if(-1===n)throw new Error("Corrupted zip : can't find end of central directory");if(this.reader.setIndex(n),this.checkSignature(A.CENTRAL_DIRECTORY_END),this.readBlockEndOfCentral(),this.diskNumber===o.MAX_VALUE_16BITS||this.diskWithCentralDirStart===o.MAX_VALUE_16BITS||this.centralDirRecordsOnThisDisk===o.MAX_VALUE_16BITS||this.centralDirRecords===o.MAX_VALUE_16BITS||this.centralDirSize===o.MAX_VALUE_32BITS||this.centralDirOffset===o.MAX_VALUE_32BITS){if(this.zip64=!0,-1===(n=this.reader.lastIndexOfSignature(A.ZIP64_CENTRAL_DIRECTORY_LOCATOR)))throw new Error("Corrupted zip : can't find the ZIP64 end of central directory locator");this.reader.setIndex(n),this.checkSignature(A.ZIP64_CENTRAL_DIRECTORY_LOCATOR),this.readBlockZip64EndOfCentralLocator(),this.reader.setIndex(this.relativeOffsetEndOfZip64CentralDir),this.checkSignature(A.ZIP64_CENTRAL_DIRECTORY_END),this.readBlockZip64EndOfCentral()}},prepareReader:function(n){var e=o.getTypeOf(n);this.reader="string"!==e||D.uint8array?"nodebuffer"===e?new a(n):new i(o.transformTo("uint8array",n)):new r(n,this.loadOptions.optimizedBinaryString)},load:function(n){this.prepareReader(n),this.readEndOfCentral(),this.readCentralDir(),this.readLocalFiles()}},e.exports=t},{"./nodeBufferReader":12,"./object":13,"./signature":14,"./stringReader":15,"./support":17,"./uint8ArrayReader":18,"./utils":21,"./zipEntry":23}],23:[function(n,e){"use strict";function t(n,e){this.options=n,this.loadOptions=e}var r=n("./stringReader"),i=n("./utils"),a=n("./compressedObject"),o=n("./object");t.prototype={isEncrypted:function(){return 1==(1&this.bitFlag)},useUTF8:function(){return 2048==(2048&this.bitFlag)},prepareCompressedContent:function(t,r,a){return function(){var n=t.index;t.setIndex(r);var e=t.readData(a);return t.setIndex(n),e}},prepareContent:function(n,e,t,r,a){return function(){var n=i.transformTo(r.uncompressInputType,this.getCompressedContent()),e=r.uncompress(n);if(e.length!==a)throw new Error("Bug : uncompressed data size mismatch");return e}},readLocalPart:function(n){var e,t;if(n.skip(22),this.fileNameLength=n.readInt(2),t=n.readInt(2),this.fileName=n.readString(this.fileNameLength),n.skip(t),-1==this.compressedSize||-1==this.uncompressedSize)throw new Error("Bug or corrupted zip : didn't get enough informations from the central directory (compressedSize == -1 || uncompressedSize == -1)");if(null===(e=i.findCompression(this.compressionMethod)))throw new Error("Corrupted zip : compression "+i.pretty(this.compressionMethod)+" unknown (inner file : "+this.fileName+")");if(this.decompressed=new a,this.decompressed.compressedSize=this.compressedSize,this.decompressed.uncompressedSize=this.uncompressedSize,this.decompressed.crc32=this.crc32,this.decompressed.compressionMethod=this.compressionMethod,this.decompressed.getCompressedContent=this.prepareCompressedContent(n,n.index,this.compressedSize,e),this.decompressed.getContent=this.prepareContent(n,n.index,this.compressedSize,e,this.uncompressedSize),this.loadOptions.checkCRC32&&(this.decompressed=i.transformTo("string",this.decompressed.getContent()),o.crc32(this.decompressed)!==this.crc32))throw new Error("Corrupted zip : CRC32 mismatch")},readCentralPart:function(n){if(this.versionMadeBy=n.readString(2),this.versionNeeded=n.readInt(2),this.bitFlag=n.readInt(2),this.compressionMethod=n.readString(2),this.date=n.readDate(),this.crc32=n.readInt(4),this.compressedSize=n.readInt(4),this.uncompressedSize=n.readInt(4),this.fileNameLength=n.readInt(2),this.extraFieldsLength=n.readInt(2),this.fileCommentLength=n.readInt(2),this.diskNumberStart=n.readInt(2),this.internalFileAttributes=n.readInt(2),this.externalFileAttributes=n.readInt(4),this.localHeaderOffset=n.readInt(4),this.isEncrypted())throw new Error("Encrypted zip are not supported");this.fileName=n.readString(this.fileNameLength),this.readExtraFields(n),this.parseZIP64ExtraField(n),this.fileComment=n.readString(this.fileCommentLength),this.dir=!!(16&this.externalFileAttributes)},parseZIP64ExtraField:function(){var n;this.extraFields[1]&&(n=new r(this.extraFields[1].value),this.uncompressedSize===i.MAX_VALUE_32BITS&&(this.uncompressedSize=n.readInt(8)),this.compressedSize===i.MAX_VALUE_32BITS&&(this.compressedSize=n.readInt(8)),this.localHeaderOffset===i.MAX_VALUE_32BITS&&(this.localHeaderOffset=n.readInt(8)),this.diskNumberStart===i.MAX_VALUE_32BITS&&(this.diskNumberStart=n.readInt(4)))},readExtraFields:function(n){var e,t,r,a=n.index;for(this.extraFields=this.extraFields||{};n.index<a+this.extraFieldsLength;)e=n.readInt(2),t=n.readInt(2),r=n.readString(t),this.extraFields[e]={id:e,length:t,value:r}},handleUTF8:function(){var n,e;this.useUTF8()?(this.fileName=o.utf8decode(this.fileName),this.fileComment=o.utf8decode(this.fileComment)):(null!==(n=this.findExtraFieldUnicodePath())&&(this.fileName=n),null!==(e=this.findExtraFieldUnicodeComment())&&(this.fileComment=e))},findExtraFieldUnicodePath:function(){var n=this.extraFields[28789];if(n){var e=new r(n.value);return 1!==e.readInt(1)||o.crc32(this.fileName)!==e.readInt(4)?null:o.utf8decode(e.readString(n.length-5))}return null},findExtraFieldUnicodeComment:function(){var n=this.extraFields[25461];if(n){var e=new r(n.value);return 1!==e.readInt(1)||o.crc32(this.fileComment)!==e.readInt(4)?null:o.utf8decode(e.readString(n.length-5))}return null}},e.exports=t},{"./compressedObject":2,"./object":13,"./stringReader":15,"./utils":21}],24:[function(n,e){"use strict";var t={};(0,n("./lib/utils/common").assign)(t,n("./lib/deflate"),n("./lib/inflate"),n("./lib/zlib/constants")),e.exports=t},{"./lib/deflate":25,"./lib/inflate":26,"./lib/utils/common":27,"./lib/zlib/constants":30}],25:[function(n,e,t){"use strict";function r(n,e){var t=new D(e);if(t.push(n,!0),t.err)throw t.msg;return t.result}var o=n("./zlib/deflate.js"),A=n("./utils/common"),C=n("./utils/strings"),a=n("./zlib/messages"),i=n("./zlib/zstream"),D=function(n){this.options=A.assign({level:-1,method:8,chunkSize:16384,windowBits:15,memLevel:8,strategy:0,to:""},n||{});var e=this.options;e.raw&&0<e.windowBits?e.windowBits=-e.windowBits:e.gzip&&0<e.windowBits&&e.windowBits<16&&(e.windowBits+=16),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new i,this.strm.avail_out=0;var t=o.deflateInit2(this.strm,e.level,e.method,e.windowBits,e.memLevel,e.strategy);if(0!==t)throw new Error(a[t]);e.header&&o.deflateSetHeader(this.strm,e.header)};D.prototype.push=function(n,e){var t,r,a=this.strm,i=this.options.chunkSize;if(this.ended)return!1;r=e===~~e?e:!0===e?4:0,a.input="string"==typeof n?C.string2buf(n):n,a.next_in=0,a.avail_in=a.input.length;do{if(0===a.avail_out&&(a.output=new A.Buf8(i),a.next_out=0,a.avail_out=i),1!==(t=o.deflate(a,r))&&0!==t)return this.onEnd(t),!(this.ended=!0);(0===a.avail_out||0===a.avail_in&&4===r)&&this.onData("string"===this.options.to?C.buf2binstring(A.shrinkBuf(a.output,a.next_out)):A.shrinkBuf(a.output,a.next_out))}while((0<a.avail_in||0===a.avail_out)&&1!==t);return 4!==r||(t=o.deflateEnd(this.strm),this.onEnd(t),this.ended=!0,0===t)},D.prototype.onData=function(n){this.chunks.push(n)},D.prototype.onEnd=function(n){0===n&&(this.result="string"===this.options.to?this.chunks.join(""):A.flattenChunks(this.chunks)),this.chunks=[],this.err=n,this.msg=this.strm.msg},t.Deflate=D,t.deflate=r,t.deflateRaw=function(n,e){return(e=e||{}).raw=!0,r(n,e)},t.gzip=function(n,e){return(e=e||{}).gzip=!0,r(n,e)}},{"./utils/common":27,"./utils/strings":28,"./zlib/deflate.js":32,"./zlib/messages":37,"./zlib/zstream":39}],26:[function(n,e,t){"use strict";function r(n,e){var t=new A(e);if(t.push(n,!0),t.err)throw t.msg;return t.result}var D=n("./zlib/inflate.js"),E=n("./utils/common"),s=n("./utils/strings"),F=n("./zlib/constants"),a=n("./zlib/messages"),i=n("./zlib/zstream"),o=n("./zlib/gzheader"),A=function(n){this.options=E.assign({chunkSize:16384,windowBits:0,to:""},n||{});var e=this.options;e.raw&&0<=e.windowBits&&e.windowBits<16&&(e.windowBits=-e.windowBits,0===e.windowBits&&(e.windowBits=-15)),!(0<=e.windowBits&&e.windowBits<16)||n&&n.windowBits||(e.windowBits+=32),15<e.windowBits&&e.windowBits<48&&0==(15&e.windowBits)&&(e.windowBits|=15),this.err=0,this.msg="",this.ended=!1,this.chunks=[],this.strm=new i,this.strm.avail_out=0;var t=D.inflateInit2(this.strm,e.windowBits);if(t!==F.Z_OK)throw new Error(a[t]);this.header=new o,D.inflateGetHeader(this.strm,this.header)};A.prototype.push=function(n,e){var t,r,a,i,o,A=this.strm,C=this.options.chunkSize;if(this.ended)return!1;r=e===~~e?e:!0===e?F.Z_FINISH:F.Z_NO_FLUSH,A.input="string"==typeof n?s.binstring2buf(n):n,A.next_in=0,A.avail_in=A.input.length;do{if(0===A.avail_out&&(A.output=new E.Buf8(C),A.next_out=0,A.avail_out=C),(t=D.inflate(A,F.Z_NO_FLUSH))!==F.Z_STREAM_END&&t!==F.Z_OK)return this.onEnd(t),!(this.ended=!0);A.next_out&&(0===A.avail_out||t===F.Z_STREAM_END||0===A.avail_in&&r===F.Z_FINISH)&&("string"===this.options.to?(a=s.utf8border(A.output,A.next_out),i=A.next_out-a,o=s.buf2string(A.output,a),A.next_out=i,A.avail_out=C-i,i&&E.arraySet(A.output,A.output,a,i,0),this.onData(o)):this.onData(E.shrinkBuf(A.output,A.next_out)))}while(0<A.avail_in&&t!==F.Z_STREAM_END);return t===F.Z_STREAM_END&&(r=F.Z_FINISH),r!==F.Z_FINISH||(t=D.inflateEnd(this.strm),this.onEnd(t),this.ended=!0,t===F.Z_OK)},A.prototype.onData=function(n){this.chunks.push(n)},A.prototype.onEnd=function(n){n===F.Z_OK&&(this.result="string"===this.options.to?this.chunks.join(""):E.flattenChunks(this.chunks)),this.chunks=[],this.err=n,this.msg=this.strm.msg},t.Inflate=A,t.inflate=r,t.inflateRaw=function(n,e){return(e=e||{}).raw=!0,r(n,e)},t.ungzip=r},{"./utils/common":27,"./utils/strings":28,"./zlib/constants":30,"./zlib/gzheader":33,"./zlib/inflate.js":35,"./zlib/messages":37,"./zlib/zstream":39}],27:[function(n,e,t){"use strict";var r="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Int32Array;t.assign=function(n){for(var e=Array.prototype.slice.call(arguments,1);e.length;){var t=e.shift();if(t){if("object"!=typeof t)throw new TypeError(t+"must be non-object");for(var r in t)t.hasOwnProperty(r)&&(n[r]=t[r])}}return n},t.shrinkBuf=function(n,e){return n.length===e?n:n.subarray?n.subarray(0,e):(n.length=e,n)};var a={arraySet:function(n,e,t,r,a){if(e.subarray&&n.subarray)n.set(e.subarray(t,t+r),a);else for(var i=0;i<r;i++)n[a+i]=e[t+i]},flattenChunks:function(n){for(var e,t,r,a=0,i=0,o=n.length;i<o;i++)a+=n[i].length;for(r=new Uint8Array(a),i=e=0,o=n.length;i<o;i++)t=n[i],r.set(t,e),e+=t.length;return r}},i={arraySet:function(n,e,t,r,a){for(var i=0;i<r;i++)n[a+i]=e[t+i]},flattenChunks:function(n){return[].concat.apply([],n)}};t.setTyped=function(n){n?(t.Buf8=Uint8Array,t.Buf16=Uint16Array,t.Buf32=Int32Array,t.assign(t,a)):(t.Buf8=Array,t.Buf16=Array,t.Buf32=Array,t.assign(t,i))},t.setTyped(r)},{}],28:[function(n,e,t){"use strict";function C(n,e){if(e<65537&&(n.subarray&&i||!n.subarray&&a))return String.fromCharCode.apply(null,D.shrinkBuf(n,e));for(var t="",r=0;r<e;r++)t+=String.fromCharCode(n[r]);return t}var D=n("./common"),a=!0,i=!0;try{String.fromCharCode.apply(null,[0])}catch(n){a=!1}try{String.fromCharCode.apply(null,new Uint8Array(1))}catch(n){i=!1}for(var E=new D.Buf8(256),r=0;r<256;r++)E[r]=252<=r?6:248<=r?5:240<=r?4:224<=r?3:192<=r?2:1;E[254]=E[254]=1,t.string2buf=function(n){for(var e,t,r,a,i=n.length,o=0,A=0;A<i;A++)55296==(64512&(t=n.charCodeAt(A)))&&A+1<i&&(56320==(64512&(r=n.charCodeAt(A+1)))&&(t=65536+(t-55296<<10)+(r-56320),A++)),o+=t<128?1:t<2048?2:t<65536?3:4;for(e=new D.Buf8(o),A=a=0;a<o;A++)55296==(64512&(t=n.charCodeAt(A)))&&A+1<i&&(56320==(64512&(r=n.charCodeAt(A+1)))&&(t=65536+(t-55296<<10)+(r-56320),A++)),t<128?e[a++]=t:(t<2048?e[a++]=192|t>>>6:(t<65536?e[a++]=224|t>>>12:(e[a++]=240|t>>>18,e[a++]=128|t>>>12&63),e[a++]=128|t>>>6&63),e[a++]=128|63&t);return e},t.buf2binstring=function(n){return C(n,n.length)},t.binstring2buf=function(n){for(var e=new D.Buf8(n.length),t=0,r=e.length;t<r;t++)e[t]=n.charCodeAt(t);return e},t.buf2string=function(n,e){for(var t,r,a=e||n.length,i=new Array(2*a),o=0,A=0;A<a;)if((t=n[A++])<128)i[o++]=t;else if(4<(r=E[t]))i[o++]=65533,A+=r-1;else{for(t&=2===r?31:3===r?15:7;1<r&&A<a;)t=t<<6|63&n[A++],r--;1<r?i[o++]=65533:t<65536?i[o++]=t:(t-=65536,i[o++]=55296|t>>10&1023,i[o++]=56320|1023&t)}return C(i,o)},t.utf8border=function(n,e){var t;for((e=e||n.length)>n.length&&(e=n.length),t=e-1;0<=t&&128==(192&n[t]);)t--;return!(t<0)&&0!==t&&t+E[n[t]]>e?t:e}},{"./common":27}],29:[function(n,e){"use strict";e.exports=function(n,e,t,r){for(var a=65535&n|0,i=n>>>16&65535|0,o=0;0!==t;){for(t-=o=2e3<t?2e3:t;i=i+(a=a+e[r++]|0)|0,--o;);a%=65521,i%=65521}return a|i<<16|0}},{}],30:[function(n,e){e.exports={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8}},{}],31:[function(n,e){"use strict";var A=function(){for(var n,e=[],t=0;t<256;t++){n=t;for(var r=0;r<8;r++)n=1&n?3988292384^n>>>1:n>>>1;e[t]=n}return e}();e.exports=function(n,e,t,r){var a=A,i=r+t;n^=-1;for(var o=r;o<i;o++)n=n>>>8^a[255&(n^e[o])];return-1^n}},{}],32:[function(n,e,t){"use strict";function C(n,e){return n.msg=g[e],e}function D(n){return(n<<1)-(4<n?9:0)}function E(n){for(var e=n.length;0<=--e;)n[e]=0}function s(n){var e=n.state,t=e.pending;t>n.avail_out&&(t=n.avail_out),0!==t&&(h.arraySet(n.output,e.pending_buf,e.pending_out,t,n.next_out),n.next_out+=t,e.pending_out+=t,n.total_out+=t,n.avail_out-=t,e.pending-=t,0===e.pending&&(e.pending_out=0))}function F(n,e){p._tr_flush_block(n,0<=n.block_start?n.block_start:-1,n.strstart-n.block_start,e),n.block_start=n.strstart,s(n.strm)}function B(n,e){n.pending_buf[n.pending++]=e}function c(n,e){n.pending_buf[n.pending++]=e>>>8&255,n.pending_buf[n.pending++]=255&e}function i(n,e){var t,r,a=n.max_chain_length,i=n.strstart,o=n.prev_length,A=n.nice_match,C=n.strstart>n.w_size-V?n.strstart-(n.w_size-V):0,D=n.window,E=n.w_mask,s=n.prev,F=n.strstart+x,B=D[i+o-1],c=D[i+o];n.prev_length>=n.good_match&&(a>>=2),A>n.lookahead&&(A=n.lookahead);do{if(D[(t=e)+o]===c&&D[t+o-1]===B&&D[t]===D[i]&&D[++t]===D[i+1]){i+=2,t++;do{}while(D[++i]===D[++t]&&D[++i]===D[++t]&&D[++i]===D[++t]&&D[++i]===D[++t]&&D[++i]===D[++t]&&D[++i]===D[++t]&&D[++i]===D[++t]&&D[++i]===D[++t]&&i<F);if(r=x-(F-i),i=F-x,o<r){if(n.match_start=e,A<=(o=r))break;B=D[i+o-1],c=D[i+o]}}}while((e=s[e&E])>C&&0!=--a);return o<=n.lookahead?o:n.lookahead}function l(n){var e,t,r,a,i,o,A,C,D,E,s=n.w_size;do{if(a=n.window_size-n.lookahead-n.strstart,n.strstart>=s+(s-V)){for(h.arraySet(n.window,n.window,s,s,0),n.match_start-=s,n.strstart-=s,n.block_start-=s,e=t=n.hash_size;r=n.head[--e],n.head[e]=s<=r?r-s:0,--t;);for(e=t=s;r=n.prev[--e],n.prev[e]=s<=r?r-s:0,--t;);a+=s}if(0===n.strm.avail_in)break;if(o=n.strm,A=n.window,C=n.strstart+n.lookahead,D=a,E=void 0,E=o.avail_in,D<E&&(E=D),t=0===E?0:(o.avail_in-=E,h.arraySet(A,o.input,o.next_in,E,C),1===o.state.wrap?o.adler=P(o.adler,A,E,C):2===o.state.wrap&&(o.adler=m(o.adler,A,E,C)),o.next_in+=E,o.total_in+=E,E),n.lookahead+=t,n.lookahead+n.insert>=U)for(i=n.strstart-n.insert,n.ins_h=n.window[i],n.ins_h=(n.ins_h<<n.hash_shift^n.window[i+1])&n.hash_mask;n.insert&&(n.ins_h=(n.ins_h<<n.hash_shift^n.window[i+U-1])&n.hash_mask,n.prev[i&n.w_mask]=n.head[n.ins_h],n.head[n.ins_h]=i,i++,n.insert--,!(n.lookahead+n.insert<U)););}while(n.lookahead<V&&0!==n.strm.avail_in)}function r(n,e){for(var t,r;;){if(n.lookahead<V){if(l(n),n.lookahead<V&&e===S)return G;if(0===n.lookahead)break}if(t=0,n.lookahead>=U&&(n.ins_h=(n.ins_h<<n.hash_shift^n.window[n.strstart+U-1])&n.hash_mask,t=n.prev[n.strstart&n.w_mask]=n.head[n.ins_h],n.head[n.ins_h]=n.strstart),0!==t&&n.strstart-t<=n.w_size-V&&(n.match_length=i(n,t)),n.match_length>=U)if(r=p._tr_tally(n,n.strstart-n.match_start,n.match_length-U),n.lookahead-=n.match_length,n.match_length<=n.max_lazy_match&&n.lookahead>=U){for(n.match_length--;n.strstart++,n.ins_h=(n.ins_h<<n.hash_shift^n.window[n.strstart+U-1])&n.hash_mask,t=n.prev[n.strstart&n.w_mask]=n.head[n.ins_h],n.head[n.ins_h]=n.strstart,0!=--n.match_length;);n.strstart++}else n.strstart+=n.match_length,n.match_length=0,n.ins_h=n.window[n.strstart],n.ins_h=(n.ins_h<<n.hash_shift^n.window[n.strstart+1])&n.hash_mask;else r=p._tr_tally(n,0,n.window[n.strstart]),n.lookahead--,n.strstart++;if(r&&(F(n,!1),0===n.strm.avail_out))return G}return n.insert=n.strstart<U-1?n.strstart:U-1,e===v?(F(n,!0),0===n.strm.avail_out?N:z):n.last_lit&&(F(n,!1),0===n.strm.avail_out)?G:J}function a(n,e){for(var t,r,a;;){if(n.lookahead<V){if(l(n),n.lookahead<V&&e===S)return G;if(0===n.lookahead)break}if(t=0,n.lookahead>=U&&(n.ins_h=(n.ins_h<<n.hash_shift^n.window[n.strstart+U-1])&n.hash_mask,t=n.prev[n.strstart&n.w_mask]=n.head[n.ins_h],n.head[n.ins_h]=n.strstart),n.prev_length=n.match_length,n.prev_match=n.match_start,n.match_length=U-1,0!==t&&n.prev_length<n.max_lazy_match&&n.strstart-t<=n.w_size-V&&(n.match_length=i(n,t),n.match_length<=5&&(1===n.strategy||n.match_length===U&&4096<n.strstart-n.match_start)&&(n.match_length=U-1)),n.prev_length>=U&&n.match_length<=n.prev_length){for(a=n.strstart+n.lookahead-U,r=p._tr_tally(n,n.strstart-1-n.prev_match,n.prev_length-U),n.lookahead-=n.prev_length-1,n.prev_length-=2;++n.strstart<=a&&(n.ins_h=(n.ins_h<<n.hash_shift^n.window[n.strstart+U-1])&n.hash_mask,t=n.prev[n.strstart&n.w_mask]=n.head[n.ins_h],n.head[n.ins_h]=n.strstart),0!=--n.prev_length;);if(n.match_available=0,n.match_length=U-1,n.strstart++,r&&(F(n,!1),0===n.strm.avail_out))return G}else if(n.match_available){if((r=p._tr_tally(n,0,n.window[n.strstart-1]))&&F(n,!1),n.strstart++,n.lookahead--,0===n.strm.avail_out)return G}else n.match_available=1,n.strstart++,n.lookahead--}return n.match_available&&(r=p._tr_tally(n,0,n.window[n.strstart-1]),n.match_available=0),n.insert=n.strstart<U-1?n.strstart:U-1,e===v?(F(n,!0),0===n.strm.avail_out?N:z):n.last_lit&&(F(n,!1),0===n.strm.avail_out)?G:J}function u(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=_,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new h.Buf16(2*K),this.dyn_dtree=new h.Buf16(2*(2*I+1)),this.bl_tree=new h.Buf16(2*(2*M+1)),E(this.dyn_ltree),E(this.dyn_dtree),E(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new h.Buf16(O+1),this.heap=new h.Buf16(2*R+1),E(this.heap),this.heap_len=0,this.heap_max=0,this.depth=new h.Buf16(2*R+1),E(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}function o(n){var e;return n&&n.state?(n.total_in=n.total_out=0,n.data_type=T,(e=n.state).pending=0,e.pending_out=0,e.wrap<0&&(e.wrap=-e.wrap),e.status=e.wrap?j:H,n.adler=2===e.wrap?0:1,e.last_flush=S,p._tr_init(e),y):C(n,k)}function d(n){var e,t=o(n);return t===y&&((e=n.state).window_size=2*e.w_size,E(e.head),e.max_lazy_match=W[e.level].max_lazy,e.good_match=W[e.level].good_length,e.nice_match=W[e.level].nice_length,e.max_chain_length=W[e.level].max_chain,e.strstart=0,e.block_start=0,e.lookahead=0,e.insert=0,e.match_length=e.prev_length=U-1,e.match_available=0,e.ins_h=0),t}function A(n,e,t,r,a,i){if(!n)return k;var o=1;if(e===L&&(e=6),r<0?(o=0,r=-r):15<r&&(o=2,r-=16),a<1||w<a||t!==_||r<8||15<r||e<0||9<e||i<0||b<i)return C(n,k);8===r&&(r=9);var A=new u;return(n.state=A).strm=n,A.wrap=o,A.gzhead=null,A.w_bits=r,A.w_size=1<<A.w_bits,A.w_mask=A.w_size-1,A.hash_bits=a+7,A.hash_size=1<<A.hash_bits,A.hash_mask=A.hash_size-1,A.hash_shift=~~((A.hash_bits+U-1)/U),A.window=new h.Buf8(2*A.w_size),A.head=new h.Buf16(A.hash_size),A.prev=new h.Buf16(A.w_size),A.lit_bufsize=1<<a+6,A.pending_buf_size=4*A.lit_bufsize,A.pending_buf=new h.Buf8(A.pending_buf_size),A.d_buf=A.lit_bufsize>>1,A.l_buf=3*A.lit_bufsize,A.level=e,A.strategy=i,A.method=t,d(n)}function f(n,e,t,r,a){this.good_length=n,this.max_lazy=e,this.nice_length=t,this.max_chain=r,this.func=a}var h=n("../utils/common"),p=n("./trees"),P=n("./adler32"),m=n("./crc32"),g=n("./messages"),S=0,v=4,y=0,k=-2,L=-1,b=4,T=2,_=8,w=9,R=286,I=30,M=19,K=2*R+1,O=15,U=3,x=258,V=x+U+1,j=42,H=113,G=1,J=2,N=3,z=4,W=[new f(0,0,0,0,function(n,e){var t=65535;for(t>n.pending_buf_size-5&&(t=n.pending_buf_size-5);;){if(n.lookahead<=1){if(l(n),0===n.lookahead&&e===S)return G;if(0===n.lookahead)break}n.strstart+=n.lookahead,n.lookahead=0;var r=n.block_start+t;if((0===n.strstart||n.strstart>=r)&&(n.lookahead=n.strstart-r,n.strstart=r,F(n,!1),0===n.strm.avail_out))return G;if(n.strstart-n.block_start>=n.w_size-V&&(F(n,!1),0===n.strm.avail_out))return G}return n.insert=0,e===v?(F(n,!0),0===n.strm.avail_out?N:z):(n.strstart>n.block_start&&(F(n,!1),n.strm.avail_out),G)}),new f(4,4,8,4,r),new f(4,5,16,8,r),new f(4,6,32,32,r),new f(4,4,16,16,a),new f(8,16,32,32,a),new f(8,16,128,128,a),new f(8,32,128,256,a),new f(32,128,258,1024,a),new f(32,258,258,4096,a)];t.deflateInit=function(n,e){return A(n,e,_,15,8,0)},t.deflateInit2=A,t.deflateReset=d,t.deflateResetKeep=o,t.deflateSetHeader=function(n,e){return!n||!n.state||2!==n.state.wrap?k:(n.state.gzhead=e,y)},t.deflate=function(n,e){var t,r,a,i,o;if(!n||!n.state||5<e||e<0)return n?C(n,k):k;if(r=n.state,!n.output||!n.input&&0!==n.avail_in||666===r.status&&e!==v)return C(n,0===n.avail_out?-5:k);if(r.strm=n,t=r.last_flush,r.last_flush=e,r.status===j&&(2===r.wrap?(n.adler=0,B(r,31),B(r,139),B(r,8),r.gzhead?(B(r,(r.gzhead.text?1:0)+(r.gzhead.hcrc?2:0)+(r.gzhead.extra?4:0)+(r.gzhead.name?8:0)+(r.gzhead.comment?16:0)),B(r,255&r.gzhead.time),B(r,r.gzhead.time>>8&255),B(r,r.gzhead.time>>16&255),B(r,r.gzhead.time>>24&255),B(r,9===r.level?2:2<=r.strategy||r.level<2?4:0),B(r,255&r.gzhead.os),r.gzhead.extra&&r.gzhead.extra.length&&(B(r,255&r.gzhead.extra.length),B(r,r.gzhead.extra.length>>8&255)),r.gzhead.hcrc&&(n.adler=m(n.adler,r.pending_buf,r.pending,0)),r.gzindex=0,r.status=69):(B(r,0),B(r,0),B(r,0),B(r,0),B(r,0),B(r,9===r.level?2:2<=r.strategy||r.level<2?4:0),B(r,3),r.status=H)):(o=_+(r.w_bits-8<<4)<<8,o|=(2<=r.strategy||r.level<2?0:r.level<6?1:6===r.level?2:3)<<6,0!==r.strstart&&(o|=32),o+=31-o%31,r.status=H,c(r,o),0!==r.strstart&&(c(r,n.adler>>>16),c(r,65535&n.adler)),n.adler=1)),69===r.status)if(r.gzhead.extra){for(a=r.pending;r.gzindex<(65535&r.gzhead.extra.length)&&(r.pending!==r.pending_buf_size||(r.gzhead.hcrc&&r.pending>a&&(n.adler=m(n.adler,r.pending_buf,r.pending-a,a)),s(n),a=r.pending,r.pending!==r.pending_buf_size));)B(r,255&r.gzhead.extra[r.gzindex]),r.gzindex++;r.gzhead.hcrc&&r.pending>a&&(n.adler=m(n.adler,r.pending_buf,r.pending-a,a)),r.gzindex===r.gzhead.extra.length&&(r.gzindex=0,r.status=73)}else r.status=73;if(73===r.status)if(r.gzhead.name){a=r.pending;do{if(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>a&&(n.adler=m(n.adler,r.pending_buf,r.pending-a,a)),s(n),a=r.pending,r.pending===r.pending_buf_size)){i=1;break}i=r.gzindex<r.gzhead.name.length?255&r.gzhead.name.charCodeAt(r.gzindex++):0,B(r,i)}while(0!==i);r.gzhead.hcrc&&r.pending>a&&(n.adler=m(n.adler,r.pending_buf,r.pending-a,a)),0===i&&(r.gzindex=0,r.status=91)}else r.status=91;if(91===r.status)if(r.gzhead.comment){a=r.pending;do{if(r.pending===r.pending_buf_size&&(r.gzhead.hcrc&&r.pending>a&&(n.adler=m(n.adler,r.pending_buf,r.pending-a,a)),s(n),a=r.pending,r.pending===r.pending_buf_size)){i=1;break}i=r.gzindex<r.gzhead.comment.length?255&r.gzhead.comment.charCodeAt(r.gzindex++):0,B(r,i)}while(0!==i);r.gzhead.hcrc&&r.pending>a&&(n.adler=m(n.adler,r.pending_buf,r.pending-a,a)),0===i&&(r.status=103)}else r.status=103;if(103===r.status&&(r.gzhead.hcrc?(r.pending+2>r.pending_buf_size&&s(n),r.pending+2<=r.pending_buf_size&&(B(r,255&n.adler),B(r,n.adler>>8&255),n.adler=0,r.status=H)):r.status=H),0!==r.pending){if(s(n),0===n.avail_out)return r.last_flush=-1,y}else if(0===n.avail_in&&D(e)<=D(t)&&e!==v)return C(n,-5);if(666===r.status&&0!==n.avail_in)return C(n,-5);if(0!==n.avail_in||0!==r.lookahead||e!==S&&666!==r.status){var A=2===r.strategy?function(n,e){for(var t;;){if(0===n.lookahead&&(l(n),0===n.lookahead)){if(e===S)return G;break}if(n.match_length=0,t=p._tr_tally(n,0,n.window[n.strstart]),n.lookahead--,n.strstart++,t&&(F(n,!1),0===n.strm.avail_out))return G}return n.insert=0,e===v?(F(n,!0),0===n.strm.avail_out?N:z):n.last_lit&&(F(n,!1),0===n.strm.avail_out)?G:J}(r,e):3===r.strategy?function(n,e){for(var t,r,a,i,o=n.window;;){if(n.lookahead<=x){if(l(n),n.lookahead<=x&&e===S)return G;if(0===n.lookahead)break}if(n.match_length=0,n.lookahead>=U&&0<n.strstart&&((r=o[a=n.strstart-1])===o[++a]&&r===o[++a]&&r===o[++a])){i=n.strstart+x;do{}while(r===o[++a]&&r===o[++a]&&r===o[++a]&&r===o[++a]&&r===o[++a]&&r===o[++a]&&r===o[++a]&&r===o[++a]&&a<i);n.match_length=x-(i-a),n.match_length>n.lookahead&&(n.match_length=n.lookahead)}if(n.match_length>=U?(t=p._tr_tally(n,1,n.match_length-U),n.lookahead-=n.match_length,n.strstart+=n.match_length,n.match_length=0):(t=p._tr_tally(n,0,n.window[n.strstart]),n.lookahead--,n.strstart++),t&&(F(n,!1),0===n.strm.avail_out))return G}return n.insert=0,e===v?(F(n,!0),0===n.strm.avail_out?N:z):n.last_lit&&(F(n,!1),0===n.strm.avail_out)?G:J}(r,e):W[r.level].func(r,e);if(A!==N&&A!==z||(r.status=666),A===G||A===N)return 0===n.avail_out&&(r.last_flush=-1),y;if(A===J&&(1===e?p._tr_align(r):5!==e&&(p._tr_stored_block(r,0,0,!1),3===e&&(E(r.head),0===r.lookahead&&(r.strstart=0,r.block_start=0,r.insert=0))),s(n),0===n.avail_out))return r.last_flush=-1,y}return e!==v?y:r.wrap<=0?1:(2===r.wrap?(B(r,255&n.adler),B(r,n.adler>>8&255),B(r,n.adler>>16&255),B(r,n.adler>>24&255),B(r,255&n.total_in),B(r,n.total_in>>8&255),B(r,n.total_in>>16&255),B(r,n.total_in>>24&255)):(c(r,n.adler>>>16),c(r,65535&n.adler)),s(n),0<r.wrap&&(r.wrap=-r.wrap),0!==r.pending?y:1)},t.deflateEnd=function(n){var e;return n&&n.state?(e=n.state.status)!==j&&69!==e&&73!==e&&91!==e&&103!==e&&e!==H&&666!==e?C(n,k):(n.state=null,e===H?C(n,-3):y):k},t.deflateInfo="pako deflate (from Nodeca project)"},{"../utils/common":27,"./adler32":29,"./crc32":31,"./messages":37,"./trees":38}],33:[function(n,e){"use strict";e.exports=function(){this.text=0,this.time=0,this.xflags=0,this.os=0,this.extra=null,this.extra_len=0,this.name="",this.comment="",this.hcrc=0,this.done=!1}},{}],34:[function(n,e){"use strict";e.exports=function(n,e){var t,r,a,i,o,A,C=n.state,D=n.next_in,E=n.input,s=D+(n.avail_in-5),F=n.next_out,B=n.output,c=F-(e-n.avail_out),l=F+(n.avail_out-257),u=C.dmax,d=C.wsize,f=C.whave,h=C.wnext,p=C.window,P=C.hold,m=C.bits,g=C.lencode,S=C.distcode,v=(1<<C.lenbits)-1,y=(1<<C.distbits)-1;n:do{m<15&&(P+=E[D++]<<m,m+=8,P+=E[D++]<<m,m+=8),t=g[P&v];e:for(;;){if(P>>>=r=t>>>24,m-=r,0===(r=t>>>16&255))B[F++]=65535&t;else{if(!(16&r)){if(0==(64&r)){t=g[(65535&t)+(P&(1<<r)-1)];continue e}if(32&r){C.mode=12;break n}n.msg="invalid literal/length code",C.mode=30;break n}a=65535&t,(r&=15)&&(m<r&&(P+=E[D++]<<m,m+=8),a+=P&(1<<r)-1,P>>>=r,m-=r),m<15&&(P+=E[D++]<<m,m+=8,P+=E[D++]<<m,m+=8),t=S[P&y];t:for(;;){if(P>>>=r=t>>>24,m-=r,!(16&(r=t>>>16&255))){if(0==(64&r)){t=S[(65535&t)+(P&(1<<r)-1)];continue t}n.msg="invalid distance code",C.mode=30;break n}if(i=65535&t,m<(r&=15)&&(P+=E[D++]<<m,(m+=8)<r&&(P+=E[D++]<<m,m+=8)),u<(i+=P&(1<<r)-1)){n.msg="invalid distance too far back",C.mode=30;break n}if(P>>>=r,m-=r,(r=F-c)<i){if(f<(r=i-r)&&C.sane){n.msg="invalid distance too far back",C.mode=30;break n}if(A=p,(o=0)===h){if(o+=d-r,r<a){for(a-=r;B[F++]=p[o++],--r;);o=F-i,A=B}}else if(h<r){if(o+=d+h-r,(r-=h)<a){for(a-=r;B[F++]=p[o++],--r;);if(o=0,h<a){for(a-=r=h;B[F++]=p[o++],--r;);o=F-i,A=B}}}else if(o+=h-r,r<a){for(a-=r;B[F++]=p[o++],--r;);o=F-i,A=B}for(;2<a;)B[F++]=A[o++],B[F++]=A[o++],B[F++]=A[o++],a-=3;a&&(B[F++]=A[o++],1<a&&(B[F++]=A[o++]))}else{for(o=F-i;B[F++]=B[o++],B[F++]=B[o++],B[F++]=B[o++],2<(a-=3););a&&(B[F++]=B[o++],1<a&&(B[F++]=B[o++]))}break}}break}}while(D<s&&F<l);D-=a=m>>3,P&=(1<<(m-=a<<3))-1,n.next_in=D,n.next_out=F,n.avail_in=D<s?s-D+5:5-(D-s),n.avail_out=F<l?l-F+257:257-(F-l),C.hold=P,C.bits=m}},{}],35:[function(n,e,t){"use strict";function M(n){return(n>>>24&255)+(n>>>8&65280)+((65280&n)<<8)+((255&n)<<24)}function a(){this.mode=0,this.last=!1,this.wrap=0,this.havedict=!1,this.flags=0,this.dmax=0,this.check=0,this.total=0,this.head=null,this.wbits=0,this.wsize=0,this.whave=0,this.wnext=0,this.window=null,this.hold=0,this.bits=0,this.length=0,this.offset=0,this.extra=0,this.lencode=null,this.distcode=null,this.lenbits=0,this.distbits=0,this.ncode=0,this.nlen=0,this.ndist=0,this.have=0,this.next=null,this.lens=new U.Buf16(320),this.work=new U.Buf16(288),this.lendyn=null,this.distdyn=null,this.sane=0,this.back=0,this.was=0}function r(n){var e;return n&&n.state?(e=n.state,n.total_in=n.total_out=e.total=0,n.msg="",e.wrap&&(n.adler=1&e.wrap),e.mode=W,e.last=0,e.havedict=0,e.dmax=32768,e.head=null,e.hold=0,e.bits=0,e.lencode=e.lendyn=new U.Buf32(C),e.distcode=e.distdyn=new U.Buf32(D),e.sane=1,e.back=-1,N):z}function i(n){var e;return n&&n.state?((e=n.state).wsize=0,e.whave=0,e.wnext=0,r(n)):z}function o(n,e){var t,r;return n&&n.state?(r=n.state,e<0?(t=0,e=-e):(t=1+(e>>4),e<48&&(e&=15)),e&&(e<8||15<e)?z:(null!==r.window&&r.wbits!==e&&(r.window=null),r.wrap=t,r.wbits=e,i(n))):z}function A(n,e){var t,r;return n?(r=new a,(n.state=r).window=null,(t=o(n,e))!==N&&(n.state=null),t):z}var K,O,U=n("../utils/common"),x=n("./adler32"),V=n("./crc32"),j=n("./inffast"),H=n("./inftrees"),G=1,J=2,N=0,z=-2,W=1,C=852,D=592,Y=!0;t.inflateReset=i,t.inflateReset2=o,t.inflateResetKeep=r,t.inflateInit=function(n){return A(n,15)},t.inflateInit2=A,t.inflate=function(n,e){var t,r,a,i,o,A,C,D,E,s,F,B,c,l,u,d,f,h,p,P,m,g,S,v,y,k,L,b,T,_,w=0,R=new U.Buf8(4),I=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];if(!n||!n.state||!n.output||!n.input&&0!==n.avail_in)return z;12===(t=n.state).mode&&(t.mode=13),o=n.next_out,a=n.output,C=n.avail_out,i=n.next_in,r=n.input,A=n.avail_in,D=t.hold,E=t.bits,s=A,F=C,g=N;n:for(;;)switch(t.mode){case W:if(0===t.wrap){t.mode=13;break}for(;E<16;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(2&t.wrap&&35615===D){R[t.check=0]=255&D,R[1]=D>>>8&255,t.check=V(t.check,R,2,0),E=D=0,t.mode=2;break}if(t.flags=0,t.head&&(t.head.done=!1),!(1&t.wrap)||(((255&D)<<8)+(D>>8))%31){n.msg="incorrect header check",t.mode=30;break}if(8!=(15&D)){n.msg="unknown compression method",t.mode=30;break}if(E-=4,m=8+(15&(D>>>=4)),0===t.wbits)t.wbits=m;else if(m>t.wbits){n.msg="invalid window size",t.mode=30;break}t.dmax=1<<m,n.adler=t.check=1,t.mode=512&D?10:12,E=D=0;break;case 2:for(;E<16;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(t.flags=D,8!=(255&t.flags)){n.msg="unknown compression method",t.mode=30;break}if(57344&t.flags){n.msg="unknown header flags set",t.mode=30;break}t.head&&(t.head.text=D>>8&1),512&t.flags&&(R[0]=255&D,R[1]=D>>>8&255,t.check=V(t.check,R,2,0)),E=D=0,t.mode=3;case 3:for(;E<32;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}t.head&&(t.head.time=D),512&t.flags&&(R[0]=255&D,R[1]=D>>>8&255,R[2]=D>>>16&255,R[3]=D>>>24&255,t.check=V(t.check,R,4,0)),E=D=0,t.mode=4;case 4:for(;E<16;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}t.head&&(t.head.xflags=255&D,t.head.os=D>>8),512&t.flags&&(R[0]=255&D,R[1]=D>>>8&255,t.check=V(t.check,R,2,0)),E=D=0,t.mode=5;case 5:if(1024&t.flags){for(;E<16;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}t.length=D,t.head&&(t.head.extra_len=D),512&t.flags&&(R[0]=255&D,R[1]=D>>>8&255,t.check=V(t.check,R,2,0)),E=D=0}else t.head&&(t.head.extra=null);t.mode=6;case 6:if(1024&t.flags&&(A<(B=t.length)&&(B=A),B&&(t.head&&(m=t.head.extra_len-t.length,t.head.extra||(t.head.extra=new Array(t.head.extra_len)),U.arraySet(t.head.extra,r,i,B,m)),512&t.flags&&(t.check=V(t.check,r,B,i)),A-=B,i+=B,t.length-=B),t.length))break n;t.length=0,t.mode=7;case 7:if(2048&t.flags){if(0===A)break n;for(B=0;m=r[i+B++],t.head&&m&&t.length<65536&&(t.head.name+=String.fromCharCode(m)),m&&B<A;);if(512&t.flags&&(t.check=V(t.check,r,B,i)),A-=B,i+=B,m)break n}else t.head&&(t.head.name=null);t.length=0,t.mode=8;case 8:if(4096&t.flags){if(0===A)break n;for(B=0;m=r[i+B++],t.head&&m&&t.length<65536&&(t.head.comment+=String.fromCharCode(m)),m&&B<A;);if(512&t.flags&&(t.check=V(t.check,r,B,i)),A-=B,i+=B,m)break n}else t.head&&(t.head.comment=null);t.mode=9;case 9:if(512&t.flags){for(;E<16;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(D!==(65535&t.check)){n.msg="header crc mismatch",t.mode=30;break}E=D=0}t.head&&(t.head.hcrc=t.flags>>9&1,t.head.done=!0),n.adler=t.check=0,t.mode=12;break;case 10:for(;E<32;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}n.adler=t.check=M(D),E=D=0,t.mode=11;case 11:if(0===t.havedict)return n.next_out=o,n.avail_out=C,n.next_in=i,n.avail_in=A,t.hold=D,t.bits=E,2;n.adler=t.check=1,t.mode=12;case 12:if(5===e||6===e)break n;case 13:if(t.last){D>>>=7&E,E-=7&E,t.mode=27;break}for(;E<3;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}switch(t.last=1&D,--E,3&(D>>>=1)){case 0:t.mode=14;break;case 1:if(function(n){if(Y){var e;for(K=new U.Buf32(512),O=new U.Buf32(32),e=0;e<144;)n.lens[e++]=8;for(;e<256;)n.lens[e++]=9;for(;e<280;)n.lens[e++]=7;for(;e<288;)n.lens[e++]=8;for(H(G,n.lens,0,288,K,0,n.work,{bits:9}),e=0;e<32;)n.lens[e++]=5;H(J,n.lens,0,32,O,0,n.work,{bits:5}),Y=!1}n.lencode=K,n.lenbits=9,n.distcode=O,n.distbits=5}(t),t.mode=20,6!==e)break;D>>>=2,E-=2;break n;case 2:t.mode=17;break;case 3:n.msg="invalid block type",t.mode=30}D>>>=2,E-=2;break;case 14:for(D>>>=7&E,E-=7&E;E<32;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if((65535&D)!=(D>>>16^65535)){n.msg="invalid stored block lengths",t.mode=30;break}if(t.length=65535&D,E=D=0,t.mode=15,6===e)break n;case 15:t.mode=16;case 16:if(B=t.length){if(A<B&&(B=A),C<B&&(B=C),0===B)break n;U.arraySet(a,r,i,B,o),A-=B,i+=B,C-=B,o+=B,t.length-=B;break}t.mode=12;break;case 17:for(;E<14;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(t.nlen=257+(31&D),D>>>=5,E-=5,t.ndist=1+(31&D),D>>>=5,E-=5,t.ncode=4+(15&D),D>>>=4,E-=4,286<t.nlen||30<t.ndist){n.msg="too many length or distance symbols",t.mode=30;break}t.have=0,t.mode=18;case 18:for(;t.have<t.ncode;){for(;E<3;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}t.lens[I[t.have++]]=7&D,D>>>=3,E-=3}for(;t.have<19;)t.lens[I[t.have++]]=0;if(t.lencode=t.lendyn,t.lenbits=7,S={bits:t.lenbits},g=H(0,t.lens,0,19,t.lencode,0,t.work,S),t.lenbits=S.bits,g){n.msg="invalid code lengths set",t.mode=30;break}t.have=0,t.mode=19;case 19:for(;t.have<t.nlen+t.ndist;){for(;d=(w=t.lencode[D&(1<<t.lenbits)-1])>>>16&255,f=65535&w,!((u=w>>>24)<=E);){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(f<16)D>>>=u,E-=u,t.lens[t.have++]=f;else{if(16===f){for(v=u+2;E<v;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(D>>>=u,E-=u,0===t.have){n.msg="invalid bit length repeat",t.mode=30;break}m=t.lens[t.have-1],B=3+(3&D),D>>>=2,E-=2}else if(17===f){for(v=u+3;E<v;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}E-=u,m=0,B=3+(7&(D>>>=u)),D>>>=3,E-=3}else{for(v=u+7;E<v;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}E-=u,m=0,B=11+(127&(D>>>=u)),D>>>=7,E-=7}if(t.have+B>t.nlen+t.ndist){n.msg="invalid bit length repeat",t.mode=30;break}for(;B--;)t.lens[t.have++]=m}}if(30===t.mode)break;if(0===t.lens[256]){n.msg="invalid code -- missing end-of-block",t.mode=30;break}if(t.lenbits=9,S={bits:t.lenbits},g=H(G,t.lens,0,t.nlen,t.lencode,0,t.work,S),t.lenbits=S.bits,g){n.msg="invalid literal/lengths set",t.mode=30;break}if(t.distbits=6,t.distcode=t.distdyn,S={bits:t.distbits},g=H(J,t.lens,t.nlen,t.ndist,t.distcode,0,t.work,S),t.distbits=S.bits,g){n.msg="invalid distances set",t.mode=30;break}if(t.mode=20,6===e)break n;case 20:t.mode=21;case 21:if(6<=A&&258<=C){n.next_out=o,n.avail_out=C,n.next_in=i,n.avail_in=A,t.hold=D,t.bits=E,j(n,F),o=n.next_out,a=n.output,C=n.avail_out,i=n.next_in,r=n.input,A=n.avail_in,D=t.hold,E=t.bits,12===t.mode&&(t.back=-1);break}for(t.back=0;d=(w=t.lencode[D&(1<<t.lenbits)-1])>>>16&255,f=65535&w,!((u=w>>>24)<=E);){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(d&&0==(240&d)){for(h=u,p=d,P=f;d=(w=t.lencode[P+((D&(1<<h+p)-1)>>h)])>>>16&255,f=65535&w,!(h+(u=w>>>24)<=E);){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}D>>>=h,E-=h,t.back+=h}if(D>>>=u,E-=u,t.back+=u,t.length=f,0===d){t.mode=26;break}if(32&d){t.back=-1,t.mode=12;break}if(64&d){n.msg="invalid literal/length code",t.mode=30;break}t.extra=15&d,t.mode=22;case 22:if(t.extra){for(v=t.extra;E<v;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}t.length+=D&(1<<t.extra)-1,D>>>=t.extra,E-=t.extra,t.back+=t.extra}t.was=t.length,t.mode=23;case 23:for(;d=(w=t.distcode[D&(1<<t.distbits)-1])>>>16&255,f=65535&w,!((u=w>>>24)<=E);){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(0==(240&d)){for(h=u,p=d,P=f;d=(w=t.distcode[P+((D&(1<<h+p)-1)>>h)])>>>16&255,f=65535&w,!(h+(u=w>>>24)<=E);){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}D>>>=h,E-=h,t.back+=h}if(D>>>=u,E-=u,t.back+=u,64&d){n.msg="invalid distance code",t.mode=30;break}t.offset=f,t.extra=15&d,t.mode=24;case 24:if(t.extra){for(v=t.extra;E<v;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}t.offset+=D&(1<<t.extra)-1,D>>>=t.extra,E-=t.extra,t.back+=t.extra}if(t.offset>t.dmax){n.msg="invalid distance too far back",t.mode=30;break}t.mode=25;case 25:if(0===C)break n;if(B=F-C,t.offset>B){if((B=t.offset-B)>t.whave&&t.sane){n.msg="invalid distance too far back",t.mode=30;break}c=B>t.wnext?(B-=t.wnext,t.wsize-B):t.wnext-B,B>t.length&&(B=t.length),l=t.window}else l=a,c=o-t.offset,B=t.length;for(C<B&&(B=C),C-=B,t.length-=B;a[o++]=l[c++],--B;);0===t.length&&(t.mode=21);break;case 26:if(0===C)break n;a[o++]=t.length,C--,t.mode=21;break;case 27:if(t.wrap){for(;E<32;){if(0===A)break n;A--,D|=r[i++]<<E,E+=8}if(F-=C,n.total_out+=F,t.total+=F,F&&(n.adler=t.check=(t.flags?V:x)(t.check,a,F,o-F)),F=C,(t.flags?D:M(D))!==t.check){n.msg="incorrect data check",t.mode=30;break}E=D=0}t.mode=28;case 28:if(t.wrap&&t.flags){for(;E<32;){if(0===A)break n;A--,D+=r[i++]<<E,E+=8}if(D!==(4294967295&t.total)){n.msg="incorrect length check",t.mode=30;break}E=D=0}t.mode=29;case 29:g=1;break n;case 30:g=-3;break n;case 31:return-4;case 32:default:return z}return n.next_out=o,n.avail_out=C,n.next_in=i,n.avail_in=A,t.hold=D,t.bits=E,(t.wsize||F!==n.avail_out&&t.mode<30&&(t.mode<27||4!==e))&&(k=(y=n).output,L=n.next_out,b=F-n.avail_out,null===(_=y.state).window&&(_.wsize=1<<_.wbits,_.wnext=0,_.whave=0,_.window=new U.Buf8(_.wsize)),b>=_.wsize?(U.arraySet(_.window,k,L-_.wsize,_.wsize,0),_.wnext=0,_.whave=_.wsize):(b<(T=_.wsize-_.wnext)&&(T=b),U.arraySet(_.window,k,L-b,T,_.wnext),(b-=T)?(U.arraySet(_.window,k,L-b,b,0),_.wnext=b,_.whave=_.wsize):(_.wnext+=T,_.wnext===_.wsize&&(_.wnext=0),_.whave<_.wsize&&(_.whave+=T))),0)?(t.mode=31,-4):(s-=n.avail_in,F-=n.avail_out,n.total_in+=s,n.total_out+=F,t.total+=F,t.wrap&&F&&(n.adler=t.check=(t.flags?V:x)(t.check,a,F,n.next_out-F)),n.data_type=t.bits+(t.last?64:0)+(12===t.mode?128:0)+(20===t.mode||15===t.mode?256:0),(0==s&&0===F||4===e)&&g===N&&(g=-5),g)},t.inflateEnd=function(n){if(!n||!n.state)return z;var e=n.state;return e.window&&(e.window=null),n.state=null,N},t.inflateGetHeader=function(n,e){var t;return n&&n.state?0==(2&(t=n.state).wrap)?z:((t.head=e).done=!1,N):z},t.inflateInfo="pako inflate (from Nodeca project)"},{"../utils/common":27,"./adler32":29,"./crc32":31,"./inffast":34,"./inftrees":36}],36:[function(n,e){"use strict";var I=n("../utils/common"),M=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0],K=[16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78],O=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0],U=[16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64];e.exports=function(n,e,t,r,a,i,o,A){for(var C,D,E,s,F,B,c,l,u,d=A.bits,f=0,h=0,p=0,P=0,m=0,g=0,S=0,v=0,y=0,k=0,L=null,b=0,T=new I.Buf16(16),_=new I.Buf16(16),w=null,R=0,f=0;f<=15;f++)T[f]=0;for(h=0;h<r;h++)T[e[t+h]]++;for(m=d,P=15;1<=P&&0===T[P];P--);if(P<m&&(m=P),0===P)return a[i++]=20971520,a[i++]=20971520,A.bits=1,0;for(p=1;p<P&&0===T[p];p++);for(m<p&&(m=p),f=v=1;f<=15;f++)if(v<<=1,(v-=T[f])<0)return-1;if(0<v&&(0===n||1!==P))return-1;for(_[1]=0,f=1;f<15;f++)_[f+1]=_[f]+T[f];for(h=0;h<r;h++)0!==e[t+h]&&(o[_[e[t+h]]++]=h);if(B=0===n?(L=w=o,19):1===n?(L=M,b-=257,w=K,R-=257,256):(L=O,w=U,-1),f=p,F=i,E=-1,s=(y=1<<(g=m))-1,1===n&&852<y||2===n&&592<y)return 1;for(S=h=k=0;;){for(c=f-S,u=o[h]<B?(l=0,o[h]):o[h]>B?(l=w[R+o[h]],L[b+o[h]]):(l=96,0),C=1<<f-S,p=D=1<<g;a[F+(k>>S)+(D-=C)]=c<<24|l<<16|u|0,0!==D;);for(C=1<<f-1;k&C;)C>>=1;if(0!==C?(k&=C-1,k+=C):k=0,h++,0==--T[f]){if(f===P)break;f=e[t+o[h]]}if(m<f&&(k&s)!==E){for(0===S&&(S=m),F+=p,v=1<<(g=f-S);g+S<P&&!((v-=T[g+S])<=0);)g++,v<<=1;if(y+=1<<g,1===n&&852<y||2===n&&592<y)return 1;a[E=k&s]=m<<24|g<<16|F-i|0}}return 0!==k&&(a[F+k]=f-S<<24|64<<16|0),A.bits=m,0}},{"../utils/common":27}],37:[function(n,e){"use strict";e.exports={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"}},{}],38:[function(n,e,t){"use strict";function r(n){for(var e=n.length;0<=--e;)n[e]=0}function C(n){return n<256?H[n]:H[256+(n>>>7)]}function D(n,e){n.pending_buf[n.pending++]=255&e,n.pending_buf[n.pending++]=e>>>8&255}function E(n,e,t){n.bi_valid>a-t?(n.bi_buf|=e<<n.bi_valid&65535,D(n,n.bi_buf),n.bi_buf=e>>a-n.bi_valid,n.bi_valid+=t-a):(n.bi_buf|=e<<n.bi_valid&65535,n.bi_valid+=t)}function s(n,e,t){E(n,t[2*e],t[2*e+1])}function F(n,e){for(var t=0;t|=1&n,n>>>=1,t<<=1,0<--e;);return t>>>1}function B(n,e,t){for(var r,a=new Array(T+1),i=0,o=1;o<=T;o++)a[o]=i=i+t[o-1]<<1;for(r=0;r<=e;r++){var A=n[2*r+1];0!==A&&(n[2*r]=F(a[A]++,A))}}function A(n){for(var e=0;e<y;e++)n.dyn_ltree[2*e]=0;for(e=0;e<k;e++)n.dyn_dtree[2*e]=0;for(e=0;e<L;e++)n.bl_tree[2*e]=0;n.dyn_ltree[2*w]=1,n.opt_len=n.static_len=0,n.last_lit=n.matches=0}function c(n){8<n.bi_valid?D(n,n.bi_buf):0<n.bi_valid&&(n.pending_buf[n.pending++]=n.bi_buf),n.bi_buf=0,n.bi_valid=0}function i(n,e,t,r){var a=2*e,i=2*t;return n[a]<n[i]||n[a]===n[i]&&r[e]<=r[t]}function l(n,e,t){for(var r=n.heap[t],a=t<<1;a<=n.heap_len&&(a<n.heap_len&&i(e,n.heap[a+1],n.heap[a],n.depth)&&a++,!i(e,r,n.heap[a],n.depth));)n.heap[t]=n.heap[a],t=a,a<<=1;n.heap[t]=r}function u(n,e,t){var r,a,i,o,A=0;if(0!==n.last_lit)for(;r=n.pending_buf[n.d_buf+2*A]<<8|n.pending_buf[n.d_buf+2*A+1],a=n.pending_buf[n.l_buf+A],A++,0==r?s(n,a,e):(s(n,(i=G[a])+v+1,e),0!==(o=K[i])&&E(n,a-=J[i],o),s(n,i=C(--r),t),0!==(o=O[i])&&E(n,r-=N[i],o)),A<n.last_lit;);s(n,w,e)}function d(n,e){var t,r,a,i=e.dyn_tree,o=e.stat_desc.static_tree,A=e.stat_desc.has_stree,C=e.stat_desc.elems,D=-1;for(n.heap_len=0,n.heap_max=b,t=0;t<C;t++)0!==i[2*t]?(n.heap[++n.heap_len]=D=t,n.depth[t]=0):i[2*t+1]=0;for(;n.heap_len<2;)i[2*(a=n.heap[++n.heap_len]=D<2?++D:0)]=1,n.depth[a]=0,n.opt_len--,A&&(n.static_len-=o[2*a+1]);for(e.max_code=D,t=n.heap_len>>1;1<=t;t--)l(n,i,t);for(a=C;t=n.heap[1],n.heap[1]=n.heap[n.heap_len--],l(n,i,1),r=n.heap[1],n.heap[--n.heap_max]=t,n.heap[--n.heap_max]=r,i[2*a]=i[2*t]+i[2*r],n.depth[a]=(n.depth[t]>=n.depth[r]?n.depth[t]:n.depth[r])+1,i[2*t+1]=i[2*r+1]=a,n.heap[1]=a++,l(n,i,1),2<=n.heap_len;);n.heap[--n.heap_max]=n.heap[1],function(n,e){for(var t,r,a,i,o,A=e.dyn_tree,C=e.max_code,D=e.stat_desc.static_tree,E=e.stat_desc.has_stree,s=e.stat_desc.extra_bits,F=e.stat_desc.extra_base,B=e.stat_desc.max_length,c=0,l=0;l<=T;l++)n.bl_count[l]=0;for(A[2*n.heap[n.heap_max]+1]=0,t=n.heap_max+1;t<b;t++)B<(l=A[2*A[2*(r=n.heap[t])+1]+1]+1)&&(l=B,c++),A[2*r+1]=l,C<r||(n.bl_count[l]++,i=0,F<=r&&(i=s[r-F]),o=A[2*r],n.opt_len+=o*(l+i),E&&(n.static_len+=o*(D[2*r+1]+i)));if(0!==c){do{for(l=B-1;0===n.bl_count[l];)l--;n.bl_count[l]--,n.bl_count[l+1]+=2,n.bl_count[B]--,c-=2}while(0<c);for(l=B;0!==l;l--)for(r=n.bl_count[l];0!==r;)C<(a=n.heap[--t])||(A[2*a+1]!==l&&(n.opt_len+=(l-A[2*a+1])*A[2*a],A[2*a+1]=l),r--)}}(n,e),B(i,D,n.bl_count)}function f(n,e,t){var r,a,i=-1,o=e[1],A=0,C=7,D=4;for(0===o&&(C=138,D=3),e[2*(t+1)+1]=65535,r=0;r<=t;r++)a=o,o=e[2*(r+1)+1],++A<C&&a===o||(A<D?n.bl_tree[2*a]+=A:0!==a?(a!==i&&n.bl_tree[2*a]++,n.bl_tree[2*R]++):A<=10?n.bl_tree[2*I]++:n.bl_tree[2*M]++,i=a,D=(A=0)===o?(C=138,3):a===o?(C=6,3):(C=7,4))}function h(n,e,t){var r,a,i=-1,o=e[1],A=0,C=7,D=4;for(0===o&&(C=138,D=3),r=0;r<=t;r++)if(a=o,o=e[2*(r+1)+1],!(++A<C&&a===o)){if(A<D)for(;s(n,a,n.bl_tree),0!=--A;);else 0!==a?(a!==i&&(s(n,a,n.bl_tree),A--),s(n,R,n.bl_tree),E(n,A-3,2)):A<=10?(s(n,I,n.bl_tree),E(n,A-3,3)):(s(n,M,n.bl_tree),E(n,A-11,7));i=a,D=(A=0)===o?(C=138,3):a===o?(C=6,3):(C=7,4)}}function p(n,e,t,r){var a,i,o,A;E(n,(S<<1)+(r?1:0),3),i=e,o=t,A=!0,c(a=n),A&&(D(a,o),D(a,~o)),P.arraySet(a.pending_buf,a.window,i,o,a.pending),a.pending+=o}var P=n("../utils/common"),m=0,g=1,S=0,o=29,v=256,y=v+1+o,k=30,L=19,b=2*y+1,T=15,a=16,_=7,w=256,R=16,I=17,M=18,K=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],O=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],U=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],x=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],V=new Array(2*(y+2));r(V);var j=new Array(2*k);r(j);var H=new Array(512);r(H);var G=new Array(256);r(G);var J=new Array(o);r(J);var N=new Array(k);r(N);function z(n,e){this.dyn_tree=n,this.max_code=0,this.stat_desc=e}var W,Y,X,Z=function(n,e,t,r,a){this.static_tree=n,this.extra_bits=e,this.extra_base=t,this.elems=r,this.max_length=a,this.has_stree=n&&n.length},Q=!1;t._tr_init=function(n){Q||(function(){for(var n,e,t,r=new Array(T+1),a=0,i=0;i<o-1;i++)for(J[i]=a,n=0;n<1<<K[i];n++)G[a++]=i;for(G[a-1]=i,i=t=0;i<16;i++)for(N[i]=t,n=0;n<1<<O[i];n++)H[t++]=i;for(t>>=7;i<k;i++)for(N[i]=t<<7,n=0;n<1<<O[i]-7;n++)H[256+t++]=i;for(e=0;e<=T;e++)r[e]=0;for(n=0;n<=143;)V[2*n+1]=8,n++,r[8]++;for(;n<=255;)V[2*n+1]=9,n++,r[9]++;for(;n<=279;)V[2*n+1]=7,n++,r[7]++;for(;n<=287;)V[2*n+1]=8,n++,r[8]++;for(B(V,y+1,r),n=0;n<k;n++)j[2*n+1]=5,j[2*n]=F(n,5);W=new Z(V,K,v+1,y,T),Y=new Z(j,O,0,k,T),X=new Z(new Array(0),U,0,L,_)}(),Q=!0),n.l_desc=new z(n.dyn_ltree,W),n.d_desc=new z(n.dyn_dtree,Y),n.bl_desc=new z(n.bl_tree,X),n.bi_buf=0,n.bi_valid=0,A(n)},t._tr_stored_block=p,t._tr_flush_block=function(n,e,t,r){var a,i,o=0;0<n.level?(2===n.strm.data_type&&(n.strm.data_type=function(n){for(var e=4093624447,t=0;t<=31;t++,e>>>=1)if(1&e&&0!==n.dyn_ltree[2*t])return m;if(0!==n.dyn_ltree[18]||0!==n.dyn_ltree[20]||0!==n.dyn_ltree[26])return g;for(t=32;t<v;t++)if(0!==n.dyn_ltree[2*t])return g;return m}(n)),d(n,n.l_desc),d(n,n.d_desc),o=function(n){var e;for(f(n,n.dyn_ltree,n.l_desc.max_code),f(n,n.dyn_dtree,n.d_desc.max_code),d(n,n.bl_desc),e=L-1;3<=e&&0===n.bl_tree[2*x[e]+1];e--);return n.opt_len+=3*(e+1)+5+5+4,e}(n),a=n.opt_len+3+7>>>3,(i=n.static_len+3+7>>>3)<=a&&(a=i)):a=i=t+5,t+4<=a&&-1!==e?p(n,e,t,r):4===n.strategy||i===a?(E(n,2+(r?1:0),3),u(n,V,j)):(E(n,4+(r?1:0),3),function(n,e,t,r){var a;for(E(n,e-257,5),E(n,t-1,5),E(n,r-4,4),a=0;a<r;a++)E(n,n.bl_tree[2*x[a]+1],3);h(n,n.dyn_ltree,e-1),h(n,n.dyn_dtree,t-1)}(n,n.l_desc.max_code+1,n.d_desc.max_code+1,o+1),u(n,n.dyn_ltree,n.dyn_dtree)),A(n),r&&c(n)},t._tr_tally=function(n,e,t){return n.pending_buf[n.d_buf+2*n.last_lit]=e>>>8&255,n.pending_buf[n.d_buf+2*n.last_lit+1]=255&e,n.pending_buf[n.l_buf+n.last_lit]=255&t,n.last_lit++,0===e?n.dyn_ltree[2*t]++:(n.matches++,e--,n.dyn_ltree[2*(G[t]+v+1)]++,n.dyn_dtree[2*C(e)]++),n.last_lit===n.lit_bufsize-1},t._tr_align=function(n){var e;E(n,2,3),s(n,w,V),16===(e=n).bi_valid?(D(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):8<=e.bi_valid&&(e.pending_buf[e.pending++]=255&e.bi_buf,e.bi_buf>>=8,e.bi_valid-=8)}},{"../utils/common":27}],39:[function(n,e){"use strict";e.exports=function(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0}},{}]},{},[9])(9)}),jt.Keys={VK_ESCAPE:{c:27,n:"Esc"},VK_F1:{c:112,n:"F1"},VK_F2:{c:113,n:"F2"},VK_F3:{c:114,n:"F3"},VK_F4:{c:115,n:"F4"},VK_F5:{c:116,n:"F5"},VK_F6:{c:117,n:"F6"},VK_F7:{c:118,n:"F7"},VK_F8:{c:119,n:"F8"},VK_F9:{c:120,n:"F9"},VK_F10:{c:121,n:"F10"},VK_F11:{c:122,n:"F11"},VK_F12:{c:123,n:"F12"},VK_SCROLL_LOCK:{c:145,n:"ScrLck"},VK_PAUSE:{c:19,n:"Pause"},VK_QUOTE:{c:192,n:"'"},VK_TILDE:{c:222,n:"~"},VK_1:{c:49,n:"1"},VK_2:{c:50,n:"2"},VK_3:{c:51,n:"3"},VK_4:{c:52,n:"4"},VK_5:{c:53,n:"5"},VK_6:{c:54,n:"6"},VK_7:{c:55,n:"7"},VK_8:{c:56,n:"8"},VK_9:{c:57,n:"9"},VK_0:{c:48,n:"0"},VK_MINUS:{c:189,n:"-"},VK_MINUS2:{c:173,n:"-"},VK_EQUALS:{c:187,n:"="},VK_EQUALS2:{c:61,n:"="},VK_BACK_SPACE:{c:8,n:"Bkspc"},VK_TAB:{c:9,n:"Tab"},VK_Q:{c:81,n:"Q"},VK_W:{c:87,n:"W"},VK_E:{c:69,n:"E"},VK_R:{c:82,n:"R"},VK_T:{c:84,n:"T"},VK_Y:{c:89,n:"Y"},VK_U:{c:85,n:"U"},VK_I:{c:73,n:"I"},VK_O:{c:79,n:"O"},VK_P:{c:80,n:"P"},VK_ACUTE:{c:219,n:"´"},VK_OPEN_BRACKET:{c:221,n:"["},VK_CLOSE_BRACKET:{c:220,n:"]"},VK_CAPS_LOCK:{c:20,n:"CpsLck"},VK_A:{c:65,n:"A"},VK_S:{c:83,n:"S"},VK_D:{c:68,n:"D"},VK_F:{c:70,n:"F"},VK_G:{c:71,n:"G"},VK_H:{c:72,n:"H"},VK_J:{c:74,n:"J"},VK_K:{c:75,n:"K"},VK_L:{c:76,n:"L"},VK_CEDILLA:{c:186,n:"Ç"},VK_ENTER:{c:13,n:"Enter"},VK_SHIFT:{c:16,n:"Shift"},VK_BACK_SLASH:{c:226,n:"\\"},VK_Z:{c:90,n:"Z"},VK_X:{c:88,n:"X"},VK_C:{c:67,n:"C"},VK_V:{c:86,n:"V"},VK_B:{c:66,n:"B"},VK_N:{c:78,n:"N"},VK_M:{c:77,n:"M"},VK_COMMA:{c:188,n:"] ="},VK_PERIOD:{c:190,n:"."},VK_SEMICOLON:{c:191,n:";"},VK_SLASH:{c:193,n:"/"},VK_CONTROL:{c:17,n:"Ctrl"},VK_ALT:{c:18,n:"Alt"},VK_SPACE:{c:32,n:"Space"},VK_INSERT:{c:45,n:"Ins"},VK_DELETE:{c:46,n:"Del"},VK_HOME:{c:36,n:"Home"},VK_END:{c:35,n:"End"},VK_PAGE_UP:{c:33,n:"PgUp"},VK_PAGE_DOWN:{c:34,n:"PgDown"},VK_UP:{c:38,n:"Up"},VK_DOWN:{c:40,n:"Down"},VK_LEFT:{c:37,n:"Left"},VK_RIGHT:{c:39,n:"Right"},VK_NUM_LOCK:{c:144,n:"Num"},VK_DIVIDE:{c:111,n:"Num /"},VK_MULTIPLY:{c:106,n:"Num *"},VK_SUBTRACT:{c:109,n:"Num -"},VK_ADD:{c:107,n:"Num +"},VK_DECIMAL:{c:194,n:"Num ."},VK_NUMPAD0:{c:96,n:"Num 0"},VK_NUMPAD1:{c:97,n:"Num 1"},VK_NUMPAD2:{c:98,n:"Num 2"},VK_NUMPAD3:{c:99,n:"Num 3"},VK_NUMPAD4:{c:100,n:"Num 4"},VK_NUMPAD5:{c:101,n:"Num 5"},VK_NUMPAD6:{c:102,n:"Num 6"},VK_NUMPAD7:{c:103,n:"Num 7"},VK_NUMPAD8:{c:104,n:"Num 8"},VK_NUMPAD9:{c:105,n:"Num 9"},VK_NUMPAD_CENTER:{c:12,n:"Num Cntr"}},jt.KeysByCode={},jt.Keys)jt.KeysByCode[jt.Keys[n].c]=jt.Keys[n];Javatari.preferences={},Javatari.preferences.defaults={KP0LEFT:jt.Keys.VK_LEFT.c,KP0UP:jt.Keys.VK_UP.c,KP0RIGHT:jt.Keys.VK_RIGHT.c,KP0DOWN:jt.Keys.VK_DOWN.c,KP0BUT:jt.Keys.VK_SPACE.c,KP0BUT2:jt.Keys.VK_DELETE.c,KP1LEFT:jt.Keys.VK_F.c,KP1UP:jt.Keys.VK_T.c,KP1RIGHT:jt.Keys.VK_H.c,KP1DOWN:jt.Keys.VK_G.c,KP1BUT:jt.Keys.VK_A.c,KP1BUT2:jt.Keys.VK_PERIOD.c,JP0DEVICE:-1,JP0XAXIS:0,JP0XAXISSIG:1,JP0YAXIS:1,JP0YAXISSIG:1,JP0PAXIS:0,JP0PAXISSIG:1,JP0BUT:0,JP0BUT2:1,JP0SELECT:8,JP0RESET:9,JP0PAUSE:7,JP0FAST:6,JP0DEADZONE:.3,JP0PCENTER:.3,JP0PSENS:.75,JP1DEVICE:-1,JP1XAXIS:0,JP1XAXISSIG:1,JP1YAXIS:1,JP1YAXISSIG:1,JP1PAXIS:0,JP1PAXISSIG:1,JP1BUT:0,JP1BUT2:1,JP1SELECT:8,JP1RESET:9,JP1PAUSE:7,JP1FAST:6,JP1DEADZONE:.3,JP1PCENTER:.3,JP1PSENS:.75},Javatari.preferences.loadDefaults=function(){for(var n in Javatari.preferences.defaults)Javatari.preferences[n]=Javatari.preferences.defaults[n]},Javatari.preferences.load=function(){try{Javatari.preferences.loadDefaults();var n=JSON.parse(localStorage.javatariprefs||"{}");for(var e in Javatari.preferences.defaults)n[e]&&(Javatari.preferences[e]=n[e])}catch(n){}},Javatari.preferences.save=function(){try{localStorage.javatariprefs=JSON.stringify(Javatari.preferences)}catch(n){}},jt.GamepadConsoleControls=function(l){function i(e,n){var r;this.index=e,this.update=function(n){return!!(r=n[e])},this.hasMoved=function(){var n=r.timestamp;return!n||F<n&&(F=n,!0)},this.getButtonDigital=function(n){var e=r.buttons[n];return"object"==typeof e?e.pressed||.5<e.value:.5<e},this.getDPadDirection=function(){return this.getButtonDigital(12)?this.getButtonDigital(15)?1:this.getButtonDigital(14)?7:0:this.getButtonDigital(13)?this.getButtonDigital(15)?3:this.getButtonDigital(14)?5:4:this.getButtonDigital(14)?6:this.getButtonDigital(15)?2:-1},this.getStickDirection=function(){var n=r.axes[a],e=r.axes[i];if((n<0?-n:n)<C?n=0:n*=o,(e<0?-e:e)<C?e=0:e*=A,0===n&&0===e)return-1;var t=(1-Math.atan2(n,e)/Math.PI)/2;return 1<=(t+=1/16)&&--t,8*t|0},this.getPaddlePosition=function(){var n=r.axes[t]*D*E+s|0;return n<0?n=0:380<n&&(n=380),n};var a=n.xAxis,i=n.yAxis,o=n.xAxisSig,A=n.yAxisSig,C=n.deadzone,t=n.paddleAxis,D=n.paddleAxisSig,E=n.paddleSens,s=n.paddleCenter,F=Number.MIN_VALUE}this.connect=function(n){u=n},this.connectScreen=function(n){t=n},this.powerOn=function(){(B=!!navigator.getGamepads)&&(this.applyPreferences(),n())},this.powerOff=function(){B=!1},this.toggleMode=function(){B&&(n(),p=!p,t.getMonitor().showOSD("Gamepad input "+(p?"Swapped":"Normal"),!0))},this.setPaddleMode=function(n){B&&(h=n,e.xPosition=r.xPosition=-1)},this.setP1ControlsMode=function(n){P=n},this.clockPulse=function(){var n;B&&(60<=++c&&(c=0),(o||A||0===c)&&(n=navigator.getGamepads(),o?o.update(n)?o.hasMoved()&&s(o,e,a,!p):D(!(o=null),!1):0===c&&(o=E(a,C,n))&&D(!0,!0),A?A.update(n)?A.hasMoved()&&s(A,r,C,p):(A=null,D(!1,!1)):0===c&&(A=E(C,a,n))&&D(!1,!0)))};var u,t,o,A,e,r,a,C,D=function(n,e){t.getMonitor().showOSD((n^P^p?"P1":"P2")+" Gamepad "+(e?"connected":"disconnected"),n)},E=function(n,e,t){if(t&&0!==t.length){if(0<=n.device)return t[n.device]?new i(n.device,n):null;for(var r=0,a=t.length;r<a;r++)if(t[r]&&!(r===e.device||o&&o.index===r||A&&A.index===r))return new i(r,n)}},n=function(){e=F(),r=F()},s=function(n,e,t,r){var a;!h||0===t.paddleSens||(a=n.getPaddlePosition())!==e.xPosition&&(e.xPosition=a,u.controlValueChanged(r^P?f.PADDLE0_POSITION:f.PADDLE1_POSITION,a));var i,o,A,C,D,E,s,F,B,c=n.getDPadDirection();-1!==c||h&&0!==t.paddleSens||(c=n.getStickDirection()),c!==e.direction&&(i=7===c||0===c||1==c,o=1===c||2===c||3===c,A=3===c||4===c||5===c,C=5===c||6===c||7===c,r?(l.processKeyEvent(Javatari.preferences.KP0UP,i,0),l.processKeyEvent(Javatari.preferences.KP0RIGHT,o,0),l.processKeyEvent(Javatari.preferences.KP0DOWN,A,0),l.processKeyEvent(Javatari.preferences.KP0LEFT,C,0)):(l.processKeyEvent(Javatari.preferences.KP1UP,i,0),l.processKeyEvent(Javatari.preferences.KP1RIGHT,o,0),l.processKeyEvent(Javatari.preferences.KP1DOWN,A,0),l.processKeyEvent(Javatari.preferences.KP1LEFT,C,0)),e.direction=c),m!==n?((D=n.getButtonDigital(t.button)||n.getButtonDigital(t.button2))!==e.button&&(l.processKeyEvent(r?Javatari.preferences.KP0BUT:Javatari.preferences.KP1BUT,D,0),e.button=D),(E=n.getButtonDigital(t.select))!==e.select&&(l.processKeyEvent(jt.DOMConsoleControls.KEY_SELECT,E,0),e.select=E),(s=n.getButtonDigital(t.reset))!==e.reset&&(l.processKeyEvent(jt.DOMConsoleControls.KEY_RESET,s,0),e.reset=s),(F=n.getButtonDigital(t.pause))!==e.pause&&(l.processKeyEvent(jt.DOMConsoleControls.KEY_PAUSE,F,jt.DOMConsoleControls.KEY_ALT_MASK),e.pause=F),(B=n.getButtonDigital(t.fastSpeed))!==e.fastSpeed&&(l.processKeyEvent(jt.DOMConsoleControls.KEY_FAST_SPEED,B,0),e.fastSpeed=B)):d()},F=function(){return{direction:-1,button:!1,select:!1,reset:!1,fastSpeed:!1,pause:!1,xPosition:-1}},d=function(){},B=!(this.applyPreferences=function(){a={device:Javatari.preferences.JP0DEVICE,xAxis:Javatari.preferences.JP0XAXIS,xAxisSig:Javatari.preferences.JP0XAXISSIG,yAxis:Javatari.preferences.JP0YAXIS,yAxisSig:Javatari.preferences.JP0YAXISSIG,paddleAxis:Javatari.preferences.JP0PAXIS,paddleAxisSig:Javatari.preferences.JP0PAXISSIG,button:Javatari.preferences.JP0BUT,button2:Javatari.preferences.JP0BUT2,select:Javatari.preferences.JP0SELECT,reset:Javatari.preferences.JP0RESET,pause:Javatari.preferences.JP0PAUSE,fastSpeed:Javatari.preferences.JP0FAST,paddleCenter:-190*Javatari.preferences.JP0PCENTER+190-5,paddleSens:-190*Javatari.preferences.JP0PSENS,deadzone:Javatari.preferences.JP0DEADZONE},C={device:Javatari.preferences.JP1DEVICE,xAxis:Javatari.preferences.JP1XAXIS,xAxisSig:Javatari.preferences.JP1XAXISSIG,yAxis:Javatari.preferences.JP1YAXIS,yAxisSig:Javatari.preferences.JP1YAXISSIG,paddleAxis:Javatari.preferences.JP1PAXIS,paddleAxisSig:Javatari.preferences.JP1PAXISSIG,button:Javatari.preferences.JP1BUT,button2:Javatari.preferences.JP1BUT2,select:Javatari.preferences.JP1SELECT,reset:Javatari.preferences.JP1RESET,pause:Javatari.preferences.JP1PAUSE,fastSpeed:Javatari.preferences.JP1FAST,paddleCenter:-190*Javatari.preferences.JP1PCENTER+190-5,paddleSens:-190*Javatari.preferences.JP1PSENS,deadzone:Javatari.preferences.JP1DEADZONE}}),c=-1,f=jt.ConsoleControls,h=!1,p=!1,P=!1,m=null},jt.DOMConsoleControls=function(){var a=this;this.connect=function(n,e){E&&E.removeInsertionListener(this),(E=e).addInsertionListener(this),(D=n).connectControls(this),F.connect(n)},this.connectPeripherals=function(n,e){s=n.getMonitor(),F.connectScreen(n),this.addInputElements(n.keyControlsInputElements()),e&&this.addInputElements(e.keyControlsInputElements())},this.powerOn=function(){n(),F.powerOn(),0===b?i(!1,!1):1===b&&i(!0,!1)},this.powerOff=function(){i(!1,!1),F.powerOff()},this.destroy=function(){},this.addInputElements=function(n){for(var e=0;e<n.length;e++)n[e].addEventListener("keydown",this.keyDown),n[e].addEventListener("keyup",this.keyUp)},this.toggleP1ControlsMode=function(){this.setP1ControlsMode(!c),r()},this.setP1ControlsMode=function(n){c=n,F.setP1ControlsMode(n),this.applyPreferences()},this.isP1ControlsMode=function(){return c},this.togglePaddleMode=function(){i(!l,!0)},this.isPaddleMode=function(){return l},this.getGamepadControls=function(){return F},this.keyDown=function(n){var e=0|(n.ctrlKey?ln:0)|(n.altKey?un:0)|(n.shiftKey?dn:0);if(t(n.keyCode,!0,e))return n.returnValue=!1,n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),!1},this.keyUp=function(n){var e=0|(n.ctrlKey?ln:0)|(n.altKey?un:0)|(n.shiftKey?dn:0);if(t(n.keyCode,!1,e))return n.returnValue=!1,n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),!1},this.cartridgeInserted=function(n){var e;!n||0<=b||(e=1===n.rom.info.p,l!==e&&i(e,!1))},this.clockPulse=function(){F.clockPulse(),l&&(h?f||((u-=d)<0&&(u=0),D.controlValueChanged(B.PADDLE0_POSITION,u)):f&&(380<(u+=d)&&(u=380),D.controlValueChanged(B.PADDLE0_POSITION,u)),g?m||((p-=P)<0&&(p=0),D.controlValueChanged(B.PADDLE1_POSITION,p)):m&&(380<(p+=P)&&(p=380),D.controlValueChanged(B.PADDLE1_POSITION,p)))},this.processKeyEvent=function(n,e,t){if(o(n,t,e))return!0;var r=A(n,t);if(null==r)return!1;l&&(r=C(r));var a=L[r];return a&&a===e||(L[r]=e,D.controlStateChanged(r,e)),!0};var t=this.processKeyEvent,r=function(){s.showOSD("Controllers: "+(l?"Paddles":"Joysticks")+(c?", Swapped":""),!0)},i=function(n,e){f=h=m=g=!1,d=P=2,u=p=(l=n)?190:-1;for(var t=0;t<B.playerDigitalControls.length;t++)D.controlStateChanged(B.playerDigitalControls[t],!1);D.controlValueChanged(B.PADDLE0_POSITION,u),D.controlValueChanged(B.PADDLE1_POSITION,p),F.setPaddleMode(l),e&&r()},o=function(n,e,t){var r;if(t){if(e===un||e===ln)switch(n){case _:return a.toggleP1ControlsMode(),!0;case T:return F.toggleMode(),!0;case w:return a.togglePaddleMode(),!0}if(l){if(null==(r=A(n,e)))return!1;switch(r){case B.JOY0_LEFT:return f=!0;case B.JOY0_RIGHT:return h=!0;case B.JOY0_UP:return d<10&&d++,s.showOSD("P1 Paddle speed: "+d,!0),!0;case B.JOY0_DOWN:return 1<d&&d--,s.showOSD("P1 Paddle speed: "+d,!0),!0;case B.JOY1_LEFT:return m=!0;case B.JOY1_RIGHT:return g=!0;case B.JOY1_UP:return P<10&&P++,s.showOSD("P2 Paddle speed: "+P,!0),!0;case B.JOY1_DOWN:return 1<P&&P--,s.showOSD("P2 Paddle speed: "+P,!0),!0}}}else if(l){if(null==(r=A(n,e)))return!1;switch(r){case B.JOY0_LEFT:return!(f=!1);case B.JOY0_RIGHT:return!(h=!1);case B.JOY1_LEFT:return!(m=!1);case B.JOY1_RIGHT:return!(g=!1)}}return!1},A=function(n,e){switch(e){case 0:var t=S[n];return t?t:v[n];case ln:return y[n];case un:return k[n]}return null},C=function(n){switch(n){case B.JOY0_BUTTON:return B.PADDLE0_BUTTON;case B.JOY1_BUTTON:return B.PADDLE1_BUTTON}return n},n=function(){window.onhelp=function(){return!1}},e=function(){a.applyPreferences(),v[x]=B.POWER,v[V]=B.BLACK_WHITE,v[j]=B.DIFFICULTY0,v[cn]=B.CARTRIDGE_REMOVE,v[sn]=B.SAVE_STATE_FILE,v[H]=B.DIFFICULTY1,v[I]=B.SELECT,v[M]=B.SELECT,v[K]=B.RESET,k[x]=B.POWER,k[V]=B.BLACK_WHITE,k[j]=B.DIFFICULTY0,k[cn]=B.CARTRIDGE_REMOVE,k[sn]=B.SAVE_STATE_FILE,k[H]=B.DIFFICULTY1,k[I]=B.SELECT,k[M]=B.SELECT,k[K]=B.RESET,v[O]=B.FAST_SPEED,k[U]=B.PAUSE,k[G]=B.FRAME,k[J]=B.TRACE,k[N]=B.DEBUG,k[z]=B.NO_COLLISIONS,k[W]=B.VIDEO_STANDARD,y[U]=B.PAUSE,y[G]=B.FRAME,y[J]=B.TRACE,y[N]=B.DEBUG,y[z]=B.NO_COLLISIONS,y[W]=B.VIDEO_STANDARD,y[x]=B.POWER_FRY,y[Y]=B.SAVE_STATE_0,y[X]=B.SAVE_STATE_0,y[Z]=B.SAVE_STATE_1,y[Q]=B.SAVE_STATE_2,y[$]=B.SAVE_STATE_3,y[q]=B.SAVE_STATE_4,y[nn]=B.SAVE_STATE_5,y[en]=B.SAVE_STATE_6,y[tn]=B.SAVE_STATE_7,y[rn]=B.SAVE_STATE_8,y[an]=B.SAVE_STATE_9,y[on]=B.SAVE_STATE_10,y[An]=B.SAVE_STATE_11,y[Cn]=B.SAVE_STATE_11,y[Dn]=B.SAVE_STATE_12,y[En]=B.SAVE_STATE_12,k[Y]=B.LOAD_STATE_0,k[X]=B.LOAD_STATE_0,k[Z]=B.LOAD_STATE_1,k[Q]=B.LOAD_STATE_2,k[$]=B.LOAD_STATE_3,k[q]=B.LOAD_STATE_4,k[nn]=B.LOAD_STATE_5,k[en]=B.LOAD_STATE_6,k[tn]=B.LOAD_STATE_7,k[rn]=B.LOAD_STATE_8,k[an]=B.LOAD_STATE_9,k[on]=B.LOAD_STATE_10,k[An]=B.LOAD_STATE_11,k[Cn]=B.LOAD_STATE_11,k[Dn]=B.LOAD_STATE_12,k[En]=B.LOAD_STATE_12,k[R]=B.CARTRIDGE_FORMAT,k[Fn]=B.CARTRIDGE_CLOCK_DEC,k[Bn]=B.CARTRIDGE_CLOCK_INC,y[R]=B.CARTRIDGE_FORMAT,y[Fn]=B.CARTRIDGE_CLOCK_DEC,y[Bn]=B.CARTRIDGE_CLOCK_INC};this.applyPreferences=function(){S={},c?(S[Javatari.preferences.KP0LEFT]=B.JOY1_LEFT,S[Javatari.preferences.KP0UP]=B.JOY1_UP,S[Javatari.preferences.KP0RIGHT]=B.JOY1_RIGHT,S[Javatari.preferences.KP0DOWN]=B.JOY1_DOWN,S[Javatari.preferences.KP0BUT]=B.JOY1_BUTTON,S[Javatari.preferences.KP0BUT2]=B.JOY1_BUTTON,S[Javatari.preferences.KP1LEFT]=B.JOY0_LEFT,S[Javatari.preferences.KP1UP]=B.JOY0_UP,S[Javatari.preferences.KP1RIGHT]=B.JOY0_RIGHT,S[Javatari.preferences.KP1DOWN]=B.JOY0_DOWN,S[Javatari.preferences.KP1BUT]=B.JOY0_BUTTON,S[Javatari.preferences.KP1BUT2]=B.JOY0_BUTTON):(S[Javatari.preferences.KP0LEFT]=B.JOY0_LEFT,S[Javatari.preferences.KP0UP]=B.JOY0_UP,S[Javatari.preferences.KP0RIGHT]=B.JOY0_RIGHT,S[Javatari.preferences.KP0DOWN]=B.JOY0_DOWN,S[Javatari.preferences.KP0BUT]=B.JOY0_BUTTON,S[Javatari.preferences.KP0BUT2]=B.JOY0_BUTTON,S[Javatari.preferences.KP1LEFT]=B.JOY1_LEFT,S[Javatari.preferences.KP1UP]=B.JOY1_UP,S[Javatari.preferences.KP1RIGHT]=B.JOY1_RIGHT,S[Javatari.preferences.KP1DOWN]=B.JOY1_DOWN,S[Javatari.preferences.KP1BUT]=B.JOY1_BUTTON,S[Javatari.preferences.KP1BUT2]=B.JOY1_BUTTON)};var D,E,s,F,B=jt.ConsoleControls,c=!1,l=!1,u=0,d=3,f=!1,h=!1,p=0,P=3,m=!1,g=!1,S={},v={},y={},k={},L={},b=Javatari.PADDLES_MODE,T=jt.DOMConsoleControls.KEY_TOGGLE_JOYSTICK,_=jt.DOMConsoleControls.KEY_TOGGLE_P1_MODE,w=jt.DOMConsoleControls.KEY_TOGGLE_PADDLE,R=jt.DOMConsoleControls.KEY_CARTRIDGE_FORMAT,I=jt.DOMConsoleControls.KEY_SELECT,M=jt.DOMConsoleControls.KEY_SELECT2,K=jt.DOMConsoleControls.KEY_RESET,O=jt.DOMConsoleControls.KEY_FAST_SPEED,U=jt.DOMConsoleControls.KEY_PAUSE,x=jt.Keys.VK_F1.c,V=jt.Keys.VK_F2.c,j=jt.Keys.VK_F4.c,H=jt.Keys.VK_F9.c,G=jt.Keys.VK_F.c,J=jt.Keys.VK_Q.c,N=jt.Keys.VK_D.c,z=jt.Keys.VK_C.c,W=jt.Keys.VK_V.c,Y=jt.Keys.VK_QUOTE.c,X=jt.Keys.VK_TILDE.c,Z=jt.Keys.VK_1.c,Q=jt.Keys.VK_2.c,$=jt.Keys.VK_3.c,q=jt.Keys.VK_4.c,nn=jt.Keys.VK_5.c,en=jt.Keys.VK_6.c,tn=jt.Keys.VK_7.c,rn=jt.Keys.VK_8.c,an=jt.Keys.VK_9.c,on=jt.Keys.VK_0.c,An=jt.Keys.VK_MINUS.c,Cn=jt.Keys.VK_MINUS2.c,Dn=jt.Keys.VK_EQUALS.c,En=jt.Keys.VK_EQUALS2.c,sn=jt.Keys.VK_F8.c,Fn=jt.Keys.VK_END.c,Bn=jt.Keys.VK_HOME.c,cn=jt.Keys.VK_F7.c,ln=1,un=jt.DOMConsoleControls.KEY_ALT_MASK,dn=4;F=new jt.GamepadConsoleControls(a),e()},jt.DOMConsoleControls.KEY_SELECT=jt.Keys.VK_F11.c,jt.DOMConsoleControls.KEY_SELECT2=jt.Keys.VK_F10.c,jt.DOMConsoleControls.KEY_RESET=jt.Keys.VK_F12.c,jt.DOMConsoleControls.KEY_FAST_SPEED=jt.Keys.VK_TAB.c,jt.DOMConsoleControls.KEY_PAUSE=jt.Keys.VK_P.c,jt.DOMConsoleControls.KEY_TOGGLE_JOYSTICK=jt.Keys.VK_J.c,jt.DOMConsoleControls.KEY_TOGGLE_P1_MODE=jt.Keys.VK_K.c,jt.DOMConsoleControls.KEY_TOGGLE_PADDLE=jt.Keys.VK_L.c,jt.DOMConsoleControls.KEY_CARTRIDGE_FORMAT=jt.Keys.VK_B.c,jt.DOMConsoleControls.KEY_ALT_MASK=2,jt.DOMMonitorControls=function(r){this.addInputElements=function(n){for(var e=0;e<n.length;e++)n[e].addEventListener("keydown",this.keyDown)},this.keyDown=function(n){var e=0|(n.ctrlKey?y:0)|(n.altKey?k:0)|(n.shiftKey?L:0);if(t(n.keyCode,e))return n.returnValue=!1,n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),!1};var t=function(n,e){var t=a(n,e);return!!t&&(r.controlActivated(t),!0)},a=function(n,e){switch(e){case 0:return i[n];case k:return A[n];case L:return o[n];case y:return E[n];case y|k:return s[n];case L|y:return C[n];case L|k:return D[n]}return null},n=function(){var n=jt.Monitor.Controls;i[v]=n.EXIT,i[u]=n.LOAD_CARTRIDGE_FILE,i[d]=n.LOAD_CARTRIDGE_URL,A[u]=n.LOAD_CARTRIDGE_FILE,A[d]=n.LOAD_CARTRIDGE_URL,E[u]=n.LOAD_CARTRIDGE_FILE_NO_AUTO_POWER,E[d]=n.LOAD_CARTRIDGE_URL_NO_AUTO_POWER,A[p]=n.CRT_FILTER,A[m]=n.DEBUG,A[g]=n.STATS,A[P]=n.CRT_MODES,A[S]=n.FULLSCREEN,E[p]=n.CRT_FILTER,E[m]=n.DEBUG,E[g]=n.STATS,E[P]=n.CRT_MODES,E[S]=n.FULLSCREEN,o[F]=n.SIZE_MINUS,o[c]=n.SIZE_PLUS,o[e]=n.SIZE_MINUS,o[B]=n.SIZE_PLUS,D[F]=n.SCALE_Y_MINUS,D[c]=n.SCALE_Y_PLUS,D[e]=n.SCALE_X_MINUS,D[B]=n.SCALE_X_PLUS,s[F]=n.ORIGIN_Y_MINUS,s[c]=n.ORIGIN_Y_PLUS,s[e]=n.ORIGIN_X_MINUS,s[B]=n.ORIGIN_X_PLUS,C[F]=n.HEIGHT_MINUS,C[c]=n.HEIGHT_PLUS,C[e]=n.WIDTH_MINUS,C[B]=n.WIDTH_PLUS,o[h]=n.LOAD_CARTRIDGE_PASTE,E[f]=n.LOAD_CARTRIDGE_PASTE,i[l]=n.SIZE_DEFAULT},i={},o={},A={},C={},D={},E={},s={},e=jt.Keys.VK_LEFT.c,F=jt.Keys.VK_UP.c,B=jt.Keys.VK_RIGHT.c,c=jt.Keys.VK_DOWN.c,l=jt.Keys.VK_BACK_SPACE.c,u=jt.Keys.VK_F5.c,d=jt.Keys.VK_F6.c,f=jt.Keys.VK_V.c,h=jt.Keys.VK_INSERT.c,p=jt.Keys.VK_T.c,P=jt.Keys.VK_R.c,m=jt.Keys.VK_D.c,g=jt.Keys.VK_G.c,S=jt.Keys.VK_ENTER.c,v=jt.Keys.VK_ESCAPE.c,y=1,k=2,L=4;n()},jt.Monitor=function(){this.connectDisplay=function(n){var e=(r=n).displayDefaultOpeningScaleX(R,I);h(e,e/tn),p()},this.connectPeripherals=function(n){a=n},this.connect=function(n,e){e.addInsertionListener(this),(i=n).connectMonitor(this),B()},this.addControlInputElements=function(n){o.addInputElements(n)},this.nextLine=function(n,e){if(!D(null!==n))return!1;var t=!1;return J<w?O<=J&&J<O+I&&(L?jt.Util.arrayCopy(n,K,L,(J-O)*_,R):jt.Util.uInt32ArrayCopyToUInt8Array(n,K,b,(J-O)*_,R)):t=C(),J++,j||z++,e&&(j||s(),t=A()||t),t},this.getDisplayParameters=function(){return{signalWidth:_,signalHeight:w,displayWidth:R,displayHeight:I,displayOriginX:K,displayOriginY:O,displayScaleX:x,displayScaleY:V,crtMode:Dn}},this.synchOutput=function(){n()},this.currentLine=function(){return J},this.showOSD=function(n,e){r.showOSD(n,e)},this.videoStandardDetectionStart=function(){j=null,z=H=0},this.getVideoStandardDetected=function(){return j},this.cartridgeInserted=function(n){0<=An||0!==Dn&&1!==Dn||P(n&&n.rom.info.c||0)};function e(n){var e=0|n;e<1&&(e=1),h(e*tn,e)}function t(){return!!Javatari.CARTRIDGE_CHANGE_DISABLED&&(r.showOSD("Cartridge change is disabled",!0),!0)}var r,a,i,o,A=function(){return!(J<w-an)&&(X&&r.showOSD(i.standard.name+"  "+J+" lines",!0),!(J=0))},C=function(){return w+an+on<J&&A()},D=function(n){return n?(N=!0,B()):(N=!1,c()),n},E=function(n){_=(T=n).width,w=n.height,d(R,M),u(K,U)},s=function(){var n=z;z=0,(250<=n&&n<=281||300<=n&&n<=325)&&5<=++H&&F(n)},F=function(n){var e=n-(j=n<290?jt.VideoStandard.NTSC:jt.VideoStandard.PAL).height;(e=2<e?(6<e?6:e)-2:0)!=W&&(W=e,E(j))},B=function(){T!=i.standard&&E(i.standard)},c=function(){J=0,r.adjustToVideoSignalOff()},l=function(){var n;d(q,nn),u(Q,$),null!=r?(n=r.displayDefaultOpeningScaleX(R,I),h(n,n/tn)):h(en,rn),p()},u=function(n,e){(K=n)<0?K=0:_-R<K&&(K=_-R),(U=e)<0?U=0:w-I<U/100*w&&(U=(w-I)/w*100),w<(O=U/100*w+W/2|0)+I&&(O=w-I)},d=function(n,e){(R=n)<10?R=10:_<R&&(R=_),(M=e)<10?M=10:100<M&&(M=100),w<(I=M/100*(w+W)|0)&&(I=w),u(K,U),f()},f=function(){r&&(r.displaySize(R*x|0,I*V|0),r.displayMinimumSize(R*en/rn|0,I))},h=function(n,e){(x=n)<1&&(x=1),(V=e)<1&&(V=1),f()},p=function(){r&&r.displayCenter()},n=function(){N&&(y.putImageData(k,0,0),r.refresh(v,R,I),0<Y&&g())},P=function(n){var e=4<n||n<0?0:n;Dn!==e&&(Dn=e,r.showOSD("CRT mode: "+Cn[Dn],!0))},m=function(){(v=document.createElement("canvas")).width=jt.VideoStandard.PAL.width,v.height=jt.VideoStandard.PAL.height,y=v.getContext("2d"),(k=y.getImageData(0,0,v.width,v.height)).data.buffer?L=new Uint32Array(k.data.buffer):b=k.data},g=function(){L&&jt.Util.arrayFill(L,4278255360)},S=jt.Monitor.Controls;this.controlActivated=function(n){switch(n){case S.LOAD_CARTRIDGE_FILE:t()||a.openFileChooserDialog(!0);break;case S.LOAD_CARTRIDGE_FILE_NO_AUTO_POWER:t()||a.openFileChooserDialog(!1);break;case S.LOAD_CARTRIDGE_URL:t()||a.openURLChooserDialog(!0);break;case S.LOAD_CARTRIDGE_URL_NO_AUTO_POWER:t()||a.openURLChooserDialog(!1);break;case S.CRT_MODES:P(Dn+1);break;case S.CRT_FILTER:r.toggleCRTFilter();break;case S.STATS:X=!X,r.showOSD(null,!0);break;case S.DEBUG:4<++Y&&(Y=0);break;case S.ORIGIN_X_MINUS:u(K+1,U);break;case S.ORIGIN_X_PLUS:u(K-1,U);break;case S.ORIGIN_Y_MINUS:u(K,U+.5);break;case S.ORIGIN_Y_PLUS:u(K,U-.5);break;case S.SIZE_DEFAULT:l();break;case S.FULLSCREEN:r.displayToggleFullscreen();break;case S.EXIT:r.exit()}if(!Z)switch(n){case S.WIDTH_MINUS:d(R-1,M);break;case S.WIDTH_PLUS:d(R+1,M);break;case S.HEIGHT_MINUS:d(R,M-.5);break;case S.HEIGHT_PLUS:d(R,M+.5);break;case S.SCALE_X_MINUS:h(x-.5,V);break;case S.SCALE_X_PLUS:h(x+.5,V);break;case S.SCALE_Y_MINUS:h(x,V-.5);break;case S.SCALE_Y_PLUS:h(x,V+.5);break;case S.SIZE_MINUS:e(V-1);break;case S.SIZE_PLUS:e(V+1)}};var v,y,k,L,b,T,_,w,R,I,M,K,O,U,x,V,j,H,G,J=0,N=!1,z=0,W=0,Y=0,X=!1,Z=Javatari.SCREEN_RESIZE_DISABLED,Q=68,$=12.4,q=160,nn=81.5,en=4,tn=2,rn=2,an=16,on=5,An=Javatari.SCREEN_CRT_MODE,Cn=["OFF","Phosphor","Phosphor Scanlines","RGB","RGB Phosphor"],Dn=An<0?0:An;G=this,m(),E(jt.VideoStandard.NTSC),l(),o=new jt.DOMMonitorControls(G)},jt.Monitor.Controls={WIDTH_PLUS:1,HEIGHT_PLUS:2,WIDTH_MINUS:3,HEIGHT_MINUS:4,ORIGIN_X_PLUS:5,ORIGIN_Y_PLUS:6,ORIGIN_X_MINUS:7,ORIGIN_Y_MINUS:8,SCALE_X_PLUS:9,SCALE_Y_PLUS:10,SCALE_X_MINUS:11,SCALE_Y_MINUS:12,SIZE_PLUS:13,SIZE_MINUS:14,SIZE_DEFAULT:15,FULLSCREEN:16,LOAD_CARTRIDGE_FILE:21,LOAD_CARTRIDGE_FILE_NO_AUTO_POWER:22,LOAD_CARTRIDGE_URL:23,LOAD_CARTRIDGE_URL_NO_AUTO_POWER:24,LOAD_CARTRIDGE_PASTE:25,CRT_FILTER:31,CRT_MODES:32,DEBUG:41,STATS:42,EXIT:51},jt.CanvasDisplay=function(t){this.connectPeripherals=function(n,e){n.registerForDnD(t),n.registerForFileInputElement(t),e.registerForDownloadElement(t),r.connectPeripherals(n)},this.connect=function(n,e,t){r.connect(n,t),a=e},this.powerOn=function(){t.style.visibility="visible",this.focus(),k()},this.powerOff=function(){t.style.visibility="hidden",t.style.display="none"},this.refresh=function(n,e,t){O=!0,D.drawImage(n,0,0,e,t,0,0,C.width,C.height)},this.adjustToVideoSignalOff=function(){O=!1,k()},this.keyControlsInputElements=function(){return[t]},this.displayDefaultOpeningScaleX=function(n,e){if(x){for(var t=A.clientWidth,r=A.clientHeight,a=t/n,i=(a-=a%H)/H*e;r+35<i;)i=(a-=H)/H*e;return 0|a}return G},this.displaySize=function(n,e){v(n,e),y(),O||k()},this.displayMinimumSize=function(n,e){},this.displayCenter=function(){this.focus()},this.getMonitor=function(){return r},this.showOSD=function(n,e){if(B&&clearTimeout(B),!n)return F.style.transition="all 0.15s linear",F.style.top="-29px",F.style.opacity=0,void(K=!1);!e&&K||(F.innerHTML=n),F.style.transition="none",F.style.top="15px",F.style.opacity=1,K=!0,B=setTimeout(function(){F.style.transition="all 0.15s linear",F.style.top="-29px",F.style.opacity=0,K=!1},j)},this.toggleCRTFilter=function(){U=!U,this.showOSD(U?"CRT Filter: ON":"CRT Filter: OFF",!0),y()},this.displayToggleFullscreen=function(){Javatari.SCREEN_FULLSCREEN_DISABLED||(document.fullscreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.msFullscreenElement?document.exitFullscreen?document.exitFullscreen():document.webkitExitFullscreen?document.webkitExitFullscreen():document.mozCancelFullScreen?document.mozCancelFullScreen():document.msExitFullscreen&&document.msExitFullscreen():A.requestFullscreen?A.requestFullscreen():A.webkitRequestFullscreen?A.webkitRequestFullscreen():A.webkitRequestFullScreen?A.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT):A.mozRequestFullScreen?A.mozRequestFullScreen():A.msRequestFullscreen?A.msRequestFullscreen():this.showOSD("Fullscreen is not supported by your browser!"))},this.exit=function(){a.controlStateChanged(jt.ConsoleControls.POWER_OFF,!0),r.controlActivated(jt.Monitor.Controls.SIZE_DEFAULT)},this.focus=function(){C.focus()};function e(n){(i=i||new jt.Settings).show(n)}function n(){var n=document.fullscreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.msFullscreenElement;x=!!n,r.controlActivated(jt.Monitor.Controls.SIZE_DEFAULT),x&&setTimeout(function(){r.controlActivated(jt.Monitor.Controls.SIZE_DEFAULT)},120)}var r,a,i,o,A,C,D,E,s,F,B,c,l,u,d,f,h,p,P,m,g,S,v=function(n,e){C.width=n,C.height=e,C.style.width=n+"px",C.style.height=e+"px",x||(o.style.width=n+"px",o.style.height=e+"px",n+=2*m,e+=P+g,t.style.width=n+"px",t.style.height=e+"px")},y=function(){D.hasOwnProperty("imageSmoothingEnabled")?D.imageSmoothingEnabled=U:(D.webkitImageSmoothingEnabled=U,D.mozImageSmoothingEnabled=U,D.msImageSmoothingEnabled=U)},k=function(){var n,e,t;D.fillStyle="black",D.fillRect(0,0,C.width,C.height),c.isLoaded&&(t=c.width,(e=c.height)>.7*C.height&&(e=e*(n=.7*C.height/e)|0,t=t*n|0),D.drawImage(c,(C.width-t)/2|0,(C.height-e)/2|0,t,e))},L=function(){t.style.position="relative",t.style.overflow="hidden",t.style.outline="none",t.tabIndex="-1",(o=document.createElement("div")).style.position="relative",o.style.overflow="hidden",o.style.background="black",o.style.border="0 solid black",o.style.borderWidth=P+"px "+m+"px "+g+"px",2===Javatari.SCREEN_CONTROL_BAR&&(o.style.borderImage="url("+V+"screenborder.png) "+P+" "+m+" "+g+" repeat stretch"),(A=document.createElement("div")).style.position="relative",A.style.width="100%",A.style.height="100%",A.style.overflow="hidden",A.style.background="black",document.addEventListener("fullscreenchange",n),document.addEventListener("webkitfullscreenchange",n),document.addEventListener("mozfullscreenchange",n),document.addEventListener("msfullscreenchange",n),o.appendChild(A),(C=document.createElement("canvas")).style.position="absolute",C.style.display="block",C.style.left=C.style.right=0,C.style.top=C.style.bottom=0,C.style.margin="auto",C.tabIndex="-1",C.style.outline="none",A.appendChild(C),v(jt.CanvasDisplay.DEFAULT_STARTING_WIDTH,jt.CanvasDisplay.DEFAULT_STARTING_HEIGHT),t.appendChild(o)},b=function(){(E=document.createElement("div")).style.position="absolute",E.style.left="0",E.style.right="0",E.style.height="29px",2===Javatari.SCREEN_CONTROL_BAR?E.style.bottom="0":1===Javatari.SCREEN_CONTROL_BAR?(E.style.bottom="-30px",E.style.background="rgba(47, 47, 43, .8)",E.style.transition="bottom 0.3s ease-in-out",t.addEventListener("mouseover",function(){s&&clearTimeout(s),E.style.bottom="0px"}),t.addEventListener("mouseleave",function(){s=setTimeout(function(){E.style.bottom="-30px"},1e3)})):(E.style.bottom="0",E.style.background="rgb(44, 44, 40)",E.style.border="1px solid black"),l=T(6,-26,24,23,-436,-208),w(l,jt.ConsoleControls.POWER);var n=23;Javatari.SCREEN_FULLSCREEN_DISABLED||(h=T(-53,-26,24,22,-387,-209),_(h,jt.Monitor.Controls.FULLSCREEN),n=0),Javatari.SCREEN_RESIZE_DISABLED||(d=T(-92+n,-26,18,22,-342,-209),_(d,jt.Monitor.Controls.SIZE_MINUS),f=T(-74+n,-26,21,22,-364,-209),_(f,jt.Monitor.Controls.SIZE_PLUS)),(p=T(-29,-26,24,22,-412,-209)).style.cursor="pointer",p.addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),e()}),(u=T("CENTER",-26,24,24,-388,-181)).style.cursor="pointer",u.addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),e("ABOUT")}),t.appendChild(E)},T=function(n,e,t,r,a,i,o){var A=document.createElement("div");return A.style.position="absolute","CENTER"===n?(A.style.left=A.style.right=0,A.style.margin="0 auto"):0<n?A.style.left=n+"px":A.style.right=-t-n+"px",0<e?A.style.top=e+"px":A.style.bottom=-r-e+"px",A.style.width=t+"px",A.style.height=r+"px",A.style.outline="none",o||(A.style.backgroundImage="url("+V+"sprites.png)",A.style.backgroundPosition=a+"px "+i+"px",A.style.backgroundRepeat="no-repeat"),E.appendChild(A),A},_=function(n,e){n.style.cursor="pointer",n.addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),r.controlActivated(e)})},w=function(n,e){n.style.cursor="pointer",n.addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),a.controlStateChanged(e,!0)})},R=function(){(c=new Image).isLoaded=!1,c.onload=function(){c.isLoaded=!0,k()},c.src=V+"logo.png"},I=function(){(F=document.createElement("div")).style.position="absolute",F.style.overflow="hidden",F.style.top="-29px",F.style.right="18px",F.style.height="29px",F.style.padding="0 12px",F.style.margin="0",F.style.font="bold 15px/29px sans-serif",F.style.color="rgb(0, 255, 0)",F.style.background="rgba(0, 0, 0, 0.4)",F.style.opacity=0,F.innerHTML="",A.appendChild(F)},M=function(){g=2===Javatari.SCREEN_CONTROL_BAR?(m=P=5,31):1===Javatari.SCREEN_CONTROL_BAR?m=P=1:(m=P=1,30)},K=!1,O=!1,U=!1,x=!1,V=Javatari.IMAGES_PATH,j=2500,H=2,G=2*(Javatari.SCREEN_OPENING_SIZE||2);S=this,M(),L(),I(),b(),R(),D=C.getContext("2d"),(r=new jt.Monitor).connectDisplay(S),r.addControlInputElements(S.keyControlsInputElements())},jt.CanvasDisplay.DEFAULT_STARTING_WIDTH=640,jt.CanvasDisplay.DEFAULT_STARTING_HEIGHT=426,jt.ConsolePanel=function(C){this.connectPeripherals=function(n,e){(r=n).getMonitor().addControlInputElements(this.keyControlsInputElements()),e.registerForDnD(C)},this.connect=function(n,e){(a=n).addForwardedInput(this),a.addRedefinitionListener(this),e.addInsertionListener(this)},this.powerOn=function(){C.style.visibility="visible",n(),e()},this.powerOff=function(){C.style.visibility="hidden",C.style.display="none"},this.keyControlsInputElements=function(){return[C]};function t(){a.controlsStateReport(y),n()}var r,a,n=function(){s(l,!y[B.POWER]),s(u,y[B.BLACK_WHITE]),s(d,y[B.SELECT]),s(f,y[B.RESET]),s(h,y[B.DIFFICULTY0]),s(p,y[B.DIFFICULTY1]),e()},e=function(){var n;s(P,c),s(v,c),v.innerHTML=c&&c.rom.info.l||b,c&&c.rom.info.lc?(n=c.rom.info.lc.trim().split(/\s+/),v.style.color=n[0]||T,v.style.background=n[1]||_,v.style.borderColor=n[2]||w):(v.style.color=T,v.style.background=_,v.style.borderColor=w)},i=function(){C.style.position="relative",C.style.width=jt.ConsolePanel.DEFAULT_WIDTH+"px",C.style.height=jt.ConsolePanel.DEFAULT_HEIGHT+"px",C.style.background="black url("+L+"sprites.png) no-repeat",C.style.outline="none",C.tabIndex="-1"},o=function(){l=A(31,-85,25,47,2,-141),D(l,B.POWER,!1),u=A(95,-85,25,47,-22,-141),D(u,B.BLACK_WHITE,!1),d=A(351,-85,25,47,-46,-141),D(d,B.SELECT,!0),f=A(414,-85,25,47,-70,-141),D(f,B.RESET,!0),h=A(162,-133,33,22,-94,-157),D(h,B.DIFFICULTY0,!1),p=A(275,-133,33,22,-94,-137),D(p,B.DIFFICULTY1,!1),P=A(141,-94,189,82,-127,-139),m=A(143,-93,184,55,0,0,!0),E(m,jt.Monitor.Controls.LOAD_CARTRIDGE_FILE),Javatari.CARTRIDGE_CHANGE_DISABLED||(g=A(171,-35,31,30,2,-188),E(g,jt.Monitor.Controls.LOAD_CARTRIDGE_FILE),s(g,!0),S=A(267,-35,31,30,-94,-188),E(S,jt.Monitor.Controls.LOAD_CARTRIDGE_URL),s(S,!0))},A=function(n,e,t,r,a,i,o){var A=document.createElement("div");return A.style.opacity=0,A.style.position="absolute",0<n?A.style.left=n+"px":A.style.right=-t-n+"px",0<e?A.style.top=e+"px":A.style.bottom=-r-e+"px",A.style.width=t+"px",A.style.height=r+"px",A.style.outline="none",o||(A.style.backgroundImage="url("+L+"sprites.png)",A.style.backgroundPosition=a+"px "+i+"px",A.style.backgroundRepeat="no-repeat"),C.appendChild(A),A},D=function(n,e,t){var r;e&&(n.style.cursor="pointer",n.addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),r=!0,a.controlStateChanged(e,!0)}),t&&(n.addEventListener("mouseup",function(n){n.preventDefault&&n.preventDefault(),r=!1,a.controlStateChanged(e,!1)}),n.addEventListener("mouseleave",function(n){n.preventDefault&&n.preventDefault(),r&&(r=!1,a.controlStateChanged(e,!1))})))},E=function(n,e){n.style.cursor="pointer",n.addEventListener("click",function(n){n.preventDefault&&n.preventDefault(),r.getMonitor().controlActivated(e)})},s=function(n,e){n.style.opacity=e?1:0},F=function(){var n=(Javatari.CARTRIDGE_LABEL_COLORS||"").trim().split(/\s+/);n[0]&&(T=n[0]),n[1]&&(_=n[1]),n[2]&&(w=n[2]),(v=document.createElement("div")).style.position="absolute",v.style.overflow="hidden",v.style.textOverflow="ellipsis",v.style.whiteSpace="nowrap",v.style.top="52px",v.style.left="158px",v.style.width="148px",v.style.height="25px",v.style.padding="0 2px",v.style.margin="0",v.style.font="bold 14px/25px sans-serif",v.style.textAlign="center",v.style.color=T,v.style.background=_,v.style.border="1px solid "+w,v.style.opacity="0",v.innerHTML="",E(v,jt.Monitor.Controls.LOAD_CARTRIDGE_FILE),C.appendChild(v)},B=jt.ConsoleControls;this.controlStateChanged=function(n,e){k[n]&&t()},this.controlValueChanged=function(n,e){},this.controlsStateReport=function(n){},this.controlsStatesRedefined=function(){t()},this.cartridgeInserted=function(n){c=n,e()};var c,l,u,d,f,h,p,P,m,g,S,v,y={},k={};k[B.POWER]=1,k[B.BLACK_WHITE]=1,k[B.SELECT]=1,k[B.RESET]=1,k[B.DIFFICULTY0]=1,k[B.DIFFICULTY1]=1;var L=Javatari.IMAGES_PATH,b="JAVATARI.js",T="#fa2525",_="#101010",w="transparent";i(),o(),F()},jt.ConsolePanel.DEFAULT_WIDTH=465,jt.ConsolePanel.DEFAULT_HEIGHT=137,jt.WebAudioSpeaker=function(){this.connect=function(n){(r=n).connectMonitor(this)},this.powerOn=function(){e?this.play():(t(),e&&((n="function"==typeof e.createScriptProcessor?e.createScriptProcessor(Javatari.AUDIO_BUFFER_SIZE,0,1):e.createJavaScriptNode(Javatari.AUDIO_BUFFER_SIZE,0,1)).onaudioprocess=i,this.play()))},this.powerOff=function(){this.mute()},this.play=function(){e&&(n&&n.connect(e.destination),e.resume())},this.mute=function(){e&&(e.suspend(),n&&n.disconnect())};var r,a,e,n,t=function(){try{var n=window.AudioContext||window.webkitAudioContext||window.WebkitAudioContext;if(!n)throw new Error("WebAudio API not supported by the browser");e=new n,a=jt.TiaAudioSignal.SAMPLE_RATE/e.sampleRate,jt.Util.log("Speaker AudioContext created. Sample rate: "+e.sampleRate)}catch(n){jt.Util.log("Could not create AudioContext. Audio disabled.\n"+n.message)}},i=function(n){var e,t;r&&(e=n.outputBuffer.getChannelData(0),t=r.retrieveSamples(e.length*a|0),jt.Util.arrayCopyCircularSourceWithStep(t.buffer,t.start,t.bufferSize,a,e,0,e.length))}},jt.LocalStorageSaveStateMedia=function(){this.connect=function(n){n.connectMedia(this)},this.registerForDownloadElement=function(n){e=n},this.saveState=function(n,e){var t=i(e);return t&&a("save"+n,t)},this.loadState=function(n){var e=t("save"+n);return o(e)},this.saveStateFile=function(n,e){var t=i(e);return t&&A(n||"JavatariSave",t)},this.loadStateFile=function(n){return o(n)},this.saveResourceToFile=function(n,e){try{var t=e&&JSON.stringify(e);return a(n,t)}catch(n){}},this.loadResourceFromFile=function(n){try{var e=t(n);return e&&JSON.parse(e)}catch(n){}};var r,e,a=function(n,e){try{return localStorage["javatari"+n]=e,!0}catch(n){return!1}},t=function(n){try{return localStorage["javatari"+n]}catch(n){}},i=function(n){try{return D+JSON.stringify(n)}catch(n){}},o=function(n){try{var e=n instanceof Array?jt.Util.uInt8ArrayToByteString(n.slice(0,D.length)):n.substr(0,D.length);if(e!==D)return;var t=n.slice(D.length);return t instanceof Array&&(t=jt.Util.uInt8ArrayToByteString(t)),t&&JSON.parse(t)}catch(n){}},A=function(n,e){r||C(),r.href&&(window.URL||window.webkitURL).revokeObjectURL(r.href),n&&(n+=E);var t=new Blob([e],{type:"data:application/octet-stream"});return r.download=n.trim(),r.href=(window.URL||window.webkitURL).createObjectURL(t),r.click(),!0},C=function(){(r=document.createElement("a")).style.display="none",r.href="#",e.appendChild(r)},D="javatarijsstate!",E=".jst"},jt.ROMLoader=function(){var r=this;this.connect=function(n,e){E=n,s=e},this.registerForDnD=function(n){n.addEventListener("dragover",i,!1),n.addEventListener("drop",o,!1)},this.registerForFileInputElement=function(n){a=n},this.openFileChooserDialog=function(n){t||C(),B=!1!==n,t.click()},this.openURLChooserDialog=function(n){var e;B=!1!==n;try{e=localStorage&&localStorage[l]}catch(n){}if((e=prompt("Load ROM from URL:",e||""))&&(e=e.toString().trim())){try{localStorage[l]=e}catch(n){}this.loadFromURL(e)}},this.loadFromFile=function(t){jt.Util.log("Reading ROM file: "+t.name);var n=new FileReader;n.onload=function(n){var e=new Uint8Array(n.target.result);A(t.name,e)},n.onerror=function(n){F("File reading error: "+n.target.error.name)},n.readAsArrayBuffer(t)},this.loadFromURL=function(e){jt.Util.log("Reading ROM from URL: "+e);var t=new XMLHttpRequest;t.withCredentials=!0,t.open("GET",e,!0),t.responseType="arraybuffer",t.timeout=2e3,t.onload=function(){var n;200===t.status?(n=new Uint8Array(t.response),A(e,n)):F("URL reading error: "+(t.statusText||t.status))},t.onerror=function(){F("URL reading error: "+(t.statusText||t.status))},t.ontimeout=function(){F("URL reading error: "+(t.statusText||t.status))},t.send()};function e(n){if(n.returnValue=!1,n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),n.target.focus(),this.files&&this.files.length){var e=this.files[0];try{t.value=""}catch(n){}return r.loadFromFile(e),!1}}var E,s,t,a,i=function(n){n.returnValue=!1,n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),Javatari.CARTRIDGE_CHANGE_DISABLED?n.dataTransfer.dropEffect="none":n.dataTransfer.dropEffect="link"},o=function(n){var e,t;n.returnValue=!1,n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),n.target.focus(),B=!0!==n.altKey,Javatari.CARTRIDGE_CHANGE_DISABLED||n.dataTransfer&&((e=n.dataTransfer&&n.dataTransfer.files)&&0<e.length?r.loadFromFile(e[0]):(t=n.dataTransfer.getData("URL"))&&0<t.length&&r.loadFromURL(t))},A=function(n,t){var r,a,i;try{if(i=new Array(t.length),jt.Util.arrayCopy(t,0,i,0,i.length),s.loadStateFile(i))return void jt.Util.log("SaveState file loaded");a=new jt.ROM(n,i),r=jt.CartridgeDatabase.createCartridgeFromRom(a),E&&E.insert(r,B)}catch(e){if(!e.javatari)throw jt.Util.log(e.stack),e;try{for(var o=new JSZip(t).file(c),A=0;A<o.length;A++){var C=o[A];jt.Util.log("Trying zip file content: "+C.name);try{var D=C.asUint8Array();return i=new Array(D.length),jt.Util.arrayCopy(D,0,i,0,i.length),a=new jt.ROM(C.name,i),r=jt.CartridgeDatabase.createCartridgeFromRom(a),void(E&&E.insert(r,B))}catch(n){}}F("No valid ROM files inside zip file")}catch(n){F(e.message)}}},F=function(n){jt.Util.log(""+n),Javatari.SHOW_ERRORS&&jt.Util.message("Could not load ROM:\n\n"+n)},C=function(n){(t=document.createElement("input")).id="ROMLoaderFileInput",t.type="file",t.accept=D,t.style.display="none",t.addEventListener("change",e),a.appendChild(t)},B=!0,c=/^.*\.(bin|BIN|rom|ROM|a26|A26|jst|JST)$/,D=".bin,.rom,.a26,.zip,.jst",l="javatarilasturl";Javatari.loadROMFromURL=this.loadFromURL,Javatari.loadROM=A},jt.Settings=function(){var r=this;this.show=function(n){if(!this.panel)return e(this),void setTimeout(function(){r.show(n)},0);u=!1,c=null,i(),n&&this.setPage(n),this["jt-cover"].classList.add("show"),this["jt-modal"].classList.add("show"),this.panel.focus()},this.hide=function(){u&&n(),this["jt-modal"].classList.remove("show"),this["jt-cover"].classList.remove("show"),Javatari.room.screen.focus()},this.setPage=function(n){var e={HELP:"0",CONTROLS:"-560px",ABOUT:"-1120px"}[n],t={HELP:"0",CONTROLS:"33.3%",ABOUT:"66.6%"}[n];e&&(r["jt-content"].style.left=e),t&&(r["jt-menu-selection"].style.left=t),r["jt-menu-help"].classList["HELP"===n?"add":"remove"]("selected"),r["jt-menu-controls"].classList["CONTROLS"===n?"add":"remove"]("selected"),r["jt-menu-about"].classList["ABOUT"===n?"add":"remove"]("selected")};var e=function(){var n=document.createElement("style");n.type="text/css",n.innerHTML=SettingsGUI.css(),document.head.appendChild(n),r.panel=document.createElement("div"),r.panel.innerHTML=SettingsGUI.html(),r.panel.style.outline="none",r.panel.tabIndex=-1,document.body.appendChild(r.panel),delete SettingsGUI.html,delete SettingsGUI.css,t(),a()},t=function(){!function n(e,t){t(e);for(var r=e.childNodes,a=0;a<r.length;a++)n(r[a],t)}(r.panel,function(n){n.id&&(r[n.id]=n)})},a=function(){for(var n in r.panel.addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),r.hide()}),r["jt-modal"].addEventListener("mousedown",function(n){n.stopPropagation&&n.stopPropagation(),C()}),r["jt-back"].addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),r.hide()}),r.panel.addEventListener("keydown",function(n){n.preventDefault&&n.preventDefault(),n.stopPropagation&&n.stopPropagation(),o(n)}),r["jt-menu-help"].addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),r.setPage("HELP")}),r["jt-menu-controls"].addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),r.setPage("CONTROLS")}),r["jt-menu-about"].addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),r.setPage("ABOUT")}),B)!function(e){r[e].addEventListener("mousedown",function(n){n.stopPropagation&&n.stopPropagation(),n.preventDefault&&n.preventDefault(),A(e)})}(n);for(var t in r["jt-controls-defaults"].addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),s()}),r["jt-controls-revert"].addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),F()}),l)!function(e){r[l[t]].addEventListener("mousedown",function(n){n.preventDefault&&n.preventDefault(),Javatari.room.controls.processKeyEvent(e,!0,jt.DOMConsoleControls.KEY_ALT_MASK),C()})}(0|t)},i=function(){r["jt-browserinfo"].innerHTML=navigator.userAgent,Javatari.room.controls.isPaddleMode()?(r["jt-control-p1-controller"].style.backgroundPositionY="-91px",r["jt-control-p2-controller"].style.backgroundPositionY="-91px",r["jt-control-p1-up-label"].innerHTML=r["jt-control-p2-up-label"].innerHTML="+ Speed",r["jt-control-p1-down-label"].innerHTML=r["jt-control-p2-down-label"].innerHTML="- Speed"):(r["jt-control-p1-controller"].style.backgroundPositionY="0",r["jt-control-p2-controller"].style.backgroundPositionY="0",r["jt-control-p1-up-label"].innerHTML=r["jt-control-p2-up-label"].innerHTML="Up",r["jt-control-p1-down-label"].innerHTML=r["jt-control-p2-down-label"].innerHTML="Down");var n,e=Javatari.room.controls.isP1ControlsMode();for(var t in r["jt-control-p1-label"].innerHTML="Player "+(e?"2":"1"),r["jt-control-p2-label"].innerHTML="Player "+(e?"1":"2"),B){t===c?(r[t].classList.add("redefining"),r[t].classList.remove("undefined"),r[t].innerHTML="?"):(r[t].classList.remove("redefining"),(n=jt.KeysByCode[Javatari.preferences[B[t]]])?(r[t].classList.remove("undefined"),r[t].innerHTML=n.n):(r[t].classList.add("undefined"),r[t].innerHTML="-"))}},o=function(n){n.keyCode===d?E():c?D(n.keyCode):n.altKey&&l[n.keyCode]&&(Javatari.room.controls.keyDown(n),i())},A=function(n){c=n,i()},C=function(){c=null,i()},D=function(n){if(c&&jt.KeysByCode[n]){if(Javatari.preferences[B[c]]!==n){for(var e in B)Javatari.preferences[B[e]]===n&&(Javatari.preferences[B[e]]=-1);Javatari.preferences[B[c]]=n,u=!0}C()}},E=function(){c?C():r.hide()},s=function(){Javatari.preferences.loadDefaults(),u=!0,C()},F=function(){Javatari.preferences.load(),u=!1,C()},n=function(){Javatari.room.controls.applyPreferences(),Javatari.preferences.save(),u=!1},B={"jt-control-p1-button1":"KP0BUT","jt-control-p1-button2":"KP0BUT2","jt-control-p1-up":"KP0UP","jt-control-p1-left":"KP0LEFT","jt-control-p1-right":"KP0RIGHT","jt-control-p1-down":"KP0DOWN","jt-control-p2-button1":"KP1BUT","jt-control-p2-button2":"KP1BUT2","jt-control-p2-up":"KP1UP","jt-control-p2-left":"KP1LEFT","jt-control-p2-right":"KP1RIGHT","jt-control-p2-down":"KP1DOWN"},c=null,l={};l[jt.DOMConsoleControls.KEY_TOGGLE_P1_MODE]="jt-controls-swap-keys",l[jt.DOMConsoleControls.KEY_TOGGLE_JOYSTICK]="jt-controls-swap-gamepads";var u=!(l[jt.DOMConsoleControls.KEY_TOGGLE_PADDLE]="jt-controls-toggle-paddles"),d=27},SettingsGUI={html:function(){return'<div id="jt-cover"><div id="jt-modal"><div id="jt-menu"><div id="jt-back"><div id="jt-back-arrow">&larr;</div></div><div class="caption">Settings</div><div class="items"><div id="jt-menu-help" class="item selected">HELP</div><div id="jt-menu-controls" class="item">CONTROLS</div><div id="jt-menu-about" class="item">ABOUT</div><div id="jt-menu-selection"></div></div></div><div id="jt-content"><div id="jt-help"><div class="left"><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Ctrl</div> + <div class="key">1 - 0</div></div><div class="desc">Save State</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">1 - 0</div></div><div class="desc">Load State</div></div><div class="hotkey"><div class="command"><div class="key">F8</div></div><div class="desc">Save State File</div></div><div class="hotkey"></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">P</div></div><div class="desc">Pause</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">F</div></div><div class="desc">Next Frame</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">V</div></div><div class="desc">NTSC/PAL</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">R</div></div><div class="desc">CRT Modes</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">T</div></div><div class="desc">CRT Filter</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">G</div></div><div class="desc">Show Info</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">D</div></div><div class="desc">Debug Modes</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">C</div></div><div class="desc">Collisions</div></div></div><div class="right"><div class="hotkey"><div class="command"><div class="key">Tab</div></div><div class="desc">Fast Speed</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">Enter</div></div><div class="desc">Full Screen</div></div><div class="hotkey"><div class="command"><div class="key key-ctrlalt">Ctrl</div> + <div class="key">F1</div></div><div class="desc">Fry Console</div></div><div class="hotkey"><div class="command"><div class="key">F7</div></div><div class="desc">Remove Cartridge</div></div><div class="hotkey"></div><div class="hotkey"><div class="command right-bottom"><div class="key">Backspace</div></div><div class="desc">Screen Defaults</div></div><div class="hotkey"><div class="command right-bottom"><div class="key">Shift</div> + <div class="key">Arrows</div></div><div class="desc">Screen Size</div></div><div class="hotkey"><div class="command right-bottom"><div class="key">Shift</div> <div class="key key-ctrlalt">Alt</div> + <div class="key">Arrows</div></div><div class="desc">Screen Scale</div></div><div class="hotkey"><div class="command right-bottom"><div class="key">Shift</div> <div class="key key-ctrlalt">Ctrl</div> + <div class="key">Arrows</div></div><div class="desc">Viewport Size</div></div><div class="hotkey"><div class="command right-bottom"><div class="key key-ctrlalt">Ctrl</div> <div class="key key-ctrlalt">Alt</div> + <div class="key">Arrows</div></div><div class="desc">Viewport Origin</div></div><div class="hotkey"></div><div class="hotkey"><div class="desc">Drag/Drop Files or URLs to load ROMs</div></div></div></div><div id="jt-controls"><div class="player p1"><div id="jt-control-p1-label" class="title">Player 1</div><div class="command fire1">Button<br><div id="jt-control-p1-button1" class="key">Space</div></div><div class="command up"><div id="jt-control-p1-up-label">Up</div><div id="jt-control-p1-up" class="key">Up</div></div><div class="command fire2">Button<br><div id="jt-control-p1-button2" class="key">Del</div></div><div class="command left">Left<br><div id="jt-control-p1-left" class="key">Left</div></div><div class="command controller"><div id="jt-control-p1-controller"></div></div><div class="command right">Right<br><div id="jt-control-p1-right" class="key">Right</div></div><div class="command down"><div id="jt-control-p1-down-label">Down</div><div id="jt-control-p1-down" class="key">Down</div></div></div><div class="player p2"><div id="jt-control-p2-label" class="title">Player 2</div><div class="command fire1">Button<br><div id="jt-control-p2-button1" class="key">A</div></div><div class="command up"><div id="jt-control-p2-up-label">Up</div><div id="jt-control-p2-up" class="key">T</div></div><div class="command fire2">Button<br><div id="jt-control-p2-button2" class="key">Dot</div></div><div class="command left">Left<br><div id="jt-control-p2-left" class="key">F</div></div><div class="command controller"><div id="jt-control-p2-controller"></div></div><div class="command right">Right<br><div id="jt-control-p2-right" class="key">H</div></div><div class="command down"><div id="jt-control-p2-down-label">Down</div><div id="jt-control-p2-down" class="key">G</div></div></div><div class="modes"><div class="title">Modes</div><div id="jt-controls-swap-keys" class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">K</div></div><div class="desc">Swap Keys</div></div><div id="jt-controls-swap-gamepads" class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">J</div></div><div class="desc">Swap Gamepads</div></div><div id="jt-controls-toggle-paddles" class="hotkey"><div class="command"><div class="key key-ctrlalt">Alt</div> + <div class="key">L</div></div><div class="desc">Toggle Paddles</div></div></div><div id="jt-controls-revert">REVERT</div><div id="jt-controls-defaults">DEFAULTS</div></div><div id="jt-about"><div id="jt-logo-version">'+Javatari.VERSION+'</div><div class="info">Created by Paulo Augusto Peccin<br><a href="http://javatari.org">http://javatari.org</a></div><div id="jt-browserinfo"></div></div></div></div></div>'},css:function(){return'#jt-cover {position: fixed;top: 0;right: 0;bottom: 0;left: 0;z-index: 1000;visibility: hidden;opacity: 0;background-color: rgba(0, 0, 0, 0.6);transition: all .2s ease-out;}#jt-cover.show {visibility: visible;opacity: 1;}#jt-modal {position: relative;overflow: hidden;width: 560px;top: 80px;left: -120px;margin: 0 auto;color: rgba(0, 0, 0, 0.90);font-family: arial, sans-serif;box-shadow: 3px 3px 15px 2px rgba(0, 0, 0, .4);transition: all .2s ease-out;}#jt-modal.show {left: 0;}#jt-modal .hotkey {height: 27px;padding: 3px 5px;font-size: 13px;box-sizing: border-box;}#jt-modal .hotkey .command {position: relative;float: left;font-weight: 600;color: rgba(0, 0, 0, .50);}#jt-modal .hotkey .desc {float: left;padding-top: 3px;}#jt-modal .key {position: relative;display: inline-block;top: -1px;min-width: 25px;height: 21px;padding: 4px 6px 3px;box-sizing: border-box;font-weight: 600;font-size: 12px;line-height: 12px;color: rgba(0, 0, 0, .68);background-color: white;border-radius: 3px;border: 1px solid rgb(210, 210, 210);box-shadow: 0 1px 0 1px rgba(0, 0, 0, .5);text-align: center;}#jt-modal .key-ctrlalt {width: 31px;padding-left: 0;padding-right: 2px;}#jt-menu {position: relative;background-color: white;border-bottom: 1px solid rgb(200, 200, 200);}#jt-menu #jt-back {position: absolute;width: 18px;height: 32px;margin: 3px;padding: 0 11px;font-size: 35px;color: white;cursor: pointer;}#jt-menu #jt-back:hover {background-color: rgba(0, 0, 0, .12);}#jt-menu #jt-back-arrow {position: relative;overflow: hidden;top: -7px;}#jt-menu .caption {height: 29px;margin: 0 -1px;padding: 9px 0 0 48px;font-size: 19px;color: white;background-color: rgb(235, 62, 35);box-shadow: 0 1px 4px rgba(0, 0, 0, .8);}#jt-menu .items {position: relative;width: 70%;height: 39px;margin: 0 auto;font-weight: 600;}#jt-menu .item {float: left;width: 33.3%;height: 100%;padding-top: 13px;font-size: 14px;color: rgba(0, 0, 0, .43);text-align: center;cursor: pointer}#jt-menu .selected {color: rgb(224, 56, 34);}#jt-menu #jt-menu-selection {position: absolute;left: 0;bottom: 0;width: 33.3%;height: 3px;background-color: rgb(235, 62, 35);transition: left 0.3s ease-in-out}#jt-content {position: relative;left: 0;width: 1680px;height: 370px;background-color: rgb(220, 220, 220);transition: left 0.3s ease-in-out}#jt-help, #jt-controls, #jt-about {position: absolute;width: 560px;height: 100%;box-sizing: border-box;}#jt-help {padding-top: 22px;}#jt-help .left {float: left;padding-left: 30px;}#jt-help .right {float: left;padding-left: 34px;}#jt-help .left .command {width: 104px;}#jt-help .right .command {width: 109px;}#jt-help .command.right-bottom {width: 164px;}#jt-controls {left: 560px;}#jt-controls .player {position: absolute;top: 15px;width: 217px;color: rgba(0, 0, 0, .8);}#jt-controls .p1 {left: 28px;}#jt-controls .p2 {right: 28px;}#jt-controls .title {padding-bottom: 4px;margin: 0 14px 8px 12px;font-size: 18px;text-align: center;border-bottom: 2px solid rgba(242, 66, 35, .55);}#jt-controls .player .command {position: relative;float: left;width: 33%;height: 45px;font-size: 13px;text-align: center;}#jt-controls .command.fire1, #jt-controls .command.fire2 {top: 14px;}#jt-controls .command.left, #jt-controls .command.right {top: 27px;}#jt-controls .command.down {float: none;clear: both;margin: 0 auto;}#jt-controls .command.controller {height: 90px;}#jt-controls #jt-control-p1-controller, #jt-controls #jt-control-p2-controller {width: 70px;height: 89px;margin-left: 1px;background: url("'+Javatari.IMAGES_PATH+'sprites.png") no-repeat -466px 0;}#jt-controls .player .key {min-width: 33px;height: 23px;padding: 5px 6px 4px;margin-top: 2px;cursor: pointer;}#jt-controls .player .key:hover {box-shadow: 0 1px 0 1px rgba(0, 0, 0, .5), 1px 2px 6px 4px rgb(170, 170, 170);}#jt-controls .player .key.redefining {color: white;background-color: rgb(87, 128, 255);border-color: rgb(71, 117, 255);}#jt-controls .player .key.undefined {background-color: rgb(255, 150, 130);border-color: rgb(255, 130, 90);}#jt-controls .modes {position: absolute;top: 200px;left: 0;right: 0;width: 200px;margin: 0 auto;}#jt-controls .modes .hotkey {position: relative;padding-left: 8px;cursor: pointer;}#jt-controls .modes .hotkey:hover {background-color: white;box-shadow: 1px 1px 3px 1px rgb(180, 180, 180);}#jt-controls .modes .command {margin-right: 12px;}#jt-controls-defaults, #jt-controls-revert {position: absolute;bottom: 18px;padding: 7px 10px;font-size: 12px;font-weight: 600;border-radius: 1px;cursor: pointer}#jt-controls-defaults:hover, #jt-controls-revert:hover {background-color: white;box-shadow: 1px 1px 3px 1px rgb(180, 180, 180);}#jt-controls-revert {right: 30px;color: rgba(0, 0, 0, 0.8);}#jt-controls-defaults {right: 115px;color: rgb(0, 80, 230);}#jt-about {left: 1120px;}#jt-about #jt-logo-version {width: 248px;height: 220px;margin: 28px auto 14px;font-size: 18px;color: rgba(255, 255, 255, 0.97);padding-top: 190px;box-sizing: border-box;text-align: center;background: black url("'+Javatari.IMAGES_PATH+'logo.png") no-repeat 5px 13px;background-size: 233px 173px;box-shadow: 3px 3px 14px rgb(75, 75, 75);}#jt-about .info {font-size: 18px;line-height: 30px;text-align: center;}#jt-about a {color: rgb(0, 80, 230);text-decoration: none;}#jt-about #jt-browserinfo {position: absolute;left: 0;right: 0;bottom: 7px;font-size: 10px;text-align: center;color: transparent;}'}},jt.Room=function(n,e,t){var r=this;this.powerOn=function(n){A(),r.screen.powerOn(),r.consolePanel&&this.consolePanel.powerOn(),r.speaker.powerOn(),r.controls.powerOn(),a(),r.console.getCartridgeSocket().inserted()&&!r.console.powerIsOn&&r.console.powerOn(n)},this.powerOff=function(){r.console.powerOff(),r.controls.powerOff(),r.speaker.powerOff(),r.screen.powerOff(),r.consolePanel&&this.consolePanel.powerOff()};var a=function(){r.console.getCartridgeSocket().inserted()||t&&r.console.getCartridgeSocket().insert(t,!1)},i=function(){r.stateMedia=new jt.LocalStorageSaveStateMedia,r.romLoader=new jt.ROMLoader,r.screen=new jt.CanvasDisplay(n),r.screen.connectPeripherals(r.romLoader,r.stateMedia),e&&(r.consolePanel=new jt.ConsolePanel(e),r.consolePanel.connectPeripherals(r.screen,r.romLoader)),r.speaker=new jt.WebAudioSpeaker,r.controls=new jt.DOMConsoleControls,r.controls.connectPeripherals(r.screen,r.consolePanel)},o=function(){r.console=new jt.AtariConsole,r.stateMedia.connect(r.console.getSavestateSocket()),r.romLoader.connect(r.console.getCartridgeSocket(),r.console.getSavestateSocket()),r.screen.connect(r.console.getVideoOutput(),r.console.getControlsSocket(),r.console.getCartridgeSocket()),r.consolePanel&&r.consolePanel.connect(r.console.getControlsSocket(),r.console.getCartridgeSocket(),r.controls),r.speaker.connect(r.console.getAudioOutput()),r.controls.connect(r.console.getControlsSocket(),r.console.getCartridgeSocket())},A=function(){document.addEventListener("visibilitychange",function(){document.hidden?r.speaker.mute():r.speaker.play()})};this.screen=null,this.consolePanel=null,this.speaker=null,this.controls=null,this.console=null,this.stateMedia=null,this.romLoader=null,i(),o()},Javatari.start=function(){if(Javatari.preferences.load(),!Javatari.screenElement&&(Javatari.screenElement=document.getElementById(Javatari.SCREEN_ELEMENT_ID),!Javatari.screenElement))throw new Error('Javatari cannot be started. HTML document is missing screen element with id "'+Javatari.SCREEN_ELEMENT_ID+'"');Javatari.consolePanelElement||(Javatari.consolePanelElement=document.getElementById(Javatari.CONSOLE_PANEL_ELEMENT_ID)),Javatari.room=new jt.Room(Javatari.screenElement,Javatari.consolePanelElement),Javatari.room.powerOn(),Javatari.ROM_AUTO_LOAD_URL&&Javatari.room.romLoader.loadFromURL(Javatari.ROM_AUTO_LOAD_URL),Javatari.shutdown=function(){Javatari.room&&Javatari.room.powerOff(),jt.Util.log("shutdown"),delete Javatari},delete Javatari.start,delete Javatari.preLoadImagesAndStart,jt.Util.log(Javatari.VERSION+" started")},Javatari.preLoadImagesAndStart=function(){function n(n){Javatari.start&&!1!==Javatari.AUTO_START&&(n||r&&0===a)&&Javatari.start()}var e=["sprites.png","logo.png","screenborder.png"],t=e.length,r=!1,a=t;document.addEventListener("DOMContentLoaded",function(){n(!(r=!0))});for(var i=0;i<t;i++){var o=new Image;o.src=Javatari.IMAGES_PATH+e[i],o.onload=function(){a--,n(!1)}}window.addEventListener("load",function(){n(!0)})},Javatari.preLoadImagesAndStart();